/***************************************************************************
                               PackageSelect.h
                             -------------------                                         
    begin                : Fri Oct 29 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef PackageSelect_included
#define PackageSelect_included

#include "PackageSelectData.h"
#include "config.h"
#include <rpmlib.h>

#include <qdict.h>

#include <stdio.h>
#include <mntent.h>

#include "installselect.h"

class PackageListItem;
class InstallSelect;

class PackageSelect : public PackageSelectData {
    Q_OBJECT

public:
    PackageSelect( QWidget *parent, InstallSelect *install, const char *name = NULL );
    virtual ~PackageSelect();

		void showEvent( QShowEvent * );

		void insertItems();
		void initializeSelection( bool blDepsCheck = true );

		int findInstallSource();
#ifdef GBLI_STANDALONE
		void setInitialized(bool val) { initialized = val; }
		bool getInitialized() { return initialized; }
#endif

public slots:
		void finish() {}
		void updateFinished();

signals:
    void nextEnabled( QWidget*, bool);		
		void updateStarted();

private slots:
		void startUpdate();
		void displayFreeSpace();
		void updateDependencies();

	  void slotSelectionChanged(class QListViewItem *);
	  void slotCurrentChanged(class QListViewItem *);
		void slotToggleSelectionOfPackage(class QListViewItem *);
		void slotTotalChanged( int a_size );
		
private:
		PackageListItem *findAppropriateGroup( QString& a_group );
		int mirrorSystemPackagesSelectionToList();

		InstallSelect *install;
		PackageListItem *root;
		bool initialized;
		QDict<QString> DGroups;
		int iFreeSpace;
		bool blManualSourceMount; // shows that we have to unmount it at the end
};
#endif // PackageSelect_included
