/***************************************************************************
                              addmodulespage.h
                             -------------------
    begin                : Tue Jan 4 2000
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

//#ifndef DEBUGALIAS
//	#define DEBUGALIAS
//#endif

#ifndef ADDMODULESPAGE_H
#define ADDMODULESPAGE_H

#include "gblipage.h"

#include <qlistview.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qcombobox.h>
#include <qsortedlist.h>
#include <qdialog.h>
#include <qdict.h>
#include <qtextview.h>
#include <qcheckbox.h>
#include <qmultilineedit.h>


/*enum deviceTypes { DEVICE_NONE = 0, DEVICE_HD, DEVICE_FD, DEVICE_CDROM,
			DEVICE_TAPE };*/
enum driverTypes { DRIVER_SCSI = 0, DRIVER_NET = 1, DRIVER_CDROM = 2,
		   DRIVER_PCMCIA = 3, DRIVER_FS = 4,
		   DRIVER_PREREQ = 4, DRIVER_OTHER = 1000};
enum driverMinor { DRIVER_MINOR_NONE = 0, DRIVER_MINOR_ETHERNET,
		   DRIVER_MINOR_PLIP, DRIVER_MINOR_TR };

struct driver;
typedef int (*driverOkayFn)(struct driver * dev);

struct driver {
    char * name;
    char * modules;
    int isLoaded;
    driverOkayFn okay;
    enum driverTypes type;
    enum driverMinor minor;
};

struct types {
	QString	name;
	int			index;
	types		*next;
};

struct vals {
	QString	mask;
	QString	values;
	vals		*next;
};

struct param {
	QString	name;
	QString	description;
	bool		hasMinMax;
	int			min,max;
	bool		hasDef;
	QString	def;
  vals		*values;
	param		*next;
};

struct module {
	QString	name;
	int			type;
	QString	alias;
	QString	description;
	bool		hasParam;
	param		*parameters;
	module	*next;
};

struct iparam {
	bool		subParam;
	QString	param;
	iparam	*next;
};
struct imodule {
	int 		type;
	QString	name;
	QString	alias;
	iparam	*params;
	imodule	*next;
	bool		installed;
};

static int checkSCSIDev(struct driver * dev){
	return 1;
}

#ifndef DISABLE_NETWORK
static int checkEthernetDev(struct driver * dev){
	return 1;
}
static int checkPlipDev(struct driver * dev){
	return 1;
}
static int checkTokenRingDev(struct driver * dev){
	return 1;
}
#endif

//static int checkSCSIDev(struct driver * dev);
//
//#ifndef DISABLE_NETWORK
//static int checkEthernetDev(struct driver * dev);
//static int checkPlipDev(struct driver * dev);
//static int checkTokenRingDev(struct driver * dev);
//#endif



static struct driver drivers[] = {
#ifndef DISABLE_NETWORK
    { "3com 3c509", "3c509", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "3com 3c501", "3c501", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "3com 3c503", "3c503", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "3com 3c505", "3c505", 0, checkEthernetDev,
               DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "3com 3c507", "3c507", 0, checkEthernetDev,
               DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "3com 3c515", "3c515", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "3com 3c59x (Vortex)", "3c59x", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "3com 3c90x (Boomerang)", "3c59x", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Allied Telesis AT1700", "at1700", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Ansel Communication AC3200", "ac3200", 0, checkEthernetDev,
                DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "AMD PC/Net 32", "pcnet32", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Apricot 82596", "apricot", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "ATP", "atp", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Cabletron E2100", "e2100", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Compaq Netelligent", "tlan", 0, checkEthernetDev,
                DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Digital 425,434,435,450,500", "de4x5", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Digital DEPCA and EtherWORKS", "depca", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Digital EtherWORKS 3", "ewrk3", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Digital 21040 (Tulip)", "tulip", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "D-Link DE-600 pocket adapter", "de600", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "D-Link DE-620 pocket adapter", "de620", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "EPIC 100", "epic100", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "HP10/100VG any LAN ", "hp100", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "HP LAN/AnyLan", "hp", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "HP PCLAN/plus", "hp-plus", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "ICL EtherTeam 16i", "eth16i", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Intel EtherExpress", "eexpress", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Intel EtherExpress Pro", "eepro", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Intel EtherExpress Pro 100", "eepro100", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Lance", "lance", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Mylex LNE390", "lne390", 0, checkEthernetDev,
               DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "MyriCOM Gigabit Ethernet", "myri_sbus", 0, checkEthernetDev,
    		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "NE2000 and compatible", "ne", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "NE2000 PCI", "ne2k-pci", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "NE3210", "ne3210", 0, checkEthernetDev,
                DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "NI 5010", "ni5010", 0, checkEthernetDev,
                DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "NI 5210", "ni52", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "NI 6510", "ni65", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "PLIP (parallel port)", "plip", 0, checkPlipDev,
		DRIVER_NET, DRIVER_MINOR_PLIP },
#ifdef __sparc__		
    { "Sun BigMac Ethernet", "sunbmac", 0, checkEthernetDev,
    		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Sun Happy Meal Ethernet", "sunhme", 0, checkEthernetDev,
    		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Sun Quad Ethernet", "sunqe", 0, checkEthernetDev,
    		DRIVER_NET, DRIVER_MINOR_ETHERNET },
#endif
    { "RealTek RTL8129/8139","rtl8139", 0, checkEthernetDev,
                DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Racal-Interlan ES3210", "es3210", 0, checkEthernetDev,
                DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "RedCreek PCI45 LAN","rcpci45", 0, checkEthernetDev,
                DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "SMC 83c170 EPIC/100", "epic100", 0, checkEthernetDev,
                DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "SMC 9000 series", "smc9194", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "SMC Ultra", "smc-ultra", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "SMC Ultra 32", "smc-ultra32", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "Token Ring", "ibmtr", 0, checkTokenRingDev,
		DRIVER_NET, DRIVER_MINOR_TR },
    { "VIA Rhine", "via-rhine", 0, checkEthernetDev,
                DRIVER_NET, DRIVER_MINOR_ETHERNET },
    { "WD8003, WD8013 and compatible", "wd", 0, checkEthernetDev,
		DRIVER_NET, DRIVER_MINOR_ETHERNET },
#endif /* DISABLE_NETWORK */
    { "AMD SCSI", "AM53C974", 0, checkSCSIDev,
                DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "AMI MegaRAID", "megaraid", 0, checkSCSIDev,
                DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Adaptec 152x", "aha152x", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Adaptec 1542", "aha1542", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Adaptec 1740", "aha1740", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Adaptec 2740, 2840, 2940", "aic7xxx", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "AdvanSys Adapters", "advansys", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Always IN2000", "in2000", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "BusLogic MultiMaster SCSI host adapter", "BusLogic", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Compaq Smart-2/P RAID Controller", "cpqarray", 0, NULL,
                DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "DTC 3180/3280", "dtc", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "EATA DMA Adapters", "eata_dma", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "EATA PIO Adapters", "eata_pio", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Future Domain TMC-885, TMC-950", "seagate", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Future Domain TMC-16x0", "fdomain", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "ICP Disk Array Controller", "gdth", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Iomega PPA3 (parallel port Zip)", "ppa", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Mylex DAC960", "DAC960", 0, NULL,
      		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "NCR 5380", "g_NCR5380", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "NCR 53c406a", "NCR53c406a", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "NCR 53C8xx PCI series SCSI host adapter", "ncr53c8xx", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "NCR/Symbios 53c7xx series SCSI host adapters", "53c7,8xx", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Perceptive Solutions PCI-2000", "pci2000", 0, checkSCSIDev,
                DRIVER_SCSI, DRIVER_MINOR_NONE },
#ifdef __sparc__
    { "Performance Technologies ISP", "qlogicpti", 0, checkSCSIDev,
    		DRIVER_SCSI, DRIVER_MINOR_NONE },
#endif
    { "Pro Audio Spectrum/Studio 16", "pas16", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Qlogic FAS", "qlogicfas", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Qlogic ISP", "qlogicisp", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Seagate ST01/02", "seagate", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
#ifdef __sparc__
    { "Sun SparcSTORAGE Array", "fc4:soc:pluto", 0, checkSCSIDev,
    		DRIVER_SCSI, DRIVER_MINOR_NONE },
#endif
    { "Trantor T128/T128F/T228", "t128", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "UltraStor 14F/34F", "u14-34f", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "UltraStor 14F/24F/34F", "ultrastor", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },
    { "Western Digital wd7000", "wd7000", 0, checkSCSIDev,
		DRIVER_SCSI, DRIVER_MINOR_NONE },

// Nokia WLAN
    { "3Com LAN CardBus 3CCFE575CT", "3c59x"/*"3c575_cb"*/, 0, checkEthernetDev,
		DRIVER_PCMCIA, DRIVER_MINOR_NONE },
    { "Nokia C110/C111 Wireless LAN Card", "nokia_c110", 0, checkEthernetDev,
		DRIVER_PCMCIA, DRIVER_MINOR_NONE },
//

    { "PCMCIA core support", "pcmcia_core", 0, NULL,
		DRIVER_PCMCIA, DRIVER_MINOR_NONE },
    { "PCMCIA card support", "ds", 0, NULL,
		DRIVER_PCMCIA, DRIVER_MINOR_NONE },
    { "PCMCIA i82365 controller", "i82365", 0, NULL,
		DRIVER_PCMCIA, DRIVER_MINOR_NONE },
    { "PCMCIA tcic controller", "tcic", 0, NULL,
		DRIVER_PCMCIA, DRIVER_MINOR_NONE },

    { "iso9660", "isofs", 0, NULL,
		DRIVER_FS, DRIVER_MINOR_NONE },
    { "Network File System (nfs)", "nfs", 0, NULL,
		DRIVER_FS, DRIVER_MINOR_NONE },
    { "Windows SMB", "smbfs", 0, NULL,
		DRIVER_FS, DRIVER_MINOR_NONE },

    { "Aztech CD", "aztcd", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },
    { "Backpack CDROM", "bpcd", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },
    { "Goldstar R420", "gscd", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },
    { "Mitsumi", "mcd", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },
    { "Mitsumi (alternate)", "mcdx", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },
    { "Optics Storage 8000", "optcd", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },
    { "Phillips CM206/CM260", "cm206", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },
    { "Sanyo", "sjcd", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },
    { "Sony CDU-31A", "cdu31a", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },
    { "Sony CDU-5xx", "sonycd535", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },
    { "SoundBlaster/Panasonic", "sbpcd", 0, NULL,
		DRIVER_CDROM, DRIVER_MINOR_NONE },

    { "Loopback device", "loop", 0, NULL, DRIVER_OTHER, DRIVER_MINOR_NONE },
    { "Parallel Printer", "lp", 0, NULL, DRIVER_OTHER, DRIVER_MINOR_NONE },

    { "Advanced Power Management", "apm", 0, NULL, DRIVER_OTHER, DRIVER_MINOR_NONE },

    { NULL, NULL, 0, NULL, DRIVER_OTHER }, /* sentinel */
};

class ModuleOptionsDialog: public QDialog{
  Q_OBJECT

public:
//	ModuleOptionsDialog( QWidget* parent, imodule *mInstalled, module *curModule,QString &module, QString &strOptions, const char *name=0 );
	ModuleOptionsDialog( QWidget* parent, imodule *mInstalled, module *curModule,QString &module, const char *name=0 );
	~ModuleOptionsDialog() { }

  /** Last active combobox number */
  int lastTag;
	QComboBox	**Params;
	int pCount;

private slots:
	void changeOptionsSlot();
	void showHelp();
public slots:
  void valClicked();
signals:
	void changeOptions( QString &module, QString &options );

private:	
	void ModuleOptionsDialog::regInstalledModules(module *from, imodule *to);	
	module *Module;

	QString strModule;

	QLineEdit *options;
	
	QPushButton *btnHelp;
	QPushButton *btnOK;
	QPushButton *btnCancel;

};

/********************************************************************/



class AddModulesPage : public GBLIPage {
   Q_OBJECT
public:
	AddModulesPage( QWidget *parent, const char *name=0 );
	module	*Modules;
	imodule	*InstModules;
	types		*modTypes;

protected:
	void showEvent( QShowEvent * );

public slots:
	void finish();

protected slots:
	void typeChanged( int a_i );
	void typeSubChanged( int a_i );
	void selectionChanged();

	void installModule();
	void removeModule();
	void callEditOptions();

	void changeOptions( QString &module, QString &options );
	QString getOptions( QString &module ){ return *(DOptions.find( module )); };

private:
	imodule*	copyModules( QString &modName);
	QString	getParamString(QString	&modName);
	imodule *installedModule(module *Module);
//	void	getParamString(QString &oldModule);
	void	regInstalledModules(bool Exist, module *from, imodule *to, ModuleOptionsDialog *from = NULL);
	imodule*	getParameters(module 	*Module);
	void	loadModulesData();
	int		registerTypes(QString type);

	void remove_iModule( QString &rModule );
	QString getStrType( int a_type );


	bool loadData( QString &path );
	void initSubTypes();
	int editOptions( QString &module, bool no_probing = false );

	QComboBox *listSubType;
	QComboBox *listType;
	QListView *listModel;
	QListView *listInstalled;

	QCheckBox		*chkProbe;
	QPushButton *btnAdd;
	QPushButton *btnRemove;
	QPushButton *btnEdit;

	int aiListToType[5];

	QDict<QString> DOptions;

	QDict<int> DMods;

	bool initialized;
};


/********************************************************************/

class ModuleOptionsHelpDialog: public QDialog{
  Q_OBJECT

public:
	ModuleOptionsHelpDialog( QWidget* parent, module *Module, const char *name=0 );
	~ModuleOptionsHelpDialog() { }

private:
	param				*Params;
	QComboBox		*paramCombo;
//	QTextView		*paramDescr;
	QMultiLineEdit *paramDescr;
public slots: // Public slots
	void paramChange(int index);

};

#endif


