/***************************************************************************
                           changepartitiondialog.h
                             -------------------                                         
    begin                : Mon Dec 20 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url		            	 : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef CHANGEPARTITIONDIALOG_H
#define CHANGEPARTITIONDIALOG_H

#include "config.h"

#include <qdialog.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qbuttongroup.h>
#include <qlineedit.h>
#include <qlabel.h>

class DiskItem;

// this dialog is used when you click "Edit" button on custom partitioning
// create it, set the variables and show it, then read the variables after
// close
class ChangePartitionDialog : public QDialog{
    Q_OBJECT
public:

    ChangePartitionDialog( QWidget* parent, const char *name=0);
    ~ChangePartitionDialog(){}

    // these variables are used for the communication with the dialog
    QString name;
    int number;
    bool isNewPartition; // then the size is editable
    bool hasSubpartitions;
    signed long start; //sectors
    signed long size;  //sectors
    int origId;
    int id;
    bool bootable;
    bool isNew;
    bool willBeFormated;

    // call do settings after you set all of them. Then do the exec()
		// initializes fields according to settings
    void doSettings( DiskItem* disk_ );

    QComboBox* freeSpaces;
    QString mountPoint() {
    	if( mountPointEdit->currentText()!="" )
    	  return mountPointEdit->currentText();
    	else
    	  return QString::null;
    }
    void setMountPoint( const QString& mp) {
			mountPointEdit->setEditText( mp );
    }

protected slots:
		// clicked Ok, then lets validate and save the data to the variables
		void userAgreed();

    void lineEditChanged( const QString& );
    void freeSpaceComboActivated( int );
    void systemComboActivated( const QString& );
    void mountPointComboActivated( const QString& );

private:
    bool updateSizeInfo();
    void updateFormatCheck();
		void updateBootCheck();
//    void getLimits( const int a_index, signed long *a_start, signed long *a_end );
//    void setupCurrent();
    signed long curStart;
    signed long curEnd;
    signed long curSize;
    signed long curMax;
	
    QPushButton* ok;
    QPushButton* cancel;

    QButtonGroup* groupSize;
    QLabel* sizeInfo;
#ifdef ADVANCED_SIZE
    QLineEdit* startEdit;
    QLineEdit* endEdit;
#else
    QLineEdit* sizeEdit;
#endif

    QButtonGroup* groupSystem;
    QComboBox* systemCombo;
    QComboBox* mountPointEdit;
    QCheckBox* bootableCheck;
    QCheckBox* formatCheck;

    DiskItem* disk;

    void warnAboutSubpartitions();
};

#endif
