/***************************************************************************
                               configfile.cpp
                             -------------------                                         
    begin                : Thu Nov 11 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "configfile.h"

#include "log.h"

ConfigFile::ConfigFile(const char *root, const char *name)
: path(root)
{
		path += name;
    data = 0;
    count = 0;
}

ConfigFile::~ConfigFile()
{
    char	**p;
//BUGGY MESSAGE
    for( p = data; p && *p; p++ )
    	free(*p);
		if( data )
	    free(data);
}

bool ConfigFile::mkdirp( QString path )
{
/*    int status = 0;
    char szPath[128];
    sprintf( szPath, "mkdir -m0755 -p %s", path.ascii() );
    int pid = fork();
    if( !pid ){
      ::execlp( "mkdir", szPath, 0 );
      ::exit( -1 );
    }
    waitpid( pid, &status, 0 );
    Log::logMain( 32, "mkdirp %s  status: %d", path.ascii(), WIFEXITED(status)?WEXITSTATUS(status):0 );
    return true;*/
    if (::mkdir(path.ascii(), 0755) >= 0 || errno == EEXIST){
      if( errno != EEXIST )
  			Log::logMain( 33, "mkdir %s\n", path.ascii() );
			return true;
		}
    if (errno == ENOENT) {
			int	i;

			i = path.findRev('/');
			if (i > 0 && mkdirp(path.left(i))) {
	  	  if (::mkdir(path.ascii(), 0755) >= 0){
					Log::logMain( 33, "mkdir %s\n", path.ascii() );
					return true;
				}
			}
    }
    return false;
}

FILE *ConfigFile::open(const char *mode)
{
    QString dir;
    FILE    *fp;

    if( strchr( "wa", *mode ) && !mkdirp(path.left(path.findRev('/'))) )
        return 0;

    if( !(fp = fopen(path.ascii(), mode)) )
      Log::logMain( 32, "Trying to open %s (mode %s): %m\n", path.ascii(), mode );

    return fp;
}

bool ConfigFile::load()
{
    char	buffer[1024], *sp;
    FILE	*fp;

    fp = open( "r" );
    if( fp == NULL )
			return true;

    while( fgets(buffer, sizeof(buffer), fp) != NULL ) {
			if( (sp = strchr(buffer, '\n')) != '\0' )
	  	  *sp = '\0';
			if (!append(buffer)) {
	  	  Log::logMain( 32, "Out of memory when loading %s\n", path.ascii() );
	    	fclose(fp);
		    return false;
			}
    }

    fclose(fp);
    return true;
}

bool ConfigFile::append(const char *line)
{
    if( (count % 16) == 0 ){
      // plus one for the NULL pointer
      data = (char **) realloc(data, (count+16+1) * sizeof(char *));
      if (data == 0)
        return false;
    }
    data[count] = strdup(line);
    if( data[count] == 0 )
      return false;
    data[++count] = 0;
    return true;
}

bool ConfigFile::save(void)
{
    FILE	*fp;
    char	**sp;

    fp = open("w");
    if (fp == 0)
    	return false;
    for (sp = data; sp && *sp; sp++) {
    	fprintf(fp, "%s\n", *sp);
    }
    fclose(fp);
    return true;
}

//~ AZ original
void UpdateString (QString* strNew, QString strOriginal, QString strVarname, QString strValue )
{

//in some cases code breaks configuration structure


	int index = strOriginal.find (strVarname);

//	*strNew = strVarname ;
	*strNew = strOriginal.left(index);
	*strNew += strVarname ;

	QChar ch;

	int iItemLen = strVarname.length();
	while (1)
	{
		ch = strOriginal[index + iItemLen];
		if (ch.latin1()==' '|| ch.latin1() =='=' || ch.latin1() == '\t' ||
		    ch.latin1()=='+' )
		{
      *strNew+=ch;
		}
		else
			break;

		index++;
  }
		*strNew+= strValue ;
		//printf ("\nThe new string is=%s\n", strNew.latin1());		
}


// AZ:
bool ConfigFile::search_and_replace_new( QString sSearch, QString sRepValue /* ,int iMode =0 */)
{
	int index=-1;
	QFile file( path );

	if ( !file.exists() ){
					return false;
	}

	::rename( path.ascii(), (path + "_old").ascii() );
	QFile confold( path + "_old" );
	QFile confnew( path );

	if( confold.open( IO_ReadOnly ) ){
		if( confnew.open( IO_WriteOnly ) ){
			QTextStream inf( &confold );
			QTextStream outf( &confnew );
			while( !inf.eof() ){
				QString str( inf.readLine() );				

				if( (str[0] == '#') ||( (index=str.find( sSearch )) < 0) ){

  					outf << str << endl;
				}
				else {
						QChar ch;
							if (index >0)
              {

                ch = str[index-1];
								if ((ch.latin1() != '\t') && (!ch.isSpace()))
                {
									outf << str << endl;
/*									#ifdef GBLI_DEVEL
											printf("else: if ((ch!=' ') || (ch != '\t'))\n");
											printf("Code of str[index-1] %d\n",(int)((char)ch));
											printf("Written str: %s\n",str.latin1());
									#endif
*/
									continue;
								}

							}
						QString sModString;


						int iItemLen = sSearch.length();
						ch = str[index + iItemLen];

						if (ch.latin1()== ' '
							|| ch.latin1()== '='
							||ch.latin1()=='\t')
						{
//							Log::logMain( 32, " Passed Inside %s\n", sSearch.latin1() );
/*									#ifdef GBLI_DEVEL
											printf("It looks like our string!\n");
									#endif
*/
						}
				    else
						{ //tipa unknown sintax :^|
/*  								#ifdef GBLI_DEVEL
											printf("tipa unknown sintax\n");
											printf("Written str: %s\n",str.latin1());
									#endif
*/

							outf << str << endl;
							continue;
						}
						  //it looks like a shit

            UpdateString (&sModString, str, sSearch, sRepValue/*,iMode*/);

/*						#ifdef GBLI_DEVEL
							printf("UpdateString (&sModString, str, sSearch, sRepValue); %s %s %s %s \n",sModString.latin1(), str.latin1(), sSearch.latin1(), sRepValue.latin1());
						#endif
*/

  					//sModString.sprintf ("%s=%s", sSearch.latin1() , sRepValue.latin1());
//            Log::logMain( 32, " Modified string is =  %s\n", sModString.ascii() );
						outf << sModString << endl;
						
				}
			}			
			confnew.close();
		}
		confold.close();
		confold.remove();
	} else {
				return false;
	}
	return true;
}




// AA: Search strings in file and replace it to value
bool ConfigFile::search_and_replace( QString sSearch, QString sRepValue ){
//Check that file exist
	QFile file( path );
	if ( !file.exists() ) return false;

	::rename( path.ascii(), (path + "_old").ascii() );
	QFile confold( path + "_old" );
	QFile confnew( path );

	if( confold.open( IO_ReadOnly ) ){
		if( confnew.open( IO_WriteOnly ) ){
			QTextStream inf( &confold );
			QTextStream outf( &confnew );
			while( !inf.eof() ){
				QString str( inf.readLine() );				
				if( str.find( sSearch ) < 0 )
  					outf << str << endl;
				else {
						QString sModString;
						sModString = str;
						int iFindPos = sModString.find( sSearch );
						while( iFindPos >= 0 ) {
							sModString.remove( iFindPos, sSearch.length() );
							sModString = sModString.insert( iFindPos, sRepValue );
							iFindPos = sModString.find( sSearch );
						}
						outf << sModString << endl;
						
				}
			}			
			confnew.close();
		}
		confold.close();
		confold.remove();
	} else {
	return false;
	}
	return true;
}
//test for consistency

//modified by YP: open new file if old was not found
bool ConfigFile::replaceLine( QString sSearch, QString sReplace, bool append)
{
	rename( path.ascii(), (path + ".old").ascii() );
	QFile	oldFile( path + ".old" );
	QFile	newFile( path );

	bool	found = false;

	if( newFile.open( IO_WriteOnly ) ){
			QTextStream outf( &newFile );
 	if( oldFile.open( IO_ReadOnly ) ){
		QTextStream inf( &oldFile );
	
			while( !inf.eof() )
			{
				QString str( inf.readLine() );
				QString orig = str;
				// Skip comments
				if (str.find('#', 0) != -1)
					str = str.left(str.find('#', 0));
				if( str.find( sSearch, 0, FALSE ) == -1 )
  				outf << orig << endl;
				else
				{
					outf << sReplace << endl;
					found = true;
				}
			}//while
				oldFile.close();
				oldFile.remove();		

    } //if old
			if (append && !found)
				outf << sReplace << endl;
  			newFile.close();
	}
	else
	return false;

	return true;
}
/*
YP:
bool ConfigFile::replaceLineWithRet(const QString& sSearch,const QString& sReplace, bool append)

Function returns from search if pattern was found and replace it by new one.
It pattern was not found, then new pattern is appended to the end of file
*/

bool ConfigFile::replaceLineWithRet(const QString& sSearch,const QString& sReplace, bool append)
{
	rename( path.ascii(), (path + ".old").ascii() );
	QFile	oldFile( path + ".old" );
	QFile	newFile( path );

	bool	found = false;

	if( newFile.open( IO_WriteOnly ) ){
			QTextStream outf( &newFile );
 	if( oldFile.open( IO_ReadOnly ) ){
		QTextStream inf( &oldFile );
	
			while( !inf.eof() )
			{
				QString str( inf.readLine() );
				QString orig = str;
				// Skip comments
				if (str.find('#', 0) != -1) str = str.left(str.find('#', 0));
				if( str.find( sSearch, 0, FALSE ) == -1 )
  				outf << orig << endl;
				else
				{
					if (!found){
						outf << sReplace << endl;
						found = true;
					}

				}
			}//while
				oldFile.close();
				oldFile.remove();		

    } //if old
			if (append && !found)
				outf << sReplace << endl;
  			newFile.close();
	}
	else
	return false;

	return true;
}


/*
This is Serg's modified version of replaceLine
TASK of function

Add line(record) to config file (pap-secrets),if we have line
with already used login,then replace it.

//can be used for removing old data, of sReplace is empty string

*/


bool ConfigFile::replaceChapPapSecretsLine(const QString &sSearch,const QString &sReplace)
{
	QFile	oldFile( path + ".old");
	QFile	newFile( path );
	QString str,orig;
	char tmpStr[1024]; //should be enough for login
										 //in most cases

	rename( path.ascii(), (path + ".old").ascii() );

	if( newFile.open( IO_WriteOnly ) ){
			QTextStream outf( &newFile );

			if( oldFile.open( IO_ReadOnly ) ){
				QTextStream inf( &oldFile );
				while( !inf.atEnd() ){

				orig = inf.readLine();

				//parsing: get first substring
				//put limitation on string

				if (sscanf( orig.latin1(),"%1023s",tmpStr)==1){
				//protection against overflow
					 str = tmpStr;
//DISABLE COMMENT	         if (str.find('#', 0) == -1){
							if  (str.compare(sSearch)==0) continue;									
									//full equality,delete line					
//DISABLE COMMENT					 } //comment not found 					

				}//if string extracted
        //copy data,this string is not interesting
       outf << orig << endl;

		  }//while
	 		oldFile.close();	
			oldFile.remove();		

    } //end of if old			
			if (!sReplace.isEmpty()) outf << sReplace << endl;
			newFile.close();
			return true;

  } //end of if new
	return false;
}
/*
function find record by login ,and returns password value to sPasswd
*/
bool ConfigFile::getChapPapSecretsPasswd(const QString &sLogin, QString &sPasswd)
{
	QFile	oldFile( path );
	QString str,orig;
	char fakeStr[1024],tmpStr2[1024],tmpStr[1024];
	//should be enough for login and passwd
		
		if( oldFile.open( IO_ReadOnly ) ){
				QTextStream inf( &oldFile );
				while( !inf.atEnd() ){

				orig = inf.readLine();

				//parsing: get 3rd substring
				//put limitation on string

				if (sscanf( orig.latin1(),"%1023s%1023s%1023s",tmpStr,fakeStr,tmpStr2)==3){
				//protection against overflow
					 str = tmpStr;
//DISABLE COMMENT	         if (str.find('#', 0) == -1){
							if  (str.compare(sLogin)==0){
								//we found ,what we need
								sPasswd = tmpStr2;
								return true;									
							}
									//full equality					
//DISABLE COMMENT					 } //comment not found 					

				}//if string extracted
		  }//while
	 		oldFile.close();	
    } //end of if old			

	return false;
}



bool ConfigFile::SetMode(QString &qsStr) //for example"600"
{
if (system(("chmod "+qsStr+" "+path).latin1())==0) return true;
else return false;
}
