/***************************************************************************
                               configfile.h
                             -------------------                                         
    begin                : Thu Nov 11 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIGFILE_H
#define CONFIGFILE_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <qstring.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>

#include "qfile.h"
#include "qtextstream.h"
#include "qstring.h"
#include "config.h"
/**
  *@author Anton Safonov (Maddy)
  */
#define CF_USUAL 0
#define CF_DHCP	 1


class ConfigFile {
public:
    ConfigFile( const char *root, const char *path );
    ConfigFile( const QString &root, const QString &path )
    {
			ConfigFile( root.ascii(), path.ascii() );
		};
    ~ConfigFile();

    FILE *open( const char *mode );
    bool	load();
    bool	save();
    bool	append(const char *);
		// AA: Search strings in file and replace it to value
    bool search_and_replace( QString sSearch, QString sRepValue );
		bool search_and_replace_new ( QString sSearch, QString sRepValue /*,int iMode */);
		// Serg_ : Search string in file and replace whole line with new line
		bool replaceLine( QString sSearch, QString sReplace, bool append);
		// YP
		bool replaceLineWithRet(const QString& sSearch,const QString& sReplace, bool append);
		//should have special code to work with pap-secrets,replacing records
		//if we have line with pattern,then replace new line instead
		//in another case ,append record
		bool replaceChapPapSecretsLine(const QString &sSearch,const QString &sReplace);	
		bool getChapPapSecretsPasswd( const QString &sLogin, QString  &sPasswd);
		bool SetMode(QString  &qsStr);
//		bool CreateEmpty();	
		
protected:
    bool	mkdirp(QString);

protected:
    QString	path;
    char **	data;
    int		count;
};

#endif




