/***************************************************************************
                          diskpartitioner.h  -  description                              
                             -------------------                                         
    begin                : Mon Dec 20 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		 : Anton Safonov (Maddy)                                         
    author email         : as@bestlinux.net                                          
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef DISKPARTITIONER_H
#define DISKPARTITIONER_H

#include "config.h"
#include "gblipage.h"
#include "partitionview.h"

#include <qwidget.h>
#include <qpushbutton.h>

class DiskPartitioner : public GBLIPage {
    Q_OBJECT
public:
    DiskPartitioner( QWidget *parent=0, const char *name=0 );
    ~DiskPartitioner();

    // The partition view may be used outside the disk partitioner to
    // provide easy access to the partition tables.
    PartitionView* getView();
		QPushButton	*writeButton;

public slots:
		void finish() {}
		
signals:
    void nextEnabled(QWidget*, bool);
    void changePartitionTable();

protected:
    void showEvent( QShowEvent * );

private slots:
    void writeEnabled(bool);

private:
    PartitionView* view;
		QPushButton *btnReset;
};

#endif

