/***************************************************************************
                               etcfiles.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "etcfiles.h"

#include "mouse.h"
#include "lvideomodeselector.h"
#include "lvideocard.h"
#include "lmonitor.h"
#include "keyboard.h"
#include "ltemplate.h"
#include "log.h"
#include "fdisk.h"
#include "mountpoint.h"

#include <math.h>
#include <time.h>

#include <qdir.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qstrlist.h>
#include <qregexp.h>

#define __USE_XOPEN
#include <unistd.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <stdlib.h>
#include <stdio.h>

#include <qdatetime.h>

#include "config.h"
#include "network.h"
#include "language.h"
#include "sysconfigfile.h"
#include "xserver.h"

static char     KeyChars[33];

EtcFiles::EtcFiles( const QString &a_userLogin ): KDE_PATH( "/opt/kde2" )
{
    userLogin = a_userLogin;
//    Log::logMain( 33, "userLogin = %s", userLogin.ascii() );
		gettimeofday( &time1, NULL );

    // Initialize BLED key chars
    memset(KeyChars, 0, sizeof(KeyChars));
    for (int i=0; i < 26; i++)
        KeyChars[i] = i + 'A';

    for (int i=1; i < 7; i++)
        KeyChars[25+i] = i + '0';
}


QString today( const int offset = 0 )
{
  QString r;
  QTextStream result(r, IO_WriteOnly);
  result << (int)( time(0L)/86400 + offset );
  return r;
}


static char mksalt( int seed )
{
    int num = seed % 64;

    if (num < 26)
			return 'a' + num;
    else if (num < 52)
			return 'A' + (num - 26);
    else if (num < 62)
			return '0' + (num - 52);
    else if (num == 63)
			return '.';
    else
			return '/';
}

int EtcFiles::copy( const char* a_src, const char *a_dest )
{	
	return 0;
}

// Function to use in BLED key checking
QString bin2str(char* bin_buf)
{
    QString     result = "";

    if (!bin_buf) return QString("");
    for (int i=0; i < 16; i++)
    {
        unsigned char   ch = 0;
        for (int j=0; j < 4; j++)
        {
            if (bin_buf[i*4+j] == 1)
                ch = ch | (1 << j);
        }
        result += ch + '0';
    }

    return result;
}

bool EtcFiles::checkKey( const char* key ){
	return true;
}

char *EtcFiles::genKey(){
	return NULL;
}

void EtcFiles::writePasswds(
					const QString & userName,
          const QString & userP,
				  const QString & rootPassword )
{
  struct timeval time2;
  char salt[3];
  char cmd[200];
	int pid;

	gettimeofday( &time2, NULL );

	salt[0] = mksalt( time1.tv_usec );
	salt[1] = mksalt( time2.tv_usec );
	salt[2] = '\0';

	enableShadow();

Log::logMain( 32, "user in passwd	- %s", userLogin.ascii() );
	
  sprintf( cmd, "/usr/sbin/groupadd -g 501 %s", userLogin.ascii() );
	char rootPath[16];
	::strcpy( rootPath, NEWROOT.ascii() );
  if( !(pid = ::fork()) ) {
		::chroot( rootPath );
		::chdir("/");

		::system( cmd );
		::exit( -1 );		
  }
Log::logMain( 34, "writePasswdStuff1 pid: %d\n", pid );
  waitpid(pid, NULL, 0);

  sprintf( cmd, "/usr/sbin/useradd -c \'%s\' -m -n -s /bin/bash -g 501 -G users %s", userName.ascii(), userLogin.ascii() );

  if( !(pid = fork()) ) {
		::chroot( rootPath );
		::chdir("/");

		::system( cmd );
		::exit( -1 );
  }
//Log::logMain( 34, "writePasswdStuff2 pid: %d\n", pid );
  waitpid(pid, NULL, 0);

  QFile shadowFile( NEWROOT + "/etc/shadow" );
  QFile newShadowFile( NEWROOT + "/etc/shadow.new" );
	if( shadowFile.open( IO_ReadOnly ) && newShadowFile.open( IO_WriteOnly ) ){
  	::fchmod( shadowFile.handle(), 0600 );
  	QTextStream shadow( &shadowFile );
  	QTextStream newShadow( &newShadowFile );
		QString temp;
		while( (temp = shadow.readLine()).length() ){
			if( temp.left( 5 ) == "root:" ){
			  // strange, but if you make latin1() here, then it stops working ;(
		  	newShadow << "root:" << ::crypt( rootPassword, salt ) << ":" << today() << ":0:99999:14:-1:-1:\n";
			}else if( temp.left( userLogin.length()+1 ) == (userLogin + ":") ){
				gettimeofday( &time2, NULL );
				salt[1] = mksalt( time2.tv_usec + 375 );
		    newShadow << userLogin << ":" << ::crypt( userP, salt )
	  		 << ":" << today() << ":0:99999:14:-1:-1:\n";
			}else
				newShadow << temp << endl;
		}
		shadowFile.close();
		newShadowFile.close();
		::sync();

		QString strPath = NEWROOT +"/etc/shadow";
    ::unlink( strPath.ascii() );
		::rename( (strPath +".new").ascii(), strPath.ascii() );
		::sync();
	}
  ::sync();
Log::logMain( 34, "finished passwd stuff" );
}

void EtcFiles::writeWindowsBat(){
	QString winDr = Fdisk::winDrive;
	QString rootDrive = MountPoints::mountPartition( "/" );

	if( rootDrive.length() && winDr.length() ){
		QString mpt = MountPoints::mountPoint( winDr );

		if( mpt == QString::null || !mpt.length() ){
			mpt = "/mnt/tmp";
			system( ("mount "+ winDr +" "+ mpt).ascii() );
		}
		else mpt = NEWROOT + mpt;
		//system( "mkdir -p -m0755 "+ mpt +"/BL" );
		
	  QFile outf( mpt +"/BL/boot.bat" );
	  if ( outf.exists() )
	  {
		if( outf.open( IO_WriteOnly ) ){
  		::fchmod( outf.handle(), 0755 );
	  	QTextStream outt( &outf );
			outt << "@echo off\r\nsmartdrv /C\r\n";
			outt << "loadlin vmlinuz root=" << rootDrive << " 5\r\n";
			outf.close();

			// remove windows configuration file and initrd
			system( ("rm -f "+ mpt +"/BL/linux.cfg >/dev/null 2>&1").ascii() );
			system( ("rm -f "+ mpt +"/BL/initrd >/dev/null 2>&1").ascii() );

    	char buf[32];
    	int iPathLen = readlink( (NEWROOT +"/boot/vmlinuz").ascii(), buf, 32 );
    	if( iPathLen != -1 ){
				buf[iPathLen] = 0;
				system( ("cp -a "+ NEWROOT +"/boot/"+ buf +" "+ mpt +"/BL/vmlinuz >/dev/null 2>&1").ascii() );
				
				// TODO: initrd should be copied also to get SCSI support,
				// but problem with name
			}
		}
		}
		if( mpt == "/mnt/tmp" )
			system( ("umount "+ winDr).ascii() );
	}
}

void EtcFiles::writeUserConfig()
{
	if( !QDir( NEWROOT + KDE_PATH ).exists() )
		KDE_PATH = "/usr";
	Log::logMain( 38, "KDE_PATH: %s\n", KDE_PATH.ascii() );
	if( !QDir( NEWROOT + KDE_PATH +"/share/config" ).exists() )
		return; // ;-(

	system( ("mkdir -p "+ NEWROOT +"/home/"+ userLogin +"/.kde/share/config/ >/dev/null 2>&1").ascii() );
	system( ("mkdir -p "+ NEWROOT +"/root/.kde/share/config/ >/dev/null 2>&1").ascii() );
//	system( ("chown "+ userLogin +"."+ userLogin +" -R "+ NEWROOT +"/home/"+ userLogin +"/.kde").ascii() );

	if( *Language::lang->key != "C" && *Language::lang->key != "en" ){
	  writeKdeLocales();
		writeKikbd();
  }
//  writeKvt();
  writeKdmrc();
  writeScreenSaver();

	if( !QDir( NEWROOT +"/home/"+ userLogin +"/Desktop" ).exists() )
		system( ("mkdir -m0770 "+ NEWROOT +"/home/"+ userLogin +"/Desktop").ascii() );
	system( ("cp -af "+ NEWROOT +"/root/Desktop/?: "+ NEWROOT +"/home/"+ userLogin +"/Desktop/ >/dev/null 2>&1").ascii() );

  // chown/chmod all configurations
	char cmd[192];
	sprintf( cmd, "chroot %s bash -c \"chown %s.%s -R /home/%s/.kde /home/%s/.kderc\"",
		NEWROOT.ascii(), userLogin.ascii(), userLogin.ascii(), userLogin.ascii(), userLogin.ascii() );
  system( cmd );
	sprintf( cmd, "chroot %s bash -c \"chmod u+rw -R /home/%s/.kde /home/%s/.kderc\"",
		NEWROOT.ascii(), userLogin.ascii(), userLogin.ascii() );
  system( cmd );
	sprintf( cmd, "chroot %s bash -c \"chmod o-rwx -R /home/%s\"",
		NEWROOT.ascii(), userLogin.ascii() );
  system( cmd );
	sprintf( cmd, "chroot %s bash -c \"chown %s.%s -R /home/%s/Desktop\"",
		NEWROOT.ascii(), userLogin.ascii(), userLogin.ascii(), userLogin.ascii() );
  system( cmd );
}
  	
void EtcFiles::writeKdeLocales()
{  	
#ifdef OLD_KDE
  	char buf[128];
  	sprintf( buf, "/home/%s/.kderc", userLogin.ascii() );
  	system( ("touch "+ NEWROOT +buf).ascii() );
    SysConfigFile sysconfig( NEWROOT.ascii(), buf );
    sysconfig.load();
  	sprintf( buf, "%s:C:C", Language::lang->key->ascii() );
    sysconfig.set( "Language", buf, false );
    sysconfig.save();
  	
  	// set up right charset for user desktop
  	setupRightCharset( QString( NEWROOT + buf ) );

  	// .kderc for root seems to be quite clean;
  	// may be set up fonts also?
    SysConfigFile sysconfig1( NEWROOT.ascii(), "/root/.kderc" );
    sysconfig1.load();
  	sprintf( buf, "%s:C:C", Language::lang->key->ascii() );
    sysconfig1.set( "Language", buf, false );
    sysconfig1.save();
#else
  	ConfigFile config = ConfigFile( NEWROOT.ascii(), "/root/.kde/share/config/kdeglobals" );
   	FILE *fp = config.open( "a" );
    if( fp ){
	
			fprintf ( fp, "\n" );
			fprintf ( fp, "[General]\n" );
			fprintf ( fp, "fixed=adobe-helvetica,10,5,%s,50,0\n", Language::lang->sKDEFont->ascii() );
			fprintf ( fp, "fixedCharset=%s\n", Language::lang->charset->ascii() );

			fprintf ( fp, "font=adobe-helvetica,12,5,%s,50,0\n", Language::lang->sKDEFont->ascii() );
			fprintf ( fp, "fontCharset=%s\n", Language::lang->charset->ascii() );

			fprintf ( fp, "menuFont=adobe-helvetica,12,5,%s,50,0\n", Language::lang->sKDEFont->ascii() );
			fprintf ( fp, "menuFontCharset=%s\n", Language::lang->charset->ascii() );

			fprintf ( fp, "taskbarFont=adobe-helvetica,11,5,%s,50,0\n", Language::lang->sKDEFont->ascii() );
			fprintf ( fp, "taskbarFontCharset=%s\n", Language::lang->charset->ascii() );

			fprintf ( fp, "toolBarFont=adobe-helvetica,12,5,%s,50,0\n", Language::lang->sKDEFont->ascii() );
			fprintf ( fp, "toolBarFontCharset=%s\n", Language::lang->charset->ascii() );

			fprintf ( fp, "\n" );
  		fprintf( fp, "[Locale]\n" );

			fprintf( fp, "Charset=%s\n", Language::lang->charset->ascii() );
			if( *Language::lang->key == "sv" )
				fprintf( fp, "Country=se\n" );
			else if( *Language::lang->key == "et" )
				fprintf( fp, "Country=ee\n" );
			else if( *Language::lang->key == "da" )
				fprintf( fp, "Country=dk\n" );
			else if( *Language::lang->key == "uk" || *Language::lang->key == "uk_UA" )
				fprintf( fp, "Country=ua\n" );
			else if( *Language::lang->key == "pt_BR" )
				fprintf( fp, "Country=pt\n" );
			else
				fprintf( fp, "Country=%s\n", Language::lang->key->ascii() );

			fprintf( fp, "Language=%s\n", Language::lang->key->ascii() );

			fprintf( fp, "\n[WM]\n");
			fprintf( fp, "activeFont=adobe-helvetica,12,5,%s,75,0\n", Language::lang->sKDEFont->ascii() );
			fprintf( fp, "activeFontCharset=%s\n", Language::lang->charset->ascii() );

  		fclose( fp );
			system( ("cp -a "+ NEWROOT +"/root/.kde/share/config/kdeglobals "+
				NEWROOT +"/home/"+ userLogin +"/.kde/share/config/").ascii() );
			system( ("cp -a "+ NEWROOT +"/root/.kde/share/config/kdeglobals "+
				NEWROOT +"/etc/skel/.kde/share/config/").ascii() );
  	}
#endif

}

void EtcFiles::writeScreenSaver(){
	char cmd[256];

#ifdef OLD_KDE
	sprintf( cmd, "cp %s/templates/kssrc %s/templates/kswarm.kssrc %s/templates/kcmdisplayrc %s/home/%s/.kde/share/config/",
		GBLI_DATA_PATH, GBLI_DATA_PATH, GBLI_DATA_PATH, NEWROOT.ascii(), userLogin.ascii() );
  system( cmd );
	sprintf( cmd, "cp %s/templates/kssrc %s/templates/kswarm.kssrc %s/templates/kcmdisplayrc %s/root/.kde/share/config/",
		GBLI_DATA_PATH, GBLI_DATA_PATH, GBLI_DATA_PATH, NEWROOT.ascii() );
#endif

	sprintf( cmd, "cp %s/templates/kswarm.kssrc %s/home/%s/.kde/share/config/",
		GBLI_DATA_PATH, NEWROOT.ascii(), userLogin.ascii() );
  system( cmd );
	sprintf( cmd, "cp %s/templates/kswarm.kssrc %s/root/.kde/share/config/",
		GBLI_DATA_PATH, NEWROOT.ascii() );
  system( cmd );

 	FILE *fp = fopen( (NEWROOT + "/root/.kde/share/config/kdesktoprc").ascii(), "a" );
 	if( fp ){
  		fprintf( fp, "[ScreenSaver]\nEnabled=true\nLock=true\nPriority=19\nSaver=KSwarm.desktop\nTimeout=600\n" );
  		fclose( fp );
	}
	sprintf( cmd, "cp %s/root/.kde/share/config/kdesktoprc %s/home/%s/.kde/share/config/",
		NEWROOT.ascii(), NEWROOT.ascii(), userLogin.ascii() );
  system( cmd );
}
  	
void EtcFiles::writeKvt()
{  	
  QString name;
	if( *Language::lang->key != "ru" )
	  name = "kvtrc.std";
	else
	  name = "kvtrc.koi8r";

	char cmd[128];
	sprintf( cmd, "cp %s/templates/%s %s/home/%s/.kde/share/config/kvtrc", GBLI_DATA_PATH, name.ascii(), NEWROOT.ascii(), userLogin.ascii() );
  system( cmd );

	sprintf( cmd, "mkdir -p -m0751 %s/root/.kde/share/config/", NEWROOT.ascii() );
  system( cmd );
	sprintf( cmd, "cp %s/templates/%s %s/root/.kde/share/config/kvtrc", GBLI_DATA_PATH, name.ascii(), NEWROOT.ascii() );
  system( cmd );

}
  	
void EtcFiles::writeKdmrc()
{  	

#ifdef OLD_KDE  	

	char cmd[128];
	sprintf( cmd, "cp -f %s/templates/kdmrc %s/home/%s/.kde/share/config/kdmrc", GBLI_DATA_PATH, NEWROOT.ascii(), userLogin.ascii() );
  system( cmd );
	sprintf( cmd, "mkdir -p -m0751 %s/root/.kde/share/config/", NEWROOT.ascii() );
  system( cmd );
	sprintf( cmd, "cp -f %s/templates/kdmrc %s/root/.kde/share/config/kdmrc", GBLI_DATA_PATH, NEWROOT.ascii() );
  system( cmd );

#else

	FILE *fp = fopen( (NEWROOT + "/etc/X11/xdm/kdmrc").ascii(), "a" );
	if( fp )
	{
		fprintf ( fp, "[X-*-Greeter]\n" );
		fprintf ( fp, "Language=%s\n", Language::lang->key->ascii() );

		if( *Language::lang->key == "ru" )
		{
			fprintf ( fp, "GreetFont=charter,24,5,16,50,0\n" );
			fprintf ( fp, "StdFont=helvetica,14,5,16,50,0\n" );
			fprintf ( fp, "FailFont=helvetica,14,5,16,75,0\n" );
		}
		if( *Language::lang->key == "fi" )
		{
			fprintf ( fp, "GreetFont=charter,24,5,2,50,0\n" );
			fprintf ( fp, "StdFont=helvetica,14,5,2,50,0\n" );
			fprintf ( fp, "FailFont=helvetica,14,5,2,75,0\n" );
		}
		if( *Language::lang->key == "sv" )
		{
			fprintf ( fp, "GreetFont=charter,24,5,0,50,0\n" );
			fprintf ( fp, "StdFont=helvetica,14,5,0,50,0\n" );
			fprintf ( fp, "FailFont=helvetica,14,5,0,75,0\n" );
		}

		fclose( fp );
	}
	else
	  Log::logMain( 32, "Failed to open %s ;(", (NEWROOT + "/etc/X11/xdm/kdmrc").ascii() );

#endif


/*	system( ("cp -f "+ NEWROOT + KDE_PATH +"/share/config/kdmrc "+ NEWROOT +"/root/.kde/share/config/").ascii() );

if( *Language::lang->key != "C" && *Language::lang->key != "en" )
{
	FILE *fp = fopen( (NEWROOT + "/etc/X11/xdm/kdmrc").ascii(), "a" );
	if( fp ){
		fprintf( fp, "[Locale]\nLanguage=%s\n", Language::lang->key->ascii() );
		fprintf( fp, "Charset=%s\n", Language::lang->charset->ascii() );
		char tmp[8];
		if( !strcmp( Language::lang->key->ascii(), "sv" ) )
			strcpy( tmp, "se" );
		else
			strcpy( tmp, Language::lang->key->ascii() );
		fprintf( fp, "Country=%s\n", tmp );
		fprintf( fp, "Numbers=%s\n", tmp );
		fprintf( fp, "Time=%s\n", tmp );
		fprintf( fp, "Money=%s\n", tmp );
		fclose( fp );
	}else
	  Log::logMain( 32, "Failed to open %s ;(", (NEWROOT + KDE_PATH +"/share/config/kdmrc").ascii() );

	// set charsets for login screen
	setupRightCharset( QString( NEWROOT + "/root/.kde/share/config/kdmrc" ) );
}

	system( ("cp -f "+ NEWROOT +"/root/.kde/share/config/kdmrc "+
		NEWROOT +"/home/"+ userLogin +"/.kde/share/config/").ascii() );*/

}

void EtcFiles::writeKikbd()
{  	
	if( !Language::lang->kimap->length() ) return;

	QString	ifKDE = NEWROOT + "/root/.kderc";
	if ( !QFileInfo ( ifKDE ).exists() )
		return;

	QString	kxkbrcRoot = NEWROOT + "/root/.kde/share/config/kxkbrc";
	SysConfigFile	confKxkbdrc ( "/", kxkbrcRoot );
	confKxkbdrc.load();

//	Allready checked in writeUserConfig. BP
//	if ( *Language::lang->key != "en" )
//	{
		confKxkbdrc.set ( "Additional", *Language::lang->key, false );
		confKxkbdrc.set ( "AdditionalEncodings", *Language::lang->charset, false );
		confKxkbdrc.save();
//	}

//	Copy to everywhere
	system ( ( "cp -af " + kxkbrcRoot + " " + NEWROOT + "/etc/skel/.kde/share/config/").ascii() );
	system ( ( "cp -af " + kxkbrcRoot + " " + NEWROOT + "/home/" + userLogin + "/.kde/share/config/").ascii() );



//  if( !Language::lang->kimap->length() ) return;
//
//  QString kikbdSrc = KDE_PATH +"/share/config/kikbdrc";
//	if( !QFileInfo( NEWROOT + kikbdSrc ).exists() ){
//	  Log::logMain( 2, "No src file %s... ;(", kikbdSrc.ascii() );
//	  return;
//	}
//	QString kikbdDest = "/home/"+ userLogin +"/.kde/share/config/kikbdrc";
//	
//	system( ("cp -af "+ NEWROOT + kikbdSrc +" "+ NEWROOT + kikbdDest).ascii() );
//  SysConfigFile sysconfig3( NEWROOT.ascii(), kikbdDest );
//  sysconfig3.load();
//  if( QFile( NEWROOT +"/usr/share/fonts/winfonts/fonts.dir" ).exists() && *Language::lang->key == "ru" ){
//  	sysconfig3.set( "Map1", "ruw", false );
//  	sysconfig3.set( "Map2", Language::lang->kimap->ascii(), false );  	
//  	sysconfig3.set( "Map3", "", false );
//  }else{
//  	sysconfig3.set( "Map1", Language::lang->kimap->ascii(), false );
//  	sysconfig3.set( "Map2", "", false );
//  }
//	sysconfig3.set( "AutoStart", "true", false );
//	sysconfig3.set( "Docking", "true", false );
//	sysconfig3.set( "Switch", "Shift_L+Shift_R", false );
//	sysconfig3.set( "AltSwitch", "Control_R", false );
//  sysconfig3.save();
//
//  // change charset
//	setupRightCharset( QString( NEWROOT + kikbdDest ) );
//
//	system( ("chmod u+rw "+ NEWROOT + kikbdDest).ascii() );
//	
//	// copy it to root also
//	system( ("cp -af "+ NEWROOT + kikbdDest +" "+ NEWROOT +"/root/.kde/share/config/").ascii() );
}

void EtcFiles::setupRightCharset( const QString &a_strFileName )
{
	QFile file( a_strFileName );
	char databuf[2048];
	memset( databuf, 0, sizeof( databuf ) );
	if( file.open( IO_ReadOnly ) ){
		file.readBlock( databuf, sizeof( databuf ) );
		file.close();
	}
	QString configData = QString::fromLatin1( databuf );
	QString subst( *Language::lang->charset );
#ifndef OLD_KDE
	if( subst.find( "koi" ) >= 0 )
		subst = "16"; // magic here - koi8 list number. Maddy.
	else
		subst = "0"; // default
#endif
	substituteCharset( configData, QString("iso8859-1"), subst );
	substituteCharset( configData, QString("iso-8859-1"), subst );
	if( file.open( IO_WriteOnly ) ){
		file.writeBlock( configData.ascii(), configData.length() );
		file.close();
	}
}

void EtcFiles::substituteCharset( QString &a_str, const QString &oldOne, const QString &newOne )
{
	int pos = 0;
	int len = oldOne.length();
	int count = 1000;
	while( (pos = a_str.find( oldOne, pos )) >= 0 && count-- > 0 ){
		a_str.remove( pos, len );
		a_str.insert( pos, newOne );
		pos++;
	}
}

void EtcFiles::enableShadow()
{
	int pid = ::fork();
	if( !pid ){
		ConfigFile config( NEWROOT.ascii(), "/etc/sysconfig/network" );
  	FILE *fp = config.open( "a" );
    if( fp )
			fclose( fp );

		::chroot( NEWROOT.ascii() );
		::execlp( "authconfig", "authconfig",
			"--kickstart", "--nostart", "--enablemd5", "--useshadow", 0 );
		::exit( -1 );
	}
	::waitpid( pid, NULL, 0 );
	pid = 0;
}

void EtcFiles::writeX4Config( const QString &dir,
            LVideoCard * card,
			      LMonitor * monitor,
			      LVideoModeSelector * mode,
			      Mouse * mouse,
			      Keyboard * keyboard )
{
  if ( !card || !monitor || !mode || !mouse || !keyboard )
    return;

  QString tpl     ;
//  if (card->defaultVGA16())
//    tpl = QString( GBLI_DATA_PATH ) +"/templates/XF86Config.VGA16";
//  else
    tpl = QString( GBLI_DATA_PATH ) +"/templates/XF86Config.4";

  LTemplate xconfig(tpl);
  QString value;

	if( keyboard ){
	  xconfig.addToken("KEYBOARD_MODEL", keyboard->model());
  	xconfig.addToken("KEYBOARD_LAYOUT", keyboard->xkb());
	}
	if( mouse ){
	  xconfig.addToken("MOUSE_NAME", mouse->getMouseName());
	  xconfig.addToken("MOUSE_LINK", mouse->getPortName());
	}
  xconfig.addToken("MONITOR_VENDOR", monitor->vendorName());
  xconfig.addToken("MONITOR_MODEL", monitor->modelName());
  xconfig.addToken("MONITOR_HSYNC", monitor->horizSync());
  xconfig.addToken("MONITOR_REFRESH", monitor->vertRefresh());
  xconfig.addToken("MODE_NAME", mode->name());
  xconfig.addToken("MODE_LINE", mode->line());
  xconfig.addToken("CARD_CLOCKLINE", card->clockLine());
  value.setNum( (int)(card->memory()/1024) );
  xconfig.addToken("CARD_MEMORY", value);
  value.setNum(mode->defaultColorDepth());
  xconfig.addToken("COLOR_DEPTH", value);

	// switcher by Vladislav <hugevlad@yahoo.com>
	xconfig.addToken("XKB_OPTIONS", "Option \"XkbOptions\"\t\"grp:ctrl_shift_toggle\"" );

	QString serv = card->server();

//  printf("---->Writing card driver: '%s'\n", serv.ascii() );
	if( card->defaultVGA16() ){
	  serv = "vga";
	}else if( serv.left( 2 ) != "XF" ){
		if ((dir == (NEWROOT + "/etc")) && (serv == "nv") && (card->CardName().find("riva128", 0, false) == -1))
		{
			serv = "nvidia";   // select nvidia native driver
		}
  }else{
		serv = serv.right( serv.length() - 5 ).lower();
	}
//  printf("---->Writing card driver: '%s'\n", serv.ascii() );
	xconfig.addToken( "CARD_DRIVER", serv );
	if( serv == "vga" )
	  xconfig.addToken("SCREEN", "VGA16 Screen" );
	else
		xconfig.addToken("SCREEN", "Primary Screen" );

  if (mode->size() != mode->virtualResolution()){
      QString virt = "        Virtual %0 %1";
      xconfig.addToken("VIRTUAL_SIZE", virt.arg((mode->virtualResolution()).width()).arg((mode->virtualResolution()).height()));
  }else
    xconfig.addToken("VIRTUAL_SIZE", "");

//  if (mouse->hasWheel())
    xconfig.addToken( "WHEEL", "Option \"ZAxisMapping\"\t\"4 5\"" );
//  else
//    xconfig.addToken( "WHEEL", "" );

	if( QFile( dir +"/X11/XF86Config" ).exists() )
		system( ("mv -f "+ dir +"/X11/XF86Config "+ dir +"/X11/XF86Config.old").ascii() );
  xconfig.write( dir +"/X11/XF86Config" );
}

void EtcFiles::writeXConfig( const QString &dir,
            LVideoCard * card,
			      LMonitor * monitor,
			      LVideoModeSelector * mode,
			      Mouse * mouse,
			      Keyboard * keyboard )
{
  if ( !card || !monitor || !mode || !mouse || !keyboard )
    return;

  QString tpl     ;
  if (card->defaultVGA16())
    tpl = QString( GBLI_DATA_PATH ) +"/templates/XF86Config.VGA16";
  else
    tpl = QString( GBLI_DATA_PATH ) +"/templates/XF86Config";

  LTemplate xconfig(tpl);
  QString value;

	if( keyboard ){
	  xconfig.addToken("KEYBOARD_MODEL", keyboard->model());
  	xconfig.addToken("KEYBOARD_LAYOUT", keyboard->xkb());
	}
	if( mouse ){
	  xconfig.addToken("MOUSE_NAME", mouse->getMouseName());
	  xconfig.addToken("MOUSE_LINK", mouse->getPortName());
	}
  xconfig.addToken("MONITOR_VENDOR", monitor->vendorName());
  xconfig.addToken("MONITOR_MODEL", monitor->modelName());
  xconfig.addToken("MONITOR_HSYNC", monitor->horizSync());
  xconfig.addToken("MONITOR_REFRESH", monitor->vertRefresh());
  xconfig.addToken("MODE_NAME", mode->name());
  xconfig.addToken("MODE_LINE", mode->line());
  xconfig.addToken("CARD_CLOCKLINE", card->clockLine());
  value.setNum( (int)(card->memory()/1024) );
  xconfig.addToken("CARD_MEMORY", value);
  value.setNum(mode->defaultColorDepth());
  xconfig.addToken("COLOR_DEPTH", value);

  if (mode->size() != mode->virtualResolution()){
      QString virt = "        Virtual %0 %1";
      xconfig.addToken("VIRTUAL_SIZE", virt.arg((mode->virtualResolution()).width()).arg((mode->virtualResolution()).height()));
  }else
    xconfig.addToken("VIRTUAL_SIZE", "");

  if (mouse->emulate3buttons())
    xconfig.addToken("EMULATE3RD", "Emulate3Buttons");
  else
    xconfig.addToken("EMULATE3RD", "");

  if (mouse->hasWheel())
    xconfig.addToken("WHEEL", "ZAxisMapping 4 5");
  else
    xconfig.addToken("WHEEL", "");

  xconfig.write( dir +"/X11/XF86Config" );
}

void EtcFiles::writeEtcConfig()
{
//	if( QFile( "/etc/rc.d/init.d/hdparm" ).exists() ){
//		system( ("cp -af /etc/rc.d/init.d/hdparm "+ NEWROOT +"/etc/rc.d/init.d/").ascii() );
//		system( ("cp -af /etc/rc.d/*hdparm "+ NEWROOT +"/etc/rc.d/rc5.d/").ascii() );
//	}

/*	config = ConfigFile( NEWROOT.ascii(), "/etc/bashrc" );
  fp = config.open( "a" );
	if( fp ){
    fprintf( fp, "alias l=\"ls -lAp --color=auto\"\n" );
    fprintf( fp, "alias ls=\"ls -p --color=auto\"\n" );
		fprintf( fp, "alias less=\"less -r\"\n" );
		fprintf( fp, "alias c=\"cd ..\"\n" );
		fprintf( fp, "alias h=\"history 25|more\"\n" );
		fprintf( fp, "alias k=\"kill\"\n" );
		fprintf( fp, "alias m=\"more\"\n" );
		fprintf( fp, "alias z=\"zmore\"\n" );
		fprintf( fp, "alias grep=\"grep -n\"\n" );
		fprintf( fp, "alias pico=\"pico -w -b -z\"\n" );
		fclose( fp );
	}*/

#ifdef GBLI_SERVER
	// bloody hack
	system( ("cp -af "+ INSTALL_SOURCE +"/software/sources/nokia_c110/nokia_c110_up.o "+ NEWROOT +"/lib/modules/2.4.2-29/pcmcia/nokia_c110.o >/dev/null 2>&1").latin1() );
	system( ("cp -af "+ INSTALL_SOURCE +"/software/sources/nokia_c110/nokia_c110_smp.o "+ NEWROOT +"/lib/modules/2.4.2-29smp/pcmcia/nokia_c110.o >/dev/null 2>&1").latin1() );

	system( ("cat "+    INSTALL_SOURCE +"/software/sources/nokia_c110/scripts/nokia_c110.config >> "+ NEWROOT +"/etc/pcmcia/config").latin1() );
	system( ("cp -af "+ INSTALL_SOURCE +"/software/sources/nokia_c110/scripts/nokia_c110 "+ NEWROOT +"/etc/pcmcia/").latin1() );
	system( ("cp -af "+ INSTALL_SOURCE +"/software/sources/nokia_c110/scripts/nokia_c110.opts "+ NEWROOT +"/etc/pcmcia/").latin1() );
	system( ("cp -af "+ INSTALL_SOURCE +"/software/sources/nokia_c110/scripts/dctl.opts "+ NEWROOT +"/etc/pcmcia/").latin1() );
#endif

	if( !XServer::safe_mode ){
    SysConfigFile sysconfig1( NEWROOT.ascii(), "/etc/sysconfig/harddisks" );
    sysconfig1.load();
    sysconfig1.set( "EXTRA_PARAMS", "-c3 -m2 -u1", true );
    sysconfig1.save();
	}

	QFile outf( NEWROOT +"/etc/rc.d/rc.local" );
	if( outf.open( IO_WriteOnly | IO_Append ) ){
    QTextStream outt( &outf );
		outt << endl << "if [ -f /proc/sys/kernel/lowlatency ] ; then" << endl;
		outt << "\techo \"1\" > /proc/sys/kernel/lowlatency" << endl;
    outt << "fi" << endl;

		//not sure about these two
		outt << endl << "if [ -f /proc/sys/kernel/shmall ] ; then" << endl;
		outt << "\techo \"8388608\" > /proc/sys/kernel/shmall" << endl;
		outt << "\techo \"134217728\" > /proc/sys/kernel/shmmax" << endl;
    outt << "fi" << endl;

		// scsi logging
		outt << endl << "if [ -f /proc/scsi/scsi ] ; then" << endl;
		outt << "\techo \"scsi log error 1\" > /proc/scsi/scsi" << endl;
    outt << "fi" << endl;

		// APM
		outt << endl << "modprobe -qs apm > /dev/null 2>&1" << endl;

		outf.close();
	}

}

void EtcFiles::configureFonts(){
	
// Don't replace xfs config
//	if( *Language::lang->key == "ru" || *Language::lang->key == "uk_UA" || *Language::lang->key == "uk" ){
//  	system( ("cp -af "+ NEWROOT +"/etc/X11/fs/config "+ NEWROOT +"/etc/X11/fs/config.orig").ascii() );
//	  system( ("cp -af "+ QString( GBLI_DATA_PATH ) +"/templates/xfs_config_cyr "+ NEWROOT +"/etc/X11/fs/config").ascii() );
////    system( ("chroot "+ NEWROOT +" chkfontpath -q -a --first /usr/share/fonts/KOI8-R/100dpi").ascii() );
////    system( ("chroot "+ NEWROOT +" chkfontpath -q -a --first /usr/share/fonts/KOI8-R/75dpi").ascii() );
////    system( ("chroot "+ NEWROOT +" chkfontpath -q -a --first /usr/share/fonts/KOI8-R/misc").ascii() );
//  }else{
//  	system( ("cp -af "+ NEWROOT +"/etc/X11/fs/config "+ NEWROOT +"/etc/X11/fs/config.orig").ascii() );
//	  system( ("cp -af "+ QString( GBLI_DATA_PATH ) +"/templates/xfs_config "+ NEWROOT +"/etc/X11/fs/config").ascii() );
////    system( ("chroot "+ NEWROOT +" chkfontpath -q -a /usr/share/fonts/KOI8-R/100dpi").ascii() );
////    system( ("chroot "+ NEWROOT +" chkfontpath -q -a /usr/share/fonts/KOI8-R/75dpi").ascii() );
////    system( ("chroot "+ NEWROOT +" chkfontpath -q -a /usr/share/fonts/KOI8-R/misc").ascii() );
//  }

  QString winpath = NEWROOT + "/usr/share/fonts/winfonts";
  if( QDir( winpath ).exists() ){
    system( ("chmod a-x "+ NEWROOT +"/usr/share/fonts/winfonts/*").ascii() );
    // fonts.dir
    system( ("ttmkfdir -d "+ winpath +" -o "+ winpath +"/fonts.scale").ascii() );
    system( ("mkfontdir "+ winpath ).ascii() );

    system( ("echo -e \"\\n\\n% Fonts from users Microsoft Windows copy\\n\" > "+ winpath +"/Fontmap").ascii() );
    system( ("cp -a /usr/sbin/ttf2pt1 /usr/sbin/ttfontmap /usr/sbin/t1asm "+ NEWROOT +"/usr/sbin").ascii() );
    system( ("chroot "+ NEWROOT +" /usr/bin/perl /usr/sbin/ttfontmap /usr/share/fonts/winfonts/ >> "+ NEWROOT +"/usr/share/fonts/winfonts/Fontmap").ascii() );

    // ghostscript
    // TODO for BL2k1: search for installed version of ghost, not fixed
    QString ghostscript = NEWROOT +"/usr/share/ghostscript/5.50";
    system( ("cp -a "+ ghostscript +"/Fontmap "+ ghostscript +"/Fontmap.prewinfonts").ascii() );
    system( ("cat "+ winpath +"/Fontmap >> "+ ghostscript +"/Fontmap").ascii() );

    // StarOffice
    QString strOffice = NEWROOT + "/opt/Office52/share";
    if( QDir( NEWROOT +"/opt/Office52/" ).exists() ){
      system( ("mkdir -p -m0775 "+ NEWROOT +"/opt/Office52/rus_fonts/fonts/type1").ascii() );
      system( ("mkdir -p -m0775 "+ NEWROOT +"/opt/Office52/rus_fonts/xp3/fontmetrics/afm").ascii() );
      system( ("mkdir -p -m0775 "+ NEWROOT +"/opt/Office52/rus_fonts/xp3/pssoftfonts").ascii() );
      system( ("cp -a "+ winpath +"/*.afm "+ NEWROOT +"/opt/Office52/rus_fonts/xp3/fontmetrics/afm/").ascii() );
      system( ("cp -a "+ winpath +"/*.pfb "+ NEWROOT +"/opt/Office52/rus_fonts/xp3/pssoftfonts/").ascii() );
      system( ("cp -a "+ winpath +"/*.pfb "+ NEWROOT +"/opt/Office52/rus_fonts/fonts/type1/").ascii() );

      system( ("cp -a "+ NEWROOT +"/var/tmp/psstd.fonts.add "+ NEWROOT +"/var/tmp/psstd.fonts.add.prewinfonts").ascii() );

  		QFile psstd( NEWROOT +"/usr/share/fonts/winfonts/fonts.dir" );
  		QFile psstdnew( NEWROOT +"/var/tmp/psstd.fonts.add" );
  		QFile psstdold( NEWROOT +"/var/tmp/psstd.fonts.add.prewinfonts" );
  		
		  if( psstdnew.open( IO_WriteOnly ) ){
  			QTextStream outf( &psstdnew );
  			
    		if( psstdold.open( IO_ReadOnly ) ){
    			QTextStream inf1( &psstdold );
    			while( !inf1.eof() ){
      			QString str( inf1.readLine() );
      			outf << str << endl;
    			}
    			outf << endl; // to check and separate
    			psstdold.close();
    		}
  					  		
    		if( psstd.open( IO_ReadOnly ) ){
    			QTextStream inf( &psstd );
  				QRegExp ttf( "\\.ttf" );
  				QRegExp zeros( "0-0-0-0" );

          if( !inf.eof() ) inf.readLine(); // number of files
  				outf << endl << "# Fonts from users Microsoft Windows" << endl;
  				  				
    			while( !inf.eof() ){
    				QString str( inf.readLine() );
    				if( str.find( "microsoft-cp12" ) < 0 &&
    				    str.find( "koi8-u" ) < 0 &&
    				    str.find( "koi8-r" ) < 0 &&
    				    str.find( "iso8859-" ) < 0 ) continue; // some strange encoding

    				str.replace( ttf, "," );
    				str.replace( zeros, "%d-%d-%d-%d" );
   					outf << str << endl;
    			}			
	  		  psstd.close();
    		}
  			psstdnew.close();
  	  }

// test
//      system( ("cp -a "+ strOffice +"/xp3/fontmetrics/afm/Fontmap"+ strOffice +"/xp3/fontmetrics/afm/Fontmap.prewinfonts").ascii() );
//      system( ("cat "+ winpath +"/Fontmap >> "+ strOffice +"/xp3/fontmetrics/afm/Fontmap").ascii() );
//      system( ("mv "+ winpath +"/*.afm "+ strOffice +"/xp3/fontmetrics/afm/").ascii() );
//      system( ("cp -a "+ winpath +"/*.pfb "+ strOffice +"/xp3/pssoftfonts/").ascii() );
//      system( ("mkdir -p -m0775 "+ strOffice +"/fonts/winfonts").ascii() );
//      system( ("mv "+ winpath +"/*.pfb "+ strOffice +"/fonts/winfonts/").ascii() );
//      system( ("cp -a "+ winpath +"/fonts.* "+ strOffice +"/fonts/winfonts/").ascii() );

      // TODO
//      system( ("cat "+ winpath +"/fonts.dir >> "+ strOffice +"/xp3/psstd.fonts").ascii() );
    }
    system( ("rm -rf "+ NEWROOT +"/usr/sbin/ttf2pt1 "+ NEWROOT
			+"/usr/sbin/ttfontmap "+ NEWROOT +"/usr/sbin/t1asm").latin1() );

    // for BL2k1
    //system( ("chroot "+ NEWROOT +" chkfontpath -q -a --first /usr/share/fonts/winfonts").ascii() );
  }
  	
}

