/***************************************************************************
                                etcfiles.h
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef ETCFILES_H
#define ETCFILES_H

class LVideoCard;
class LMonitor;
class LVideoModeSelector;
class Mouse;
class LUser;
class Keyboard;

#include <qstring.h>
#include <sys/time.h>

// class for saving configs to /etc directories, which are not saved directly
// by other classes
class EtcFiles
{
  public:
    EtcFiles( const QString &a_userLogin );

		// created users and save their passwords
    void writePasswds( const QString &, const QString & , const QString & );

		// save /etc/X11/XF86Config
    void writeXConfig( const QString &dir, LVideoCard *, LMonitor *, LVideoModeSelector *,
		       Mouse *, Keyboard * );
    void writeX4Config( const QString &dir, LVideoCard *, LMonitor *, LVideoModeSelector *,
		       Mouse *, Keyboard * );

		// create bat file on windows partition to run Linux
		void writeWindowsBat();

		// several separate /etc tunings
		void writeEtcConfig();

    // write user and root settings to their .kde directory
		void writeUserConfig();

		static int copy( const char* src, const char *dest );

		// check the key for installing commercial rpm's
		static bool checkKey( const char* key );
		static char *genKey();

		// substitute existing charset by current one in the given file (kde?)
		void setupRightCharset( const QString &a_strFileName );

		// setup font server and convert Windows fonts if available
		void configureFonts();
				
private:
		// enable passwords to be in /etc/shadow and in md5
		void enableShadow();

		// substiture one charset with another in the given string
		void substituteCharset( QString &a_str, const QString &oldOne, const QString &newOne );

		// save kde configs for user and root
		void writeKdeLocales();
		void writeKvt();
		void writeKdmrc();
    void writeKikbd();
    void writeScreenSaver();

    QString userLogin;
    struct timeval time1;

		QString KDE_PATH;
};


#endif








