/***************************************************************************
                               finalpage.cpp
                             -------------------                                         
    begin                : Fri Nov 5 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "config.h"
#include "finalpage.h"
#include "language.h"
#include "log.h"

#include <qlayout.h>
#include <qdir.h>
#include <qstring.h>
#include <qmime.h>
#include <qsocket.h>

#include <stdlib.h>
#include <unistd.h>

FinalPage::FinalPage( QWidget * parent, const char * name )
    : GBLIPage( parent, name )
{
  QVBoxLayout * l  = new QVBoxLayout();
  QHBoxLayout * h = new QHBoxLayout( this );

  someText = new LInlineHelp( this );
	someText->setMinimumWidth( 10 );
	someText->setMaximumWidth( 800 );
//	setDocument( "index.html" );

  l->addSpacing( 10 );
  l->addWidget( someText );
  l->addSpacing( 10 );

  h->addSpacing( 1 );
  h->addLayout( l );
  h->addSpacing( 1 );

}

FinalPage::~FinalPage() {
}

void FinalPage::setDocument( const QString &a_str )
{
	// i tried to implement real Internet browsing,
	// but it is too complex for Qt-2,
	// so now we browse only help files on the CD
	if( true /*a_str == "index.html"*/ ){
  	QString strPath( INSTALL_SOURCE +"/manuals/Manual/" );

		// current language, e.g. en, fi, ru
  	QString strLang = QString( *Language::lang->key );
		// lets try to find manual for current language
    if( !QFile( strPath + strLang +"/"+ a_str ).exists()  &&
    		!QFile( strPath + strLang +"/welcome.html" ).exists() )
  		strLang = "/en";
		// lets try to find manual once more (e.g. if language changed)
		// if not found in language specific directory when it could be also
		// in the root of the manual directory
    if( !QFile( strPath + strLang +"/"+ a_str ).exists()  &&
    		!QFile( strPath + strLang +"/welcome.html" ).exists() )
  		strLang = "";

  	QMimeSourceFactory *mimefuck = (QMimeSourceFactory *)someText->mimeSourceFactory();
    someText->mimeSourceFactory()->setFilePath( QStringList( strPath + strLang ) );
		// setup mime types specific for cyrillic
  	if( strLang == "ru" ){
  		mimefuck->setExtensionType( "html", "text/html;charset=koi8-r");
  		mimefuck->setExtensionType( "htm", "text/html;charset=koi8-r");

  //		someText->mimeSourceFactory()->setExtensionType( "html", "text/html;charset=koi8-r");
  //		someText->mimeSourceFactory()->setExtensionType( "htm", "text/html;charset=koi8-r");
      QFont font( QFont::defaultFont() );
  		font.setFamily( "helvetica" );
  //		font.setPointSize( 28 );
  		font.setCharSet( QFont::KOI8R );
  		someText->viewport()->setFont( font );
  		//koi8-r, KOI8R, KOI8-R, AnyCharSet  ??? which one is right
  	}else{
  		mimefuck->setExtensionType( "html", "text/html;charset=iso8859-1");
  		mimefuck->setExtensionType( "htm", "text/html;charset=iso8859-1");

  //		someText->mimeSourceFactory()->setExtensionType( "html", "text/html;charset=iso8859-1");
  //		someText->mimeSourceFactory()->setExtensionType("htm", "text/html;charset=iso8859-1");
  	}
  	someText->setMimeSourceFactory( mimefuck );
  	QString str;

  	if( !QFile( strPath + strLang +"/"+ a_str ).exists() ){
  		str = "welcome.html";
  	}else
  		str = a_str;

		// lets show if we found at least something
  	if( QFile( strPath + strLang +"/"+ str ).exists() )
  	  someText->setDocument( strPath + strLang +"/"+ str );
	}else{

		// this was a try to read information from the net

return;

//  	QMimeSourceFactory *mimef = (QMimeSourceFactory *)someText->mimeSourceFactory();
//    someText->mimeSourceFactory()->setFilePath( a_str );
//// 		mimef->setExtensionType( "html", "text/html;charset=iso8859-1");
//// 		mimef->setExtensionType( "htm", "text/html;charset=iso8859-1");
//  	someText->setMimeSourceFactory( mimef );
//
// 	  someText->setDocument( a_str );


			QSocket *sock = new QSocket( this, "my spec socket;)" );
			sock->connectToHost( a_str, 80 );

			QString str = "";
			char *buf;

			int iCount = 0;

			while( sock->canReadLine() || sock->state() != QSocket::Idle ){
Log::logMain( 34, "can: %d, state: %d, count: %d      %d\n", sock->canReadLine(), sock->state(), iCount++, QSocket::Idle );
				int ib = sock->bytesAvailable();
				if( ib > 0 ){
//  				buf = (char*)malloc( ib * sizeof(char) + 1 );
  				buf = (char*)new char[ ib * sizeof(char) + 1 ];
  				ib = sock->readLine( buf, ib );
  				str += QString( buf );
  				free( buf );
				}
				sleep( 1 );
				if( iCount > 9999 )
					break;
			}

			QString url = someText->mimeSourceFactory()->makeAbsolute( a_str, someText->context() );
			someText->setText( str, url );
//	 	  someText->setDocument( a_str );
	}
}

