/***************************************************************************
                              installselect.cpp
                             -------------------
    begin                : Sat Oct 29 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "installselect.h"
#include "log.h"
#include "windows.h"
#include "smp.h"
#include "syslog.h"
#include "config.h"
#include "packagelistitem.h"
#include "mountpoint.h"
#include "language.h"

#include "gblidebug.h"

#include <iostream.h>
#include <stdio.h>
#include <qdir.h>
#include <signal.h>
#include <sys/time.h>
#include <unistd.h>
#include <string.h>

#include <qapplication.h>
#include <qwizard.h>

#include "etcfiles.h"

#define TESTCOMMENT

#ifdef GBLI_RPM3
	#define Fseek fdLseek
#endif

#define FILENAME_TAG 1000000
int curTemp;
long curInstalled;

#define isDependsMULTILIB(_dflags)      ((_dflags) & RPMSENSE_MULTILIB)
int log = 0;
/*
void * xrealloc (void *ptr, size_t size);
void * xcalloc (size_t nmemb, size_t size);
char * xstrdup (const char *str);
static int indexcmp(const void * one, const void * two);
static int intcmp(const void * a, const void *b);
*/

// list of commercial rpms, they will be checked and decrypted if needed

#ifdef GBLI_SERVER

char *commercialList[] = {
	"Manual-Server",
	"acroread",
	"acroread-plugin",
	"jdk",
	NULL };

#else

char *commercialList[] = {
	"acroread",
	"acroread-plugin",
	"Manual-Desktop",
	"soto",
	NULL };

#endif



extern QString GBLI_DIR;

bool InstallSelect::keyOK = false;

bool InstallSelect::blUpdate = false;
bool InstallSelect::blUpdateNP = false;

char * skipList[] = { NULL };

/*
struct devnum {
    char * name;
    short major, minor;
    int isChar;
};

static struct devnum devices[] = {
    { "aztcd",		29,	0,	0 },
    { "bpcd",		41,	0,	0 },
    { "cdu31a",		15,	0,	0 },
    { "cdu535",		24,	0,	0 },
    { "cm206cd",	32,	0,	0 },
    { "fd0",     	2,	0,	0 },
    { "fd1",		2,	1,	0 },
    { "gscd",		16,	0,	0 },
    { "lp0",		6,	0,	1 },
    { "lp1",		6,	1,	1 },
    { "lp2",		6,	2,	1 },
    { "mcd",		23,	0,	0 },
    { "mcdx",		20,	0,	0 },
    { "nst0",		9,	128,	1 },
    { "optcd",		17,	0,	0 },
    { "sbpcd",		25,	0,	0 },
    { "scd0",		11,	0,	0 },
    { "scd1",		11,	1,	0 },
    { "sjcd",		18,	0,	0 },
};

int numDevices = sizeof(devices) / sizeof(struct devnum);

static int mkdirIfNone(char * directory) {
    int rc, mkerr;
    char * chptr;

    // If the file exists it *better* be a directory -- I'm not going to
    // actually check or anything
    if (!access(directory, X_OK)) return 0;

    // if the path is '/' we get ENOFILE not found" from mkdir, rather
    // then EEXIST which is weird
    for (chptr = directory; *chptr; chptr++)
      if (*chptr != '/') break;
    if (!*chptr) return 0;

    rc = mkdir(directory, 0755);
    mkerr = errno;

    Log::logMain( 2, "creating directory %s rc = %d", directory, rc );

    if (!rc || mkerr == EEXIST) return 0;

    Log::logMain( 2, "    error: %s", strerror(mkerr) );

    return INST_ERROR;
}

static int mkdirChain(char * origChain) {
    char * chain;
    char * chptr;

    chain = (char *)alloca(strlen(origChain) + 1);
    strcpy(chain, origChain);
    chptr = chain;

    while ((chptr = strchr(chptr, '/'))) {
    	*chptr = '\0';
    	if (mkdirIfNone(chain)) {
    	    *chptr = '/';
    	    return INST_ERROR;
    	}

    	*chptr = '/';
    	chptr++;
    }

    if (mkdirIfNone(chain))
			return INST_ERROR;

    return 0;
}

int devMakeInode(char * name, char * path) {
    int i;
    int major, minor;
    int type;
    char *ptr;
    char *dir;

    if (name[0] == 's' && name[1] == 'd') {
    	type = S_IFBLK;
    	major = 8;
    	minor = (name[2] - 'a') << 4;
    	if (name[3] && name[4])
   	   minor += 10 + (name[4] - '0');
    	else if (name[3])
   	   minor += (name[3] - '0');
    } else if (name[0] == 'h' && name[1] == 'd') {
    	type = S_IFBLK;
    	if (name[2] == 'a')
    	    major = 3, minor = 0;
    	else if (name[2] == 'b')
    	    major = 3, minor = 64;
    	else if (name[2] == 'c')
    	    major = 22, minor = 0;
    	else if (name[2] == 'd')
    	    major = 22, minor = 64;
    	else if (name[2] == 'e')
    	    major = 33, minor = 0;
    	else if (name[2] == 'f')
    	    major = 33, minor = 64;
    	else if (name[2] == 'g')
    	    major = 34, minor = 0;
    	else if (name[2] == 'h')
    	    major = 34, minor = 64;
    	else
    	    return INST_ERROR;

    	if (name[3] && name[4])
    	   minor += 10 + (name[4] - '0');
    	else if (name[3])
    	   minor += (name[3] - '0');
    } else if (!strncmp(name, "ram", 3)) {
    	type = S_IFBLK;
    	major = 1;
    	minor = 1;
    	if (name[3])
    	    minor += name[3] - '1';
    } else if (!strncmp(name, "rd/", 3)) {
    	// dac 960 "/rd/cXdXXpX". It can have 8 controllers, 32 drives
    	//   per controller and 7 partitions per drive.
    	char *c, *d, *p;

      type = S_IFBLK;
    	
    	// Copy "XdXXpX". Get controller #.
    	c = (char *)alloca (strlen (&name [4]) + 1);
    	strcpy (c, &name [4]);

    	// Get drive #.
    	d = c;
    	d++;
    	d++;
    	
    	// Get partition #.
    	p = d;
    	while (*p != '\0' && *p != 'p') p++;
    	
    	major = 48 + *c - '0';
    	if (*p == 'p') {
    	    // Get partition #.
    	    *p++ = '\0';
    	    minor = atoi (d) * 8 + *p - '0';
    	}
    	else {
    	    minor = atoi (d) * 8;
    	}
    } else if (!strncmp(name, "ida/", 4)) {
    	// Compaq Smart Array "ida/c0d0{p1}
    	type = S_IFBLK;
    	major = 72;                    // controller
    	minor = (name[7] - '0') * 16;  // disk
    	if (strlen(name) > 8)          // partition
   	    minor += atoi(name + 9);
    } else {
    	for (i = 0; i < numDevices; i++) {
   	    if( !strcmp(devices[i].name, name) ) break;
    	}
    	if (i == numDevices) return INST_ERROR;
    	major = devices[i].major;
    	minor = devices[i].minor;

    	if (devices[i].isChar)
   	    type = S_IFCHR;
    	else
   	    type = S_IFBLK;
    }

    // make a directory for this inode if needed.
    ptr = path;
    i = 0;
    while (*ptr)
      if (*ptr++ == '/')
        i++;
    if (i > 2) {
      dir = (char *)alloca(strlen(path) + 1);
      strcpy(dir, path);
      ptr = dir + (strlen(path) - 1);
      while (*ptr != '/')
        *ptr-- = '\0';
      mkdir(dir, 0755);
    }

    unlink(path);
    if( mknod(path, type | 0600, makedev(major, minor)) ) {
			printf( "mknod() failed %s\n", strerror(errno));
			return INST_ERROR;
    }else{
			printf( "created device file %s\n", path );
		}

    return 0;
}

void devRemoveInode(char * path) {
		printf( "removing device file %s", path );
    unlink(path);
}

int doPwMount(char * dev, char * where, char * fs, int rdonly, char * acct, char * pw);

int doMount(char * dev, char * where, char * fs, int rdonly ) {
	  return doPwMount(dev, where, fs, rdonly, NULL, NULL);
}

int doPwMount(char * dev, char * where, char * fs, int rdonly, char * acct, char * pw) {
    char * buf = NULL;
    int isnfs = 0;
    char * mount_opt = NULL;
    long int flag;

    if( !strcmp( fs, "nfs" ) ) isnfs = 1;

    Log::logMain( 1, "mounting %s on %s as type %s\n", dev, where, fs );

		mkdirChain(where);

  	if( !isnfs && *dev == '/' ){
	    buf = dev;
		}else if( !isnfs ){
	    buf = (char *)alloca(200);
	    strcpy( buf, "/tmp/" );
	    strcat( buf, dev );

	    if( devMakeInode(dev, buf) ) return 1;
		}
  	flag = MS_MGC_VAL;
  	if( rdonly )
 	    flag |= MS_RDONLY;

  	if( !strncmp( fs, "vfat", 4 ) )
 	    mount_opt="check=relaxed";

  	Log::logMain( 2, "calling mount(%s, %s, %s, %ld, %p)", buf, where, fs,
 			flag, mount_opt );

  	if (mount(buf, where, fs, flag, mount_opt)) {
  		fprintf(stderr, "mount failed: %s\n", strerror(errno));
 	    return 1;
  	}

  	if (!isnfs) devRemoveInode(buf);

    return 0;
}*/

static int pkgCompare( const void * first, const void * second )
{
    packageInfo ** a = (packageInfo **)first;
    packageInfo ** b = (packageInfo **)second;

    // put packages w/o names at the end
    if (!(*a)->name) return 1;
    if (!(*b)->name) return -1;

    return strcasecmp( (*a)->name, (*b)->name );
}

static int psGetArchScore( const Header h )
{
    char * pkgArch;
    int type, count;

    if( !headerGetEntry(h, RPMTAG_ARCH, &type, (void **)&pkgArch, &count) ||
        type == RPM_INT8_TYPE )
       return 150;
    else
       return rpmMachineScore( RPM_MACHTABLE_INSTARCH, pkgArch );
}

static int pkgCompareVer( const void * first, const void * second )
{
    packageInfo ** a = (packageInfo **)first;
    packageInfo ** b = (packageInfo **)second;
    int ret, score1, score2;

    // put packages w/o names at the end
    if (!(*a)->name) return 1;
    if (!(*b)->name) return -1;

    ret = strcasecmp( (*a)->name, (*b)->name );
    if (ret) return ret;
    score1 = psGetArchScore((*a)->h);
    if (!score1) return 1;
    score2 = psGetArchScore((*b)->h);
    if (!score2) return -1;
    if (score1 < score2) return -1;
    if (score1 > score2) return 1;
    return rpmVersionCompare( (*b)->h, (*a)->h );
}

#ifdef GBLI_STANDALONE
KeyForBLC::KeyForBLC(QWidget* parent, const char *name)
										 :QDialog(parent, name, true)
{
	this->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));
  QDialog::setCaption(QDialog::tr("SOT Linux installation key"));

  OKBut = new QPushButton (QDialog::tr("Ok"), this);
  QObject::connect(OKBut, SIGNAL(clicked()), this, SLOT(accept()));
	OKBut->setEnabled(false);

  CancelBut = new QPushButton (QDialog::tr("Cancel"), this);
  QObject::connect(CancelBut, SIGNAL(clicked()), this, SLOT(reject()));

	QLabel *warningMes = new QLabel(tr("You have chosen to update one or more commercial packages.\nYou are required to enter your installation key."), this );
	warningMes->setAutoMask(true);
	warningMes->setAlignment(AlignCenter);

	lblComKey = new QLabel(tr( "Installation key:"), this);
	lblComKey->setAutoMask(true);

	leComKey = new QLineEdit(this);
	leComKey->setMaxLength(14);
	leComKey->setMinimumWidth(180);
	leComKey->setMaximumWidth(220);
	leComKey->setFocus();
	leComKey->installEventFilter(this);

	QLabel *lblInfo = new QLabel(tr("The installation key can be obtained from http://register.sotlinux.com/"), this);
	lblInfo->setAutoMask( true );
	lblInfo->setAlignment(AlignLeft);
	QFont font1 = lblInfo->font();
	font1.setItalic(true);
	lblInfo->setFont(font1);

  QVBoxLayout *lvMain = new QVBoxLayout(this, 10, 10);

  QHBoxLayout *lhMes = new QHBoxLayout();
  lhMes->addWidget(warningMes);

  QHBoxLayout *lhRegKey = new QHBoxLayout();
	lhRegKey->addWidget(lblComKey);
	lhRegKey->addWidget(leComKey);

  QVBoxLayout *lvRegKey = new QVBoxLayout();
	lvRegKey->addLayout(lhRegKey);
	lvRegKey->addWidget(lblInfo);

  QHBoxLayout *hbutton = new QHBoxLayout();
  hbutton->addWidget(OKBut);
  hbutton->addStretch();
  hbutton->addWidget(CancelBut);

	lvMain->addLayout(lhMes);
	lvMain->addLayout(lvRegKey);
	lvMain->addLayout(hbutton);
}

bool KeyForBLC::eventFilter(QObject *o, QEvent *e)
{
	if((e->type() == QEvent::KeyPress || e->type() == QEvent::KeyRelease) &&
			 o == leComKey ) // key press
	{
		if(!leComKey->isEnabled())
			return QWidget::eventFilter(o, e);

		int len = leComKey->text().length();
		InstallSelect::keyOK = false;

		if(len < 14)
		{
			OKBut->setEnabled(false);
			InstallSelect::keyOK = false;
		}
		else if(len == 14)
		{
			bool check = EtcFiles::checkKey(leComKey->text().latin1());

			if(!check)
				OKBut->setEnabled(false);
			else
				OKBut->setEnabled(true);

			InstallSelect::keyOK = check;
		}
		else if(len > 14)
		{
			OKBut->setEnabled(false);
			InstallSelect::keyOK = false;
		}
	}
	return QWidget::eventFilter(o, e);  // standard event processing
}

#endif

InstallSelect::InstallSelect( QWidget * parent, const char * name )
    : GBLIPage( parent, name ), iStage( notdefined ), selected( undefined ),
			currentProgress( 0 ), maxProgress( 0 )
{
		labels[full]=tr("Full installation (recommended)");
#ifndef GBLI_SERVER
		labels[typical]=tr("Typical installation");
#else
		labels[develop]=tr("IPv6 development platform");
		labels[server]=tr("Server installation");
#endif
		labels[base]=tr("Minimal installation");


#ifdef GBLI_SERVER
		cs.develop = NULL;
		cs.server = NULL;
#else
		cs.typical = NULL;
#endif
    cs.base = NULL;
		cs.numComponents = 0;
		ps.numPackages = 0;

    gb = new QButtonGroup( 0 );

    QHBoxLayout * lh = new QHBoxLayout( this, 0, 6 );
    QVBoxLayout * l = new QVBoxLayout( 6 );
	
		lh->addStretch( 5 );
    lh->addLayout( l, 2 );
		lh->addStretch( 5 );

    QHBoxLayout* lrh = new QHBoxLayout();
    l->addStretch( 1 );
    l->addLayout( lrh, 2 );
    l->addStretch( 1 );

    QVBoxLayout *lr = new QVBoxLayout();
//    lrh->addStretch( 1 );
    lrh->addLayout( lr, 5 );
		
		for( int i = 0; i < MAX_INSTALL_TYPE; i++ ){
			if( labels[i] && labels[i].length() ){
				rbAll[i] = new QRadioButton( labels[i] , this );
				rbAll[i]->setAutoMask( true );
				rbAll[i]->setAutoResize( true );
  	  	lr->addWidget( rbAll[i], 3, AlignTop + AlignLeft );
	    	gb->insert( rbAll[i], i );
			}else
				rbAll[i] = NULL;
		}

    connect( gb, SIGNAL(clicked(int)), this, SLOT(setSelected(int)) );
		rbAll[0]->setChecked( true );

		//Added selection drawing
		rbAll[0]->setFocus();

    QVBoxLayout *lr2 = new QVBoxLayout( 6 );
    l->addLayout( lr2, 1 );
    l->addStretch( 1 );

		chkCustom = new QCheckBox( tr( "Customize selection" ), this );
		chkCustom->setAutoMask( true );
    QHBoxLayout *lh0 = new QHBoxLayout( 6 );
    //lr2->addLayout( lh0 ); Commented by dk
    lr->addLayout( lh0 );
		lh0->addWidget( chkCustom );
		lh0->addStretch( 1 );
    lr2->addSpacing( 10 );
    lr2->addStretch( 1 );

		chkCom = new QCheckBox( tr( "Install commercial software" ), this );

#ifndef GBLI_STANDALONE
		setSelected( full );
#else
		setSelected( update );
#endif

		chkCom->setAutoMask( true );
    QHBoxLayout *lh3 = new QHBoxLayout( 6 );
    lr2->addLayout( lh3 );
		lh3->addWidget( chkCom );
		lh3->addStretch( 1 );
		connect( chkCom, SIGNAL( toggled( bool ) ), this, SLOT( showComFields( bool ) ) );

/*		lblComUser = new QLabel( tr( "User name:" ), this );
		lblComUser->setAutoMask( true );
		lr2->addWidget( lblComUser );
		leComUser = new QLineEdit( this );
		lr2->addWidget( leComUser );

		lblComEmail = new QLabel( tr( "e-mail:" ), this );
		lblComEmail->setAutoMask( true );
		lr2->addWidget( lblComEmail );
		leComEmail = new QLineEdit( this );
		lr2->addWidget( leComEmail );*/
//

		lblComKey = new QLabel( tr( "Installation key:" ), this );
		lblComKey->setAutoMask( true );
    QHBoxLayout *lh4 = new QHBoxLayout( 6 );
    lr2->addLayout( lh4 );
		lh4->addWidget( lblComKey );
		leComKey = new QLineEdit( this );
		leComKey->setMaxLength( 14 );
		leComKey->setMinimumWidth( 180 );
		leComKey->setMaximumWidth( 220 );
		lh4->addWidget( leComKey );
		leComKey->installEventFilter( this );

		lblComStatus = new QLabel( "", this );
		lblComStatus->setAutoMask( true );
		lblComStatus->setMinimumWidth( 90 );
		lh4->addWidget( lblComStatus );

		lh4->addStretch( 1 );

		QLabel *lblInfo = new QLabel( tr("The installation key can be obtained from http://register.sotlinux.com/"), this );
		lblInfo->setAutoMask( true );
		lblInfo->setAlignment( AlignLeft /* | WordBreak*/ );
		QFont font1 = lblInfo->font();
		font1.setItalic( true );
		lblInfo->setFont( font1 );
    QHBoxLayout *lh5 = new QHBoxLayout( 6 );
    lr2->addLayout( lh5 );
		lh5->addWidget( lblInfo );
		lh5->addStretch( 1 );

		showComFields( true );

#ifdef DONT_ASK_FOR_KEY
    chkCom->hide();
    lblComKey->hide();
    leComKey->hide();
    lblComStatus->hide();
    lblInfo->hide();
#endif

	  rpmReadConfigFiles( NULL, NULL );
		iStage = initialized;

//// For server BLED always needed
//// For desktop BLED key needed only for installing commercial software
#ifdef GBLI_SERVER
		chkCom->setChecked( true );
		chkCom->hide();
#else
		chkCom->setChecked( false );
		lblComKey->setEnabled( false );
		leComKey->setEnabled( false );
		emit nextEnabled( this, true );
#endif
}

// enables/disables key input fields
void InstallSelect::showComFields( bool a_bl ){
	if( lblComKey ){
		lblComKey->setEnabled( a_bl );
		leComKey->setEnabled( a_bl );
		InstallSelect::keyOK = false;
		emit nextEnabled( this, !a_bl );
		if( !a_bl ){
			leComKey->setText( "" );
			lblComStatus->setText( "" );
		}else{
//			lblComStatus->setText( "- "+ tr( "Too short" ) );
//			lblComStatus->setText( "" );
//			lblComStatus->setText( "- "+ tr( "Incorrect" ) );
		}
	}
}

// checks if entered commercial packages installation key is correct
bool InstallSelect::eventFilter( QObject *o, QEvent *e ){

	if ( (e->type() == QEvent::KeyPress || e->type() == QEvent::KeyRelease) &&
			 o == leComKey ) {// key press
     //Adding focus switching
		 //leComKey->setFocus();

		if( !leComKey->isEnabled() ) return QWidget::eventFilter( o, e );
//		QKeyEvent *k = (QKeyEvent*)e;
//		qDebug( "key press %d", k->key() );
		int len = leComKey->text().length();
		InstallSelect::keyOK = false;
		if( len < 14 ){
//   all "Correct" "Incorrect" messages are disabled
//			lblComStatus->setText( "- "+ tr( "Incorrect" ) );
			emit nextEnabled( this, false );
		}else if( len == 14 ){
			// check key
			bool check = EtcFiles::checkKey( leComKey->text().latin1());
			if( !check )
			{
			//lblComStatus->setText( "- "+ tr( "Incorrect" ) );
				emit nextEnabled( this, false );
			}
			else
			{
//				lblComStatus->setText( "- "+ tr( "Correct" ) );
				emit nextEnabled( this, true );
			}
			InstallSelect::keyOK = check;
		}else if( len > 14 ){
//			lblComStatus->setText( "- "+ tr( "Incorrect" ) );
			emit nextEnabled( this, false );
		}
	}
	return QWidget::eventFilter( o, e );  // standard event processing
}

// set given install type as selected to be installed
void InstallSelect::setSelected( int a_i )
{
	selected = a_i;

  withX = ( selected != base && !isCustom() );

	blUpdate = (selected == update); // lets change this flag only here, pls!!!

	Log::closeMain();
	if( !blUpdate )
	{
		chkCom->setText( tr( "Install commercial software" ) );
		for( int i = 0; rbAll[i] && i < MAX_INSTALL_TYPE; i++ )
			rbAll[i]->setEnabled(true);
		Log::mainLogName = "install.log";

		if(QFile::exists(QString(NEWROOT + "/tmp/update.log")))
			::system(("mv " + NEWROOT + "/tmp/update.log " + NEWROOT + "/tmp/install.log").latin1());
	}
	else
	{
		chkCom->setText( tr( "Update commercial software" ) );
		for( int i = 0; rbAll[i] && i < MAX_INSTALL_TYPE; i++ )
		{
			rbAll[i]->setEnabled(false);
			rbAll[i]->setChecked(false);
		}
		Log::mainLogName = "update.log";

		//Added by dk to avoid the duplicating info in modules.conf
		if (QFile::exists(QString(NEWROOT + "/etc/modules.conf")))
		{
			//::system("cat "+ NEWROOT + "/etc/modules.conf| while read LINE; do echo \"#$LINE\" >> testtt.tmp; done; mv testtt.tmp "+ NEWROOT + "/etc/modules.conf");
			#ifdef TESTCOMMENT
			::system("echo \"#\" >>"+ NEWROOT+ "/etc/modules.conf");
			#endif
		}

		if(QFile::exists(QString(NEWROOT + "/tmp/install.log")))
			::system(("mv " + NEWROOT + "/tmp/install.log " + NEWROOT + "/tmp/update.log").latin1());
	}
	Log::closeMain();

	//Added selection redraw
//	rbAll[a_i]->setFocus();
}

// an array with space in MB needed for directories for
// different installation types
static int needed_space[
#ifndef GBLI_SERVER
3
#else
4
#endif
][9] = {
// old data
/*	{ 1200, 120,25, 53, 4, 7, 8, 5, 8 },  //full
#ifndef GBLI_SERVER
	{ 525,  120,20, 53, 4, 5, 8, 5, 7 },  //typical
#else
// TODO!!!!!!!!!!!!!! update numbers later
	{ 0,  120,20, 53, 4, 5, 8, 5, 7 },  //develop
	{ 0,  120,20, 53, 4, 5, 8, 5, 7 },  //server
#endif
	{ 110,  1,  5,  43, 4, 4, 8, 2, 3 }   //minimal
*/
///////ALL SIZES ACCORDING TO EACH DIR////
//	{ "/usr","/opt","/var","/lib","/bin","/sbin","/boot","/home","/etc" };
#ifdef GBLI_SERVER
	{ 1419, 56,36, 38, 6, 9, 5, 5, 8 },  //full server
#else
  { 1194, 130,25, 42, 6, 8, 5, 2, 6 },  //full desktop
#endif

#ifndef GBLI_SERVER  //desktop
	{ 1075, 1, 24, 42, 5, 7, 5, 1, 5 },  //typical desktop
#else                //server
	{ 1235, 1,26, 38, 6, 8, 5, 2, 6 },  //develop
	{ 1045, 1,27, 38, 6, 8, 5, 5, 7 },  //server
#endif
#ifdef GBLI_SERVER
	{ 535,  1,  21,  38, 6, 8, 5, 1, 4 }   //minimal server
#else
	{ 476,  1,  21,  41, 5, 7, 4, 1, 3 }   //minimal desktop
#endif
};

// dirs for which we know how much will it take
static char *dirs[] =
	{ "/usr","/opt","/var","/lib","/bin","/sbin","/boot","/home","/etc" };

// checks total space needed for different installation types,
// updates their labels and enables/disables if fits
void InstallSelect::checkFreeSpace()
{
	MountPointList mps = MountPoints::allDirectories();

	MountPoint *mp;
	int iDirsMax = sizeof( dirs ) / sizeof( char * );
	for( int install_type = 0; install_type < base+1; install_type++ ){
		int iFullSize = 0;
		for( int i = 0; i < iDirsMax; i++ )
			iFullSize += needed_space[install_type][i];
//		Log::logMain( 0, "Needed space for install_type %d is %d\n", install_type, iFullSize );
		int iNeededRoot = iFullSize;;
		int iRootPartSize = 0;
		bool enough = true;
		if( iFullSize ){// if we don't need anything, why we need to check it, right?
  		for( mp = mps.first(); mp != NULL; mp = mps.next() ){
  			char name[128];
  			strcpy( name, mp->name().latin1() );
  			if( !strcmp( name, "/" ) ){
  				iRootPartSize = (int)(mp->free() / 0x100000);
//printf( "iRootPartSize: %d\n", iRootPartSize );
  			}else{
//printf( "partition: %s - %d\n", mp->name().ascii(), (int)(mp->free()/0x100000) );
     			for( int n = 0; n < iDirsMax; n++ )
     				if( !strcmp( dirs[n], name ) ){
  						int size = (int)(mp->free() / 0x100000);
     					enough = needed_space[install_type][n] <= size;
  						iNeededRoot -= needed_space[install_type][n];
     					break;
     				}
  			}
  			if( !enough ) break;
    	}
//printf( "iNeededRoot: %d\n", iNeededRoot );
  		if( enough ){
  			if( iRootPartSize )
  				enough = iRootPartSize >= iNeededRoot;
  			else // it's unbelievable that we come here, but still
  				enough = false;
  		}
		}else
			enough = true;
    QRadioButton *curtype = rbAll[ install_type ];
		if( iFullSize ){
/*			QString tmpStr;
			tmpStr = labels[install_type];
			tmpStr = labels[install_type] + "   ~"+ QString::number(iFullSize) +tr("MB");*/
			//REMEMBER
			curtype->setText(  labels[install_type]  + "   ~"+ QString::number(iFullSize) +tr("MB") );
		}
		else
			curtype->setText(  labels[install_type]  );
#ifndef GBLI_DEVEL
		curtype->setEnabled( enough );
#else
		curtype->setEnabled( true );
#endif
		curtype->adjustSize();
	}

// if this /data/demo file is present on the CD, then it is a special
// "magazine" edition with only typical enabled
	if( !QFile( QString( GBLI_DATA_PATH ) +"/data/demo" ).exists() ){
		if( selected == undefined || !selected ){
    	for( int i = 0; i < base+1; i++ )
    		if( rbAll[i] && ((QRadioButton*)rbAll[i])->isEnabled() ){
    			((QRadioButton*)rbAll[i])->setChecked( true );
    			setSelected( i );
    			break;
    		}
		}
  }
#ifndef GBLI_SERVER
	else{// demo edition, only typical
    needed_space[1][1] = 3; // /opt is without StarOffice
  	for( int i = 0; i < base+1; i++ ){
			if( rbAll[i] ){
	      ((QRadioButton*)rbAll[i])->setEnabled( i == typical );
  	    ((QRadioButton*)rbAll[i])->setChecked( i == typical );
			}
    }
  }
#endif
}

// loads packages descriptions from the CD (hdlist, comps, deps)
// or loads installed packages list from the running system for removing
int InstallSelect::loadData()
{
	bool changedCursorHere = false;
	if( !qApp->overrideCursor() ){
	 	qApp->setOverrideCursor( Qt::waitCursor );
		changedCursorHere = true;
	}

#ifndef GBLI_DEVEL
	QString str = INSTALL_SOURCE + "/software/base/hdlist";
#else
	QString str = INSTALL_SOURCE + "/software/base/hdlist";
//	QString str = "/tmp/hdlist";
#endif
	int res = INST_OK;
	bool blRun = isRunning();

	if( QFile( str ).exists() ){
		if( blRun ) printf( "#progress\n" );
  	if( !ps.packages || !ps.numPackages )
  		res = getPackageSet( str );
		if( blRun ) printf( "#progress\n" );
  	if( res == INST_OK ){
			if( !cs.numComponents ){
	  		str = INSTALL_SOURCE + "/software/base/comps";
  			res = getComponentSet( str );
			}
  	}else if( blRun ) printf( "#done1\n" );
		if( blRun ) printf( "#progress\n" );
  	if( res == INST_OK ){
#ifndef GBLI_DEVEL
  		str = INSTALL_SOURCE + "/software/base/depslist";
#else
//  		str = INSTALL_SOURCE + "/software/base/depslist";
  		str = "/tmp/depslist";
#endif
  	  getDepsList( str );
  	}else if( blRun ) printf( "#done2\n" );
		if( blRun ) printf( "#progress\n" );
	}else{ // load package list from the system
		if( blRun ) printf( "#progress\n" );
  	if( !ps.packages || !ps.numPackages )
  		res = getPackageSetFromSystem();
		if( blRun ) printf( "#progress\n" );
	}

	if( changedCursorHere )
		qApp->restoreOverrideCursor();

	return res;
}

void InstallSelect::showEvent( QShowEvent *ev )
{
#ifdef GBLI_SERVER
	emit nextEnabled( this, keyOK );
#endif

	if( selected != update )
		checkFreeSpace();
}

void InstallSelect::hideEvent( QHideEvent *ev )
{
}

// called by GBLI in order to run backgrond packages installation
// loads packages list if needed, selects appropriate component,
// verify dependecies and installs packages, updating progress bar
// in GBLI class
void InstallSelect::runInstall()
{
	Log::logMain( 33, "entered runInstall()\n" );

  emit prevEnabled( this, false );
  emit enableKeyboardPass( false );

	curInstalled = 0;

	createDirs();

//system( ("lsof >> "+ NEWROOT +"/tmp/lsof0.log").latin1() );

  int fd[2];
  ::pipe( fd );

 	int s;
  if ( (s = fcntl( fd[0], F_GETFL, 0 ) ) >= 0 ) {
 		s |= FNDELAY;
 		fcntl( fd[0], F_SETFL, s );
  }

	// we will get our printf's as input data to that showInstallation progress()
	notifier = new QSocketNotifier(fd[0], QSocketNotifier::Read, this);
	connect(notifier, SIGNAL( activated(int)),
					this, SLOT( showInstallationProgress(int)));

	// NB! Don't use logMain function within the install process,
	// because anyway every printf will be logged by the function above

	// lets run it in the background
  pid = ::fork();
  if( pid == 0 ) {
		::close( fd[0] );
		::close( STDERR_FILENO );
		::close( STDOUT_FILENO );

	 	if( fd[1] != STDOUT_FILENO ) {
			int res = -1;
   	  res = dup2( fd[1], STDOUT_FILENO );
		 	if( res >= 0 && fd[1] != STDERR_FILENO )
				res = dup2( fd[1], STDERR_FILENO );
     	::close( fd[1] );
			if( res < 0 ){ printf( "#done99\n" ); exit(-1); };
	 	}

		::sleep( 1 );
		::nice( 19 );// lets make X work without glitches
		
		QString curDir = QDir::currentDirPath();
		QDir::setCurrent( INSTALL_SOURCE + "/software/RPMS.BL/" );
		
		printf( "Install type - %d\n", selected );

		printf( "#start1000\n" );
		// lets make sure that packages list is already loaded
		int res = loadData();
		if( res != INST_OK ) exit( -1 );

		// select some packages according to the install type
		selectPackages();

		if( selected != full ){ // it's meaningful to check full install
//		if( selected != full && selected != update ){
			Log::logMain( 32, "Start to verify deps!" );
			// verify dependencies
  		res = verifyDependencies_();
  		if( res != INST_OK ){ // resolving deps failed
				printf( "#done3\n" ); exit(-1);
			}
			Log::logMain( 34, "Verified deps!" );
		}
		printf( "#withX%d\n", (checkForX())?1:0 );
    printf( "#emitnext\n" );

		printf( "Total ready to %s: %d\n", (selected == update) ? "update" : "install", countSelected() );

#ifndef GBLI_DEVEL
		if(selected == update)
			renameConfModules();

		// lets start the real installation
		res = doInstall(); // main method

		printf( "#progress999\n" );
    printf( "Out of install function: %d!\n", res );

		if(selected == update)
			afterUpdateScripts();

		// lets free the memory, especially useful for the BLC
		freeComponentSet();
		if( res != INST_OK ){ printf( "#done4\n" ); exit(-1); };
#else
		printf( "Devel mode: real package installation skipped!\n" );
#endif

		if(selected != update)
		{
// Post-install
//HACK - cleaning out strange crap
			char buf[64];
			sprintf( buf, "rm -f %s/fonts.dir > /dev/null 2> /dev/null", NEWROOT.latin1());
  	  system( ("mv -f "+ NEWROOT +"/tmp/fstab* "+ NEWROOT +"/etc/fstab >/dev/null 2>&1").latin1());
			system( buf );
//HACK-end
		}
		printf( "#progress1000\n" );  		

		QDir::setCurrent( curDir );

		printf( "#done0\n" );
		exit(1);
  }
  ::close( fd[1] );
}

void InstallSelect::afterUpdateScripts()
{
  for(int i = 0; i < ps.numPackages; i++)
	{
		if(ps.packages[i]->selected)
		{
			if(!strcmp(ps.packages[i]->name, "initscripts"))
			{
				::system(("chroot " + NEWROOT + " /sbin/chkconfig --level 345 network on").latin1());
				::system(("chroot " + NEWROOT + " /usr/lib/lsb/install_initd /etc/rc.d/init.d/random").latin1());
				::system(("chroot " + NEWROOT + " /usr/lib/lsb/install_initd /etc/rc.d/init.d/netfs").latin1());
				::system(("chroot " + NEWROOT + " /usr/lib/lsb/install_initd /etc/rc.d/init.d/rawdevices").latin1());
			}
			else if(!strcmp(ps.packages[i]->name, "XFree86"))
			{
 	    	::system(("chroot " + NEWROOT + " grep \"^/usr/X11R6/lib$\" /etc/ld.so.conf &> /dev/null").latin1());
				::system(("chroot " + NEWROOT + " [ $? -ne 0 ] && echo \"/usr/X11R6/lib\" >> /etc/ld.so.conf").latin1());
				::system(("chroot " + NEWROOT + " /sbin/ldconfig").latin1());
			}			
			else if(!strcmp(ps.packages[i]->name, "kde"))
				::system(("echo DESKTOP=\\\"KDE\\\" > " + NEWROOT + "/etc/sysconfig/desktop").latin1());
		}
	}
}

void InstallSelect::renameConfModules()
{
QString tmp;
QStringList strList;

QFile conf((NEWROOT + "/etc/conf.modules"));
QFile modules((NEWROOT + "/etc/modules.conf"));

	if(!modules.exists())
	{
		if(conf.exists())
		{
			::system(("mv " + NEWROOT + "/etc/conf.modules " + NEWROOT + "/etc/modules.conf").latin1());
			::system(("rm -f " + NEWROOT + "/etc/conf.modules*").latin1());
		}
	}
	else
	{
		if(conf.exists())
		{
			strList.clear();

			modules.open(IO_ReadOnly);
			while(!modules.atEnd())
			{
				modules.readLine(tmp, 256);		
				strList.append(tmp);
			}
			modules.close();

			modules.open(IO_WriteOnly);
			conf.open(IO_ReadOnly);

			for(QStringList::Iterator it = strList.begin(); it != strList.end(); it++)
				modules.writeBlock((*it).latin1(), (*it).length());

			while(!conf.atEnd())
			{
				conf.readLine(tmp, 256);
				if(strList.find(tmp) == strList.end())
					modules.writeBlock(tmp.latin1(), tmp.length());
			}

			modules.flush();
			modules.close();
			conf.close();

			strList.clear();
			::system(("rm -f " + NEWROOT + "/etc/conf.modules*").latin1());
		}
	}
}

// returns the number of currently selected packages; needed for debugging
int InstallSelect::countSelected(){
  int count = 0;
  for( int i = 0; i < ps.numPackages; i++ ){
  	if( ps.packages[i]->selected ){
#ifdef GBLI_DEVEL
  		printf( "Test: %s\n", ps.packages[i]->name );
#endif
  		count++;
  	}
	}
	return count;
}

static unsigned int emptyCount = 0;

// a bridge between background installation process and the main process,
// e.g. for showing progress
// gets a handler of input stream, on the other end was printf
void InstallSelect::showInstallationProgress( int fd )
{
  QFile f;
  if ( f.open( IO_ReadOnly, fd ) ) {    // file opened successfully
	 	QTextStream t( &f );	    	  			// use a text stream
		QString line = "";
		int check = 5;
		while( !line.length() && check-- > 0 ){
  		line = t.readLine();
  		if( !line.length() )
  		  sleep( 1 );
    }
		f.close();
    if( !line.length() ){
			// shit happens sometimes :(((
			// usually happens when hdlist contains packages which doesn't exist anymore
    	if( emptyCount < 20 ){
    		Log::logMain( 32, "Line: empty message!!!!!!!!!!!" );
    		emptyCount++;
				sleep( 25 );
    	}else if( emptyCount != 22 ){
    		Log::logMain( 32, "Line: TOO MUCH empty messages!!!!!!!!!!!" );
    		emptyCount = 22;
    	}
    	return;
    }else if( emptyCount > 0 )
    	emptyCount--;
		// just print messaga to the log
    if( line.left( 4 ) != "#pro" && line.latin1()[0] != '*' ){// no progress messages
    	Log::logMain( 0, "Line: %s\n", line.latin1() ); // log file
    	Log::printl( 2, "Line: %s\n", line.latin1() );  // console
    }
		if( line.left( 6 ) == "#start" ) {//begin stage
			iStage = install;
    	currentProgress = 0;
			emit showProgressBar();
	    emit resetProgress();
	    maxProgress = line.right( line.length() - 6 ).toInt();
  	  emit setTotalSteps( maxProgress );
		}else
		if( line.left( 5 ) == "#done" ) {//finish stage
		  ::sync();
 		 	::close( fd );
   		int status;
   		::waitpid( pid, &status, 0 );
         		// WUNTRACED - don't wait for unknown suspects ;)
      Log::logMain( 33, "installSelect wait_status %d\n", WIFEXITED(status)?WEXITSTATUS(status):0 );
			QString mess = "";
			if( line.length() > 5 )
    		switch( line.right( line.length() - 5 ).toInt()/*WIFEXITED(status)*/ ){
  				case 1:	mess = tr("Fatal error on getting package headers."); break;
  				case 2:	mess = tr("Fatal error on getting package components."); break;
  				case 3: mess = tr("Error on verifying package dependencies."); break;
					case 4:
					if(!blUpdate)
	  				 mess = tr("One or more packages could not be installed.\nSee /tmp/%1.log for details").arg( blUpdate?"update":"install");
					else
	  				mess = tr("One or more packages could not be updated.\nSee /tmp/%1.log for details").arg( blUpdate?"update":"install");
					break;
  				case 0:	
					default: // OK
  					break;
    		}
			if( mess.length() ){
				if(!blUpdate)
	  		  QMessageBox::critical( 0, tr("Install failed"), mess );
				else
	  		  QMessageBox::critical( 0, tr("Update failed"), mess );
				Log::logMain( 32, mess );
			}
     	delete notifier;
 			notifier = 0;
			iStage = finished;
			emit hideProgressBar();
  		emit installationFinished();
			printf( "Done!" );
		}else // update progress bar
		if( line.left( 9 ) == "#progress" ) {//show progress
      if( Log::iDebugLevel > 2 && line.compare( "#progress999" ) )
      	printf( "Set progress: %d\n", currentProgress );
			int oldCur = currentProgress;
			if( line.length() <= 9 )
	    	currentProgress++;
			else
				currentProgress = line.right( line.length() - 9 ).toInt();
			if( currentProgress > oldCur ){
		   	if( currentProgress > maxProgress ){
					printf( "Exceeding maxProgress(%d) - %d\n", maxProgress, currentProgress );
					currentProgress = maxProgress;
				}
		   	emit setProgress( currentProgress );
			}
		}else // open a window with given string as message
		if( line.left( 8 ) == "#message" ) {
			int length = line.length() - 8;
			if( length ){
				errorWindow( this, tr( line.right( length ).latin1() ) );
				Log::logMain( 32, line.right( length ).latin1() );
			}else{
				Log::logMain( 32, "Empty error message!!!!!!!!" );
			}
		}else // set maximum of the progress bar
		if( line.left( 7 ) == "#setmax" ) {
    	currentProgress = 0;
	    maxProgress = line.right( line.length() - 7 ).toInt();
  	  emit setTotalSteps( maxProgress );
    }else
    if( line.left( 6 ) == "#withX" ){
      withX = (line.right( line.length() - 6 ).toInt() != 0);
    }else // enable passing furthes on some pages
    if( line.left( 9 ) == "#emitnext" ){
			// video card, sound, printer and some other stuff is
			// dependent on X, so we should wait untill we know if X is present
      emit enableKeyboardPass( true );
		}
	}
	fflush( stdout );
	fflush( stderr );
}

// load component list from the 'comps' file
// packages info should be already loaded
int InstallSelect::getComponentSet( QString &a_strFileName )
{
		if( cs.numComponents ) return INST_OK;

    FILE * f;
    char buf[255];
    int inComp;
    int line = 0;
    char * start;
    char * chptr;
    int compsAlloced;
    int packagesAlloced = 0;
    component * currcomp = NULL;
    packageInfo packkey, ** pack;
    packageInfo * keyaddr = &packkey;
//    int skipMissing = 0;
		int iBase = 0;
#ifdef GBLI_SERVER
		int iDevelop = 0, iServer = 0;
		cs.develop = NULL;
		cs.server = NULL;
#else
		int iTypical = 0;
		cs.typical = NULL;
#endif

    cs.numComponents = 0;
    cs.base = NULL;

    f = fopen( a_strFileName.latin1(), "r" );
    if (!f) {
			printf( "#messageCannot open components file: %s\n", a_strFileName.latin1() );
			return INST_ERROR;
    }

    /* get the version number */
    line++;
    if( !fgets(buf, sizeof(buf), f) ) {
			printf( "#messageCannot read components file: %s\n", a_strFileName.latin1() );
			fclose(f);
			return INST_ERROR;
    }

    if( strcmp(buf, "0\n") && strcmp(buf, "0.1\n") ) {
			printf( "#message%s\n", "Comps file is not version 0.1 as expected" );
			fclose(f);
			return INST_ERROR;
    }

    compsAlloced = 5;
//    cs.comps = (struct component *)malloc( sizeof(*cs.comps) * compsAlloced );
//    cs.comps = (struct component *) new char[ sizeof(*cs.comps) * compsAlloced ];
    cs.comps = new component[ compsAlloced ];
		if( !cs.comps ){
			printf( "#message%s\n", "Can`t allocate memory." );
			fclose(f);
			return INST_ERROR;
    }

    inComp = 0;
    while( fgets(buf, sizeof(buf), f) ){
			line++;

			/* remove any trailing '\n', leave chptr at the end of the string */
			chptr = buf + strlen(buf) - 1;
			if( *chptr == '\n' )
	  	  *chptr = '\0';
			else
	  	  chptr++;

			/* strip leading spaces */
			start = buf;
			while( *start && isspace(*start) ) start++;

			/* empty string */
			if( !*start ) continue;
	
			/* comment */
			if( *start == '#' ) continue;

			if( !inComp ){
		    /* first digit must be a zero or a one */
		    if (*start != '0' && *start != '1') {
					printf( "#messagebad comps file at line %d\n", line );
					continue;
		    }

		    if( compsAlloced == cs.numComponents ) {
					compsAlloced += 5;
					cs.comps = (struct component *)realloc( cs.comps, sizeof(*cs.comps) * compsAlloced );
		    }
  	
	  	  currcomp = cs.comps + cs.numComponents;
	    	currcomp->selected = (*start == '1');
		    currcomp->inmenu = true;

		    start++;
	  	  while( *start && isspace(*start) ) start++;

		    if( !strncmp(start, "--hide ", 7) ) {
					start += 7;
					while (*start && isspace(*start)) start++;
					currcomp->inmenu = false;
		    }
	
		    if( !*start ) {
					printf( "#messagemissing component name at line %d\n", line );
					continue;
		    }

		    currcomp->name = strdup( start );

		    currcomp->ps.numPackages = 0;
	  	  packagesAlloced = 10;
	    	currcomp->ps.packages = (::packageInfo **)malloc(
					sizeof( ::packageInfo ) * packagesAlloced );
//	    	currcomp->ps.packages = (::packageInfo **)new char[
//					sizeof( ::packageInfo ) * packagesAlloced ];
//	    	currcomp->ps.packages = new packageInfo[ packagesAlloced ];
		    inComp = 1;
			} else {
		    if( !strcmp(start, "end") ) {
					inComp = 0;

					if( !strcasecmp(currcomp->name, "Base") ){
						iBase = cs.numComponents;
					}
#ifndef GBLI_SERVER
					else if( !strcasecmp(currcomp->name, "Typical") ){
						iTypical = cs.numComponents;
					}
#else
					else if( !strcasecmp(currcomp->name, "Development") ){
						iDevelop = cs.numComponents;
					}else if( !strcasecmp(currcomp->name, "Server") ){
						iServer = cs.numComponents;
					}
#endif

					cs.numComponents++;
		    } else {
					packkey.name = start;
					pack = (::packageInfo **)bsearch( &keyaddr, ps.packages, ps.numPackages,
						sizeof(*ps.packages), /*(void *)*/pkgCompare );
					if( !pack ) {
/*		  		  if ( !skipMissing &&
							QMessageBox::critical( this, "Error",
					      tr("package %s at line %d does not exist").arg( start ).arg( line ),
								tr("Ignore"), tr("Ignore all") ) == 1 )
*/
							Log::logMain( 32, "package %s at line %d does not exist\n", start, line );
//						skipMissing = 1;
				    continue;
					}

					if( currcomp->ps.numPackages == packagesAlloced ){
				    packagesAlloced += 10;
				    currcomp->ps.packages = (::packageInfo **)realloc( currcomp->ps.packages,
							sizeof(::packageInfo) * packagesAlloced );
					}

          if ( currcomp->ps.packages == NULL ) {
						printf( "#message%s\n", "Can`t allocate memory." );
						fclose(f);
						return INST_ERROR;
					}

// This one doesn't affect anything, since we will recalculate it later
//					if( currcomp->selected )
//						(*pack)->selected = true;

// Everything is in menu, so it is already true by default
//					if( currcomp->inmenu )
//						(*pack)->inmenu = true;

// should move it down to separate loop to speed up loading
//					if( !strcasecmp(currcomp->name, "Base") )
//						(*pack)->mustBe = 1;
					if( !strcasecmp(currcomp->name, "Base") )
#ifndef GBLI_STANDALONE
						(*pack)->mustBe = 1;
#else
						(*pack)->mustBe = 1;
#endif

//if( !strcmp( currcomp->name, "Base" ) )
//  printf( "Name: %s, selected: %d\n", (*pack)->name, (*pack)->selected );fflush( stdout );

					currcomp->ps.packages[currcomp->ps.numPackages] = *pack;
					currcomp->ps.numPackages++;
		    }
			}
    }

    fclose(f);

		cs.base = cs.comps + iBase;
#ifndef GBLI_SERVER
		if( iTypical > 0 ) cs.typical = cs.comps + iTypical;
#else
		if( iDevelop > 0 ) cs.develop = cs.comps + iDevelop;
		if( iServer > 0 ) cs.server = cs.comps + iServer;
#endif
		Log::logMain( 33, "getComponents read %d groups\n", cs.numComponents );

    return INST_OK;
}

bool InstallSelect::checkForX()
{
  if( !withX ){
  	for( int i = 0; i < ps.numPackages; i++ )
    	if( ps.packages[i]->selected && !strncmp( ps.packages[i]->name, "XF", 2 ) ){
  			withX = true;
  			break;
  		}
  }
	return withX;
}

// free memory since hdlist takes ~10MB in the memory
void InstallSelect::freeComponentSet() {
    printf( "begin to free memory...\n" );
    int i;
    struct component * currcomp;

    currcomp = cs.comps;
		if( cs.comps && cs.numComponents ){
      for (i = 0; i < cs.numComponents; i++, currcomp++ ) {
  			if( currcomp->ps.packages )
  				free( currcomp->ps.packages );
      }
		}else if( ps.packages && ps.numPackages ){
      free( ps.packages );
		}
		cs.numComponents = 0;
		ps.numPackages = 0;
		printf( "freed memory!\n" );
}

// load the packages info from the "hdlist" file
int InstallSelect::getPackageSet( QString &a_strFileName )
{
		if( ps.numPackages ) return INST_OK;

		int noSeek = 0;
    int end = 0, type, count;
    unsigned int * sizeptr;
    Header h;
    int packagesAlloced;
    char * name, * group;
    int done = 0;
    FD_t fd;
    ps.numPackages = 0;

    fd = fdOpen( a_strFileName.latin1(), O_RDONLY, 0644 );

    if( !fd ) {
//			errorWindow( this, tr("Error opening header file") );
			printf( "#messageerror opening header file: %s\n", a_strFileName.latin1() );
			return INST_ERROR;
    }

    packagesAlloced = 50;
    ps.packages = (struct packageInfo **)malloc(sizeof(*ps.packages) * packagesAlloced);
//    ps.packages = (struct packageInfo **)new char[ sizeof(*ps.packages) * packagesAlloced ];
//    ps.packages = new packageInfo[ packagesAlloced ];
  	if ( ps.packages == NULL ) {
  			printf( "#message%s\n", "Can`t allocate memory." );
  			return INST_ERROR;
  	}
    if (!noSeek) {
			count = Fseek( fd, 0, SEEK_CUR ); // old fdLseek
			end = Fseek( fd, 0, SEEK_END );
			Fseek( fd, count, SEEK_SET );
    }

    while( !done ) {
			h = headerRead( fd, HEADER_MAGIC_YES );
			if (!h && noSeek) {
		    done = 1;
			} else if (!h) {
/*				errorWindow( this, tr("Error reading header at %1").arg(
			    (int)fdLseek(fd, 0, SEEK_CUR) ) );*/
				printf( "#messageError reading header at %d\n", (int)Fseek(fd, 0, SEEK_CUR) );
		    free(ps.packages);
		    return INST_ERROR;
			} else {
	  	  headerGetEntry(h, RPMTAG_NAME, &type, (void **) &name, &count);
				int gr_res = headerGetEntry(h, RPMTAG_GROUP, &type, (void **) &group,	&count);
		    if( !gr_res || !group || !strlen( group ) ){
				printf( "unknown group!!!!!!!\n" );
					group = ( char* )new char[ 16 ];
					if( !group ){
						free(ps.packages);
						ps.packages = NULL;
						ps.numPackages = 0;
						printf( "#message%s\n", "Can`t allocate memory." );
						break;
					}
					strcpy( group, "(unknown group)" );
		    }

        if (ps.numPackages == packagesAlloced) {
    			packagesAlloced += 50;
    			packageInfo **tmpInfo = ps.packages;
    			ps.packages = (struct packageInfo **)realloc(
    				ps.packages, sizeof(*ps.packages) * packagesAlloced );
    			if( !ps.packages ){
    				free( tmpInfo );
    				ps.packages = NULL;
    				ps.numPackages = 0;
    				printf( "#message%s\n", "Can`t allocate memory." );
    				break;
    			}
        }

//	  	  ps.packages[ps.numPackages] =
//					(struct packageInfo *)malloc( sizeof(struct packageInfo) );
	  	  ps.packages[ps.numPackages] = new packageInfo;
			  if ( ps.packages[ps.numPackages] == NULL ) {
    			free( ps.packages );
					ps.packages = NULL;
					ps.numPackages = 0;
    			printf( "#message%s\n", "Can`t allocate memory." );
    			break;
			  }

	  	  ps.packages[ps.numPackages]->h = h;
	    	ps.packages[ps.numPackages]->selected = false;
	    	ps.packages[ps.numPackages]->updatable = true;
	    	ps.packages[ps.numPackages]->mustBe = 0;

		    if (headerGetEntry(h, RPMTAG_SIZE, &type, (void **) &sizeptr,	&count))
					ps.packages[ps.numPackages]->size = *sizeptr;
		    else
					ps.packages[ps.numPackages]->size = 0;

		    ps.packages[ps.numPackages]->pos = ps.numPackages;
		    ps.packages[ps.numPackages]->inmenu = true/*!skipPackage(name)*/;
		    ps.packages[ps.numPackages]->name = name;
		    ps.packages[ps.numPackages]->group = group;
		    ps.packages[ps.numPackages]->item = NULL;
				ps.packages[ps.numPackages]->iBase = 0;
	  	  headerGetEntry( h, FILENAME_TAG, &type,
		     (void **) &ps.packages[ps.numPackages]->data,
		     &count );
		    ps.numPackages++;
			}
			if (!noSeek) {
		    if (end <= Fseek(fd, 0, SEEK_CUR))
					done = 1;
			}
    }

    Log::logMain( 33, "getPackages read %d headers\n", ps.numPackages );

    pkgSort();

    fdClose(fd);

    return INST_OK;
}

// load package list from the system
int InstallSelect::getPackageSetFromSystem(){
	if( ps.numPackages ) return INST_OK;

  rpmdb db = NULL;

//printf( "NEWROOT: %s\n", NEWROOT.ascii() );

  if( rpmdbOpen( NEWROOT.latin1(), &db, O_RDONLY, 0644 ) ){
		Log::logMain( 32, "Failed to open rpmdb to get the list of packages!\n" );
		return INST_ERROR;
	}

	bool changedCursorHere = false;
	if( !qApp->overrideCursor() ){
	 	qApp->setOverrideCursor( Qt::waitCursor );
		changedCursorHere = true;
	}

	Header h = NULL;
	rpmdbMatchIterator mi;
	int type, count = 0;
  unsigned int * sizeptr;
  int packagesAlloced = 0;
  char * name, * group;

  ps.numPackages = 0;
	ps.packages = 0;

  packagesAlloced = 50;
  ps.packages = (struct packageInfo **)malloc(sizeof(*ps.packages) * packagesAlloced);
//  ps.packages = (struct packageInfo **)new char[ sizeof(*ps.packages) * packagesAlloced ];
//  ps.packages = new packageInfo[ packagesAlloced ];
	if ( ps.packages == NULL ) {
			printf( "#message%s\n", "Can`t allocate memory." );
			return INST_ERROR;
	}

	mi = rpmdbInitIterator(db, RPMDBI_PACKAGES, NULL, 0);
	Header tmp = NULL;
	while( (tmp = rpmdbNextIterator(mi)) != NULL ){
		h = headerCopy( tmp );
	  headerGetEntry(h, RPMTAG_NAME, &type, (void **) &name, &count );
		int gr_res = headerGetEntry(h, RPMTAG_GROUP, &type, (void **) &group,	&count);
    if( !gr_res || !group || !strlen( group ) ){
			printf( "unknown group!!!!!!!\n" );
			group = ( char* )new char[ 16 ];
			if( !group ){
				free(ps.packages);
				ps.packages = NULL;
				ps.numPackages = 0;
				printf( "#message%s\n", "Can`t allocate memory." );
				break;
			}
			strcpy( group, "(unknown group)" );
    }

	  if (ps.numPackages == packagesAlloced) {
			packagesAlloced += 50;
			packageInfo **tmpInfo = ps.packages;
			ps.packages = (struct packageInfo **)realloc(
				ps.packages, sizeof(*ps.packages) * packagesAlloced);
			if( !ps.packages ){
				free( tmpInfo );
				ps.packages = NULL;
				ps.numPackages = 0;
				printf( "#message%s\n", "Can`t allocate memory." );
				break;
			}
    }

	  ps.packages[ps.numPackages] = new packageInfo;
//printf( "package %d - %p\n", ps.numPackages, ps.packages[ps.numPackages] );
	  if( !ps.packages[ps.numPackages] ){
			free( ps.packages );
			ps.packages = NULL;
			ps.numPackages = 0;
			printf( "#message%s\n", "Can`t allocate memory." );
			break;
	  }

	  ps.packages[ps.numPackages]->h = h;
  	ps.packages[ps.numPackages]->selected = false;
  	ps.packages[ps.numPackages]->updatable = true;
  	ps.packages[ps.numPackages]->mustBe = 0;

    if (headerGetEntry(h, RPMTAG_SIZE, &type, (void **) &sizeptr,	&count))
			ps.packages[ps.numPackages]->size = *sizeptr;
    else
			ps.packages[ps.numPackages]->size = 0;

    ps.packages[ps.numPackages]->pos = ps.numPackages;
    ps.packages[ps.numPackages]->inmenu = true/*!skipPackage(name)*/;
    ps.packages[ps.numPackages]->name = name;
    ps.packages[ps.numPackages]->group = group;
    ps.packages[ps.numPackages]->item = NULL;
		ps.packages[ps.numPackages]->iBase = 0;
	  headerGetEntry( h, FILENAME_TAG, &type,
     (void **) &ps.packages[ps.numPackages]->data,
     &count );
    ps.numPackages++;
  }
	rpmdbFreeIterator(mi);

	rpmdbClose( db );

  pkgSort();

	if( changedCursorHere )
	 	qApp->restoreOverrideCursor();

	return INST_OK;
}

// load "beatiful" package dependencies from prepared "deps" from the CD
// if this file doesn't exist then package dependencies will
// be get from "requires" in packages info, which shows often files dependencies,
// but not always package dependencies
int InstallSelect::getDepsList( QString &a_strFileName ){
  QFile depsF( a_strFileName );
	if( depsF.open( IO_ReadOnly ) ){
	
	  deps.resize( 1000 );
	
    QTextStream inf( &depsF );
    int count = 0;
    while( !inf.eof() ){
      QString str( inf.readLine() );
      int pos = str.find( " " );
      QString name = "";
      if( pos != -1 )
        name = str.left( pos );
      else
        continue;
      pos = str.find( " ", pos+1 ); // size
      if( pos == -1 ) continue; // only name and size, nothing interesting

//printf( "check - %s\n", name.ascii() );
      dependenciesInfo *curPack = new dependenciesInfo;

      int prev_pos = pos+1;
      while( (pos = str.find( " ", prev_pos )) != -1 ||
        ( (int)prev_pos+1 < (int)str.length() &&
        (pos=str.length()) ) ){
//printf( "checkN - %d,%d (%d)-- %d - %s -- %d\n", prev_pos, pos-prev_pos, str.length(), curDep, str.mid( prev_pos, pos-prev_pos ).ascii(), curPack->dependOn.size() );fflush( stdout );
        QString strTmp( str.mid( prev_pos, pos-prev_pos ) );
        curPack->dependOn.append( strTmp );
        prev_pos = pos+1;
      }
      deps[count++] = curPack;
      if( count == 1000 )
        deps.resize( 3000 );
    }
    depsF.close();
  }else
    return INST_ERROR;
  return INST_OK;
}

// here should be added such checkings, like:
// kernel - smp or not
// X fonts - depending on language (you don't need ISO8859-2 with ru ;)
// etc.
// it is not called properly now, so should be fixed
bool InstallSelect::skipPackage( char * name )
{
/*  char ** item;

  for( item = skipList; *item; item++ ) {
		if( !strcmp( *item, name ) ) return true;
  }*/
  return false;
}

// sort packages in the array, so that we can use binary search
void InstallSelect::pkgSort()
{
		if( !ps.packages || !ps.numPackages ) return;
    int i;
    char *name;

    qsort( ps.packages, ps.numPackages, sizeof(*ps.packages), pkgCompareVer );

    name = ps.packages[0]->name;
    if (!name) {
       ps.numPackages = 0;
       return;
    }
    for (i = 1; i < ps.numPackages; i++) {
       if (!ps.packages[i]->name) break;
       if (!strcmp(ps.packages[i]->name, name))
			   ps.packages[i]->name = NULL;
       else
	  		 name = ps.packages[i]->name;
    }

    qsort(ps.packages, ps.numPackages, sizeof(*ps.packages), pkgCompareVer );

    for (i = 0; i < ps.numPackages; i++)
       if (!ps.packages[i]->name) break;
    ps.numPackages = i;
}

// create needed dirs in the filesystem
// may be it is not fully needed, since it should be created by
// "filesystem" rpm
void InstallSelect::createDirs()
{
// Now they are in: PartitionInfo::doMounting
//    ::mkdir( (NEWROOT +"/dev").latin1(), 0755 );
//    ::mkdir( (NEWROOT +"/proc").latin1(), 0755 );
    ::mkdir( (NEWROOT +"/etc").latin1(), 0755  );
    ::mkdir( (NEWROOT +"/tmp").latin1(), 01775 );
    ::mkdir( (NEWROOT +"/var").latin1(), 0755  );
    ::mkdir( (NEWROOT +"/var/tmp").latin1(), 01755 );
    ::mkdir( (NEWROOT +"/var/lib").latin1(), 0755 );
    ::mkdir( (NEWROOT +"/var/lib/rpm").latin1(), 0755 );

    ::mkdir( (NEWROOT +"/boot").latin1(), 0755 );
    ::mkdir( (NEWROOT +"/boot/grub").latin1(), 0755 );
    ::mkdir( (NEWROOT +"/usr").latin1(), 0755 );
    ::mkdir( (NEWROOT +"/usr/opt").latin1(), 0755 );
    ::mkdir( (NEWROOT +"/home").latin1(), 0755 );

//		Log::logMain( 32, "Warning: hack - creating empty ld.so.conf!\n" );
//		system( ("touch "+ NEWROOT +"/etc/ld.so.conf").latin1() );
}

static bool fatalError = false;

// called by the rpm's installation process to print out the error
static void rpmerror(void)
{
  int code;
#ifdef GBLI_RPM3
	char * str = rpmErrorString();
#else
	char * str = (char*)rpmlogMessage();
#endif

  code = rpmErrorCode();
	switch( code ){
		case RPMERR_UNLINK:
		case RPMERR_RMDIR:
			break;
		case RPMERR_SCRIPT:
			if( str )
				printf( "RPM error: %s, RPMERR_SCRIPT\n", str );
			else
				printf( "RPM error: <no message>, RPMERR_SCRIPT\n" );
			break;
		case RPMERR_NOSPACE:
		  if( !fatalError ) // to make sure
   			printf( "#messageThere is not enough disk space for this type of installation.\n" );
 			fatalError = true;
		default:
			if( str )
				printf( "RPM error: %s, %d\n", str, code );
			else
				printf( "RPM error: <no message>, %d\n", code );
	}
}

// verify the dependencies on current selected package set
int InstallSelect::verifyDependencies(){

    rpmdb db = NULL;
    rpmTransactionSet rpmdeps;
    int i;
    struct rpmDependencyConflict * conflicts;
    struct packageInfo * package;
    int numConflicts, numProblems;
    rpmErrorCallBackType old;

//    if( !QFile( NEWROOT +"/var/lib/rpm/packages.rpm" ).exists() ) {
		if( !QFile( NEWROOT +"/var/lib/rpm/Packages" ).exists() ) {
			system( ("mkdir -p -m0755 "+ NEWROOT +"/var/lib/rpm").latin1() );
			rpmSetVerbosity( RPMMESS_FATALERROR );// we don't need db really
			old = rpmErrorSetCallback( rpmerror/*emptyErrorCallback*/ );
			if( rpmdbOpen( NEWROOT.latin1(), &db, O_RDWR | O_CREAT, 0644 ) )
	  	  db = NULL;
			rpmErrorSetCallback( old );
			rpmSetVerbosity( RPMMESS_NORMAL );
    }else{
#ifndef GBLI_STANDALONE
			printf( "DB already exists!\n" );
#endif
			rpmdbOpen( NEWROOT.latin1(), &db, O_RDWR, 0644 );
		}

		if( !db ){
			Log::logMain(32, "verifyDependencies: Failed to open db\n" );
			return INST_ERROR;
		}

    rpmdeps = rpmtransCreateSet( db, NULL );

		if( iStage > initialized )
			printf( "#progress\n" );

    for (i = 0; i < ps.numPackages; i++) {
			if( ps.packages[i]->selected)
					rpmtransAddPackage( rpmdeps, ps.packages[i]->h, NULL, ps.packages[i], 0, NULL );
			else
	  	  rpmtransAvailablePackage( rpmdeps, ps.packages[i]->h, ps.packages[i] );
    }
		if( iStage > initialized )
			printf( "#progress\n" );

//printf( "Packs: %d, comps: %d\n", ps.numPackages, cs.numComponents );
    rpmdepCheck( rpmdeps, &conflicts, &numConflicts );

		if( iStage > initialized )
			printf( "#progress\n" );

    rpmtransFree(rpmdeps);

    if( db ) rpmdbClose(db);
		if( iStage > initialized )
			printf( "#progress\n" );

    /* XXX This is a hack. rpmlib seems to have problems in the conflicts
       stuff */
    numProblems = 0;
    for( i = 0; i < numConflicts; i++ ) {
			if( conflicts[i].sense == rpmDependencyConflict::RPMDEP_SENSE_REQUIRES )
				numProblems++;
    }

    if(!numProblems)
			return INST_OK;

		int count = 0;
		// Select required packages
 		for (i = 0; i < numConflicts; i++) {
   	  package = (struct packageInfo *)conflicts[i].suggestedPackage;
 	    if( package && !package->selected ){
				Log::logMain(32, "Select required package: %s (%s)\n", package->name, package->group );
				package->selected = true;

				count++;
			}
 		}

		Log::logMain(32, "Selected %d required packages!\n", count );

		// Free problems
 		rpmdepFreeConflicts( conflicts, numConflicts );

		if( iStage > initialized )
			printf( "#progress\n" );
 		return INST_OK;
}

// advanced version of package dependencies verification
int InstallSelect::verifyDependencies_(struct packageInfo *newPackage = 0, int mustBe = 0, int check = 0)
{
	if(!check && !newPackage)
		return verifyDependencies__();

    rpmdb db = 0;
    rpmTransactionSet rpmdeps;
    int i;
    struct rpmDependencyConflict * conflicts;
    struct packageInfo * package;
    int numConflicts, numProblems;
    rpmErrorCallBackType old;
		
//		int count = 0;		

#ifdef GBLI_RPM3
    if( !QFile( NEWROOT +"/var/lib/rpm/packages.rpm" ).exists() ) {
#else
		if( !QFile( NEWROOT +"/var/lib/rpm/Packages" ).exists() ) {
#endif
			system( ("mkdir -p -m0755 "+ NEWROOT +"/var/lib/rpm").latin1() );
			rpmSetVerbosity( RPMMESS_FATALERROR );// we don't need db really
			old = rpmErrorSetCallback( rpmerror/*emptyErrorCallback*/ );
			if( rpmdbOpen( NEWROOT.latin1(), &db, O_RDWR | O_CREAT, 0644 ) )
	  	  db = NULL;
			rpmErrorSetCallback( old );
			rpmSetVerbosity( RPMMESS_NORMAL );
    }else{
#ifndef GBLI_STANDALONE
			printf( "DB already exists!\n" );
#endif
			rpmdbOpen( NEWROOT.latin1(), &db, O_RDWR, 0644 );
		}

		if( !db ){
			Log::logMain(32, "verifyDependencies: Failed to open db\n" );
			return INST_ERROR;
		}

    rpmdeps = rpmtransCreateSet( db, NULL );

		if(newPackage)
		{
			rpmtransAddPackage(rpmdeps, newPackage->h, NULL, newPackage, 0, NULL);
			Log::logMain(32, "newPackage - %s\n", newPackage->name);
		}

    for (i = 0; i < ps.numPackages; i++)
		{
			if(ps.packages[i]->selected)
			{
				if(!newPackage && strcmp(ps.packages[i]->name, "XFree86-xf86cfg"))
					rpmtransAddPackage( rpmdeps, ps.packages[i]->h, NULL, ps.packages[i], 0, NULL );
			}
			else
			{
/*
				if(newPackage && !strcmp(ps.packages[i]->name, "Xconfigurator"))
				{
					Header h;
					char *name_p, *version_p, *release_p;
					const char *name, *version, *release;
					rpmdbMatchIterator mi;
					mi = rpmdbInitIterator(db, RPMDBI_PACKAGES, NULL, 0);
					while((h = rpmdbNextIterator(mi)) != NULL)
					{
						headerGetEntry(h, RPMTAG_NAME, NULL, (void **) &name_p, NULL);
						if(name_p && !strcmp(name_p, "Xconfigurator"))
						{
							headerGetEntry(h, RPMTAG_VERSION, NULL, (void **) &version_p, NULL);
							headerGetEntry(h, RPMTAG_RELEASE, NULL, (void **) &release_p, NULL);
							printf("from db:  name: %s, version: %s, release: %s\n", name_p, version_p, release_p);
	
							headerNVR(ps.packages[i]->h, &name, &version, &release);
							printf("from hdlist:  name: %s, version: %s, release: %s\n\n", name, version, release);
						}
					}
					rpmdbFreeIterator(mi);
        }
*/
 		  	rpmtransAvailablePackage( rpmdeps, ps.packages[i]->h, ps.packages[i] );
			}
		}

/*
		if(newPackage && check)
		{
			if(!strcmp(newPackage->name, "XFree86-xf86cfg"))
		    rpmdepCheck_(rpmdeps, &conflicts, &numConflicts);
		}
*/
		
		if(!check)
		{
	    rpmdepCheck(rpmdeps, &conflicts, &numConflicts);
    }

    rpmtransFree(rpmdeps);
    if(db) rpmdbClose(db);

    /* XXX This is a hack. rpmlib seems to have problems in the conflicts
       stuff */
    numProblems = 0;
    for( i = 0; i < numConflicts; i++ )
		{
			if( conflicts[i].sense == rpmDependencyConflict::RPMDEP_SENSE_REQUIRES )
				numProblems++;
    }

    if(!numProblems)
			return INST_OK;

		// Select required packages
 		for (i = 0; i < numConflicts; i++)
		{
   	  package = (struct packageInfo *)conflicts[i].suggestedPackage;
			
 	    if( package && !package->selected )
			{
				printf( "Select required package: %s (%s) for %s\n", package->name, package->group,
								newPackage ? newPackage->name : (conflicts[i].byName ? conflicts[i].byName : "unknown"));
				package->selected = true;
/*
				if(!strcmp(conflicts[i].byName, "rpm")) // mark all requirements for rpm-package as mustBe=1
					mustBe = 1;

				if(mustBe)
					package->mustBe = mustBe;
      	
				verifyDependencies_(package, mustBe, 1);
				mustBe = 0;
*/
			}
 		}

		// Free problems
 		rpmdepFreeConflicts( conflicts, numConflicts );

 		return INST_OK;
}

// called by previous function
int InstallSelect::verifyDependencies__(struct packageInfo *newPackage = 0, int mustBe = 0)
{
    rpmdb db = 0;
    rpmTransactionSet rpmdeps;
    int i;
    struct rpmDependencyConflict * conflicts;
    struct packageInfo * package, **packTmp;
    int numConflicts, numProblems;
    rpmErrorCallBackType old;
		class packageInfo *packInfoTmp;
		
//		int count = 0;		

    if(!QApplication::overrideCursor())
			QApplication::setOverrideCursor(waitCursor);

#ifdef GBLI_RPM3
    if( !QFile( NEWROOT +"/var/lib/rpm/packages.rpm" ).exists() ) {
#else
		if( !QFile( NEWROOT +"/var/lib/rpm/Packages" ).exists() ) {
#endif
			system( ("mkdir -p -m0755 "+ NEWROOT +"/var/lib/rpm").latin1() );
			rpmSetVerbosity( RPMMESS_FATALERROR );// we don't need db really
			old = rpmErrorSetCallback( rpmerror/*emptyErrorCallback*/ );
			if( rpmdbOpen( NEWROOT.latin1(), &db, O_RDWR | O_CREAT, 0644 ) )
	  	  db = NULL;
			rpmErrorSetCallback( old );
			rpmSetVerbosity( RPMMESS_NORMAL );
    }else{
#ifndef GBLI_STANDALONE
			printf( "DB already exists!\n" );
#endif
			rpmdbOpen( NEWROOT.latin1(), &db, O_RDWR, 0644 );
		}

		if( !db ){
			Log::logMain(32, "verifyDependencies: Failed to open db\n" );
			return INST_ERROR;
		}

    rpmdeps = rpmtransCreateSet( db, NULL );

		if( iStage > initialized )
			printf( "#progress\n" );

		printf("in verify\n");
    for (i = 0; i < ps.numPackages; i++)
		{
			if(ps.packages[i]->selected)
					rpmtransAddPackage( rpmdeps, ps.packages[i]->h, NULL, ps.packages[i], 0, NULL );
			else
 		  	rpmtransAvailablePackage( rpmdeps, ps.packages[i]->h, ps.packages[i] );
		}

		if( iStage > initialized )
			printf( "#progress\n" );

    rpmdepCheck(rpmdeps, &conflicts, &numConflicts);

		if( iStage > initialized )
			printf( "#progress\n" );

    rpmtransFree(rpmdeps);
    if(db) rpmdbClose(db);

		if( iStage > initialized )
			printf( "#progress\n" );

    /* XXX This is a hack. rpmlib seems to have problems in the conflicts
       stuff */
    numProblems = 0;
    for( i = 0; i < numConflicts; i++ )
		{
			if( conflicts[i].sense == rpmDependencyConflict::RPMDEP_SENSE_REQUIRES )
			{
//				printf("this package requires something: %s\n", (conflicts[i].byName ? conflicts[i].byName : "unknown"));
				numProblems++;
			}
    }

    if(!numProblems)
		{
			QApplication::restoreOverrideCursor();
			return INST_OK;
    }
	
//		printf("numProblems: %d\n", numProblems);
//		printf("numConflicts: %d\n", numConflicts);

		// Select required packages
		for (i = 0; i < numConflicts; i++)
		{
			packTmp = 0;
   	  package = (struct packageInfo *)conflicts[i].suggestedPackage;

 	    if(package && !package->selected)
			{
				printf( "Select required package: %s (%s) for %s\n", package->name, package->group,
								newPackage ? newPackage->name : (conflicts[i].byName ? conflicts[i].byName : "unknown"));
				package->selected = true;

				packInfoTmp = (class packageInfo *)malloc(sizeof(class packageInfo));
				packInfoTmp->h = conflicts[i].byHeader;
				packInfoTmp->name = (char*)conflicts[i].byName;

				packTmp = (packageInfo **)bsearch(&packInfoTmp, ps.packages, ps.numPackages,
																				 sizeof(*ps.packages), pkgCompareVer);
				if(packTmp)
				{
//        	printf("name from packTmp: %s, mustBe: %d\n", (*packTmp)->name, (*packTmp)->mustBe);
					package->mustBe = (*packTmp)->mustBe;
				}

				if(packInfoTmp)
					free(packInfoTmp);
			}

//			if(!package)
//				printf("no provides for: %s\n", conflicts[i].byName);
 		}

		// Free problems
 		rpmdepFreeConflicts( conflicts, numConflicts );

		verifyDependencies__(); // call this function again for newly selected packages
		if( iStage > initialized )
			printf( "#progress\n" );

 		return INST_OK;
}

/*
int InstallSelect::rpmdepCheck_(rpmTransactionSet ts, struct rpmDependencyConflict **conflicts, int *numConflicts)
{
    int npkgs = ts->addedPackages.size;
    struct availablePackage * p;
    int i, j;
    int rc;
    rpmdbMatchIterator mi = NULL;
    Header h = NULL;
    struct problemsSet pSet;

    pSet.alloced = 5;
    pSet.num = 0;
    pSet.problems = (rpmDependencyConflict *)xcalloc(pSet.alloced, sizeof(struct rpmDependencyConflict));

    *conflicts = NULL;
    *numConflicts = 0;

    qsort(ts->removedPackages, ts->numRemovedPackages, sizeof(int), intcmp);

    alMakeIndex(&ts->addedPackages);
    alMakeIndex(&ts->availablePackages);

    for (i = 0, p = ts->addedPackages.list; i < npkgs; i++, p++)
    {
			rc = checkPackageDeps_(ts, &pSet, p->h, NULL, p->multiLib);
			if (rc)
	  	  goto exit;
		}

	if (!pSet.num)
		free(pSet.problems);
	else
	{
		*conflicts = pSet.problems;
		*numConflicts = pSet.num;
	}

	pSet.problems = NULL;
  rc = 0;

exit:
    if (mi)
			rpmdbFreeIterator(mi);
    if (pSet.problems)
			free(pSet.problems);

		return rc;
}

int InstallSelect::checkPackageDeps_(rpmTransactionSet ts, struct problemsSet * psp,
		Header h, const char * keyName, int multiLib)
{
    const char * name, * version, * release;
    const char ** requires;
    const char ** requiresEVR = NULL;
    int * requireFlags = NULL;
    int requiresCount = 0;
    const char ** conflicts;
    const char ** conflictsEVR = NULL;
    int * conflictFlags = NULL;
    int conflictsCount = 0;
    int type;
    int i, rc;
    int ourrc = 0;
    struct availablePackage * suggestion;

    headerNVR(h, &name, &version, &release);

    if (!headerGetEntry(h, RPMTAG_REQUIRENAME, &type, (void **) &requires,
	     &requiresCount))
		{
			requiresCount = 0;
    }
		else
		{
			headerGetEntry(h, RPMTAG_REQUIREFLAGS, &type, (void **) &requireFlags, &requiresCount);
			headerGetEntry(h, RPMTAG_REQUIREVERSION, &type, (void **) &requiresEVR, &requiresCount);
    }

    for (i = 0; i < requiresCount && !ourrc; i++)
		{
			const char *keyDepend;

			if (keyName && strcmp(keyName, requires[i]))
	  	  continue;

	// If this requirement comes from the core package only, not libraries,
	//  then if we're installing the libraries only, don't count it in.
			if (multiLib && !isDependsMULTILIB(requireFlags[i]))
 		  	continue;

			printf("%s requires: %s\n", name, requires[i]);
			keyDepend = printDepend("R", requires[i], requiresEVR[i], requireFlags[i]);

			rc = unsatisfiedDepend_(ts, " Requires", keyDepend, requires[i],
															requiresEVR[i], requireFlags[i], &suggestion);
			switch (rc)
			{
				case 0:		// requirements are satisfied.
		    	break;
				case 1:		// requirements are not satisfied.
		    	rpmMessage(RPMMESS_DEBUG, "package %s-%s-%s require not satisfied: %s\n",
		    	name, version, release, keyDepend+2);

		    if (psp->num == psp->alloced) {
					psp->alloced += 5;
					psp->problems = (rpmDependencyConflict *)xrealloc(psp->problems, sizeof(*psp->problems) * psp->alloced);
		    }
	
			  psp->problems[psp->num].byHeader = headerLink(h);
	  	  psp->problems[psp->num].byName = xstrdup(name);
	    	psp->problems[psp->num].byVersion = xstrdup(version);
		    psp->problems[psp->num].byRelease = xstrdup(release);
		    psp->problems[psp->num].needsName = xstrdup(requires[i]);
	  	  psp->problems[psp->num].needsVersion = xstrdup(requiresEVR[i]);
	    	psp->problems[psp->num].needsFlags = requireFlags[i];
		    psp->problems[psp->num].sense = rpmDependencyConflict::RPMDEP_SENSE_REQUIRES;

		    if (suggestion)
					psp->problems[psp->num].suggestedPackage = suggestion->key;
	    	else
					psp->problems[psp->num].suggestedPackage = NULL;

		    psp->num++;
		    break;
				case 2:		// something went wrong!
				default:
	  	  	ourrc = 1;
		    break;
			}
			free((void *)keyDepend);
    }

    if (requiresCount) {
			free(requiresEVR);
			free(requires);
    }

	return ourrc;
}

int InstallSelect::unsatisfiedDepend_(rpmTransactionSet ts,
	const char * keyType, const char * keyDepend,
	const char * keyName, const char * keyEVR, int keyFlags,
	struct availablePackage ** suggestion)
{
    static int _cacheDependsRC = 1;
    rpmdbMatchIterator mi;
    Header h;
    int rc = 0;	// assume dependency is satisfied

    if (suggestion) *suggestion = NULL;
    if (suggestion)
			*suggestion = alSatisfiesDepend_(&ts->availablePackages, NULL, NULL, keyName, keyEVR, keyFlags);

unsatisfied:
    rpmMessage(RPMMESS_DEBUG, "%s: %-45s NO\n", keyType, keyDepend+2);
    rc = 1;	// dependency is unsatisfied

exit:
    return rc;
}

struct availablePackage * InstallSelect::alSatisfiesDepend_(
	struct availableList * al,
	const char * keyType, const char * keyDepend,
	const char * keyName, const char * keyEVR, int keyFlags)
{
    struct availableIndexEntry needle, * match;
    struct availablePackage * p;
    int i, rc;

		printf("looking for - %s\n", keyName);

//    if (*keyName == '/')
//	return alFileSatisfiesDepend(al, keyType, keyName);

    if (!al->index.size)
		{
			printf("al->index.size = 0\n");
			return NULL;
    }
		else
			printf("al->index.size = %d\n", al->index.size);

    needle.entry = keyName;
    needle.entryLen = strlen(keyName);
		log = 1;
    match = (struct availableIndexEntry*) bsearch(&needle, al->index.index, al->index.size,
		    sizeof(*al->index.index), indexcmp);

    if (match == NULL)
		{
			printf("match == NULL\n");
			return NULL;
  	}
		else
			printf("found - %s\n", match->package->name);

    p = match->package;
    rc = 0;
    switch (match->type)
		{
    case 1:
			for (i = 0; i < p->providesCount; i++)
			{
		    const char *proEVR;
	  	  int proFlags;

		    // Filter out provides that came along for the ride.
	    	if (strcmp(p->provides[i], keyName))
					continue;
      	
		    proEVR = (p->providesEVR ? p->providesEVR[i] : NULL);
		    proFlags = (p->provideFlags ? p->provideFlags[i] : 0);
	  	  rc = rpmRangesOverlap(p->provides[i], proEVR, proFlags,
				keyName, keyEVR, keyFlags);
		    if (rc) break;
			}
			if (keyType && keyDepend && rc)
	  	  rpmMessage(RPMMESS_DEBUG, "%s: %-45s YES (added provide)\n", keyType, keyDepend+2);
   	break;
    }

    if (rc)
	return p;
		printf("rc == 0\n");
    return NULL;
}
*/

// this function is called by installation process to report
// about current progress and open/close real rpm file

//static void * installCallback( const Header h, const rpmCallbackType what,
static void * installCallback( const void *h, const rpmCallbackType what,
			 const unsigned long amount, const unsigned long total,
			 const void * pkgKey, void * data ) {
  void * rc = NULL;
  struct callbackInfo * cbi = (struct callbackInfo *)data;
  struct packageInfo * pkg = (struct packageInfo *)pkgKey;
	long double newProgress = 0;
//	int realplay = 0;
	static int ldConf = 0;

  switch( what ) {
    case RPMCALLBACK_TRANS_START:
    case RPMCALLBACK_UNINST_START:
//printf( "Callback: trans start: total %d, amount %d!\n", (int)total, (int)amount );
			break;
    case RPMCALLBACK_TRANS_PROGRESS:
    case RPMCALLBACK_UNINST_PROGRESS:
//printf( "Callback: trans progress: scale %d, total %d, amount: %d\n", (int)total, (int)amount );
//			printf( "#progress%d\n", (int)amount );
			break;
    case RPMCALLBACK_TRANS_STOP:
    case RPMCALLBACK_UNINST_STOP:
//printf( "Callback: trans stop!\n" );
//			printf( "#progress30\n" );
			break;
    case RPMCALLBACK_INST_START:
//printf( "Callback: INST_START!\n" );
			curTemp = 0;
//			printf( "#setmax%d\n", 100 );
			break;
    case RPMCALLBACK_INST_PROGRESS:
//printf( "CB_INST_PROGRESS total %d, amount %d, size %d, cur %d, tsize %d!\n",
//				(int)total, (int)amount, (int)pkg->size, (int)curInstalled, (int)cbi->totalsize );
			if( curTemp++ < 20 ) break;
			curTemp = 0;
			newProgress = ((long double)pkg->size * (long double)amount) /
										 (long double)total;
			newProgress += (long double)curInstalled;
			newProgress *= (long double)968 / (long double)cbi->totalsize;
			newProgress += 30;
			printf( "#progress%d\n", (int)newProgress );
			break;
    case RPMCALLBACK_INST_CLOSE_FILE:
//printf( "Callback: INST_CLOSE_FILE!\n" );
			fdClose( cbi->fd );
			curInstalled += pkg->size;

			if(InstallSelect::blUpdate && !strcmp(pkg->name, "XFree86"))
			{
				::system(("cp -f " + NEWROOT + "/etc/ld.so.conf " + NEWROOT + "/tmp").latin1());
				ldConf = 1;
			}			

			// kill popup realplayer windows
//			realplay = !!strstr( (char*)pkg->data, "RealPlay" );
//			if( realplay )
//				system( "killall -9 realplay >/dev/null 2>&1" );

			system( ("rm -rf "+ NEWROOT +"/tmp/*.rpm >/dev/null 2>&1").latin1() );
			break;
    case RPMCALLBACK_INST_OPEN_FILE:
//printf( "Callback: INST_OPEN_FILE - %s\n", pkg->name );
      if( fatalError ){
        rc = 0; // shows that file wasn't opened
        break;
      }

			if(ldConf)
			{
				::system(("mv " + NEWROOT + "/tmp/ld.so.conf " + NEWROOT + "/etc &>/dev/null").latin1());
				::system(("chroot " + NEWROOT + " /sbin/ldconfig").latin1());
				ldConf = 0;
			}

 	    static char realName[200];
 			sprintf( realName, "%s/software/RPMS.BL/%s", INSTALL_SOURCE.latin1(), (char *)pkg->data );

			int k = 0;
			bool skip = true;
			while(commercialList[k]){
				skip = !!strstr( (char*)pkg->data, commercialList[k]);
				if( skip ){
					if( !InstallSelect::keyOK ){
				    Log::logMain(32, "Skipping - %s\n", (char *)pkg->data );
						return NULL;
					}else{
     				Log::logMain( 32, "failed to decrypt rpm %s\n", realName );
						return NULL;
					}

      	    printf( "%s - %s\n",
       		    cbi->upgrade ? "Update" : "Install", realName );

						// open the rpm file and return file handler
          	cbi->fd = fdOpen( realName, O_RDONLY, 0/*0666*/);
          	if (!cbi->fd) {
              int olderrno = errno;
      				Log::logMain( 32, "cannot open RPM file %s - error %s\n", realName,
      	    		strerror( olderrno ) );
              return NULL;
						}

			    	cbi->lastFile = realName;
						rc = cbi->fd;
				    return rc;
					}
				}
				++k;
			}

	    Log::logMain(32, "%s - %s\n",
 		    cbi->upgrade ? "Update" : "Install", (char *)pkg->data );

    	cbi->fd = fdOpen( realName, O_RDONLY, 0/*0666*/);
    	if (!cbi->fd) {
        int olderrno = errno;
				Log::logMain( 32, "cannot open RPM file %s - error %s\n", realName,
	    		strerror( olderrno ) );
        return NULL;
    	}

    	cbi->lastFile = realName;
    	rc = cbi->fd;
   		break;
    }
    return rc;
}

// selects some packages according to selected installation type
void InstallSelect::selectPackages()
{
	int i;

	if( selected == update ) return;

/*
	if( isCustom() ){ // forcely add Base in any case
		if( cs.base ){
		  for ( i = 0; i < cs.base->ps.numPackages; i++)
				cs.base->ps.packages[i]->selected = true;
		}
		return;
	}
*/	

	// Select all or none
  for(i = 0; i < ps.numPackages; i++)
  {
//		// skip install of NVIDIA packages
//		// they will be installed in finnish method of VideoCard if NVIDIA card is present
//		if (QString(ps.packages[i]->name).find("NVIDIA") != -1)
//			ps.packages[i]->selected = false;
//		else
			ps.packages[i]->selected = (selected == full);

			// Unselect commercial rpms if BLED KEY is wrong/not entered
			// to prevent msgbox 'One or more packa.....'
			if (selected == full)
			{
				int iPkg=0;
				while (commercialList[iPkg])
				{
					if (QString(ps.packages[i]->name).find(commercialList[iPkg]) != -1)
						ps.packages[i]->selected = keyOK;
					iPkg++;
				}
			}
	}

	if(selected == full)
	{
		Log::logMain(32, "all selected\n");
		return; // everything already selected
	}

	printf( "#progress\n" );
  	
	// Select 'Base'
	if( cs.base ){
    for ( i = 0; i < cs.base->ps.numPackages; i++)
  		cs.base->ps.packages[i]->selected = true;
  	Log::logMain(32, "Selected %d packages (base)\n", cs.base->ps.numPackages );
  	printf( "#progress\n" );
	}

#ifndef GBLI_SERVER
	// Select 'Typical'
	if( selected == typical && cs.typical ){
    for ( i = 0; i < cs.typical->ps.numPackages; i++)
			cs.typical->ps.packages[i]->selected = true;
		Log::logMain(32, "Selected %d packages (typical)\n", cs.typical->ps.numPackages );
		printf( "#progress\n" );
	}

#else
	// Select 'Development'
	if( selected == develop && cs.develop ){
    for ( i = 0; i < cs.develop->ps.numPackages; i++)
  		cs.develop->ps.packages[i]->selected = true;
  	Log::logMain(32, "Selected %d packages (develop)\n", cs.develop->ps.numPackages );
		printf( "#progress\n" );
	}

	// Select 'Server'
	if( selected == server && cs.server ){
    for ( i = 0; i < cs.server->ps.numPackages; i++)
  		cs.server->ps.packages[i]->selected = true;
  	Log::logMain(32, "Selected %d packages (server)\n", cs.server->ps.numPackages );
		printf( "#progress\n" );
	}
#endif

	if( selected != base ){ // lets select some localization packages
		char ispell_name[16];
		sprintf( ispell_name, "ispell-%s", Language::lang->key->latin1() );
		char kdei18n_name[32];
		sprintf( kdei18n_name, "kde-i18n-%s", Language::lang->lang->latin1() );
		char locales_name[16];
		sprintf( locales_name, "locales-%s", Language::lang->key->latin1() );

    for( i = 0; i < ps.numPackages; i++ ){
			if( !strcmp( ps.packages[i]->name, ispell_name ) ||
					!strcmp( ps.packages[i]->name, kdei18n_name ) ||
					!strcmp( ps.packages[i]->name, locales_name ) )
						ps.packages[i]->selected = true;
		}
		printf( "#progress\n" );
	}
}

// do real packages install
int InstallSelect::doInstall()
{
    int i;
		int totalNumPackages = 0;
		int totalSizePackages = 0;
    rpmdb db;
    FD_t lfFd;
    rpmTransactionSet trans;
    rpmProblemSet probs;
    struct callbackInfo cbi;
		int syslogPID = 0;

/*
#ifdef GBLI_STANDALONE
		printf("entered doInstall()\n");
    for( i = 0; i < ps.numPackages; i++ )
		{
    	if(ps.packages[i]->selected)
			{
				printf("name: %s\n", ps.packages[i]->name);
			}
		}
		return INST_OK;
#endif
*/
/*
		// save current time
		// Maddy 04/09/2001 - this caused a lot of troubles, so I switched it off
		// and set real time during installation
		struct timeval curtime, time;
    gettimeofday( &curtime, NULL );
		gettimeofday( &time, NULL );
		time.tv_sec -= 86400;// full day back
// in case someone invents time machine and travels
// back to 0 time to install Best Linux... hence we have to check
// the condition to be sure
		if( time.tv_sec < 0 )
			time.tv_sec = 0;
    settimeofday( &time, NULL );

    path = (char *)alloca( NEWROOT.length() + 20 );
    sprintf( path, "%s/tmp/install_spec.log", NEWROOT.ascii() );
    lfFd = fdOpen( path, O_RDWR | O_CREAT | O_TRUNC, 0600 );
*/

		lfFd = fdDup( Log::mainlog->_fileno );
		setlinebuf( Log::mainlog );

Log::logMain( 35, "Passed checkpoint, _fileno %d !\n", Log::mainlog->_fileno );

/*
    if( lfFd ) {
    	spec_log = fdopen( fdFileno(lfFd), "w" );
if( !spec_log )
printf( "failed to open logfile :-(\n" );
    	setlinebuf( spec_log );
printf( "opened %s\n", path );
    } else {
printf( "failed to open %s :-(\n", path );
			printf( "#message%s \n", tr("Failed to open %1. No install log will be kept.").arg(path).ascii() );
    }
*/

//    syslogPID = handleSyslogSocket( NEWROOT.ascii() );

    if( Log::iDebugLevel > 2 )	
      rpmSetVerbosity( RPMMESS_DEBUG ); //extra debug ;-)

    rpmErrorSetCallback( rpmerror );
printf( "#progress\n" );

    /* FIXME: we ought to read NEWROOT/usr/lib/rpmrc if we're in the midst of an
       upgrade, but it's not obvious how to get RPM to do that. */
    /* if we set netshared path to "" then we get no files installed
    addMacro(&globalMacroContext, "_netsharedpath", NULL,
	     netSharedPath ? netSharedPath : "" , RMIL_RPMRC); */

		// init rpm DB
    rpmdbInit( NEWROOT.latin1(), 0644 );
printf( "#progress\n" );

		int res = 0;
		// open rpm DB
    if( (res = rpmdbOpen( NEWROOT.latin1(), &db, O_RDWR | O_CREAT, 0644 )) ) {
	    Log::logMain( 32, "rpmdbOpen res: %d, error: %d, %s\n", res, rpmErrorCode(), rpmErrorString() );
			printf( "#messageFatal error opening RPM database\n" );
//	    settimeofday( &curtime, NULL );
    	return INST_ERROR;
    }
    Log::logMain(32, "opened rpm database\n" );
		::sync();

printf( "#progress\n" );

		// create transaction set
    trans = rpmtransCreateSet( db, NEWROOT.latin1() );
printf( "#progress\n" );

    rpmtransSetScriptFd( trans, lfFd );
		::sync();

    totalNumPackages = 0, totalSizePackages = 0;

		// add packages which are currently selected
    for( i = 0; i < ps.numPackages; i++ )
		{
    	if(ps.packages[i]->selected )
			{
       	if( Log::iDebugLevel > 3 )
          printf( "Add package: %s\n", ps.packages[i]->name );
   	  	
				rpmtransAddPackage( trans, ps.packages[i]->h, NULL,
		    	ps.packages[i], (int)(selected==update), NULL );

  	    totalSizePackages += ps.packages[i]->size;
			  totalNumPackages++;
    	}
    }

printf( "#progress\n" );
Log::logMain(32, "Added packages: %d of total %d!\n", totalNumPackages, ps.numPackages );

		// log missing files, i.e. which are not selected
		if( Log::iDebugLevel > 1 ){
  	  Log *strangefiles = NULL;
    	strangefiles = new Log( false, (char *)(NEWROOT +"/tmp/not_selected_packages.log").latin1() );
//  	  Log *normfiles = NULL;
//    	normfiles = new Log( false, (char *)(NEWROOT +"/tmp/selected_packages.log").latin1() );
    	bool written = false;
    	if( strangefiles ){
        for( i = 0; i < ps.numPackages; i++ ) {
        	if ( !ps.packages[i]->selected )
					{
     				strangefiles->log( 0, "%s  (%s)\n", ps.packages[i]->name, ps.packages[i]->group );
     				written = true;
        	}
//					else if( normfiles ){
//     				normfiles->log( 0, "%s  (%s)\n", ps.packages[i]->name, ps.packages[i]->group );
//					}
        }
    		strangefiles->close();
//				if( normfiles )
//					normfiles->close();
    		Log::logMain(32, "Logged missing files!\n" );
    		if( !written )
    		  system( ("rm -f "+ NEWROOT +"/tmp/not_selected_packages.log").latin1() );
    	}else{
    		Log::logMain(32, "Logging missing files failed!!!\n" );
    	}
		}

		// order packages by dependencies
    if( rpmdepOrder(trans) ) {
     	rpmdbClose( db );
     	rpmtransFree( trans );
			printf( "#message%s\n", tr("Error ordering package list: %1").arg( rpmErrorString() ).latin1() );
//	    settimeofday( &curtime, NULL );
     	return INST_ERROR;
    }
printf( "#progress\n" );
Log::logMain(32, "Ordered packages!\n" );

    cbi.upgrade = (int)(selected == update);
    cbi.totalnum = totalNumPackages;
    cbi.totalsize = totalSizePackages;

    /* mount /proc in the instroot */
//#ifdef UNMOUNT_PROC
//		system( "umount /proc" );
//#endif
//		char cmd[128];
//    sprintf( cmd, "mount -t proc proc %s/proc", NEWROOT.ascii() );
//		res = system( cmd );
//printf( "system reply to mounting proc: %d\n", res );

  	
	  if(!system(("mount |grep \"on " + NEWROOT + "/dev\" &>/dev/null").latin1()))
		{
			res = system(("umount "+ NEWROOT +"/dev").latin1());
			Log::logMain( 32, "Unmounting %s/dev: %d", NEWROOT.latin1(), res );
    }

		// Now lets try to take-off ;-)
		// package installation
		int totalResult = INST_OK;
   	if( rpmRunTransactions( trans, installCallback, &cbi, NULL, &probs,
			(rpmtransFlags)0, (rpmprobFilterFlags)~0 ) )
      totalResult = INST_ERROR;

		::sync();
		sleep( 1 );

//    sprintf( cmd, "umount %s/proc", NEWROOT.ascii() );
//		system( cmd );
//#ifdef UNMOUNT_PROC
//		system( "mount -t proc proc /proc" );
//#endif

#ifdef DEVFS
		res = system( ("mount -t devfs none "+ NEWROOT +"/dev").latin1() );
		Log::logMain( 32, "Mounting %s/dev: %d", NEWROOT.latin1(), res );
#else
		res = system( ("mount --bind /dev "+ NEWROOT +"/dev").latin1() );
		Log::logMain( 32, "Mounting %s/dev: %d", NEWROOT.latin1(), res );		
#endif
		
printf( "#progress\n" );
Log::logMain(32, "Installed packages!\n" );

    fdClose( lfFd );

		// free memory which contains error messages
    rpmProblemSetFree( probs );

		// close rpm DB
    rpmdbClose( db );

		// free memory used by transaction set
    rpmtransFree( trans );

    Log::logMain(32, "rpm database closed\n" );

    if( syslogPID > 0 ){
			::kill( syslogPID, SIGKILL );
			::waitpid( syslogPID, NULL, 0 );
	  }
		::sync();

printf( "#progress\n" );

//    settimeofday( &curtime, NULL );
    if( Log::iDebugLevel > 2 )
      printf( "Finished installing packages!\n" );

		setvbuf( Log::mainlog, (char *)NULL, _IOLBF, 0 );

    return totalResult;
}
