/***************************************************************************
                          isppage.cpp  -  description                              
                             -------------------                                         
    begin                : Mon Sep 11 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		 : Oleg Golovachov (Demiurg)
    author email         : og@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "isppage.h"
#include "lmodemdata.h"
#include "config.h"
#include "lwriter.h"
#include "language.h"


//#include "log.h" //for testing

ISPPage::ISPPage(QWidget *parent, const char *name )
      : GBLIPage(parent,name)
{
  db = new LISPDB( QString( GBLI_DATA_PATH ) +"/data/isprovider" );
  //Added by dk
	/*dk*/
	QHBoxLayout *ml = new QHBoxLayout(this);
	QVBoxLayout *vl = new QVBoxLayout();
	QHBoxLayout *hl = new QHBoxLayout();
	QHBoxLayout *hl2 = new QHBoxLayout();
	QHBoxLayout *hl3 = new QHBoxLayout();
	QHBoxLayout *hl4 = new QHBoxLayout();
	QGridLayout *grid = new QGridLayout(NULL, 2,6, 5,5);
	
	ml->addLayout(vl);
  vl->addLayout(grid);
	vl->addSpacing(3);
	vl->addLayout(hl4);
	vl->addSpacing(3);
	vl->addLayout(hl);
	vl->addSpacing(3);
	vl->addLayout(hl2);
	vl->addStretch(3);
	/*dk*/

  hasProvider = new QCheckBox(tr("&Use dial-up networking"), this);
	hasProvider->setAutoMask( true );
//  hasProvider->setChecked(true);
  grid->addMultiCellWidget(hasProvider, 0,0,0,1);
	grid->addRowSpacing(0,5);
  connect(hasProvider, SIGNAL(clicked()), this, SLOT(toggleProvider()));

  provider = new QListView(this);
  userItem = new LISPItem(provider, new LISP);
  userItem->setText(0, tr("User defined"));
  db->fillListView(provider, userItem);
  grid->addWidget(provider, 1,1);
	grid->addRowSpacing(1,5);
  provider->setFont( QFont( "helvetica", Language::iSmallFontSize ) );
  provider->addColumn( tr( "Name" ), 100 );
  provider->setColumnWidth(0, 340);
  provider->setColumnWidthMode(0, QListView::Manual);
	//Added by dk
  /*dk*/
	provider->setFixedHeight(150);
  /*dk*/
  provider->header()->hide();
  provider->setRootIsDecorated(true);
  provider->setAllColumnsShowFocus(true);
  provider->setFrameStyle( QFrame::WinPanel + QFrame::Sunken );
  provider->setVScrollBarMode(QListView::AlwaysOn);
  provider->setHScrollBarMode(QListView::Auto);
  connect(provider, SIGNAL(selectionChanged(QListViewItem *)),
	  this, SLOT(providerChanged(QListViewItem *)));

  QLabel *l = new QLabel(provider, tr("&Provider"), this);
	l->setAutoMask( true );
  grid->addWidget(l, 1,0, AlignTop);
	//Added by dk
	/*dk*/
	grid->addRowSpacing(1,5);
	/*dk*/

  savePasswd = new QCheckBox(tr("Save authentication information"), this);
	savePasswd->setAutoMask( true );
//  savePasswd->setChecked(true);
//  grid->addMultiCellWidget(savePasswd, 4,4, 0,1); //dk
  hl4->addWidget(savePasswd,0,AlignLeft);//dk
	connect(savePasswd, SIGNAL(clicked()), this, SLOT(toggleProvider()));

  details = new QPushButton(tr("&Details..."), this);
	details->setFixedWidth(90);
  //grid->addWidget(details, 2,1, AlignLeft); //dk
	hl4->addWidget(details,0,AlignRight);//dk
  connect(details, SIGNAL(clicked()), this, SLOT(editDetails()));

	//Commendted by dk
  /*QFrame *f = new QFrame(this);
  f->setFrameStyle(QFrame::Sunken | QFrame::HLine);
  grid->addMultiCellWidget(f, 3,3, 0,1);*/



//Moved here by dk
  user = new QLineEdit(this);
	user->setMaxLength(20);

	l = new QLabel(user, tr("&Login"), this);
	l->setAutoMask( true );
	//grid->addWidget(l, 5,0, AlignLeft);//dk
	//Added by dk
	/*dk*/
	hl->addWidget(l);
  hl->addSpacing(10);
	//grid->addWidget(user, 5,1);	//dk
	hl->addWidget(user);
  hl->addSpacing(10);
	/*dk*/

//Moved here by dk
	passwd = new QLineEdit(this);
  passwd->setEchoMode(QLineEdit::Password);
	passwd->setMaxLength(20);

	l = new QLabel(passwd, tr("Pass&word"), this);
	l->setAutoMask( true );
  //grid->addWidget(l, 6,0, AlignLeft);
	//Added by dk
  /*dk*/
	hl->addWidget(l);
  hl->addSpacing(10);
	
  //grid->addWidget(passwd, 6,1); //dk
	hl->addWidget(passwd);
	/*dk*/

  l = new QLabel(tr("<i>Note: saving the authentication information will"
		      " allow all users to dial up!</i>"), this);
	l->setAutoMask( true );
  //grid->addWidget(l, 7,1); //dk
	hl2->addWidget(l);//dk

	//Commented by dk
  /*f = new QFrame(this);
  f->setFrameStyle(QFrame::Sunken | QFrame::HLine);
  grid->addMultiCellWidget(f, 8,8, 0,1);*/

  test = new QPushButton(tr("Test"), this);
  //grid->addWidget(test, 9,0);  //dk
	hl3->addWidget(test);//dk

  l = new QLabel(tr("<i>Using the <b>Test</b> button will try to "
		      "dial up and connect to your provider. "
		      "It will not transfer any private data, "
		      "but may cost some connection fees.</i>"), this);
	l->setAutoMask( true );
  //grid->addWidget(l, 9,1); //dk
	hl3->addWidget(l);//dk

  // disabled for now
  //f->hide(); //dk
  test->hide();
  l->hide();

}


ISPPage::~ISPPage()
{
}

void ISPPage::load()
{
  isp = *LISPData::data();

  hasProvider->setChecked(isp.hasProvider());

  // TODO: locate the provider in the list

  updateInfo();
}


void ISPPage::save()
{
  LISPData *data = LISPData::data();

  *data = isp;
  data->setUser(user->text());
  data->setPassword(passwd->text());
  data->setSavePassword(savePasswd->isChecked());
  data->setHasProvider(hasProvider->isChecked());
}

void ISPPage::hideEvent( QHideEvent * )
{
  save();
}

void ISPPage::showEvent( QShowEvent * )
{
  load();
}

void ISPPage::finish(QString userName)
{
    LISPData *idata = LISPData::data();
    LModemData *mdata = LModemData::data();
		QString qsDeviceName;
		
		if ((mdata==NULL) || ( idata==NULL) || (hasProvider==NULL)){
			printf("ERROR: LISPData::data() or LModemData::data() missing!\n");
			return;
		}
		if (!mdata->exists()) return; //no modem configuration

    makeDirs(NEWROOT+"/etc/sysconfig/network-scripts");
//what about condition do not write those config ?      >;/
//fixed to use only empty pppX slots

	if  (hasProvider->isChecked()) //write only if dial-up networking was enabled
	for (int iInd=0; iInd<MAXPPPX; iInd++){

		qsDeviceName.sprintf("ppp%d",iInd);
	  QFile f(NEWROOT+"/etc/sysconfig/network-scripts/ifcfg-"+qsDeviceName);
		if (f.exists())	continue; //skip already ised file

    if (f.open(IO_WriteOnly))
    {
      QTextStream conf(&f);

      conf << "DEVICE=" << qsDeviceName.latin1() << endl;
      conf << "NAME="   << idata->name() << endl;
      conf << "WVDIALSECT=" << idata->name() << endl;
      conf << "MODEMPORT=" << mdata->device() << endl;
      conf << "LINESPEED=" << mdata->speed() << endl;
      conf << "PAPNAME=" << idata->user() << endl;
      conf << "USERCTL=true" << endl;
      conf << "ONBOOT=no" << endl;    //hmm
      conf << flush;
      f.close();
										break; //work should be done only once,so get out :)
  		}		
	}//for
    
    QFile f2(NEWROOT+"/etc/wvdial.conf");
    if (f2.open(IO_WriteOnly))
    {
      QTextStream conf(&f2);
      
      conf << "[Modem0]" << endl;
      conf << "Modem = " << mdata->device() << endl;
      conf << "Baud = " << mdata->speed() << endl;
      conf << "Init1 = " << mdata->initString() << endl;
      
      switch (mdata->flow())
      {
	case LModemData::None:
	  break;
	case LModemData::Software:
	  conf << "Init2 = " << mdata->softCommand() << endl; break;	
	default:
	  conf << "Init2 = " << mdata->hardCommand() << endl; break;	
      }
      conf << endl;
      
      conf << "[Dialer Defaults]" << endl;
      conf << "Modem = " << mdata->device() << endl;
      conf << "Baud = " << mdata->speed() << endl;
      conf << "Init1 = " << mdata->initString() << endl;
      
  switch (mdata->flow()){
	case LModemData::None:
	  break;
	case LModemData::Software:
	  conf << "Init2 = " << mdata->softCommand() << endl; break;	
	default:
	  conf << "Init2 = " << mdata->hardCommand() << endl; break;	
      }
      conf << endl;
      
      conf << "[Dialer " << idata->name() << "]" << endl;
      conf << "Username = " << idata->user() << endl;
      conf << "Password = " << idata->password() << endl;
      conf << "Modem = " << mdata->device() << endl;
      conf << "Phone = " << idata->phone() << endl;
      conf << "Dial Prefix = " << endl;
      conf << "Area Code = " << endl;
      conf << "Baud = " << mdata->speed() << endl;
      conf << "Stupid mode = 0" << endl;

      conf << flush;
      f2.close();
    }

	if  (hasProvider->isChecked()){ //write only if dial-up networking was enabled

		QString curUser;
		char cmd[200];
		for(int a=0;a<2;a++)
		{
			if(a==0) curUser = "root";
			else curUser = "home/"+userName;

			sprintf(cmd,("mkdir -p "+NEWROOT+"/"+curUser+"/.kde/share/config").ascii());
			system(cmd);

      char CPline[200];
      sprintf(CPline,"cp %s/templates/kppprc %s/%s/.kde/share/config/", GBLI_DATA_PATH, NEWROOT.ascii(), curUser.ascii());

      system(CPline);
			if(a==1){
				sprintf( cmd, "chroot %s bash -c \"chown %s.%s -R /home/%s/.kde/share/config\"", NEWROOT.ascii(), userName.ascii(), userName.ascii(), userName.ascii() );
			  system( cmd );
			}


      SysConfigFile sysconfig( (NEWROOT+"/"+curUser).ascii(), "/.kde/share/config/kppprc" );
      sysconfig.load();
      sysconfig.set( "Phonenumber", idata->phone().ascii(), false );
      sysconfig.set( "Name", idata->name().ascii(), false );
      sysconfig.set( "Password", idata->password().ascii(), false );
      sysconfig.set( "DNS", (idata->DNS1()+","+idata->DNS2()).ascii(), false );
      sysconfig.set( "Username", idata->user().ascii(), false );
   		if(idata->savePassword())
			sysconfig.set( "Storepassword", "1", false );
	    else
			sysconfig.set( "Storepassword", "0", false );
      sysconfig.set( "InitString", mdata->initString().ascii(), false );
      sysconfig.set( "Device", mdata->device().ascii(), false );
      char str1[10];
      sprintf( str1, "%ld", mdata->speed() );
      sysconfig.set( "Speed", str1, false );
      sysconfig.save();
		} //if hasProvide->isChecked()

    }


}


bool ISPPage::visible()
{
  LModemData *data = LModemData::data();

  return data->exists();
}

void ISPPage::updateInfo()
{
  passwd->setText(isp.password());
  user->setText(isp.user());
  savePasswd->setChecked(isp.savePassword());
  toggleProvider();
}


/*bool ISPPage::skipForward()
{
  if (LGlobal::noSkip())
    return false;
  return !LModemData::data()->exists();
} */


void ISPPage::providerChanged(QListViewItem *item)
{
  if (item == userItem)
    {
      isp.setCallByCall(false);
      updateInfo();
      return;
    }

  LISP *lisp = db->getEntry(item);

  test->setEnabled(lisp != 0);
  details->setEnabled(lisp != 0);

  if (lisp)
    {
      isp.setCategory(lisp->category());
      isp.setName(lisp->name());
      isp.setPhone(lisp->phone());
      isp.setDNS1(lisp->DNS1());
      isp.setDNS2(lisp->DNS2());
      isp.setProxy(lisp->proxy());
      isp.setMail(lisp->mail());
      isp.setPPP(lisp->PPP());
      isp.setUser(lisp->user());
      isp.setPassword(lisp->password());
      isp.setCallByCall(lisp->callByCall());

      updateInfo();
    }
}


void ISPPage::toggleProvider()
{
  bool visible = hasProvider->isChecked();

  provider->setEnabled(visible);
  details->setEnabled(visible);

  savePasswd->setEnabled(visible && !isp.callByCall());

  visible = visible && savePasswd->isChecked();

  user->setEnabled(visible);
  passwd->setEnabled(visible);
  test->setEnabled(visible);
}


void ISPPage::editDetails()
{
  LISPDetails dlg(this);

  dlg.setCaption(tr("Provider info"));

  // enter the data
  dlg.name->setText(isp.name());
  dlg.phone->setText(isp.phone());
  dlg.dns1->setAddress(isp.DNS1());
  dlg.dns2->setAddress(isp.DNS2());
  dlg.mail->setText(isp.mail());
  dlg.proxy->setText(isp.proxy());
  dlg.ppp->setChecked(isp.PPP());

  if (dlg.exec())
  {
      if (dlg.name->edited() || dlg.phone->edited() || dlg.dns1->edited()
	  || dlg.dns2->edited() || dlg.mail->edited() || dlg.proxy->edited()
	  || dlg.ppp->isChecked() != isp.PPP())
	  {
	    isp.setName(dlg.name->text());
	    isp.setPhone(dlg.phone->text());
  	  isp.setDNS1(dlg.dns1->text());
  	  isp.setDNS2(dlg.dns2->text());
  	  isp.setMail(dlg.mail->text());
  	  isp.setProxy(dlg.proxy->text());
  	  isp.setPPP(dlg.ppp->isChecked());	

  	  isp.setCallByCall(false);
  	  provider->setCurrentItem(userItem);
  	  provider->setSelected(userItem, true);
  	  provider->ensureItemVisible(userItem);
	  }
  }
}

void ISPPage::addWindowsEntry(LISP* pNewEntry)
{
	QListViewItem* item = getGroupItem(provider, tr("User defined") + "(Windows)");
	if (item) item = new LISPItem(item, pNewEntry);
	else item = new LISPItem(provider, pNewEntry);
	item->setText(0, pNewEntry->name());
	db->addEntry(pNewEntry);
}
