/***************************************************************************
                          isppage.h  -  description                              
                             -------------------                                         
    begin                : Mon Sep 11 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		 : Oleg Golovachov (Demiurg)
    author email         : og@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/





#ifndef ISPPAGE_H
#define ISPPAGE_H

#ifndef MAXPPPX
#define MAXPPPX 32
#endif

#include "gblipage.h"

#include <qwidget.h>
#include <qlayout.h>
#include <qcombobox.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qframe.h>
#include <qheader.h>

#include "lispdata.h"
#include "lispdb.h"
#include "lispdetails.h"
#include "qdir.h"

//#include "lconfig.h"
/**
  *@author Oleg Golovachov (Demiurg)
  */

class ISPPage : public GBLIPage  {
   Q_OBJECT
public: 
	ISPPage(QWidget *parent, const char *name=0);
	~ISPPage();
  void finish(QString userName);
  bool visible();

  void addWindowsEntry(LISP* pNewEntry);

public slots:
	void finish() {}

private slots:
  void providerChanged(QListViewItem *item);
  void toggleProvider();

  void editDetails();


protected:

  void load();
  void save();

  void hideEvent( QHideEvent * );
  void showEvent( QShowEvent * );

  void updateInfo();


private:
  QCheckBox *hasProvider;

  QListView *provider;
  QLineEdit *user, *passwd;
  QCheckBox *savePasswd;
  QPushButton *details, *test;

  LISPDB    *db;

  LISPData  isp;

  LISPItem *userItem;

};

#endif
