/***************************************************************************
                              keyboard.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef KEYBOARD_H
#define KEYBOARD_H
#include <qwidget.h>
#include <qlist.h>
#include <qstring.h>
#include <qdir.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "gblipage.h"

class QListBox;
class QLineEdit;

// to setup keyboard type and layout
// allows to test the settings in the special field
class Keyboard: public GBLIPage
{
    Q_OBJECT
public:
    Keyboard( QWidget * parent, const char * name = 0 );
    ~Keyboard() { }
    bool eventFilter( QObject *, QEvent * );

    QString layout();
    QString xkb();
    QString model();
		void finish();

    void init();

public slots:
    void enableNext( bool a_bl ){ nextEnabled( this, a_bl ); };

signals:
    void nextEnabled( QWidget *, bool );
		
protected:
    void showEvent( QShowEvent * );
    void hideEvent( QHideEvent * );

private:
    void set( char *a_sz = NULL );
    int setLayout;
    int setModel;

    QListBox* listLayout;
    QListBox* listModel;

    QLineEdit* editTest;

    bool initialized;
};

#endif


