/***************************************************************************
                              language.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

  	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef LANGUAGE_H
#define LANGUAGE_H

#include "timezone.h"

#include <stdio.h>

#include <qcheckbox.h>
#include <qwidget.h>
#include <qlist.h>
#include <qradiobutton.h>

//#define QT_THREAD_SUPPORT

#ifdef QT_THREAD_SUPPORT
	#include <qthread.h>
#endif

class QListBox;
class QString;

// storage for the language specification
class langInfo
{
  public:
    QString * lang, * key, * font, * map, * lc_all, * charset;
    bool beta;
    QString * kimap;
//Hack by BP
		QString	*	sKDEFont;
//Hack by BP
};

// allows user to select the language and timezone
// interconnects timezone to the language
class Language : public QWidget
{
    Q_OBJECT

public:
    Language( QWidget * parent = 0, const char * name = 0 );
    ~Language() { }

		// installer global font sizes
		static int iBigFontSize;
		static int iNormalFontSize;
		static int iSmallFontSize;

    static QList<langInfo> langs;
    static void loadLanguages();
    static langInfo* lang;

    static QFont::CharSet setupFont( QFont *a_font );
    static void finish( bool script=false );

    QString timezone();
    QComboBox* comboZone;
	  QString wrapString(QString s, int maxlen);

		// updates the time in the system
		// note that it is made in a hacky way, since it is not possible
		// to make it the same in installer and in the running system
    void finishTime();
  /**  */


		// bridge from the timezone to the language,
		// so that you click on the city and it tries to select the language
		QDict<QString> t2l;

signals:
		void updateTime();

protected:
    void showEvent( QShowEvent * );

public slots:
    void setTimezone( const QString& );
    void prepare();

		void updateTimeField();

private slots:
    void setSelected( int );
		// checkbox for GMT/not-GMT changed, let's update the system time
		void setGMT( bool a_blGMT ){
			blGMT = a_blGMT;
			chkGMT->setChecked( blGMT );
			finishTime();
		};

private:
		QListBox *lboxLangs;

    World*  world;
    bool prepared;

    QLabel*  comment;

#ifdef TIME_FIELD
		QLineEdit *curTime;
		QTimer *updateTimer;
#else
		QCheckBox *chkGMT;
#endif
		bool blGMT;

#ifdef QT_THREAD_SUPPORT
		QSemaphore *changecount;
#endif

};
#endif
