/***************************************************************************
                               lcarddb.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <qfile.h>
#include <qtextstream.h>
#include <stdlib.h>

#include "lcarddb.h"


LCardDB::LCardDB(QString filename)
{
  LCardDBEntry *entry;
  QString item;
  bool ok;

  int cnt=0;

  db.setAutoDelete(TRUE);

  QFile file(filename);
  if (file.open(IO_ReadOnly))
    {
      QTextStream is(&file);

      while (!is.eof())
	{
	  entry = new LCardDBEntry;

	  item = is.readLine();
    if( item.left(1) == "#" ){
			delete entry;
			is.readLine();
			is.readLine();
			is.readLine();
			is.readLine();
			is.readLine();
			is.readLine();
			continue;
		}
		item.remove(0, 8);
	  entry->Vendor = item;

	  item = is.readLine(); item.remove(0, 7);
	  entry->Model = item;

	  item = is.readLine(); item.remove(0, 6);
	  entry->Name = item;

	  item = is.readLine(); item.remove(0, 14); 
	  entry->VendorID = item.toInt(&ok,16);

	  item = is.readLine(); item.remove(0, 14); 
	  entry->DeviceID = item.toInt(&ok,16);

	  item = is.readLine(); item.remove(0, 8);
	  entry->Server = item;

	  is.readLine();
	
//	  system("echo \"Vendor: " + entry->Vendor + "\" >>/tmp/vcards.txt");
//	  system("echo \"Model:  " + entry->Model + "\" >>/tmp/vcards.txt");
//	  system("echo \"Name:   " + entry->Name + "\" >>/tmp/vcards.txt");
//	  system("echo \"VenID:  " + QString::number(entry->VendorID) + "\" >>/tmp/vcards.txt");
//	  system("echo \"DevID:  " + QString::number(entry->DeviceID) + "\" >>/tmp/vcards.txt");
//	  system("echo \"Server:'" + entry->Server + "'\" >>/tmp/vcards.txt");
//	  system("echo \"\" >>/tmp/vcards.txt");

	  if ((entry->VendorID != 0) && (entry->DeviceID != 0))
	    item = QString("%1,%2").arg(entry->VendorID).arg(entry->DeviceID);
	  else
	    item = QString("%1").arg(cnt++);
	  db.insert(item.ascii(), entry);
	}      
    }  
}


LCardDBEntry *LCardDB::lookup(unsigned int vendor, unsigned int device)
{
  QString item = QString("%1,%2").arg(vendor).arg(device);
  return db[item.ascii()];
}


LCardDBEntry *LCardDB::lookup(QString name)
{
  QDictIterator<LCardDBEntry> it(db);
  while (it.current()){
    if (it.current()->Name == name)
			return it.current();
    ++it;
	}

  return 0L;
}


LCardDBEntry *LCardDB::probe()
{
  QFile file("/proc/bus/pci/devices");

  int res = file.open(IO_ReadOnly);
  if( !res ){
    file.setName( NEWROOT +"/proc/bus/pci/devices");
    res = file.open(IO_ReadOnly);
  }
  if( res ){
      QTextStream is(&file);
      QString line, item;

      line = is.readLine();
      while (!line.isEmpty()){
    	  item = line.mid(5,8);

    	  bool ok;
    	  int vendor = item.left(4).toUInt(&ok, 16);
    	  int device = item.right(4).toUInt(&ok, 16);

    	  LCardDBEntry *entry = lookup(vendor,device);
    	  if (entry)
    	    return entry;
    	
    	  line = is.readLine();
    	}
    }

  return 0;
}


void LCardDB::getCardList(QStrList &list)
{
  list.clear();

  QDictIterator<LCardDBEntry> it(db);
  while (it.current())
    {
      list.append(it.current()->Name);
      ++it;
    }
}

