/****************************************************************************
**
** $Id: lglobal.cpp,v 1.11 2000/02/09 11:41:39 mhk Exp $
**
** Copyright (C) 1999 Calderasystems, Inc
** All rights reserved.
**
** This file is part of the Caldera OpenLinux Installer.
** Original Implementation: 1999 by Troll Tech AS
**
** This file may be distributed under the terms of the Q Public License
** as defined by Troll Tech AS of Norway and appearing in the file
** LICENSE included in the packaging of this file.
**
*****************************************************************************/


#include <libintl.h>

#include "lglobal.h"


// Note: To build the final version of the lizard, you have to
// define LIZARD_NODEVEL. 

#ifdef LIZARD_NODEVEL

bool LGlobal::_localDisplay = true;
bool LGlobal::_probeMouse = true;
bool LGlobal::_try_sound = true;

#else

bool LGlobal::_localDisplay = false;  // do not start a server on your devel machine :-)
bool LGlobal::_probeMouse = false;    // do not play games with the running X-Server
bool LGlobal::_try_sound = false;     

#endif


QString LGlobal::_xserver = "XF86_VGA16";
bool LGlobal::_probeNetwork = true;
bool LGlobal::_animation = false;     // no comment necessary, I guess...
bool LGlobal::_noskip = false;
bool LGlobal::_forceHires = false;
bool LGlobal::_demo = false;


QString i18n(const char* msgid) 
{
  return QString::fromLocal8Bit(dgettext( "lizard", msgid));
}


bool LGlobal::hires()
{
  if (_forceHires)
    return true;
  return (_xserver != "XF86_VGA16");
}
