/****************************************************************************
**
** $Id: lispdb.h,v 1.4 2000/02/01 10:38:54 mhk Exp $
**
** Copyright (C) 1999 Calderasystems, Inc
** All rights reserved.
**
** This file is part of the Caldera OpenLinux Installer.
** Original Implementation: 1999 by Troll Tech AS
**
** This file may be distributed under the terms of the Q Public License
** as defined by Troll Tech AS of Norway and appearing in the file
** LICENSE included in the packaging of this file.
**
*****************************************************************************/


#ifndef _L_ISPDB_H_
#define _L_ISPDB_H_


#include <qlist.h>
class QListView;
class QListViewItem;


#include "lispdata.h"


class LISPItem : public QListViewItem
{
public:

  LISPItem(QListView *lv, LISP *lisp) : QListViewItem(lv) {
    _lisp = lisp;
  };
  LISPItem(QListViewItem *item, LISP *lisp) : QListViewItem(item) {    
    _lisp = lisp;
  };
  
  LISP *lisp() { return _lisp; };


protected:

  void activate();


private:

  LISP *_lisp;

};


class LISPDB
{
public:

  LISPDB(QString filename);

  void fillListView(QListView *lv, LISPItem *u);

  LISP *getEntry(QListViewItem *item);
  /**  */
  void addEntry(LISP* pNewEntry);


private:

  QList<LISP> db;
  
  QListViewItem *user;

};

QListViewItem *getGroupItem(QListView *lv, const QStringList& groups);

#endif
