/****************************************************************************
**
** $Id: lmodemdata.h,v 1.4 2000/01/12 09:59:30 mhk Exp $
**
** Copyright (C) 1999 Calderasystems, Inc
** All rights reserved.
**
** This file is part of the Caldera OpenLinux Installer.
** Original Implementation: 1999 by Troll Tech AS
**
** This file may be distributed under the terms of the Q Public License
** as defined by Troll Tech AS of Norway and appearing in the file
** LICENSE included in the packaging of this file.
**
*****************************************************************************/


#ifndef __L_MODEM_DATA__
#define __L_MODEM_DATA__


#include <qstring.h>
#include <qlist.h>


class LModemData
{ 
public:

  enum Flow { None, Hardware, Software };

  QString device() { return _device; };
  void setDevice(QString dev) { _device = dev; };
  
  QString vendor() { return _vendor; };
  void setVendor(QString v) { _vendor = v; };

  QString model() { return _model; };
  void setModel(QString m) { _model = m; };

  unsigned long speed() { return _speed; };
  void setSpeed(unsigned long s) { _speed = s; };

  Flow flow() { return _flow; };
  void setFlow(Flow f) { _flow = f; };

  QString softCommand() { return _softcmd; };
  void setSoftCommand(QString fc) { _softcmd = fc; };

  QString hardCommand() { return _hardcmd; };
  void setHardCommand(QString fc) { _hardcmd = fc; };

  QString initString() { return _init; };
  void setInitString(QString i) { _init = i; };

  bool exists() { return _exists; };
  void setExists(bool e) { _exists = e; };
  
  bool probed() { return _probed; };
  void setProbed(bool p) { _probed = p; };

  static LModemData *data();

// LModemData *my_data = LModemData::data();

protected:
  
  LModemData();


private:

  static LModemData *_data;

  QString _device, _vendor, _model, _softcmd, _hardcmd, _init;
  unsigned long     _speed;
  Flow    _flow;
  bool    _probed, _exists;

};


#endif
