/***************************************************************************
                               main.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "config.h"
#include <stdio.h>

#include <qapplication.h>
#include <qsgistyle.h>
#include <qdir.h>
#include <qtranslator.h>
#include <qstylesheet.h>
#include <qaccel.h>
#include <qstring.h>
#include <qfile.h>
#include <qmessagebox.h>
#include <qtextstream.h>
#include <qfontinfo.h>
#include <qpalette.h>
#include <qcolor.h>
#include <qfontmetrics.h>
#include <qfontdatabase.h>

#include "liconloader.h"
#include "xserver.h"
#include "gbli.h"
#include "language.h"
#include "languagedialog.h"
#include "mouse.h"
#include "etcfiles.h"

// debug
//#include <dmalloc.h>
//#include <mcheck.h>

// symlink, unlink
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/reboot.h>
#include <stdlib.h>
#include <signal.h>

//X11
#include <X11/Xlib.h>
#include <X11/Xatom.h>

static QString GBLI_DIR = QDir::currentDirPath();

static int kde_x_errhandler( Display *dpy, XErrorEvent *err )
{
  char errstr[256];
  XGetErrorText( dpy, err->error_code, errstr, 256 );
  qWarning( "KDE detected X Error: %s %d\n  Major opcode:  %d", errstr,
    err->error_code, err->request_code );
  return 0;
}

QApplication* ptApp = NULL;
// installer itself
int main( int argc, char ** argv )
{
//		mtrace(); // this one is enabling debugging if linked with special library

		// "flag" shows that on the first screen (language)
		// user clicked Cancel, so that we don't start second stage
		// and let the script to the finish the job
    if( QFile( "/tmp/gbli_reboot" ).exists() )
			return 1;

		// I don't like when my hard drive is f**ked ;)
#ifndef GBLI_DEVEL
#ifndef GBLI_STANDALONE
		if( QDir( "/home" ).exists() ){
			printf( "It is not safe to run PRODUCTION version of GBLI on a normal system!\n" );
			printf( "Define GBLI_DEVEL in gbli/config.h\n" );
			return 1;
		}
#endif
#endif

		// find real gbli path for later references
		GBLI_DIR = QString( argv[0] );
		GBLI_DIR = GBLI_DIR.left( GBLI_DIR.findRev( '/' ) );
		if( GBLI_DIR == "gbli" ) GBLI_DIR = ".";

		// this one shows which stage we run: language or all other pages
    bool stage2 = false;
		// this is used in "Rescue mode" to just tune X server by GBLI
		bool justX = false;

#if defined(GBLI_DEVEL) || defined(GBLI_STANDALONE)
		stage2 = true;
#endif

    // check if we selected language already
    for( int i=0; i<argc; i++ ){
      if( !strcmp(argv[i],"--stage2") ){
        stage2 = true;
      }else if( !strcmp(argv[i],"--stage1") ){
				stage2 = false;
      }else if( !strcmp(argv[i],"--justX") ){
				justX = true;
			}
		}

		// remove crap from previous run	
#ifdef GBLI_DEVEL
	system( ("rm -rf /tmp/{install.log,update.log} "+ NEWROOT +"/tmp/{install.log,update.log} >/dev/null 2>&1").latin1() );
#endif

		// run it first time, so let's remove old files to enable autotune
    if( !stage2 ){
#if !defined(GBLI_DEVEL) && !defined(GBLI_STANDALONE)
//			system( "modprobe -qs kmod >/dev/null 2>&1" );
			::unlink( "/etc/X11/X" );

			// for pcmcia
			if( !QFile( "/sbin/cardmgr" ).exists() ){
				system( "ln -sf /usr/sbin/cardmgr /sbin/" );
				system( "ln -sf /usr/sbin/cardctl /sbin/" );
			}
			if (system("sh -c \"lsmod|grep pcmcia_core\" >/dev/null 2>/dev/null")==0)
			    system( "rmmod -s pcmcia_core >/dev/null 2>/dev/null" );
			system( "/etc/rc.d/init.d/pcmcia restart >/dev/null 2>&1" );

      system( QString("rm -f /etc/sysconfig/hwconf /etc/conf.modules /etc/modules.conf /etc/sysconfig/soundcard").ascii() );
      system( "kudzu -q -s" );
			if( QFile( "/etc/conf.modules" ).exists() )
				system( "mv /etc/conf.modules /etc/modules.conf" );
			system( "touch -t 01010000 "+ QString( CONF_MODULES ) );
#endif
			// autodetection of mouse
      Mouse::initMouse();
  	}
  	
    XServer s;

		if( justX )
	    return !s.serverRunning();

		// failed to run X ;(
    if( !s.serverRunning() ){
      Log::logMain(32, "Unable to start the X server.  "
	      "Please contact SOT Linux Support.\n" );
			return 2;
    }

#ifdef GBLI_DEVEL
		int width = 640;
		int height = 480;
#else
//  	QWidget *desk = QApplication::desktop();
		int width = 640;//desk->width();
		int height = 480;//desk->height();
#endif		

    // where to find the icons
    if (!justX)
		{
		LIconLoader::setLoadPath( QString( GBLI_DATA_PATH ) +"/graphics" );
		}
		else
		{
		LIconLoader::setLoadPath( QString( GBLI_DATA_PATH ) +"/graphics/blackwhite" );
		}
    LIconLoader::setStepsPath( QString( GBLI_DATA_PATH ) +"/icons" );

		// some crazy KDE stuff
    XSetErrorHandler( kde_x_errhandler );

    QApplication::setDesktopSettingsAware( FALSE );
    QApplication::setColorSpec( QApplication::NormalColor );
    QApplication::setStyle( new QSGIStyle /*QWindowsStyle*/ );
    QApplication a( argc, argv );
    ptApp = & a ;
		// this fonts tuning appeared to be crazy hard:
		// X and Qt select automatically different font sizes depending on
		// the video card
		// Those "times" and "no size" were get after 1 week of hacking ;(
//    QFont f( "helvetica" );
//    QFont f = QFont::defaultFont();
//    QFont f( "fixed" );
//    f.setPointSize( 12 );

///////////****** Font check **********
//		QFontDatabase			FB;
//
//		QStringList				fam = FB.families();
//
//		printf("Fonts:\n");
//		for ( QStringList::Iterator itf = fam.begin(); itf != fam.end(); ++itf )
//		{
//    	printf( "%s (%s)\n", (*itf).latin1(), (FB.isSmoothlyScalable((*itf)))?"Smooth":"Not smooth" );
//      printf( "  Styles:\n");
//			QStringList			styles = FB.styles( (*itf) );
//			for ( QStringList::Iterator its = styles.begin(); its != styles.end(); ++its )
//			{
//				printf( "  %s \n", (*its).latin1() );
//			}
//
//      printf( "  PointSizes:\n");
//			QValueList<int>			sizes = FB.pointSizes( (*itf) );
//			for ( QValueList<int>::Iterator itp = sizes.begin(); itp != sizes.end(); ++itp )
//			{
//				printf( "  %d \n", (*itp) );
//			}
//
//    }
    QFont f( "times" );
    f.setCharSet( QFont::ISO_8859_1 );
    f.setPointSize( Language::iNormalFontSize );
//		QFontInfo	info( f );
//		printf("Point size requested: %d\n", f.pointSize());
//		printf("Actual point size:    %d\n", info.pointSize());
//		printf("Pixel size requested: %d\n", f.pixelSize());
//		QFont::setDefaultFont( f );

#if !defined(GBLI_DEVEL) && !defined(GBLI_STANDALONE)
    QApplication::desktop()->setBackgroundColor( Qt::black );
    QApplication::flushX();
#endif

  	QFontMetrics fm( f );
  	int font_width = fm.width( "Test string!" );
//  	printf( "FontMetrics: %d\n", font_width );
		// pure magic here, this number is different on some classes of video cards
  	if( font_width > 81 ){
      Language::iBigFontSize = 16;
      Language::iNormalFontSize = 14;
      Language::iSmallFontSize = 10;
  	}else{
      Language::iBigFontSize = 24;
      Language::iNormalFontSize = 20;
      Language::iSmallFontSize = 17;
  	}
    f.setPointSize( Language::iNormalFontSize );
    f.setCharSet( QFont::ISO_8859_1 );
//		QFontInfo	info2( f );
//    QFont f( "fixed" );
//    f.setPointSize( 12 );
		QFont::setDefaultFont( f );

		// let's setup our "yellow" palette for the fields
		QPalette oldPalette = a.palette();
//		QColor baseC = oldPalette.color( QPalette::Active, QColorGroup::Base );
//printf( "base: %s\n", baseC.name().ascii() );
		oldPalette.setColor( QPalette::Active, QColorGroup::Base, QColor( 250, 237, 197 ) );
		oldPalette.setColor( QPalette::Inactive, QColorGroup::Base, QColor( 250, 237, 197 ) );
		if( XServer::safe_mode ){
			oldPalette.setColor( QPalette::Active, QColorGroup::Background, QColor( 255, 255, 255 ) );
			oldPalette.setColor( QPalette::Inactive, QColorGroup::Background, QColor( 255, 255, 255 ) );
		}
		a.setPalette( oldPalette );

		// run language&timezone setup dialog
		// it is a fake: we draw it like QWizard, but it is not ;)
    if( !stage2 ){
//printf( "Set font (main): %s, %d!\n", f.family().ascii(), f.pointSize() );
//printf( "Set actual font (main): %s, %d!\n", QFontInfo( f ).family().ascii(), QFontInfo( f ).pointSize() );
  		LanguageDialog *ld = new LanguageDialog();
  		s.startKWM();
  		ld->setFixedSize( width, height );
      ld->setGeometry( 0, 0, width, height );

			// untested thing to repair mouse problems with laptops
	    Mouse *test_mouse = new Mouse( ld, "mouse" );
			test_mouse->hide();
			test_mouse->tellXServer();

      ld->show();
      Language::finish( true );
#ifndef GBLI_DEVEL
			// xfs works so, that the order of fonts directories is important:
			// if cyrillic goes first than Finish etc will be with russian letters
			// and vice-versa, so we have cyrrilic first by default and then remove it
      if( *Language::lang->key != "ru" && *Language::lang->key != "uk_UA" && *Language::lang->key != "uk" )
				XServer::removeCyrillicFonts();
//        system( ("cp -af "+ QString( GBLI_DATA_PATH ) +"/data/xfs_cyr /etc/X11/fs/config").ascii() );
#endif
			::sync();
			return 0;
    }

		// load languages from the disk and set current the same as in environment
//    printf( "lang=%s\n", getenv( "LANG" ) );
    Language::loadLanguages();
    Language::setupFont( &f );
		QFont::setDefaultFont( f );
		a.setFont( f );
//printf( "Set font (main): %s, %d!\n", f.family().ascii(), f.pointSize() );
//printf( "Set actual font (main): %s, %d!\n", QFontInfo( f ).family().ascii(), QFontInfo( f ).pointSize() );

		// once more pure magic, now for second stage ;(
  	if( font_width > 81 ){
      Language::iBigFontSize = 16;
  	}else{
      Language::iBigFontSize = 24;
  	}

		// and absolutely crazy magic for cyrillic fonts ;(
//		Log::logMain(35, "lang: %p\n", Language::lang );
    if( Language::lang && *Language::lang->key != "ru" && *Language::lang->key != "uk_UA" && *Language::lang->key != "uk" )
			Language::iBigFontSize -= 2;

    // allow .qml files
    QMimeSourceFactory::defaultFactory()->setExtensionType("qml", "text/utf8");

		// setup fonts for the HTML parser of the final page (manual)
		QStyleSheet *stsh = QStyleSheet::defaultSheet();
		if( stsh ){
  		char *tags[] = { "h1", "h2", "h3", "h4", "b", NULL };
  		QStyleSheetItem* style1 = NULL;
  		for( int i = 0; tags[i]; i++ ){
  			style1 = stsh->item( QString::fromLatin1( tags[i] ) );
  	    if( style1 ){
//        	printf( "%s: %s - %d\n", tags[i], style1->fontFamily().ascii(), style1->fontSize() );
          style1->setFontFamily( "times" );
          style1->setFontWeight( QFont::Bold );
	        style1->setFontSize( Language::iBigFontSize );
//          style1->setDisplayMode( QStyleSheetItem::DisplayBlock );
        }
  		}
			QStyleSheet::setDefaultSheet( stsh );
		}

    // setup stylesheet for t1 and t2
    QStyleSheetItem* style = new QStyleSheetItem( QStyleSheet::defaultSheet(), "t1" );
//    style->setFontFamily( "helvetica" );
    style->setFontFamily( "times" );
    style->setFontWeight( QFont::Bold );
    style->setFontSize(14);
    style->setDisplayMode( QStyleSheetItem::DisplayBlock );

    style = new QStyleSheetItem(  QStyleSheet::defaultSheet(), "t2" );
//    style->setFontFamily( "helvetica" );
    style->setFontFamily( "times" );
    style->setFontSize(12);
    style->setDisplayMode( QStyleSheetItem::DisplayBlock);

    style = new QStyleSheetItem( QStyleSheet::defaultSheet(), "head" );
    style->setDisplayMode(QStyleSheetItem::DisplayNone);

		QApplication::syncX();
		QApplication::flushX();

		// actually it is not kwm, but whatever favorite
		s.startKWM();

    // finally: create and run the wizard
    GBLI mw;
#ifdef GBLI_STANDALONE
    mw.setCaption( "SOT Linux Configurator "+ QString::fromLatin1( GBLI_VERSION ) );
#else
    mw.setCaption( "GBLI "+ QString::fromLatin1( GBLI_VERSION ) );
#endif
		mw.setFixedSize( width, height );
    mw.setGeometry( 0, 0, width, height );
		mw.setBackgroundPixmap( LIconLoader::loadIcon( TEXTURE ) );
	  a.setMainWidget( &mw );
#if defined(GBLI_DEVEL) || defined(GBLI_STANDALONE)
		QWidget *desk = QApplication::desktop();
		mw.move( (int)(desk->width()/2) - 320, (int)(desk->height()/2) - 240 );
#endif

    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );

    int res = mw.exec();

		// gbli tends to close when some of small dialogs are closing,
		// so we check for 128 as our "gbli return code" and close
		// it only in this case; in all other case reenter event loop
#ifndef GBLI_STANDALONE
		while( res != 128 ){
#else
		while( res != 128 /*&& res != 0*/ ){
#endif
  //printf( "res: %d\n", res );
			res = a.enter_loop();
  //printf( "res: %d\n", res );
		}
  //printf( "!!!!!!!!!!!!!!!!!!!!!\n" );
    ::sync();
		return 0;
}


