/***************************************************************************
                             mountpoint.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "config.h"
#include <qstring.h>
#include <qvaluelist.h>
#include <qdict.h>
#include <qlist.h>

typedef long double mount_size;

class MountPoint {

 public:
    MountPoint( const QString& name, mount_size size );
    ~MountPoint();

    void reset();
    void setCount(uint lists) { uses.resize(lists); }

    void add( uint id, mount_size kbytes );
    void add( const QValueList<uint> &ids, mount_size kbytes );

    mount_size used( uint id ) const;
    mount_size free( uint id ) const;
    mount_size free() const;
    mount_size total() const;

    QString name() const { return m; }

private:
    QString m;
    mount_size t;
    QArray<mount_size> uses;
};

typedef QList<MountPoint> MountPointList;

class MountPoints
{
public:
    static QString mountPoint( const QString& partition );
    static QString mountPartition( const QString& mount_moint);
    static void setMountPoint( const QString& partition, const QString& mount_moint);
    static void clearMountPoint( const QString& partition );
    static void clear();

    static bool newDirectory(const QString& name, mount_size size);
    static MountPointList allDirectories();
    static void clearDirectories();
    static void addToDirectory(const QString &path, mount_size size, const QValueList<uint> &ids);
    static MountPoint* directory( const QString& name );

private:
    static QDict<QString> *mp;
    static QDict<QString> *mpR;
    static QDict<MountPoint> *lms;

};

