/***************************************************************************
                          networkpage.h  -  description                              
                             -------------------                                         
    begin                : Fri Dec 8 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		 : Oleg Golovachov (Demiurg)
    author email         : og@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/





#ifndef NETWORKPAGE_H
#define NETWORKPAGE_H

#include <qwidget.h>

#include <qtabwidget.h> // By Demiurg
#include <qtabbar.h>
#include <qwidgetstack.h>
#include <qlayout.h>
#include <qvalidator.h>
#include <qlabel.h>
#include <qframe.h>
#include <qpushbutton.h>
#include <qdict.h>
#include <qstringlist.h>

#include "config.h"
#include "network.h"
#include "adslpage.h"
#include "gblipage.h"
#include "isdnpage.h"
#include "stdio.h"

/**
  *@author Oleg Golovachov (Demiurg)
  */

class NetworkPage : public GBLIPage  {
   Q_OBJECT
public: 
	NetworkPage(QWidget *parent=0, const char *name=0);
  void show();
	void finish();
	void save(const char *root, QString userName);
	void readConfig(const char *root);
	void updateWidgets();
	bool runIfconfig();

	~NetworkPage();

	Netinfo *getNetinfo(){ return netdata; };
//	Netinfo *getADSLNetinfo(){ return adsldata; };

public slots:
    void updateInfo();
		void saveHosts(const char *root);

private slots:
    void addInputWidget(QWidget *);
		void SaveDATA(); // for testing

protected:

		void hideEvent( QHideEvent * );


private:

		QTabWidget * pageSeparator;  //By Demiurg

#ifndef GBLI_IPv6
    Network * network;

    AddressEdit * routerEdit;

    AddressEdit * ns1Edit;
    AddressEdit * ns2Edit;
    AddressEdit * ns3Edit;

    QLineEdit * nisEdit;
		char *interfaceName;
#else
    QDict<Network> network;
		NetworkCommon *ncommon;
		NetworkTunnel	*ntunnel;
#endif

    Netinfo * netdata;
//		Netinfo * adsldata;
		ADSLPage * ADSL;
		ISDNPage * ISDN;

    QLineEdit * proxyEdit;
    QLineEdit * proxyPortEdit;
    QLineEdit * noproxyforEdit;

    QLineEdit * nameEdit;

		QPushButton *testButton;

};
#endif
