/***************************************************************************
                          printercfg.cpp  -  description                              
                             -------------------                                         
    begin                : Fri Feb 11 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Natalja Drozzina
    author email         : nd@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "printercfg.h"
#include "config.h"

#include <stdio.h>
#include <qapplication.h>
#include <qlayout.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qgroupbox.h>
#include <qdir.h>
#include <qdir.h>

#include <qpushbutton.h>
#include <qstringlist.h>

#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <grp.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/wait.h>

#include <unistd.h>

#include "log.h"

/****************************************************************/

PrinterCfg::PrinterCfg(QWidget *parent, const char *name ) : QWidget(parent,name)
{
#ifndef GBLI_DEVEL
  system("/usr/sbin/modprobe parport_pc" );
  system("/usr/sbin/modprobe parport_probe" );
  system("/usr/sbin/modprobe lp" );
#endif

  NullValue();
  FillEntry();
  MainLayout();

}


/****************************************************************/

void PrinterCfg::NullValue()
{
	sDriverResult = "";
  sDescription = "";
  sTypeResult = "";
  sQueueResult = "";
  sSpoolResult = "";
  sSizeResult = "";
  sResolResult = "";
  sPixel = "";
  sDescrPixel = "";
  iStair = 0;
  sRemoteHost = "";
  sRemoteQueue = "";
  sSmbHost = "";
  sSmbIP = "";
  sSmbName = "";
  sSmbUser = "";
  sSmbPass = "";
  sSmbWorkgr = "";
  sNcpServer = "";
  sNcpQueue = "";
  sNcpUser = "";
  sNcpPass = "";
  sDevice = "";

  bPort = false;


}
/****************************************************************/
void PrinterCfg::setEnablLocal( bool bValue){

  lblDevice->setEnabled( bValue );
	cmbDevice->setEnabled( bValue );
  butTest->setEnabled( bValue );

}

/****************************************************************/
void PrinterCfg::setEnablRemote( bool bValue ){

  lblHost->setEnabled( bValue );
  editRemoteHost->setEnabled( bValue );
  lblQueueRemote->setEnabled( bValue );
  editQueueRemote->setEnabled( bValue );
}

/****************************************************************/
void PrinterCfg::setEnablSmb( bool bValue ){
  lblSmbHost->setEnabled( bValue );
  editHost->setEnabled( bValue );
  lblSmbIP->setEnabled( bValue );
  editIP->setEnabled( bValue );
  lblSmbName->setEnabled( bValue );
  editName->setEnabled( bValue );
  lblSmbUser->setEnabled( bValue );
  editUser->setEnabled( bValue );
  lblSmbPass->setEnabled( bValue );
  editPass->setEnabled( bValue );
  lblWork->setEnabled( bValue );
  editWork->setEnabled( bValue );
}

/****************************************************************/
void PrinterCfg::setEnablWare( bool bValue ){
  lblServer->setEnabled( bValue );
  editNcpServer->setEnabled( bValue );
  lblNcpQueue->setEnabled( bValue );
  editNcpQueue->setEnabled( bValue );
  lblNcpUser->setEnabled( bValue );
  editNcpUser->setEnabled( bValue );
  lblNcpPass->setEnabled( bValue );
  editNcpPass->setEnabled( bValue );

}

/****************************************************************/
void PrinterCfg::setEnablMain( bool bValue ){

  lblType->setEnabled( bValue );
  cmbType->setEnabled( bValue );
  lblQueue->setEnabled( bValue );
  editQueueMain->setEnabled( bValue );
  lblSpool->setEnabled( bValue );
  editSpool->setEnabled( bValue );
  lblSize->setEnabled( bValue );
  cmbSize->setEnabled( bValue );
  lblRes->setEnabled( bValue );
  cmbRes->setEnabled( bValue );
  chkStair->setEnabled( bValue );
  lblPixel->setEnabled( bValue );
  cmbPixel->setEnabled( bValue );

  //grBot->setEnabled( bValue );
}

/****************************************************************/


QString *PrinterCfg::GetValue( QString sline ){
  int index = sline.find( ":" );
  QString *help;

  if ( (index>=0)&&(!sline.mid( index+1, sline.length()-(index+1) ).isEmpty()) ){
  	index++;
  	while ( sline.mid( index, 1 )==" " ){
    	index++;
  	}
    return help = new QString ( sline.mid( index, sline.length()-index ) );
  }
  else return help = new QString ("");
}


/****************************************************************/
QStringList *PrinterCfg::DelBracket( QString *sline, int inum ){
  QString shelp = sline->ascii();
  int index=0;
  int indexEnd = 0;
  int icount;
  QStringList *sresult = new QStringList();

  for ( icount=0; icount<=inum; icount++ ){
		index = shelp.find("{", indexEnd);
 		if ( index >= 0 ){
  		indexEnd = shelp.find("}", index );
      sresult->append( shelp.mid(index+1, indexEnd-(index+1)) );
    }
  }
  return sresult;
}
/****************************************************************/
int PrinterCfg:: itemsCompare( QString str1, QString str2 )
{
	return strcasecmp( str1, str2 );
}


/****************************************************************/

void PrinterCfg::Sort( int iLowBorder, int iTopBorder ){

	int inext = 1;
  bool bcontinue = true;
  int index;
  QString sFirst, sSecond;


  while ( ( inext < iTopBorder ) && ( bcontinue ) ){
  	bcontinue = false;
    for ( index=iLowBorder; index<=iTopBorder-inext; index++ ){
    sFirst = list.at( index )->GetDescription()->ascii();
    sSecond = list.at( index+1 )->GetDescription()->ascii();
      if  ( itemsCompare ( sFirst, sSecond ) > 0 ){
	   	bcontinue = true;
      PrnEntry *prnPrev = list.at( index );
      PrnEntry *prnNext = list.at( index+1 );

      list.remove( index );
      list.insert( index, prnNext );

      list.remove( index+1 );
      list.insert( index+1, prnPrev );

     }
  }
  inext++;

	} 	

}

/****************************************************************/

void PrinterCfg::FillEntry(){

  QStringList *slOneRec = new QStringList();
  QString sHelp = "";
  QString sResult = "";
  QStringList::Iterator iter;
  int i = 0;

//  printf("FillEntry()->called\n");

  QString *sEntryVal = new QString( "");
  QString *sDescrVal = new QString( tr("--None--") );
  QString *sGSDriverVal = new QString("");
  QStringList *strList = new QStringList();
  strList->append( "" ) ;
  QStringList *slPixel = new QStringList();
  slPixel->append( "" );

  list.append( new PrnEntry( sEntryVal,
                             sDescrVal,
                             sGSDriverVal,
                             strList,
                             slPixel ) );

  strList = new QStringList();
  slPixel = new QStringList();
  sEntryVal = new QString("");
  sDescrVal = new QString("");
  sGSDriverVal = new QString("");


  QFile fprnData( "data/printerdb" );
//  QFile fprnData( "printerdb" );

  if ( fprnData.open(IO_ReadOnly) ){

//     printf("File printerdb is opened \n");

     QTextStream stream( &fprnData );
     QString sLineData;


     while ( !stream.eof() ){

       sLineData = stream.readLine();

       if ( sLineData.left( 1 )== "#" )
       continue;


       if ( sLineData.find("StartEntry:") >= 0 ){
	     sEntryVal = GetValue( sLineData );
      // printf("StartEntry: %s\n", sEntryVal->ascii() );
       }

       if ( sLineData.find("GSDriver:") >= 0 ){
  	     sGSDriverVal = GetValue( sLineData ) ;
        }

  		 if ( sLineData.find("Description:") >= 0 ){
				slOneRec = DelBracket( GetValue( sLineData ), 1 );
       	iter = slOneRec->at( 0 );
        sDescrVal = new QString( *iter );	
      //  printf("Description: %s\n", sDescrVal->ascii());
			 }		

        if ( sLineData.find("Resolution:") >= 0){
        slOneRec = DelBracket( GetValue ( sLineData), 2 );
        for ( i=0; i<=1; i++ ){
        	iter = slOneRec->at( i );
          sHelp = *iter;
          if ( sHelp.left( 2 ) == "NA") {
            sResult = "";
            break;
          }
          sResult.append( sHelp );
          if ( i==0 ) sResult.append("x");
        }
       strList->append( sResult ) ;

     //        QStringList *temp = new QStringList();
     //   for ( QStringList::Iterator it = strList->begin();
       //       it != strList->end(); it++ )

       }


       if ( sLineData.find("BitsPerPixel:") >= 0){
       slOneRec = DelBracket ( GetValue( sLineData ), 2 );
       for ( i=0; i<=1; i++ ){
       		iter = slOneRec->at( i );
          sHelp = *iter;
          sResult.append( sHelp );
          if ( i==0 ) sResult.append(", ");
 			 }
       slPixel->append( sResult );
       }


       if ( sLineData.find( "EndEntry" ) >= 0 ){

         if ( slPixel->isEmpty() ) slPixel->append( "Default" );

      	 list.append( new PrnEntry( sEntryVal,
																		sDescrVal,	
                                    sGSDriverVal,
                                    strList,
                                    slPixel ) );

         strList = new QStringList();
         slPixel = new QStringList();
      	 sEntryVal = new QString("");
				 sDescrVal = new QString("");
      	 sGSDriverVal = new QString("");
       }

       sResult = "";
       sHelp = "";
       slOneRec->clear();
     }
  fprnData.close();

  Sort( 1, list.count()-1 );
/* PrnEntry *prnInfo;

qsort( list, 73, sizeof( *  ), itemsCompare );*/

  }

}


/****************************************************************/

QGroupBox *PrinterCfg::FrameDraw(){
	
  QGroupBox *groupFrame = new QGroupBox( this );
  groupFrame->setTitle( tr("Additional data") );
  groupFrame->setFrameStyle( QFrame::Box | QFrame::Raised );


return groupFrame;
}

/****************************************************************/

QWidget *PrinterCfg::LocalLayout( QGroupBox *gFrame ){

  QWidget *grLocal = new QWidget( gFrame );
  lblDevice = new QLabel( tr("Printer device:"), grLocal );
  cmbDevice = new QComboBox( grLocal );

  QString butText = tr("Test here:");
  int pos = butText.find( ":" );
  if( pos != -1 )
    butText.replace( pos, 1, "!" );
  butTest = new QPushButton ( butText/*tr("Print test page")*/, grLocal );
  butTest->setFixedWidth ( 200 );

  //find of parallel devices
  int index = 0;
  QString strProcPar = QString(PROC) +"/parport/%1/hardware";
  QString strPort = "/dev/lp%1 (LPT%2)";
  QString strProcSer = QString(PROC) +"/tty/driver/serial";
//  bool blocal = false;

  if ( !QFile( QString(PROC) +"/cpuinfo" ).exists() ){
     strProcPar += NEWROOT;
     strProcSer += NEWROOT;
     Log::logMain(32, "proc looks to be mounted to /mnt/root\n" );
  }

  while ( true ){
      if ( QFile::exists( strProcPar.arg(index) ) ){
         cmbDevice->insertItem( strPort.arg(index).arg(index+1) );
         bPort = true;
      }
      else
         break;
      index++;
    }

  //find of serial devices
  index = 0;
  strPort = "/dev/ttyS%1 (COM%2)";

   QFile fport( strProcSer );
   if ( fport.open( IO_ReadOnly )){
      QTextStream stream( &fport );
      QString sLine;
      stream.readLine(); //first line is driver version
      while ( true )
      { sLine = stream.readLine ();
        if ( sLine.isEmpty() )
         break;

       if ( sLine.find("unknown") >= 0 )
       continue;

       index = sLine.left( (sLine.find(":")) ).toInt();
       cmbDevice->insertItem( strPort.arg( index ).arg( index +1 ) );
       bPort = true;
     }
     fport.close();
   }

  //VREMMENO
//   bPort = false;
   if (!bPort) cmbType->removeItem( Local );

   cmbDevice->setCurrentItem( 0 );

//   QHBoxLayout *lhoriz = new QHBoxLayout( grLocal, 0, 6 );


   QHBoxLayout *lhoriz = new QHBoxLayout( 6 );

   QHBoxLayout *lhorizMain = new QHBoxLayout( grLocal, 0, 10 );

   lhoriz->addWidget( lblDevice );
   lhoriz->addWidget( cmbDevice );

   lhorizMain->addLayout ( lhoriz );
   lhorizMain->addStretch();
   lhorizMain->addWidget ( butTest );
//butTest->hide();

   connect( butTest, SIGNAL( clicked() ), this, SLOT( TestPage() ) );


   setEnablLocal( false );

   grLocal->hide();

  return grLocal;
}

/****************************************************************/
void PrinterCfg::TestPage()
{

  qApp->setOverrideCursor( Qt::waitCursor );

  Log::logMain(32, "Called printercfg->TestPage\n" );
  if ( ResultValue() ) {
    Log::logMain(32, "ResultValue\n");
	  if( ConfigureQueue( "" ) ) {
      CreatePrintcap( "" );
      Log::logMain(32, "Queue is configured \n");
    }
  }

//  Added for probe
//  if ( chown( "/var/spool/lpd", 0, 7 ) < 0 )
//    printf("The attempt to change owner is unsuccessful \n");

  int pid = fork();
  if( !pid ){
    ::execlp( "/usr/sbin/lpd", "lpd", 0 );
    ::exit( 0 );
  }

  QString strTestFile = "testpage.asc";
  QString strTest = PRINTER_FILTER_DIR + strTestFile ;

  pid = fork();
  if( !pid ){
    ::execlp( "/bin/lpr", "lpr", strTest.ascii(), 0 );
    ::exit( 0 );
  }
  ::waitpid( pid, NULL, 0 );

  ::sleep( 15 );

  ::system( "killall -9 lpd" );

  qApp->restoreOverrideCursor();
}

/****************************************************************/

QWidget *PrinterCfg::RemoteLayout( QGroupBox *groupFrame ){

  QWidget *grRemote = new QWidget( groupFrame );
  lblHost = new QLabel( tr("Remote host:"), grRemote );
  editRemoteHost = new LAddressEdit( LAddressEdit::Address, grRemote );

  lblQueueRemote = new QLabel( tr("Remote queue:"), grRemote );
  editQueueRemote = new QLineEdit( grRemote );
  editQueueRemote->setMinimumWidth( 0 /*editQueueRemote->sizeHint().width()*/ );
  editQueueRemote -> setText( "lp" );

  QVBoxLayout *lvLbl = new QVBoxLayout(  );
  QVBoxLayout *lvList = new QVBoxLayout(  );

  QHBoxLayout *lhoriz = new QHBoxLayout( grRfemote, 0, 6 );

  editRemoteHost->setMinimumWidth( editQueueRemote->sizeHint().width() );

  lvLbl->addWidget( lblHost );
  lvLbl->addWidget( lblQueueRemote );


  lvList->addWidget( editRemoteHost );
  lvList->addWidget( editQueueRemote );

  lhoriz->addLayout( lvLbl );
  lhoriz->addStretch();
  lhoriz->addLayout( lvList );
  lhoriz->addStretch( 2 );

//  if ( cmbType->text( 0 ) == "Remote lpd" ) setEnablRemote(false);

  if ( !bPort ) setEnablRemote( false );

  grRemote->hide();

  return grRemote;

}
/****************************************************************/

QWidget *PrinterCfg::SmbLayout( QGroupBox *gFrame ){

  QWidget *grSmb = new QWidget( gFrame );

  QWidget *wLeft = new QWidget( grSmb );
  QWidget *wRight = new QWidget( grSmb );

  lblSmbHost = new QLabel( tr("SMB server host:" ), wLeft );
  editHost = new QLineEdit( wLeft );
  editHost->setMinimumWidth( 5 );

  lblSmbIP = new QLabel( tr("SMB server IP:"), wLeft );
  editIP = new LAddressEdit( LAddressEdit::Address , wLeft );

  lblSmbName = new QLabel( tr("Share name:"), wLeft );
  editName = new QLineEdit( wLeft );
  editName->setMinimumWidth( 5 );

  lblSmbUser = new QLabel( tr("User name:"), wRight );
  editUser = new QLineEdit( wRight );
  editUser->setMinimumWidth( 5 );

  lblSmbPass = new QLabel( tr("Password:"), wRight );
  editPass = new QLineEdit( wRight );
  editPass->setEchoMode( QLineEdit::Password );
  editPass->setMinimumWidth( 5 );

  lblWork = new QLabel( tr("Workgroup:"), wRight );
  editWork = new QLineEdit( wRight );
  editWork->setMinimumWidth( 5 );

  editHost->setMaximumWidth( editIP->width() );
  editName->setMaximumWidth( editIP->width() );

  QVBoxLayout *lvLblLeft = new QVBoxLayout();
  QVBoxLayout *lvListLeft = new QVBoxLayout();
  QVBoxLayout *lvLblRight = new QVBoxLayout();
  QVBoxLayout *lvListRight = new QVBoxLayout();

  QHBoxLayout *lhLeft = new QHBoxLayout( wLeft,0, 6 );
  QHBoxLayout *lhRight = new QHBoxLayout( wRight, 0, 6 );
  QHBoxLayout *lhMain = new QHBoxLayout( grSmb, 0, 10 );

  lvLblLeft->addWidget( lblSmbHost );
  lvLblLeft->addWidget( lblSmbIP );
  lvLblLeft->addWidget( lblSmbName );

  lvListLeft->addWidget( editHost );
  lvListLeft->addWidget( editIP );
  lvListLeft->addWidget( editName );

  lvLblRight->addWidget( lblSmbUser );
  lvLblRight->addWidget( lblSmbPass );
  lvLblRight->addWidget( lblWork );

  lvListRight->addWidget( editUser );
  lvListRight->addWidget( editPass );
  lvListRight->addWidget( editWork );

  lhLeft->addLayout( lvLblLeft );
  lhLeft->addLayout( lvListLeft );

  lhRight->addLayout( lvLblRight );
  lhRight->addLayout( lvListRight );

  lhMain->addWidget( wLeft,1 );
  lhMain->addWidget( wRight,1 );

  grSmb->hide();

return grSmb;

}
/****************************************************************/

QWidget *PrinterCfg::NetWareLayout( QGroupBox *groupFrame ){

  QWidget *grNetWare = new QWidget ( groupFrame );

  QWidget *wLeft = new QWidget( grNetWare );
  QWidget *wRight = new QWidget( grNetWare );

  lblServer = new QLabel( tr("Printer server:"), wLeft );
  editNcpServer = new LAddressEdit( LAddressEdit::Address , wLeft );

  lblNcpQueue = new QLabel( tr("Print queue name:"), wLeft );
  editNcpQueue = new QLineEdit( wLeft );
  editNcpQueue->setMinimumWidth( 5 );
  editNcpQueue->setMaximumWidth( editNcpServer->width() );

  lblNcpUser = new QLabel( tr("User name:"), wRight );
  editNcpUser = new QLineEdit( wRight );
  editNcpUser->setMinimumWidth( 5 );

  lblNcpPass = new QLabel( tr("Password:"), wRight );
  editNcpPass = new QLineEdit( wRight );
  editNcpPass->setEchoMode( QLineEdit::Password );
  editNcpPass->setMinimumWidth ( 5 );

  QVBoxLayout *lvLblLeft = new QVBoxLayout();
  QVBoxLayout *lvEditLeft = new QVBoxLayout();
  QVBoxLayout *lvLblRight = new QVBoxLayout();
  QVBoxLayout *lvEditRight = new QVBoxLayout();

  QHBoxLayout *lhLeft = new QHBoxLayout( wLeft, 0, 6 );
  QHBoxLayout *lhRight = new QHBoxLayout( wRight, 0, 6 );
  QHBoxLayout *lhMain = new QHBoxLayout( grNetWare , 0, 10 );


  lvLblLeft->addWidget( lblServer );
  lvLblLeft->addWidget( lblNcpQueue );

  lvEditLeft->addWidget( editNcpServer );
  lvEditLeft->addWidget( editNcpQueue );

  lvLblRight->addWidget( lblNcpUser );
  lvLblRight->addWidget( lblNcpPass );

  lvEditRight->addWidget( editNcpUser );
  lvEditRight->addWidget( editNcpPass );

  lhLeft->addLayout( lvLblLeft );
  lhLeft->addLayout( lvEditLeft );

  lhRight->addLayout( lvLblRight );
  lhRight->addLayout( lvEditRight );

  lhMain->addWidget( wLeft, 1 );
  lhMain->addWidget( wRight, 1 );

  grNetWare->hide();

  return grNetWare;

}

/****************************************************************/

void PrinterCfg::MainLayout()
{

  QGroupBox *groupTop = new QGroupBox ( this );
  groupTop->setTitle( tr("General data") );
  groupTop->setFrameStyle( QFrame::Box | QFrame::Raised );

  lblType = new QLabel( tr("Printer type:"), groupTop );
  cmbType = new QComboBox ( groupTop );
  cmbType->insertItem( tr("Local"), Local );
  cmbType->insertItem( tr("Remote lpd"), Remote );
  cmbType->insertItem( "SMB/Windows 95/NT", SMB );
  cmbType->insertItem( "NetWare", Netware );
  cmbType->setCurrentItem ( 0 );

  QLabel *lblDriver = new QLabel( tr("Printer driver:"), groupTop );
  listDriver = new QListBox( groupTop );
  listDriver->setMinimumWidth( listDriver->sizeHint().width() );
  listDriver->setMinimumHeight( listDriver->sizeHint().height() );

  lblPixel = new QLabel ( tr("Bits per pixel:"), groupTop );
  cmbPixel = new QComboBox ( groupTop );

  lblSize = new QLabel( tr("Paper size:"), groupTop );
  cmbSize = new QComboBox( groupTop );
  cmbSize->insertItem( tr("letter"), Letter );
  cmbSize->insertItem( tr("legal"), Legal );
  cmbSize->insertItem( tr("ledger"), Ledger );
  cmbSize->insertItem( "a3", a3 );
  cmbSize->insertItem( "a4", a4 );
  cmbSize->setCurrentItem( a4 );

  lblRes = new QLabel( tr("Resolution:"), groupTop );
  cmbRes = new QComboBox( groupTop );

  lblQueue = new QLabel( tr("Name of queue:"), groupTop );
  editQueueMain = new QLineEdit( groupTop );
  editQueueMain -> setText( "lp" );

  lblSpool = new QLabel( tr("Spool directory:"), groupTop );
  editSpool = new QLineEdit( groupTop );
  editSpool -> setText( SPOOL_BY_DEFAULT );

  chkStair = new QCheckBox( tr("Fix stair-stepping of text"), groupTop );

  setEnablMain( false );


 //////////////
 PrnEntry *prnInfo;
 if ( list.first() ){
   for ( prnInfo=list.first(); prnInfo != 0; prnInfo=list.next() ){
	   listDriver->insertItem ( (prnInfo->GetDescription())->ascii() );
   }
   listDriver->setCurrentItem( 0 );

//   ShowRes( 0 );
   connect( listDriver, SIGNAL( highlighted ( int )), this , SLOT( ShowRes( int )) );
 }


/* QStringList *temp = new QStringList();
 temp = prnInfo->GetResolList();

 for ( QStringList::Iterator it = temp->begin(); it != temp->end(); ++it )
 printf( *it + "\n" );*/
///////////

  QVBoxLayout *lvLeftHelp = new QVBoxLayout();
  QVBoxLayout *lvLeft = new QVBoxLayout( 6 );

  QVBoxLayout *lvRight = new QVBoxLayout( 6 );
  QVBoxLayout *lvRightLbl = new QVBoxLayout();
  QVBoxLayout *lvRightList = new QVBoxLayout();
  QVBoxLayout *lvMHelp = new QVBoxLayout( groupTop, 15, 10 );
  QVBoxLayout *lvMain = new QVBoxLayout();


  QHBoxLayout *lhRight = new QHBoxLayout( 6 );

  QHBoxLayout *lhBot = new QHBoxLayout();
  QHBoxLayout *lhoriz = new QHBoxLayout();
  QHBoxLayout *lhMain = new QHBoxLayout( this, 0, 0 );

  lvLeftHelp->addWidget( lblDriver );
  lvLeftHelp->addWidget( listDriver );

  lvLeft->addSpacing( 6 );
  lvLeft->addLayout( lvLeftHelp );

  lvRightLbl->addWidget( lblType );
  lvRightLbl->addWidget( lblQueue );
  lvRightLbl->addWidget( lblSpool );
  lvRightLbl->addWidget( lblSize );
  lvRightLbl->addWidget( lblRes );

  lvRightList->addWidget( cmbType );
  lvRightList->addWidget( editQueueMain );
  lvRightList->addWidget( editSpool );
  lvRightList->addWidget( cmbSize );
  lvRightList->addWidget( cmbRes );

  lhRight->addLayout( lvRightLbl );
  lhRight->addLayout( lvRightList );

  lhBot->addWidget( lblPixel,1 );
  lhBot->addWidget ( cmbPixel, 4 );

  lvRight->addSpacing( 6 );
//  lvRight->addStretch( );
  lvRight->addLayout( lhRight );
//  lvRight->addStretch( );
  lvRight->addWidget( chkStair );

  lhoriz->addLayout( lvLeft );
  lhoriz->addLayout( lvRight );

  lvMHelp->addLayout( lhoriz );
  lvMHelp->addLayout( lhBot );

  grBot = FrameDraw();
  groupAdd[0] = LocalLayout( grBot );
  groupAdd[1] = RemoteLayout( grBot );
  groupAdd[2] = SmbLayout( grBot );
  groupAdd[3] = NetWareLayout ( grBot );

  QHBoxLayout *lhFrame = new QHBoxLayout( grBot, 15, 0 );

  int i;
  for ( i=0; i<=ARRAY_SIZE; i++)
  lhFrame->addWidget( groupAdd[i] );

  lvMain->addWidget( groupTop, 2 );
  lvMain->addWidget( grBot , 1 );


  cmbType->setCurrentItem( 0 );
  ShowAdditional( 0 );
  //SwitchFields( false );

  connect( cmbType, SIGNAL(activated(int)), this , SLOT( ShowAdditional( int ))  );

  lhMain->addStretch( 1 );
  lhMain->addLayout( lvMain,8 );
  lhMain->addStretch( 1 );

  grBot->setEnabled(false);

}


/****************************************************************/

int PrinterCfg::getCurIndex()
{
  int i = cmbType->currentItem();
 	if( ( cmbType->count() ) < 4 )
		i++;
 	return i;
}

/****************************************************************/

void PrinterCfg::ShowAdditional( int index ){

  int icount;

  for ( icount = 0; icount <= ARRAY_SIZE; icount++ ){
	groupAdd[ icount ] -> hide ();
  }


      switch ( getCurIndex()  ) {
	case Local : 	return groupAdd[ 0 ]->show();
	case Remote :	return groupAdd[ 1 ]->show();
	case SMB : default: return groupAdd[ 2 ]->show();
  case Netware : return groupAdd[ 3 ]->show();
  }					

}

/****************************************************************/

void PrinterCfg::SwitchFields( bool bSwitch ){

 if ( cmbType->isEnabled() == !bSwitch ){
 		setEnablMain( bSwitch );
    grBot->setEnabled( bSwitch );
		switch( getCurIndex() ){
			case Remote:
				setEnablRemote( bSwitch );
				break;
			case Netware:
        setEnablWare( bSwitch );
				break;
			case SMB:
				setEnablSmb ( bSwitch );
				break;
			default:
        setEnablLocal ( bSwitch );
		}
 }

}

/****************************************************************/

void PrinterCfg::ShowRes( int index ){

 PrnEntry *prnData;
 QStringList *sltempRes = new QStringList();
 QStringList *sltempPix = new QStringList();

  if ( index==0 ) SwitchFields( false );
  else SwitchFields( true );


 	cmbRes->clear();
 	cmbPixel->clear();
 	prnData = list.at( index );

  QString sPrn = list.at( index )->GetDescription()->ascii();
  if  ( ( sPrn.find ("HP") != -1 ) ||
          ( sPrn.mid ( 0,7 ) == "DeskJet" ) ||
          ( sPrn.mid ( 0,8 ) == "LaserJet") ||
          ( sPrn.mid ( 0,2 ) == "LJ" ) )
  chkStair->setChecked ( true );

	else chkStair->setChecked ( false );


 	sltempRes = prnData->GetResolList();
 	for ( QStringList::Iterator itRes = sltempRes->begin();
  	                  itRes != sltempRes->end();
    	                itRes++ ){
    	cmbRes->insertItem( *itRes );
    	if ( *itRes == "" ){
      	 cmbRes->setEnabled( false );
       	lblRes->setEnabled( false );
  	  }
    	else {
      	lblRes->setEnabled( true );
      	cmbRes->setEnabled( true );
  	  }
	}
  	cmbRes->setCurrentItem( 0 );


 	QString sPixTemp;
 	sltempPix = prnData->GetBitsPerPixel();
 	if  ( !sltempPix->isEmpty() ) {
		 for ( QStringList::Iterator itPix = sltempPix->begin();
  		                            itPix != sltempPix->end();
    		                          itPix++ )
    	sPixTemp = *itPix;
    	if ( sPixTemp == "Default" ) cmbPixel->insertItem( tr(sPixTemp) );
    	else cmbPixel->insertItem( tr(sPixTemp) );
  	
    	cmbPixel->setCurrentItem( 0 );
 	}
}


/****************************************************************/

PrinterCfg::~PrinterCfg(){
}

/****************************************************************/

QString PrinterCfg::ConvertType( int iCount ){
      switch ( getCurIndex()  ) {
	case Local: return "LOCAL";
	case Remote:	return "REMOTE";
	case SMB: default: return "SMB";
	case Netware: return "NCP";
   }					
}
/****************************************************************/

QString PrinterCfg::ConvertSize( int iCount ){
      switch ( iCount ) {
	case Letter: return "letter";
	case Legal: return "legal";
	case Ledger: return "ledger";
	case a3: return "a3";
  case a4: default: return "a4";
  }					
}
/****************************************************************/

bool PrinterCfg::ResultValue()
{
   PrnEntry *prnData;

   int index = listDriver->currentItem();

   if ( index == 0 ){
   		sDriverResult == "None";
      return false;
   }
   else {
     prnData = list.at( index );
     sDriverResult = prnData->GetEntry()->ascii();
     sDescription = listDriver->text(index);
     Log::logMain( 32, "Description: %s\n", (listDriver->text(index)).ascii() );
	   Log::logMain( 32, "Driver: %s\n", sDriverResult.ascii() );
     }

   prnData = list.at( index );
   sGSDriverResult = prnData->GetGSDriver()->ascii();

   int iCount = cmbType->currentItem();
   sTypeResult = ConvertType( iCount );



   sQueueResult = editQueueMain->text();
   sSpoolResult = editSpool->text();
   iCount = cmbSize->currentItem();
   sSizeResult = ConvertSize ( iCount ) ;
//   Log::logMain( 34, "Size paper:%s\n", sSizeResult.ascii() );
   sResolResult = cmbRes->text( cmbRes->currentItem() );

   QString sHelpColor = "";
   QStringList *slPix = new QStringList();

   slPix = prnData->GetBitsPerPixel();

   if ( !slPix->isEmpty() )
   for ( QStringList::Iterator itPix = slPix->begin();
                    itPix != slPix->end();
                    itPix++ ){
   if ( ( *itPix == cmbPixel->text( cmbPixel->currentItem() ) )||
         ( *itPix == "Default") )
   		sHelpColor = *itPix;
   }

   if ( sHelpColor != "Default" ){
     	sPixel = sHelpColor.mid( 0, sHelpColor.find(",") );
   		sDescrPixel = sHelpColor.mid ( sHelpColor.find(" ")+1,
      		           sHelpColor.length() - sHelpColor.find(",")  );
   }
   else sPixel = "Default";


   if ( chkStair->isChecked() ) iStair = 1;

   if ( (iStair == 0)&&
        ( ( sDriverResult.find ("HP") != -1 ) ||
          ( sDriverResult.mid ( 0,7 ) == "DeskJet" ) ||
          ( sDriverResult.mid ( 0,8 ) == "LaserJet") ||
          ( sDriverResult.mid ( 0,2 ) == "LJ"  ) ) )

   		iStair = 1;


   QString sDeviceHelp = "";
   if ( sTypeResult == "LOCAL" )
   sDeviceHelp = cmbDevice->text( cmbDevice->currentItem() );
   sDevice = sDeviceHelp.mid ( 0, sDeviceHelp.find(" ") );

   if ( sTypeResult == "REMOTE" ){
   	sRemoteHost = editRemoteHost->text();
    sRemoteQueue = editQueueRemote->text();
   }


   if ( sTypeResult == "SMB" ){
      sSmbHost = editHost->text();
      sSmbIP = editIP->text();
      sSmbName = editName->text();
      sSmbUser = editUser->text();
      sSmbPass = editPass->text();
      sSmbWorkgr = editWork->text();
   }

   if ( sTypeResult == "NCP" ){
   		sNcpServer = editNcpServer->text();
      sNcpQueue = editNcpQueue->text();
      sNcpUser = editNcpUser->text();
      sNcpPass = editNcpPass->text();
   }

  return true;
}
/****************************************************************/

bool PrinterCfg::CreateSpoolDir( QString sSpoolP, QString sRootSpool ){
	int oldmask;
  struct group *grInfo;

// Log::logMain( 34, "..........SOZDANIE SPOOL DIREKTORII...........\n" );


  Log::logMain( 32, "CreateSpoolDir sRootSpool: %s \n", sRootSpool.ascii() );

  bool bExit = false;
  gid_t groupID = 0; //Group ID, struct group
  QString sGroupName = "";

	oldmask = umask( 0 );

//  Log::logMain( 34, "sSpoolP: " + sSpoolP + "\n" );

  char cmd[128];
  sprintf( cmd, "mkdir -p -m0755 %s", sSpoolP.ascii() );
  if ( system( cmd ) < 0 )
 	  if ( errno != EEXIST ){
//         Log::logMain( 34, "Oshibka pri sozdanii direktorii\n" );
//        printf("NE UDALOS' SOZDAT'DIREKTORIJU\n");

        return false; //if dir exists
    }
  umask( oldmask );

  QString sGroupFileName = sRootSpool + "/etc/group";

#ifdef GBLI_DEVEL
  sGroupFileName = "/home/nd/tmp/group";
#endif

  FILE *fileGroup = fopen( sGroupFileName, "r" );
  if (fileGroup == NULL ){
//      Log::logMain( 34, "NE UDALOS' OTKRYT' FAJL group\n" );
//      printf("NE UDALOS' OTKRYT' FAJl group\n");
      return false;
  }

   while ( true ){

  	grInfo = fgetgrent( fileGroup );
    if ( grInfo==NULL ) break;

    sGroupName = grInfo->gr_name;

    if ( sGroupName == "lp" ){
    	groupID = grInfo->gr_gid;
      bExit = true;
    }
   }

  if ( !bExit ){
//      Log::logMain( 34, "V fajle 'group' net zapisi lp\n" );
//      printf("V FAJLE 'group' net zapisi lp\n");
      return false;
  }
	fclose( fileGroup );

  //change owner of directory
  if ( chown( sSpoolP, 0, groupID ) < 0 ){
//     Log::logMain( 34, "NE UDALOS' SMENIT' VLADEL'TSA FAJLA 'group'\n" );
//     printf("NE UDALOS' SMENIT' VLADEL'TSA FAJLA 'group'\n");
     return false;
  }

//  Log::logMain( 34, "SPOOL direktorija sozdana.....\n" );
  return true;
	
}

/****************************************************************/
bool PrinterCfg::CreateConfigFile( QString sInput,
                                   QString sOutput,
                                   QStringList *cFieldName,
                                   QStringList *cFieldValue )
{

//  Log::logMain( 34, ".........CREATE CONFIG FILES.........\n" );

  int i = 0;
  int status;
  bool bExit = false;

//  Log::logMain( 34, "sOutput:%s\n", sOutput.ascii() );
//  Log::logMain( 34, "sInput:%s\n", sInput.ascii() );
  int oldmask = umask( 0 );
  int iOutVal = ::creat( sOutput.ascii(), 0755 );    // if error occured iOutVal==-1
  umask( oldmask );
//Log::logMain( 32, "iOutVal %d, errno %d\n", iOutVal, errno );
  if ( iOutVal == -1 ) {
//     Log::logMain( 34, "OSHIBKA PRI SOZDANII iOutVal\n" );
     return false;
  }

  int iInpVal = ::open( sInput.ascii(), O_RDONLY );
//Log::logMain( 32, "iInpVal %d, errno %d\n", iInpVal, errno );
  if ( iInpVal == -1 ){
//    Log::logMain( 34, "OSHIBKA PRI OTKRYTII iInpVal\n" );
    return false;
  }

  int iFieldsNum = cFieldName->count();

  char **sSedArgs = new char*[ iFieldsNum+2 ];

//VREMENNO
  sSedArgs[0] = "sed";
  sSedArgs[ iFieldsNum+1 ] = NULL;

//!!!!!!!!!!!!!NB
 QString sHelpiter1;
 QString sHelpiter2;
 QStringList::Iterator iter1;
 QStringList::Iterator iter2;

  for ( i=0; i<iFieldsNum; i++ ){
  	iter1 = cFieldName->at( i );
    sHelpiter1 = *iter1;
  	iter2 = cFieldValue->at( i );
    sHelpiter2 = *iter2;
    sSedArgs[ i+1 ] = new char [ 25 + sHelpiter1.length() +
                                 sHelpiter2.length() ];

    if (!sSedArgs[ i+1 ]){
    	for( int j=0; j<i; j++ )
      	if ( sSedArgs[ j+1 ] )
        delete[]sSedArgs[ j+1 ];

      if ( sSedArgs ) delete[]sSedArgs;
    }
    sprintf(sSedArgs[i+1],"-e s/@@@%s@@@/%s/g",
            sHelpiter1.ascii(), sHelpiter2.ascii()  );
  }

   QString sSedPath = "sed";
////////////////////////DLJA TESTIROVANIJA//////////////////
//  sSedPath = "/bin/sed";
/////////////////////////DLJA TESTIROVANIJA//////////////////

  int iChildPid = ::fork();
  if ( !iChildPid ){
    ::close( STDIN_FILENO );
    ::close( STDOUT_FILENO );

    ::dup2( iInpVal, STDIN_FILENO );
    ::dup2( iOutVal, STDOUT_FILENO );
    ::close( iOutVal );
		::close( iInpVal );
    exit( execvp( sSedPath, sSedArgs ) );
  }

		::close( iOutVal );
	  ::close( iInpVal );

  ::waitpid( iChildPid, &status, 0 );

  for ( i=0; i < iFieldsNum; i++ )
  {
     if ( sSedArgs[ i+1 ]  )
     delete[] sSedArgs[ i+1 ];
  }

  if ( sSedArgs ) delete[]sSedArgs;

 	return bExit = true;
}

/****************************************************************/
bool PrinterCfg::CopyFilter( QString sSpool, QString sRootFilter ){

  Log::logMain(32, "CopyFilter sRootFilter:%s\n", sRootFilter.ascii() );


  QString sMasterFilter = sRootFilter + PRINTER_FILTER_DIR +"master-filter";
  QString sDest = sSpool + "filter";
  QString sCp = "cp";

#ifdef GBLI_DEVEL
  sCp = "/home/nd/tmp/cp";
  sMasterFilter = "/home/nd/tmp/master-filter";
  sDest = "/home/nd/tmp2/filter";
#endif

  int status;
  int iChildPid = ::fork();
  if ( !iChildPid ) ::execlp( sCp.ascii(),
                           sCp.ascii(),
                           sMasterFilter.ascii(),
                           sDest.ascii(), NULL ) ;

  ::waitpid( iChildPid, &status, 0 );


  return true;
}

/****************************************************************/
/*void PrinterCfg::EmptyFields(){
	sInput.remove( 0, sInput.length() );
  Log::logMain( 34, "sInput posle obnulenija:%s \n", sInput.ascii()  );
  sOutput.remove( 0, sOutput.length() );
  Log::logMain( 34, "sOutput posle obnulenija:%s \n", sOutput.ascii()  );
  cFieldName->clear();
  cFieldValue->clear();
} */

/****************************************************************/

bool PrinterCfg::ConfigureQueue( QString sRoot )
{
  //create the spooldir

  cFieldName = new QStringList();
  cFieldValue = new QStringList();

  QString sSpoolPath;
  QString sSymb = "/";

  if( !sSpoolResult.isEmpty() ){
    sSpoolPath = sRoot + sSpoolResult + sSymb;  // mnt/root/var/spool/lpd/lp
    //sSpoolResult = sSpoolResult + sSymb;
  }
  else{
     sSpoolPath = SPOOL_BY_DEFAULT + sSymb;
     sSpoolResult = SPOOL_BY_DEFAULT;
  }

  Log::logMain( 32, "CONFIGURE QUEUE sSpoolPath: %s\n", sSpoolPath.ascii() );

  //sSpoolPath includes config files
#ifdef GBLI_DEVEL
  sSpoolPath = "/home/nd/tmp2/";
#endif

  if ( !CreateSpoolDir( sSpoolPath, sRoot ) ){
//      Log::logMain( 34, "VYKINULI IZ CreateSpoolDir \n" );
      return false;
  }
//  else Log::logMain( 34, "SOZDALI SPOOL_DIR\n" );

  //make the general.cfg file

//  Log::logMain( 34, "SpoolPath: %s\n", sSpoolPath.ascii() );
  QString sOutput = sSpoolPath + "general.cfg";
//  Log::logMain( 34, "sOutput: %s\n", sOutput.ascii() );
  QString sInput = sRoot + PRINTER_FILTER_DIR + "general.cfg.in";
//  Log::logMain( 34, "CONFIGURE QUEUE sInput: %s\n", sInput.ascii() );




#ifdef GBLI_DEVEL
  sInput = "/home/nd/tmp/general.cfg.in";
#endif

  cFieldName->append( "desiredto" );
  cFieldName->append( "papersize" );
  cFieldName->append( "printertype" );
  cFieldName->append( "ascps_trans" );


/*  for ( QStringList::Iterator it = cFieldName->begin();
        it != cFieldName->end(); it++ ){
   printf("\n");
   printf( *it );
  }*/

  if ( sGSDriverResult.left( 4 ) == "TEXT" )
 		cFieldValue->append( "asc" );
  else
    cFieldValue->append( "ps" );

  cFieldValue->append( sSizeResult );

  cFieldValue->append( sTypeResult );


  if (sGSDriverResult == "POSTSCRIPT")
 //       (sDescription.find ("HP") != -1 ) )
 	cFieldValue->append( "YES" );
  else
		cFieldValue->append( "NO" );


//  Log::logMain( 34, "...........general.cfg.........\n" );
	if ( !CreateConfigFile( sInput, sOutput,
                          cFieldName, cFieldValue) )	return false;



//  EmptyFields();
  cFieldName->clear();
  cFieldValue->clear();

  sOutput = sSpoolPath + "postscript.cfg";

  sInput = sRoot + PRINTER_FILTER_DIR +"postscript.cfg.in";

#ifdef GBLI_DEVEL
  sOutput = "/home/nd/tmp2/postscript.cfg";
  sInput = "/home/nd/tmp/postscript.cfg.in";
#endif

  cFieldName->append( "gsdevice" );
  cFieldName->append( "resolution" );
  cFieldName->append( "color" );
  cFieldName->append( "papersize" );
  cFieldName->append( "extragsoptions" );
  cFieldName->append( "reversepages" );
  cFieldName->append( "pssendeof" );
  cFieldName->append( "nup" );
  cFieldName->append( "rtlftmar" );
  cFieldName->append( "topbotmar" );

//gsdevise
  cFieldValue->append( sGSDriverResult );
//resolution
  cFieldValue->append( sResolResult );
//color
  QString sColor="";

  Log::logMain( 32, "Uniprint:%s\n", sGSDriverResult.ascii() );
  Log::logMain( 32, "Uniprint length:%d\n", sGSDriverResult.length() );
  if ( sGSDriverResult.left( 8 ) == "uniprint" ) cFieldValue->append( sPixel );
  else {

//    Log::logMain( 34, "sPixel:%s\n", sPixel.ascii() );
  	if ( sPixel  != "Default" ){
//      printf( "PIXEL: " + sPixel +"NU KAK?"+ "\n" );
//      printf( "LENGTH OF PIXEL: %d\n", sPixel.length() );
    	sColor = "-dBitsPerPixel=";
      sColor.append( sPixel );
      cFieldValue->append( sColor );
    }
    else cFieldValue->append( "" );
  }



//papersize
	cFieldValue->append( sSizeResult );

// "extragsoptions"
  cFieldValue->append("");

//"reversepages"
	cFieldValue->append("NO");

//"pssendeof"

  if( sGSDriverResult.left( 10 ) == "POSTSCRIPT" )
	  cFieldValue->append("YES");
  else
  	cFieldValue->append("NO");

//"nup"
   cFieldValue->append("1");

//"rtlftmar"
   cFieldValue->append("18");

//"topbotmar"
   cFieldValue->append("18");

//  Log::logMain( 34, "...........postscript.cfg.........\n" );
	if ( !CreateConfigFile( sInput, sOutput,
                          cFieldName, cFieldValue) ) return false;

  //make textonly.cfg

  //EmptyFields();
  cFieldName->clear();
  cFieldValue->clear();


  sOutput = sSpoolPath + "textonly.cfg";

//  sInput = "";
  sInput = sRoot + PRINTER_FILTER_DIR + "textonly.cfg.in";

#ifdef GBLI_DEVEL
  sOutput = "/home/nd/tmp2/textonly.cfg";
  sInput = "/home/nd/tmp/textonly.cfg.in";
#endif

  cFieldName->append("textonlyoptions");
  cFieldName->append("crlftrans");
  cFieldName->append("textsendeof");

  cFieldValue->append("");

  if ( iStair == 1 ) cFieldValue->append( "YES" );
  else cFieldValue->append("");

  cFieldValue->append("YES");

//  Log::logMain( 34, "...........textonly.cfg.........\n" );
  if ( !CreateConfigFile( sInput, sOutput,
                          cFieldName, cFieldValue) ) return false;

  //if we have SMB printer

  FILE *fout;

  if ( (sTypeResult.left( 17 ) == "SMB/Windows 95/NT") ||
       ( ( sTypeResult.left( 7 ) == "NetWare" ) )){
 //   EmptyFields();
    cFieldName->clear();
    cFieldValue->clear();

   	sOutput = sSpoolPath + ".config";

#ifdef GBLI_DEVEL
    sOutput = "/home/nd/tmp2/.config";
#endif
  }


  if ( sTypeResult == "SMB/Windows 95/NT" ){

    fout = fopen( sOutput, "w" );
    fprintf( fout,"share='\\\\%s\\%s'\n",
                  sSmbHost.ascii(), sSmbName.ascii() );
    fprintf( fout, "hostip=%s\n", sSmbIP.ascii() );
    fprintf( fout, "user='%s'\n", sSmbUser.ascii() );
    fprintf( fout, "password='%s'\n", sSmbPass.ascii() );
    fprintf( fout, "workgroup='%s'\n", sSmbWorkgr.ascii() );
  }

  //if we have NCP printer

  FILE *fNcpOut;

  if ( sTypeResult == "NetWare" ){
   fNcpOut = fopen( sOutput, "w" );
   fprintf( fNcpOut, "server=%s\n", sNcpServer.ascii()  );	
   fprintf( fNcpOut, "queue=%s\n", sNcpQueue.ascii() );
   fprintf( fNcpOut, "user=%s\n", sNcpUser.ascii() );
   fprintf( fNcpOut, "password=%s\n", sNcpPass.ascii() );
   fclose( fNcpOut );
  }

  if ( !CopyFilter( sSpoolPath, sRoot  ) ) return false;

 return true;                       //vremenno
}


/****************************************************************/
void PrinterCfg::CreatePrintcap( QString sRoot ){
	
  QString sPrintcap = sRoot + "/etc/printcap";
#ifdef GBLI_DEVEL
  sPrintcap = "/home/nd/tmp2/printcap";
#endif

  FILE *fprintc = fopen( sPrintcap.ascii(), "w" );

  if ( fprintc ){
  	fprintf ( fprintc, "#\n" );
    fprintf ( fprintc, "#Please don't edit this file directly "
             "unless you know what you are doing!\n" );
    fprintf ( fprintc, "#Be warned that the control-panel "
             "printtool requires a very strict format!\n");
    fprintf ( fprintc, "#Look at the printcap(5) man page for "
             "more info.\n");
    fprintf ( fprintc, "#\n");
    fprintf ( fprintc, "#This file can be edited with the "
              "printtool in the control-panel.\n");
    fprintf ( fprintc, "\n");
    fprintf ( fprintc, "##PRINTTOOL3## %s %s %s %s %s %s %s %d \n",
              sTypeResult.ascii(),
              sGSDriverResult.ascii(),
              sResolResult.ascii(),
              sSizeResult.ascii(),
              "{}",
              sDriverResult.ascii(),
              sPixel.ascii(),
              iStair );
    fprintf( fprintc, "%s:\\\n", sQueueResult.ascii() );
    fprintf( fprintc, "\t:sd=%s:\\\n", sSpoolResult.ascii() );
    fprintf( fprintc, "\t:mx#0:\\\n\t:sh:\\\n");

    if ( sTypeResult == "LOCAL" ){
	    fprintf( fprintc, "\t:lp=%s:\\\n", sDevice.ascii() );
    }
    else if ( sTypeResult == "REMOTE" ){
  		fprintf( fprintc, "\t:rm=%s:\\\n", sRemoteHost.ascii() );
      fprintf( fprintc, "\t:rp=%s:\\\n", sRemoteQueue.ascii() );
    }
    else {
    	fprintf( fprintc, "\t:lp=/dev/null:\\\n" );
	    fprintf( fprintc, "\t:af=%s/%s\\\n", sSpoolResult.ascii(),
                        "acct:" );
    }

    fprintf( fprintc, "\t:if=%s/%s:\n", sSpoolResult.ascii(), "filter"  );
    fclose( fprintc );

  }

/*remote lpd") );
  cmbType->insertItem( "SMB/Windows 95/NT" );
  cmbType->insertItem( "NetWare" );*/

}


/****************************************************************/

void PrinterCfg::finish()
{
//	Log::logMain( 34, "Called printercfg->finish\n" );
//  printf ( "Called printercfg->finish\n" );
  if ( ResultValue() ) {
    if( ConfigureQueue( NEWROOT ) ) CreatePrintcap( NEWROOT );
//    printf("Change root \n");
	  char cmd[128];
	  sprintf( cmd, "chroot %s /sbin/chkconfig --add --level 35 lpd", NEWROOT.ascii() );
    system( cmd );
  }

	// /mnt/root/etc/printcap
	// /mnt/root/var/log/lp/lpd
}
/****************************************************************/
