/***************************************************************************
                                packageitem.h
                             -------------------                                         
    begin                : Sun Dec 26 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef PACKAGELISTITEM_H
#define PACKAGELISTITEM_H

#include <qwidget.h>
#include <qlistview.h>

#include "config.h"
#include "installselect.h"

class PackageListItem : public QObject, public QListViewItem {
	Q_OBJECT

public:
  PackageListItem( QListView * parent, pkgSet* a_packages );
  PackageListItem( PackageListItem * parent, QString a_label );
  PackageListItem( PackageListItem * parent, QString a_label, packageInfo* a_package );

	enum Type{ Root=0, Group, Package };

	int setPackageSelected();
	int setPackageSelected( bool a_bl, bool a_blBacktrack = true );
	int getType(){ return type; };
	int getSelectedSize(){ return iSelectedSize; };
	void changeSize( const signed int a_size = 0, bool a_blBacktrack = true );
	void initSize( int *a_iSelected, int *a_iTotal, int *a_iNoUpdate );

	packageInfo *package;

signals:
	void totalChanged( int a_size );

private:
	QString sizeToString( const int a_size );

	pkgSet *packages;
	int type;
	int iTotalSize;
	int iSelectedSize;
	int iNoUpdateSize;
	bool selected;
	QString sizeString;

};


#endif


