/***************************************************************************
                               partitionitem.h
                             -------------------                                         
    begin                : Mon Dec 20 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef PARTITIONITEM_H
#define PARTITIONITEM_H

#include "config.h"
#include "diskorpartitionitem.h"
class DiskItem;

class PartitionItem : public DiskOrPartitionItem
{
public:
    PartitionItem( QListViewItem* parent, DiskItem* diskItem_,
	    bool isNew_, int number_, bool bootable_, signed long start_, signed long size_, int id_,
			QListViewItem* after = NULL );

    QString disk();
    signed long heads();
    signed long sectors();
    signed long cylinders();

    DiskItem* diskItem;

    QString name();
    int number;
    bool bootable;
    signed long start;// sectors
    signed long size; // sectors
    int id;

    bool isNew;
    bool willBeFormated;

    bool isExtended();
    bool isLogical() { return number > 4; }
    bool isNonEmptyPrimary() { return number <= 4 && size > 0; }
    bool isSwap();

    // to get Windows fonts
    bool isWindows();
    QString seekForWinFonts();
    QString winFontsPath;

    QString dump();
    signed long end(){ return start + size - 1; }
    signed long cylinderOfSector( signed long );
    double megaByteOfSectors( signed long );
    void updateView();

    double sizeInMB() { return megaByteOfSectors(size); }

    void checkForFilesystem();

    bool checkForSwapExceed();

private:
    void init( bool isNew_, int number_, bool bootable_, signed long start_, signed long size_, int id_);

};

#endif

