/***************************************************************************
			                          printercfg.cpp
                             -------------------                                         
    begin                : Fri Feb 11 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Vadim Khakhulin, Natalja Drozzina
    author email         : vh@bestlinux.net, nd@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#include "printercfg.h"
#include "config.h"

#include <stdio.h>
#include <qlayout.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qgroupbox.h>
#include <qdir.h>
#include <qobjectlist.h>
#include <qheader.h>

#include <qpushbutton.h>
#include <qstringlist.h>
#include <qmessagebox.h>

#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <stdio.h>
#include <pwd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/wait.h>

#include <unistd.h>

#include "log.h"
#include "ltemplate.h"
#include "liconloader.h"

/****************************************************************/

PrinterList::PrinterList(PrinterList *parent, const QString &name, QString id_ = "")
    : QObject(parent, name), pName(name), id(id_)
{
}

/****************************************************************/

PrinterListItem::PrinterListItem(QListView *parent, PrinterList *p)
    : QListViewItem(parent)
{
    setText(0, p->printerListName());
    id = p->printerId();

		if(p->printerListName() == QDialog::tr(" None "))
			parent->setSelected(this, true);

    if(p->children())
			insertSubFolders(p->children());
}

PrinterListItem::PrinterListItem(PrinterListItem *parent, PrinterList *p)
    : QListViewItem(parent)
{
    setText(0, p->printerListName());
    id = p->printerId();

    if(p->children())
			insertSubFolders(p->children());
}

void PrinterListItem::insertSubFolders(const QObjectList *lst)
{
    PrinterList *p;
    for(p = (PrinterList*)((QObjectList*)lst)->first(); p; p = (PrinterList*)((QObjectList*)lst)->next())
			(void)new PrinterListItem(this, p);
}

/****************************************************************/
AdvancedD::AdvancedD(QWidget* parent, const char *name, PrinterCfg *PCfg, QString dataFile_)
										 :QDialog(parent, name, true)
{
	int i = 0, j = 0, k = 0;
	char getVal[512], getCom[512];
	QString sectionV, sectionC, value;
	QString dataFile = dataFile_;

	QFile f(dataFile);
	if(!f.exists())
	{
		Log::logMain(32, "%s doesn't exist !!!\n", dataFile.latin1());
		return;
	}

// LayoutOfSecWin

	this->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));

	amountCombo = PCfg->canChange.getAmount();

	combos = new (QComboBox*)[amountCombo];

  QDialog::setCaption(QDialog::tr("Additional data"));
  groupTop2 = new QGroupBox(this);
	groupTop2->setTitle(QDialog::tr("Additional data"));
  groupTop2->setFrameStyle(QFrame::Box | QFrame::Raised);
	groupTop2->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));

  lblQueue = new QLabel( QDialog::tr("Name of queue:"), groupTop2);
	lblQueue->setAutoMask(true);
  editQueueMain = new QLineEdit(groupTop2);
	if(PCfg->wasHere)
	  editQueueMain->setText(*(PCfg->ReturnStr(1)));
	else
	  editQueueMain->setText("lp");

  lblSpool = new QLabel( QDialog::tr("Spool directory:"), groupTop2);
	lblSpool->setAutoMask(true);
  editSpool = new QLineEdit( groupTop2 );
	if(PCfg->wasHere)
	  editSpool->setText(*(PCfg->ReturnStr(2)));
	else
	  editSpool->setText(SPOOL_BY_DEFAULT);

  lblSize = new QLabel(QDialog::tr("Paper size:"), groupTop2);
	lblSize->setAutoMask(true);
  lblRes = new QLabel(QDialog::tr("Resolution:"), groupTop2);
	lblRes->setAutoMask(true);
	lblPixel = new QLabel(QDialog::tr("Colour depth:"), groupTop2);
	lblPixel->setAutoMask(true);

	if(Ini.ProfileStr(dataFile, "Info", "Values", "", getVal))
		PCfg->infoData = getVal;

	comboValMas = new (SplitString *)[PCfg->canChange.getAmount()];
	comboComMas = new (SplitString *)[PCfg->canChange.getAmount()];

	while(PCfg->canChange.Next(sectionC))
	{
	  combos[j] = new QComboBox(groupTop2);

		if(Ini.ProfileStr(dataFile, sectionC, "Values", "", getVal))
		{
			comboVal = getVal;
			comboValMas[k] = new SplitString(getVal);

			Ini.ProfileStr(dataFile, sectionC, "Comments", "", getCom);
			comboCom = getCom;
			comboComMas[k] = new SplitString(getCom);

			while(comboCom.Next(sectionV))
				combos[j]->insertItem(sectionV, i++);

//			while(comboVal.Next(sectionV))
//				combos[j]->insertItem(sectionV, i++);

			i = 0;

			if(PCfg->wasHere)
			{
				QString selectedVal = PCfg->canChangeData.getByIndex(PCfg->canChange.getIndex(sectionC));
				combos[j]->setCurrentItem(comboVal.getIndex(selectedVal));
			}
			else if(PCfg->canChangeData.getAmount() > 0) // after DefaultSettings() or data from WinGBLI
			{
				QString selectedVal = PCfg->canChangeData.getByIndex(PCfg->canChange.getIndex(sectionC));
				printf("selectedVal: %s\n", selectedVal.latin1());
				if(selectedVal != "Default")
				{
					int indx = comboVal.getIndex(selectedVal);
					if(indx != -1)
						combos[j]->setCurrentItem(indx);
				}
			}
			else
				if(Ini.ProfileStr(dataFile, sectionC, "Default", "", getVal))
					combos[j]->setCurrentItem(comboVal.getIndex(getVal));
		
			j++;
			k++;
	  }
		else
		{
			combos[j]->insertItem("Default", 0);
			j++;
		}
	}

	for(int i = 0; i < k; i++)
		printf("%s\n", comboValMas[i]->returnSections().latin1());

	amountCheck = PCfg->checkBoxes.getAmount();
	chkBoxes = new (QCheckBox *)[amountCheck];

	tr("Send FF");
	tr("Send EOT");
	tr("Assume unknown data is text");
	tr("Rerender Postscript");
	tr("Convert text to Postscript");

	for(int i = 0; PCfg->checkBoxes.Next(value); i++)
	{
		chkBoxes[i] = new QCheckBox(tr(value.latin1()), groupTop2);
		chkBoxes[i]->setAutoMask(true);

   	if(PCfg->checkBoxesData.getByIndex(PCfg->checkBoxes.getIndex(value)) == "1")
			chkBoxes[i]->setChecked(true);		
	}

  QPushButton *OKBut = new QPushButton (QDialog::tr("Ok"), this);
  QObject::connect(OKBut, SIGNAL(clicked()), this, SLOT(accept()));

  QPushButton *CancelBut = new QPushButton (QDialog::tr("Cancel"), this);
  QObject::connect(CancelBut, SIGNAL(clicked()), this, SLOT(reject()));

  QVBoxLayout *lvMain = new QVBoxLayout(this, 10);
  QHBoxLayout *lhgrTop = new QHBoxLayout(10);
  QVBoxLayout *lvgrTop = new QVBoxLayout(groupTop2, 15, 10);
  QHBoxLayout *hbutton = new QHBoxLayout();
  QVBoxLayout *lv1 = new QVBoxLayout(5);
  QVBoxLayout *lv2 = new QVBoxLayout(5);

	lv1->addStretch();
	lv1->addWidget(lblQueue);
	lv1->addStretch();
	lv1->addWidget(lblSpool);
	lv1->addStretch();
	lv1->addWidget(lblSize);
	lv1->addStretch();
	lv1->addWidget(lblRes);
	lv1->addStretch();
	lv1->addWidget(lblPixel);
	lv1->addStretch();
	
	lv2->addStretch();
	lv2->addWidget(editQueueMain);
	lv2->addStretch();
	lv2->addWidget(editSpool);
	lv2->addStretch();

	for(int i = 0; i < amountCombo; i++)
	{
		lv2->addWidget(combos[i]);
		lv2->addStretch();
	}

	QVBoxLayout *lv3 = new QVBoxLayout(5);

	for(int i = 0; i < amountCheck; i++)
		lv3->addWidget(chkBoxes[i]);

	lhgrTop->addLayout(lv1);
	lhgrTop->addLayout(lv2);
	
	lvgrTop->addLayout(lhgrTop);
	lvgrTop->addLayout(lv3);
	
  hbutton->addWidget(OKBut);
  hbutton->addStretch();
  hbutton->addWidget(CancelBut);
	
  lvMain->addWidget(groupTop2);
  lvMain->addLayout(hbutton);

// EntryOfSecWin
}

/****************************************************************/
void AdvancedD::ResultFromSecWin(PrinterCfg *PCfg)
{
// ResultFromSecWin
/*
1:sQueueResult;
2:sSpoolResult;
*/

  *(PCfg->ReturnStr(1)) = editQueueMain->text();
  *(PCfg->ReturnStr(2)) = editSpool->text();

	PCfg->canChangeData = "";
	PCfg->checkBoxesData = "";

	QString text;
	for(int i = 0, k = 0; i < amountCombo; i++)
	{
		text = combos[i]->currentText();
		
		if(text == "Default")
			PCfg->canChangeData += text;
		else
		{
			PCfg->canChangeData += comboValMas[k]->getByIndex(comboComMas[k]->getIndex(text));
			k++;
		}
  }

	for(int i = 0; i < amountCheck; i++)
		PCfg->checkBoxesData += (chkBoxes[i]->isChecked() ? "1" : "0");

	PCfg->wasHere = true;

	printf("canChange: %s\n", PCfg->canChange.returnSections().latin1());
	printf("canChangeData: %s\n", PCfg->canChangeData.returnSections().latin1());

	for(int i = 0; i < amountCheck; i++)
		printf("%s ", PCfg->checkBoxesData.getByIndex(i).latin1());
	printf("\n");
}	
/****************************************************************/

PrinterCfg::PrinterCfg(QWidget *parent, const char *name, NetworkPage *net_)
	: GBLIPage(parent,name)
{
#ifndef GBLI_DEVEL
	system( "touch -t 01010000 "+ QString( CONF_MODULES ) );
  system("modprobe -qs parport_pc" );
//  system("/usr/sbin/modprobe parport_probe" );
  system("modprobe -qs lp" );
	system( "touch -t 01010000 "+ QString( CONF_MODULES ) );
#endif

	net = net_;

	this->setBackgroundPixmap( LIconLoader::loadIcon( TEXTURE ) );
	wasHere = false;
	printersView = 0;
	printerModel = 0;
	printerId = 0;

	defaultChkBoxesVal = "0,0,1,0,1";
	perlScript = "printer.py";
	overFile = "/tmp/printer.override";
	postscriptWrapper	= "/usr/share/printconf/util/mf_postscript_wrapper";
	wrapper	= "/usr/share/printconf/util/mf_wrapper";
	smbprint	= "/usr/share/printconf/util/smbprint";
	ncpprint	= "/usr/share/printconf/util/ncpprint";
  dataFile = "/tmp/printer.data";
  defaultPageSize = "A4";

	Info = "id,make,model,driver,color,ascii";
	canChange = "PageSize,Resolution,ColourDepth";
	checkBoxes = "Send FF,Send EOT,Assume unknown data is text,Rerender Postscript,Convert text to Postscript";
	checkBoxesData = defaultChkBoxesVal;
	canChangeData = "";

	NullValue();
  FillEntry();

	lstPrinters.setAutoDelete(true);
//	lstItem.setAutoDelete(true);

	MainLayout();
}

void PrinterCfg::showEvent(QShowEvent *)
{
	if(cmbType->currentItem())
		CheckNetwork();
}

void PrinterCfg::DefaultSettings()
{
	char getVal[512];
	QString section;

	if(Ini.ProfileStr(dataFile, "Info", "Values", "", getVal))
		infoData = getVal;

	while(canChange.Next(section))
	{
		if(Ini.ProfileStr(dataFile, section, "Default", "", getVal))
			canChangeData += getVal;
	}
}

void PrinterCfg::selectionChanged(QListViewItem *listItem)
{
	wasHere = false;

	canChangeData = "";
	checkBoxesData = defaultChkBoxesVal;

	if(listItem->text(0) == QDialog::tr(" None "))
	  SetFalseTrue(false);
	else
	  SetFalseTrue(true);
}

/****************************************************************/

void PrinterCfg::NullValue()
{
  sTypeResult = "";
  sQueueResult = "";
  sSpoolResult = "";
  sRemoteHost = "";
  sRemoteQueue = "";
  sSmbHost = "";
  sSmbIP = "";
  sSmbName = "";
  sSmbUser = "";
  sSmbPass = "";
  sSmbWorkgr = "";
  sNcpServer = "";
  sNcpQueue = "";
  sNcpUser = "";
  sNcpPass = "";
  sDevice = "";

  bPort = false;
}

/****************************************************************/

void PrinterCfg::setEnablLocal(bool bValue)
{
  lblDevice->setEnabled(bValue);
	cmbDevice->setEnabled(bValue);
}

/****************************************************************/

void PrinterCfg::setEnablRemote(bool bValue)
{
	lblHost->setEnabled(bValue);
  editRemoteHost->setEnabled(bValue);
  lblQueueRemote->setEnabled(bValue);
  editQueueRemote->setEnabled(bValue);
}

/****************************************************************/

void PrinterCfg::setEnablSmb( bool bValue )
{
  lblSmbHost->setEnabled( bValue );
  editHost->setEnabled( bValue );
  lblSmbIP->setEnabled( bValue );
  editIP->setEnabled( bValue );
  lblSmbName->setEnabled( bValue );
  editName->setEnabled( bValue );
  lblSmbUser->setEnabled( bValue );
  editUser->setEnabled( bValue );
  lblSmbPass->setEnabled( bValue );
  editPass->setEnabled( bValue );
  lblWork->setEnabled( bValue );
  editWork->setEnabled( bValue );
}

/****************************************************************/

void PrinterCfg::setEnablWare( bool bValue )
{
  lblServer->setEnabled( bValue );
  editNcpServer->setEnabled( bValue );
  lblNcpQueue->setEnabled( bValue );
  editNcpQueue->setEnabled( bValue );
  lblNcpUser->setEnabled( bValue );
  editNcpUser->setEnabled( bValue );
  lblNcpPass->setEnabled( bValue );
  editNcpPass->setEnabled( bValue );
}

/****************************************************************/

bool StructureParser::startElement(const QString &namespaceURI, const QString &localName,
																				const QString &qName, const QXmlAttributes &attributes)
{
//	printf("start: %s", qName.ascii());
	curName = qName;

	if(qName == "printer")
	{
		list->append(new PrnEntry());
		curCount = 0;
  }

	if(qName == "drivers" && list->current() != 0)
		startDrv = true;

	return true;
}

bool StructureParser::endElement(const QString &namespaceURI, const QString &localName,
																 const QString &qName)
{
//	printf("end: %s\n", qName.ascii());
	curName = qName;

	if(qName == "drivers")
	{
//		printf("drivers:%s\n", (list->current())->drivers.latin1());
		startDrv = false;
		list->current()->putValue(list->current()->drivers);
		curCount++;
	}

	return true;
}

bool StructureParser::characters(const QString &data_const)
{
//	printf(" data: %s ", data_const.ascii());

	QString data = data_const.simplifyWhiteSpace();
	if(list->current() != 0 && curCount < xmlFields.getAmount())
	{
		if(xmlFields.getByIndex(curCount) == curName)
		{
			if(curName == "id")
			{
				list->current()->id = data;
				curCount++;
			}
			else if(curName == "driver")
			{
				if(startDrv && data.length())
				{
					if(list->current()->drivers.length())
						list->current()->drivers += ',';
					list->current()->drivers += data;
				}
			}
			else
			{
				list->current()->putValue(data);
				curCount++;
			}
		}	
	}
	return true;
}


/****************************************************************/

void PrinterCfg::FillEntry()
{
  list.append(new PrnEntry(new QString("0"), new QString(QDialog::tr(" None ")), new QString(""), new QString("")));
//  list.append(new PrnEntry(new QString("1"), new QString(QDialog::tr(" TEXT ")), new QString(""), new QString("")));
//  list.append(new PrnEntry(new QString("2"), new QString(QDialog::tr(" POSTSCRIPT ")), new QString(""), new QString("")));

	QFile xmlFile(GBLI_DATA_PATH + QString("/data/printerdb.foo"));

	if(!xmlFile.exists())
	{
		Log::logMain(32, "File %s does not exist !\n", xmlFile.name().latin1());
		exit(1);
	}

	StructureParser *parseFunc = new StructureParser(&list);
	QXmlInputSource source(xmlFile);
	QXmlSimpleReader reader;
	if(parseFunc)
	{
		reader.setContentHandler(parseFunc);
		reader.parse(source);
	
		xmlFields = parseFunc->getXmlFields();
		delete parseFunc;
	}
}

/****************************************************************/

QGroupBox *PrinterCfg::FrameDraw()
{
  QGroupBox *groupFrame = new QGroupBox( this );
  groupFrame->setFrameStyle( QFrame::Box | QFrame::Raised );

	return groupFrame;
}

/****************************************************************/

void PrinterCfg::TestPage()
{
/*
	getWinSettings();
	return;
		QString size;
	
		::system("/usr/bin/mpage -b? > /tmp/page_sizes");
		QFile f("/tmp/page_sizes");
		if(f.exists())
		{	
			f.open(IO_ReadOnly);
			while(!f.atEnd())
			{
				f.readLine(size, 100);
				size.replace(QRegExp(" .*"), "");
				pageSizes.append(size);
			}

			for(QStringList::Iterator it = pageSizes.begin(); it != pageSizes.end(); ++it )
				printf("%s\n", (*it).latin1());

			printf("\noccur:%d\n", pageSizes.contains(QString("Letter")));
		}

return;

*/

  QString strTestFile = QString(GBLI_DATA_PATH) + "/data/testpage.asc";
  qApp->setOverrideCursor(Qt::waitCursor);

  if(ResultValue())
 	{
  	if(!wasHere)
		{
			if(generateFooData(""))
        {
				 qApp->restoreOverrideCursor();
				 return;
				}
			else
				DefaultSettings();
		}		

    if(ConfigureQueue(""))
    	CreatePrintcap("");
		else
			{
  		 qApp->restoreOverrideCursor();
			 return;
			}
	}

	int pid;	

	::system("/usr/sbin/lpd");  	
 	::sleep(1);

  if(!(pid = fork()))
  {
    ::execlp( "/usr/bin/lpr", "lpr", strTestFile.ascii(), 0);
    ::exit(0);
  }
  ::waitpid(pid, NULL, 0);

  ::sleep(20);

  qApp->restoreOverrideCursor();

	::system("killall -9 lpd");
}

/****************************************************************/

QWidget *PrinterCfg::LocalLayout( QGroupBox *gFrame )
{
	gFrame->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));
  QWidget *grLocal = new QWidget( gFrame );
	grLocal->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));
  lblDevice = new QLabel( tr("Printer device:"), grLocal );
	lblDevice->setAutoMask(true);
  cmbDevice = new QComboBox( grLocal );
	cmbDevice->setAutoMask(true);

  //find of parallel devices
  int index = 0;
  //QString strProcPar = QString(PROC) +"/parport/%1/hardware";
  QString strProcPar = "/dev/lp%1";

  QString strPort = "/dev/lp%1 (LPT%2)";
  QString strProcSer = QString(PROC) +"/tty/driver/serial";

  if ( !QFile( QString(PROC) +"/cpuinfo" ).exists() ){
     strProcPar += NEWROOT;
     strProcSer += NEWROOT;
     Log::logMain(32, "proc looks to be mounted to %s\n", NEWROOT.latin1() );
  }

	while ( true )
	{
		if ( QFile::exists( strProcPar.arg(index) ) )
		{
			QFile fport_par( strProcPar.arg(index) );
  		if ( fport_par.open( IO_ReadOnly ) )
			{
				cmbDevice->insertItem( strPort.arg(index).arg(index+1) );
				bPort = true;
			}
			fport_par.close();
		}
    else
			break;
		index++;
  }

  //find of serial devices
  index = 0;
  strPort = "/dev/ttyS%1 (COM%2)";

	QFile fport( strProcSer );
	if ( fport.open( IO_ReadOnly ))
	{
		QTextStream stream( &fport );
		QString sLine;
		stream.readLine(); //first line is driver version
		while ( true )
		{
			sLine = stream.readLine ();
			if ( sLine.isEmpty() )
			break;

			if ( (sLine.find("unknown") >= 0 ) || (sLine.find("tx:") < 0))
				continue;

			index = sLine.left( (sLine.find(":")) ).toInt();
			cmbDevice->insertItem( strPort.arg( index ).arg( index +1 ) );
			bPort = true;
		}
		fport.close();
	}

	if(!bPort)
		cmbType->removeItem( Local );

	cmbDevice->setCurrentItem( 0 );

	QHBoxLayout *lhoriz = new QHBoxLayout( 6 );
	QHBoxLayout *lhorizMain = new QHBoxLayout( grLocal, 0, 10 );

	lhoriz->addWidget( lblDevice );
	lhoriz->addWidget( cmbDevice );

	lhorizMain->addLayout ( lhoriz );
	grLocal->hide();

	return grLocal;
}

/****************************************************************/

QWidget *PrinterCfg::RemoteLayout(QGroupBox *groupFrame)
{
	groupFrame->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));
  QWidget *grRemote = new QWidget( groupFrame );
	grRemote->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));
  lblHost = new QLabel( tr("Remote host:"), grRemote );
	lblHost->setAutoMask(true);	
  editRemoteHost = new AddressEdit( AddressEdit::Address, grRemote );
	editRemoteHost->setAutoMask(true);	

  lblQueueRemote = new QLabel( tr("Remote queue:"), grRemote );
	lblQueueRemote->setAutoMask(true);
  editQueueRemote = new QLineEdit( grRemote );
  editQueueRemote->setMinimumWidth( 0 /*editQueueRemote->sizeHint().width()*/ );
  editQueueRemote->setText( "lp" );

  QVBoxLayout *lvLbl = new QVBoxLayout(  );
  QVBoxLayout *lvList = new QVBoxLayout(  );

  QHBoxLayout *lhoriz = new QHBoxLayout( grRemote, 0, 6 );
  QVBoxLayout *lvert = new QVBoxLayout( 6 );

  editRemoteHost->setMinimumWidth( editQueueRemote->sizeHint().width() );

  lvLbl->addWidget( lblHost );
  lvLbl->addWidget( lblQueueRemote );

  lvList->addWidget( editRemoteHost );
  lvList->addWidget( editQueueRemote );

  lhoriz->addLayout( lvLbl );
  lhoriz->addStretch();
  lhoriz->addLayout( lvList );
  lhoriz->addStretch( 2 );
  lhoriz->addLayout(lvert);

  if(!bPort)
		setEnablRemote(false);

  grRemote->hide();

  return grRemote;
}
/****************************************************************/

QWidget *PrinterCfg::SmbLayout(QGroupBox *gFrame)
{
	gFrame->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));

  QWidget *grSmb = new QWidget( gFrame );
	grSmb->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));

  QWidget *wLeft = new QWidget( grSmb );
	wLeft->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));

  QWidget *wRight = new QWidget(grSmb);
	wRight->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));

  lblSmbHost = new QLabel( tr("SMB server host:" ), wLeft );
	lblSmbHost->setAutoMask(true);

  editHost = new QLineEdit( wLeft );
  editHost->setMinimumWidth( 5 );

  lblSmbIP = new QLabel( tr("SMB server IP:"), wLeft );
	lblSmbIP->setAutoMask(true);
  editIP = new AddressEdit( AddressEdit::Address , wLeft );

  lblSmbName = new QLabel( tr("Share name:"), wLeft );
	lblSmbName->setAutoMask(true);

  editName = new QLineEdit( wLeft );
  editName->setMinimumWidth( 5 );

  lblSmbUser = new QLabel( tr("User name:"), wRight );
	lblSmbUser->setAutoMask(true);

  editUser = new QLineEdit( wRight );
  editUser->setMinimumWidth( 5 );

  lblSmbPass = new QLabel( tr("Password:"), wRight );
	lblSmbPass->setAutoMask(true);

  editPass = new QLineEdit( wRight );
  editPass->setEchoMode( QLineEdit::Password );
  editPass->setMinimumWidth( 5 );

  lblWork = new QLabel( tr("Workgroup:"), wRight );
	lblWork->setAutoMask(true);

  editWork = new QLineEdit( wRight );
  editWork->setMinimumWidth( 5 );

  editHost->setMaximumWidth( editIP->width() );
  editName->setMaximumWidth( editIP->width() );

  QVBoxLayout *lvLblLeft = new QVBoxLayout();
  QVBoxLayout *lvListLeft = new QVBoxLayout();
  QVBoxLayout *lvLblRight = new QVBoxLayout();
  QVBoxLayout *lvListRight = new QVBoxLayout();

  QHBoxLayout *lhLeft = new QHBoxLayout( wLeft,0, 6 );
  QHBoxLayout *lhRight = new QHBoxLayout( wRight, 0, 6 );
  QHBoxLayout *lhMain = new QHBoxLayout( grSmb, 0, 10 );

  lvLblLeft->addWidget( lblSmbHost );
  lvLblLeft->addWidget( lblSmbIP );
  lvLblLeft->addWidget( lblSmbName );

  lvListLeft->addWidget( editHost );
  lvListLeft->addWidget( editIP );
  lvListLeft->addWidget( editName );

  lvLblRight->addWidget( lblSmbUser );
  lvLblRight->addWidget( lblSmbPass );
  lvLblRight->addWidget( lblWork );

  lvListRight->addWidget( editUser );
  lvListRight->addWidget( editPass );
  lvListRight->addWidget( editWork );

  lhLeft->addLayout( lvLblLeft );
  lhLeft->addLayout( lvListLeft );

  lhRight->addLayout( lvLblRight );
  lhRight->addLayout( lvListRight );

  lhMain->addWidget( wLeft,1 );
  lhMain->addWidget( wRight,1 );

  grSmb->hide();

	return grSmb;
}
/****************************************************************/

QWidget *PrinterCfg::NetWareLayout(QGroupBox *groupFrame)
{
	groupFrame->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));

  QWidget *grNetWare = new QWidget ( groupFrame );
	grNetWare->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));

  QWidget *wLeft = new QWidget( grNetWare );
	wLeft->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));
  QWidget *wRight = new QWidget( grNetWare );
	wRight->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));

  lblServer = new QLabel( tr("Printer server:"), wLeft );
	lblServer->setAutoMask(true);
  editNcpServer = new AddressEdit( AddressEdit::Address , wLeft );

  lblNcpQueue = new QLabel( tr("Print queue name:"), wLeft );
	lblNcpQueue->setAutoMask(true);
  editNcpQueue = new QLineEdit( wLeft );
  editNcpQueue->setMinimumWidth( 5 );
  editNcpQueue->setMaximumWidth( editNcpServer->width() );

  lblNcpUser = new QLabel( tr("User name:"), wRight );
	lblNcpUser->setAutoMask(true);
  editNcpUser = new QLineEdit( wRight );
  editNcpUser->setMinimumWidth( 5 );

  lblNcpPass = new QLabel( tr("Password:"), wRight );
	lblNcpPass->setAutoMask(true);
  editNcpPass = new QLineEdit( wRight );
  editNcpPass->setEchoMode( QLineEdit::Password );
  editNcpPass->setMinimumWidth ( 5 );

  QVBoxLayout *lvLblLeft = new QVBoxLayout();
  QVBoxLayout *lvEditLeft = new QVBoxLayout();
  QVBoxLayout *lvLblRight = new QVBoxLayout();
  QVBoxLayout *lvEditRight = new QVBoxLayout();

  QHBoxLayout *lhLeft = new QHBoxLayout( wLeft, 0, 6 );
  QHBoxLayout *lhRight = new QHBoxLayout( wRight, 0, 6 );
  QHBoxLayout *lhMain = new QHBoxLayout( grNetWare , 0, 10 );


  lvLblLeft->addWidget( lblServer );
  lvLblLeft->addWidget( lblNcpQueue );

  lvEditLeft->addWidget( editNcpServer );
  lvEditLeft->addWidget( editNcpQueue );

  lvLblRight->addWidget( lblNcpUser );
  lvLblRight->addWidget( lblNcpPass );

  lvEditRight->addWidget( editNcpUser );
  lvEditRight->addWidget( editNcpPass );

  lhLeft->addLayout( lvLblLeft );
  lhLeft->addLayout( lvEditLeft );

  lhRight->addLayout( lvLblRight );
  lhRight->addLayout( lvEditRight );

  lhMain->addWidget( wLeft, 1 );
  lhMain->addWidget( wRight, 1 );

  grNetWare->hide();

  return grNetWare;
}

int PrinterCfg::generateFooData(QString sRoot)
{
	int res, pid;
	PrinterListItem *lItem, *tmp;

	lItem	= (PrinterListItem *)printersView->selectedItem();

	if(lItem->firstChild() || (!lItem->firstChild() && lItem->id.length()))
	{
		if(sRoot.length() == 0)
			res = QMessageBox::critical(this, tr("Error"), tr("You must select a driver !\n"), tr("OK"));

		return 1;
	}
	else
	{
		driver = lItem->text(0);
		printf("text: %s\n", driver.latin1());

		while(!(lItem->id.length()))
		{		
			tmp = (PrinterListItem *)lItem->parent();
			if(tmp)
				lItem = tmp;
			else
				return 1;
		}

		id = lItem->id;

		printf("id: %s\n", id.latin1());

		::system(("mkdir -p " + NEWROOT + "/var/cache/foomatic").latin1());
		::system("mkdir -p /var/cache/");
		::system(("ln -sf " + NEWROOT + "/var/cache/foomatic /var/cache/foomatic").latin1());

		QApplication::setOverrideCursor(waitCursor);
		if(!(pid = ::fork()))
		{
			::system((perlScript + " " + driver + " " + id).latin1());
			exit(-1);
		}
		::waitpid(pid, NULL, 0);
		QApplication::restoreOverrideCursor();

		return 0;
	}
}

/****************************************************************/

void PrinterCfg::MainLayout()
{
  groupTop = new QGroupBox (this);
	groupTop->setAutoMask( true );
  groupTop->setFrameStyle( QFrame::Box | QFrame::Raised );
	groupTop->setBackgroundPixmap(LIconLoader::loadIcon(TEXTURE));

// for test
//  butConf = new QPushButton("Write Conf", groupTop);
//  butConf->setEnabled(true);
//	connect(butConf, SIGNAL(clicked()), this, SLOT(Test()));
//	connect(butConf, SIGNAL(clicked()), this, SLOT(finishTest()));
//

	lblType = new QLabel(tr("Printer type:"), groupTop);
	lblType->setAutoMask(true);
  cmbType = new QComboBox (groupTop);
  cmbType->insertItem(tr("Local"), Local);
  cmbType->insertItem(tr("Remote lpd"), Remote);
  cmbType->insertItem("SMB/Windows 95/NT", SMB);
  cmbType->insertItem("NetWare", Netware);
  cmbType->setCurrentItem(0);
	
  butAdvanced = new QPushButton(tr("Additional..."), groupTop);
	connect(butAdvanced, SIGNAL(clicked()), this, SLOT(Advanced()));
	
  butTest = new QPushButton(QDialog::tr("Print Test Page"), groupTop);
	connect(butTest, SIGNAL(clicked()), this, SLOT(TestPage()));

  grBot = FrameDraw();
  groupAdd[0] = LocalLayout(grBot);
  groupAdd[1] = RemoteLayout(grBot);
  groupAdd[2] = SmbLayout(grBot);
  groupAdd[3] = NetWareLayout(grBot);

  QHBoxLayout *lhFrame = new QHBoxLayout(grBot, 15, 0);

  for(int i = 0; i < ARRAY_SIZE; i++)
  	lhFrame->addWidget(groupAdd[i]);

  cmbType->setCurrentItem(0);
  ShowAdditional(0);
  connect(cmbType, SIGNAL(activated(int)), this , SLOT(ShowAdditional(int)));
  	
	printersView = new QListView(groupTop);
	printersView->header()->setClickEnabled( FALSE );
	printersView->addColumn(tr("Printer driver"));
	printersView->setRootIsDecorated(true);
	connect(printersView, SIGNAL(selectionChanged(QListViewItem *)),
					this, SLOT(selectionChanged(QListViewItem *)));

	if(list.first())
	{
		int count = xmlFields.getAmount(), index = 0, i;
	  PrnEntry *data;
		QString drvName;
		QString *str;
		SplitString drivers, make;
		QList<PrinterList> makeList;
	
		PrinterList **printLevels = new (PrinterList *)[count];

		int mkI = xmlFields.getIndex("make") - 1;
		int mdI = xmlFields.getIndex("model") - 1;
		int drI = xmlFields.getIndex("driver") - 1;

		for(data = list.first(); data != 0; data = list.next())
		{
			if(data->drivers.length() || data->id == "0")
			{
	 			for(i = 0, str = (data->fields).first(); str != 0; str = (data->fields).next(), i++)
 				{
   				if(i == mkI && str->length())
 					{
	 					if((index = make.getIndex(*str)) != -1)
 								printLevels[i] = (PrinterList *)makeList.at(index);
 						else
 						{
 							printLevels[i] = new PrinterList(0, QString (*str));
 							if(printLevels[i])
 							{
	 							makeList.append(printLevels[i]);
 								make += (*str);
 							}
 						}
 					}
	 				else if(i == mdI && str->length())
 					{
 						if(printLevels[i - 1])
 							printLevels[i] = new PrinterList(printLevels[i - 1], QString(*str), data->id);
	       	}
 					else if(i == drI && str->length())
 					{
 						if(printLevels[i - 1])
 						{
	   	 	     	drivers = str->latin1();
 							while(drivers.Next(drvName))
 								(void)new PrinterList(printLevels[i - 1], QString(drvName));
// 								printLevels[i] = new PrinterList(printLevels[i - 1], QString(drvName));
 						}
	 				}
 					else if(str->length())
 					{
 						if(printLevels[i - 1])
 							printLevels[i] = new PrinterList(printLevels[i - 1], QString(*str));
	 				}
 				}
 				if(index == -1)
					lstPrinters.append(printLevels[0]);
			}
		}
		delete[] printLevels;
	}				

	setupPrinters();

  QHBoxLayout *lhMain = new QHBoxLayout(this);
  QVBoxLayout *lvgrTop = new QVBoxLayout(groupTop, 15, 0);
  QVBoxLayout *lvHelp = new QVBoxLayout(5);
  QVBoxLayout *lv = new QVBoxLayout(5);
  QHBoxLayout *lh = new QHBoxLayout();
  QVBoxLayout *lvMain = new QVBoxLayout();

	lvHelp->addWidget(printersView);
  lvHelp->addWidget(lblType);

  lh->addWidget(cmbType);
  lh->addStretch();
  lh->addWidget(butAdvanced);
  lh->addStretch();
  lh->addWidget(butTest);

  lv->addLayout(lvHelp);
  lv->addLayout(lh);

  lvgrTop->addLayout(lv);

  lvMain->addWidget(groupTop, 2);
  lvMain->addWidget(grBot, 1);

  lhMain->addStretch(1);
  lhMain->addLayout(lvMain, 8);
  lhMain->addStretch(1);

  SetFalseTrue(false);
}

void PrinterCfg::setupPrinters()
{
	printersView->clear();

	for(PrinterList* p = lstPrinters.first(); p; p = lstPrinters.next() )
//		lstItem.append(new PrinterListItem(printersView, p));
		(void)new PrinterListItem(printersView, p);
}

/****************************************************************/
void PrinterCfg::Advanced()
{
	if(!generateFooData(""))
	{
	  AdvancedD *adv = new AdvancedD(this, "Advanced dialog", this, dataFile);
	  int chk = adv->exec();
		if(chk == QDialog::Accepted)
			adv->ResultFromSecWin(this);
	}
}
/****************************************************************/

int PrinterCfg::getCurIndex()
{
  int i = cmbType->currentItem();
 	if((cmbType->count()) < 4)
		i++;
 	return i;
}

/****************************************************************/

void PrinterCfg::CheckNetwork()
{
	bool Yes = false;
	FILE *fnet = fopen("/proc/net/dev", "r");
	if(fnet == NULL)
	{
		fnet = fopen( (NEWROOT +"/proc/net/dev").latin1(), "r");
		if(fnet == NULL)
		{			
			printf("Can't find /proc/net/dev");
			butTest->setEnabled(false);
		}
	}
	
	if(fnet)
	{
		char *res, *str;
		str = new char[100];
		QString *qres = new QString();
		while(!feof(fnet))
		{
			res = fgets(str, 100, fnet);
			if(res != NULL)
			{
				*qres = res;
//				if((qres->find("eth", 0, FALSE)) != -1)
//					Yes = true;
				
				if((qres->find("eth", 0, FALSE)) != -1)
					Yes = net->runIfconfig();
			}
		}				
		fclose(fnet);
		delete[] str;
	}

	if(Yes)
	{
		if(printersView->currentItem() &&
				printersView->currentItem()->text(0) != QDialog::tr(" None "))
					butTest->setEnabled(true);
	}
	else
		butTest->setEnabled(false);
}

/****************************************************************/

void PrinterCfg::ShowAdditional(int index)
{
	if(index)
		CheckNetwork();
	else
		butTest->setEnabled(true);
	
	int icount;

  for(icount = 0; icount < ARRAY_SIZE; icount++)
		groupAdd[icount]->hide();

  switch (getCurIndex())
  {
		case Local : 	return groupAdd[ 0 ]->show();
		case Remote :	return groupAdd[ 1 ]->show();
		case SMB : default: return groupAdd[ 2 ]->show();
	  case Netware : return groupAdd[ 3 ]->show();
  }					

}

/****************************************************************/

void PrinterCfg::SetFalseTrue(bool n)
{
	butAdvanced->setEnabled(n);
	butTest->setEnabled(n);
	setEnablLocal(n);
	setEnablRemote(n);   	
	setEnablSmb(n);		
	setEnablWare(n);	
	cmbType->setEnabled(n);
	
	if(n)
		if(cmbType->currentItem())
			CheckNetwork();
}

/****************************************************************/

QString PrinterCfg::ConvertType(int iCount)
{
  switch(getCurIndex())
  {
		case Local: return "LOCAL";
		case Remote:	return "REMOTE";
		case SMB: default: return "SMB";
		case Netware: return "NCP";
	}					
}
/****************************************************************/

bool PrinterCfg::ResultValue()
{
	if(printersView->selectedItem()->text(0) == QDialog::tr(" None "))
		return false;

	int iCount = cmbType->currentItem();
	sTypeResult = ConvertType( iCount );

	if (sTypeResult == "LOCAL")
	{	
		sDeviceHelp = cmbDevice->text( cmbDevice->currentItem() );
		sDevice = sDeviceHelp.mid ( 0, sDeviceHelp.find(" ") );
	}

	if ( sTypeResult == "REMOTE" )
	{
		sRemoteHost = editRemoteHost->text();
		sRemoteQueue = editQueueRemote->text();
	}

	if ( sTypeResult == "SMB" )
	{
  	sSmbHost = editHost->text();
		sSmbIP = editIP->text();
		sSmbName = editName->text();
		sSmbUser = editUser->text();
		sSmbPass = editPass->text();
		sSmbWorkgr = editWork->text();
	}

	if ( sTypeResult == "NCP" )
	{
		sNcpServer = editNcpServer->text();
		sNcpQueue = editNcpQueue->text();
		sNcpUser = editNcpUser->text();
		sNcpPass = editNcpPass->text();
	}

  return true;
}

/****************************************************************/

bool PrinterCfg::CreateSpoolDir(QString sSpoolP, QString sRoot)
{
	int oldmask;
	char *lpNames[] = { "control.lp", "log", "lp.acct", "status", "status.lp" };
	struct passwd *lpInfo;
	struct dirent *dir;
	DIR *pathDir;

  bool bExit = false;
  gid_t groupID = 0;
  uid_t userID = 0;
  QString userName = "";

	oldmask = umask( 0 );

#ifdef GBLI_DEVEL
	::system(("rm -rf " + sSpoolP).latin1());
#endif
	
  char cmd[128];
  sprintf(cmd, "mkdir -p -m0755 %s", sSpoolP.latin1());
  if(system( cmd ) < 0)
 	  if(errno != EEXIST)
			return false; 	//if dir exists

	for(int i = 0; i < (int)(sizeof(lpNames) / 	sizeof(lpNames[0])); i++)
		::system((QString("touch ") + sSpoolP + QString("/") + QString(lpNames[i])).latin1());
  ::system(("cp " + QString(GBLI_DATA_PATH) + "/data/VOLATILE " + sSpoolP).latin1());
		
  umask(oldmask);

  QString passwdFileName = sRoot + "/etc/passwd";

#ifdef GBLI_DEVEL
//  sGroupFileName = "/etc/group";
#endif

  FILE *filePasswd = fopen(passwdFileName, "r");
  if (filePasswd == NULL)
		return false;

	while(1)
	{
  	lpInfo = fgetpwent(filePasswd);
    if(lpInfo == NULL)
			break;

    userName = lpInfo->pw_name;

    if(userName == "lp")
		{
			userID = lpInfo->pw_uid;
    	groupID = lpInfo->pw_gid;
      bExit = true;
			break;
		}
	}

  if(!bExit)
		return false;

	fclose(filePasswd);

	createMfCfg(sRoot);
	createOverride();
	createPerlMassive(sRoot);

	if(sTypeResult == "SMB" || sTypeResult == "NCP")
		createScriptCfg(sTypeResult, sRoot);

	pathDir = opendir(sSpoolP.latin1());
	if(pathDir)
	{
		while((dir = readdir(pathDir)))
		{
   		if(strcmp(dir->d_name, ".."))
			{
				if(chown((sSpoolP + "/" + dir->d_name).latin1(), userID, groupID) < 0 ||
					 chmod((sSpoolP + "/" + dir->d_name).latin1(), strcmp(dir->d_name, ".") ? 0600 : 0700) < 0)
				{
					closedir(pathDir);
					return false;
				}
			}
		}
		closedir(pathDir);
	}
	else
		return false;

	if(sRoot.length())	
		createAlchemistScript();

	return true;
}

/****************************************************************/

bool PrinterCfg::ConfigureQueue(QString sRoot)
{
  QString sSpoolPath;

  if(!sSpoolResult.isEmpty())
    sSpoolPath = sRoot + sSpoolResult + "/";  // /mnt/root/var/spool/lpd/lp
  else
	{
     sSpoolPath = sRoot + SPOOL_BY_DEFAULT + "/";
     sSpoolResult = SPOOL_BY_DEFAULT;
  }

  if(sQueueResult.isEmpty())
		sQueueResult = sSpoolResult.right(sSpoolResult.length() - sSpoolResult.findRev('/') - 1);
	
  if(!CreateSpoolDir(sSpoolPath, sRoot))
		return false;

	return true;
}


/****************************************************************/
void PrinterCfg::CreatePrintcap(QString sRoot)
{
  QString sPrintcap = sRoot + "/etc/printcap";
#ifdef GBLI_DEVEL
//	sPrintcap = "/home/vh/printcap";
#endif

  FILE *fprintc = fopen(sPrintcap.ascii(), "w");

  if(fprintc)
	{
  	fprintf(fprintc, "# /etc/printcap\n#\n" );
    fprintf(fprintc, "# DO NOT EDIT! MANUAL CHANGES WILL BE LOST!\n" );
    fprintf(fprintc, "# This file is autogenerated by printconf-backend during lpd init.\n#\n");
    fprintf(fprintc, "# Hand edited changes can be put in /etc/printcap.local, and will be included.\n\n");

    fprintf(fprintc, "%s:\\\n", sQueueResult.latin1());
    fprintf(fprintc, "\t:ml=0:\\\n");
    fprintf(fprintc, "\t:mx=0:\\\n");
    fprintf(fprintc, "\t:sd=%s:\\\n", sSpoolResult.latin1());
    fprintf(fprintc, "\t:af=%s/%s.acct:\\\n", sSpoolResult.latin1(), sQueueResult.latin1());
    fprintf(fprintc, "\t:sh=0:\\\n");

    if(sTypeResult == "LOCAL")
	    fprintf( fprintc, "\t:lp=%s:\\\n", sDevice.latin1());
    else if(sTypeResult == "REMOTE")
		{
  		fprintf(fprintc, "\t:rm=%s:\\\n", sRemoteHost.latin1());
      fprintf(fprintc, "\t:rp=%s:\\\n", sRemoteQueue.latin1());
    }
    else if(sTypeResult == "SMB")
			fprintf(fprintc, "\t:lp=|%s:\\\n", smbprint.latin1());
    else if(sTypeResult == "NCP")
			fprintf(fprintc, "\t:lp=|%s:\\\n", ncpprint.latin1());
	  else
		{
    	fprintf(fprintc, "\t:lp=/dev/null:\\\n");
	    fprintf(fprintc, "\t:af=%s/%s\\\n", sSpoolResult.latin1(), "acct:");
    }
    fprintf(fprintc, "\t:lpd_bounce=true:\\\n");
    fprintf(fprintc, "\t:if=%s:\n", wrapper.latin1());
    fclose(fprintc);
  }
}

void PrinterCfg::createAlchemistScript()
{
	QString tpl = QString(GBLI_DATA_PATH) +"/templates/update_alchemist.py";
  LTemplate mfconfig(tpl);
	
  mfconfig.addToken("queue_name", sQueueResult.latin1());
  mfconfig.addToken("printer_id", id);
  mfconfig.addToken("printer_driver", driver);
  mfconfig.addToken("type", (new QString)->sprintf("%d\n", cmbType->currentItem()));

  mfconfig.addToken("sendFF", checkBoxesData.getByIndex(checkBoxes.getIndex("Send FF")));
  mfconfig.addToken("sendEOT", checkBoxesData.getByIndex(checkBoxes.getIndex("Send EOT")));
  mfconfig.addToken("assumeDataIsText", checkBoxesData.getByIndex(checkBoxes.getIndex("Assume unknown data is text")));
  mfconfig.addToken("rerenderPostscript", checkBoxesData.getByIndex(checkBoxes.getIndex("Rerender Postscript")));
  mfconfig.addToken("convertTextToPostscript", checkBoxesData.getByIndex(checkBoxes.getIndex("Convert text to Postscript")));

  mfconfig.addToken("device_key", sDevice.latin1());

  mfconfig.addToken("server_lpd", sRemoteHost.latin1());
  mfconfig.addToken("queue_lpd", sRemoteQueue.latin1());

  mfconfig.addToken("share", sSmbName.latin1());
  mfconfig.addToken("server_smb", sSmbIP.latin1());
  mfconfig.addToken("workgroup", sSmbWorkgr.latin1());
  mfconfig.addToken("user_smb", sSmbUser.latin1());
  mfconfig.addToken("passwd_smb", sSmbPass.latin1());

  mfconfig.addToken("server_ncp", sNcpServer.latin1());
  mfconfig.addToken("queue_ncp", sNcpQueue.latin1());
  mfconfig.addToken("user_ncp", sNcpUser.latin1());
  mfconfig.addToken("passwd_ncp", sNcpPass.latin1());

  mfconfig.addToken("pageSize", canChangeData.getByIndex(canChange.getIndex("PageSize")));
  mfconfig.addToken("resolution", canChangeData.getByIndex(canChange.getIndex("Resolution")));
  mfconfig.addToken("colourDepth", canChangeData.getByIndex(canChange.getIndex("ColourDepth")));

	mfconfig.write("/tmp/update_alchemist.py");
	::system(("chmod 777 /tmp/update_alchemist.py; mv /tmp/update_alchemist.py " + NEWROOT + "/tmp").latin1());
}

void PrinterCfg::createPerlMassive(QString Root)
{
	int pid;
	QApplication::setOverrideCursor(waitCursor);
	if(!(pid = ::fork()))
	{
		::system((perlScript + " " + driver + " " + id + " override").latin1());
		exit(-1);
	}
	::waitpid(pid, NULL, 0);
	QApplication::restoreOverrideCursor();

	QString fileName = driver + "-" + id + ".foo";
	::system(("cp /tmp/" + fileName + " " + Root + sSpoolResult).latin1());
}

void PrinterCfg::createOverride()
{
	char buf[256];
	::system(("touch " + overFile).latin1());

	QFile f(overFile);
	f.open(IO_WriteOnly);
	for(int i = 0; i < canChange.getAmount(); i++)
	{
		if(canChangeData.getByIndex(i) != "Default")
		{
			sprintf(buf, "%s=%s\n", canChange.getByIndex(i).latin1(), canChangeData.getByIndex(i).latin1());
			f.writeBlock(buf, strlen(buf));
		}
	}
	f.close();
}

void PrinterCfg::createMfCfg(QString copyPath)
{
	if(pageSizes.isEmpty())
	{
		QString size;
	
		::system("/usr/bin/mpage -b? > /tmp/page_sizes");
		QFile f("/tmp/page_sizes");
		if(f.exists())
		{	
			f.open(IO_ReadOnly);
			while(!f.atEnd())
			{
				f.readLine(size, 100);
				size.replace(QRegExp(" .*"), "");
				pageSizes.append(size);
			}

//			for(QStringList::Iterator it = pageSizes.begin(); it != pageSizes.end(); ++it )
//				printf("%s", (*it).latin1());
		}
	}

	QString textFilter;
	QString defaultFilter;	
	QString termination = "";
	QString rerenderPs = "";
	QString psFilter = "";

	QString tpl = QString(GBLI_DATA_PATH) +"/templates/mf.cfg";
  LTemplate mfconfig(tpl);

	if(checkBoxesData.getByIndex(checkBoxes.getIndex("Send FF")) == "1")
		termination += "\\f";
	if(checkBoxesData.getByIndex(checkBoxes.getIndex("Send EOT")) == "1")
		termination += "\\004";
	if(checkBoxesData.getByIndex(checkBoxes.getIndex("Rerender Postscript")) == "1")
		rerenderPs = "--rerender-ps";

	psFilter = QString("filter " + postscriptWrapper + " " + rerenderPs);

  mfconfig.addToken("make", infoData.getByIndex(Info.getIndex("make")).latin1());
  mfconfig.addToken("model", infoData.getByIndex(Info.getIndex("model")).latin1());
  mfconfig.addToken("printer_id", id.latin1());
  mfconfig.addToken("gs_driver", driver.latin1());
  mfconfig.addToken("termination", termination.latin1());
  mfconfig.addToken("locale", "C");

	QString color = infoData.getByIndex(Info.getIndex("color"));
  mfconfig.addToken("color", color == "1" ? "true" : "false");

	QString pSize = canChangeData.getByIndex(canChange.getIndex("PageSize"));
	if(!pageSizes.contains(pSize))
		pSize = defaultPageSize;
  mfconfig.addToken("page_size", pSize);

	if(checkBoxesData.getByIndex(checkBoxes.getIndex("Convert text to Postscript")) == "1" ||
			infoData.getByIndex(Info.getIndex("ascii")) == "0")
		textFilter = "pipe/postscript/ /usr/bin/mpage -b ifdef(`PAGEsize', PAGEsize, A4) -1 -o -P- -";
	else
		textFilter = "text \"\" \\r\\n\\14 ";

  mfconfig.addToken("text_filter", textFilter.latin1());
	
	if(checkBoxesData.getByIndex(checkBoxes.getIndex("Assume unknown data is text")) == "1")
		defaultFilter = textFilter;
	else
		defaultFilter = "cat";	

  mfconfig.addToken("ps_filter", QString(psFilter + " --mfomatic -d " + driver + "-" + id + ".foo").latin1());

  mfconfig.addToken("pcl_filter", "cat");
  mfconfig.addToken("pjl_filter", "cat");
  mfconfig.addToken("default_filter", defaultFilter.latin1());
	
	mfconfig.write(copyPath + "/" + sSpoolResult + "/mf.cfg");
}

/****************************************************************/
void PrinterCfg::createScriptCfg(QString type, QString sRoot)
{
  QString scriptCfg = sRoot + sSpoolResult + "/script.cfg";
 	FILE *fprintc = fopen(scriptCfg.latin1(), "w");

  if(fprintc)
	{
		if(type == "SMB")
		{
	 		fprintf(fprintc, "\nshare='%s'", sSmbName.latin1());
		 	fprintf(fprintc, "\nhostip='%s'", sSmbIP.latin1());
		 	fprintf(fprintc, "\nuser='%s'", sSmbUser.latin1());
	 		fprintf(fprintc, "\npassword='%s'", sSmbPass.latin1());
		 	fprintf(fprintc, "\nworkgroup='%s'", sSmbWorkgr.latin1());
		 	fprintf(fprintc, "\ntranslate=no\n");
		}
		else if(type == "NCP")
		{
	 		fprintf(fprintc, "\nserver='%s'", sNcpServer.latin1());
		 	fprintf(fprintc, "\nqueue='%s'", sNcpQueue.latin1());
		 	fprintf(fprintc, "\nuser='%s'", sNcpUser.latin1());
	 		fprintf(fprintc, "\npassword='%s'\n", sNcpPass.latin1());
		}
    fclose(fprintc);
	}
}

/****************************************************************/
void PrinterCfg::finish()
{
  if(ResultValue())
	{
  	if(!wasHere) // button "Additional..." wasn't pressed
		{
			if(generateFooData(NEWROOT))
				return;
			else
				DefaultSettings();
		}		
    if(ConfigureQueue(NEWROOT))
    	CreatePrintcap(NEWROOT);

	  char cmd[128];

	  sprintf(cmd, "chroot %s /sbin/chkconfig --add --level 35 lpd", NEWROOT.latin1());
    system(cmd);

	  sprintf(cmd, "chroot %s /tmp/update_alchemist.py", NEWROOT.latin1());
    system(cmd);
  }
}
/****************************************************************/

void PrinterCfg::getAllPrinters()
{
	const int children = printersView->childCount();
	
	printerMake.clear();
	delete[] printerModel;
	delete[] printerId;

	printerModel = new QStringList[children];
	printerId = new QStringList[children];

	for(PrinterListItem *viewItem1 = (PrinterListItem *)printersView->firstChild();
			viewItem1; viewItem1 = (PrinterListItem *)viewItem1->nextSibling())
	{
		printerMake.append(viewItem1->text(0));
//		printf("%s\n", viewItem1->text(0).latin1());
			
		PrinterListItem *viewItem2;
		for(viewItem2 = (PrinterListItem *)viewItem1->firstChild(); viewItem2;
				viewItem2 = (PrinterListItem *)viewItem2->nextSibling())
		{
			printerModel[printerMake.count() - 1].append(viewItem2->text(0));
			printerId[printerMake.count() - 1].append(viewItem2->id);
		}
		printerModel[printerMake.count() - 1].sort();
		printerId[printerMake.count() - 1].sort();
	}
}

bool PrinterCfg::lookForPrinter(QString winPrinter_, QListViewItem **retModel)
{
	int indxMake, amount, maxRes = 0, bestMaxRes = 0, res[2];
	QString	searchWord, bestMatch;
	QStringList::Iterator it;

	SplitString linuxPrinter;
	SplitString winPrinter(winPrinter_, ' ');
	linuxPrinter.SetSeparatorChar(' ');
	amount = winPrinter.getAmount();

	res[0] = res[1] = -1;

	getAllPrinters();

	if(winPrinter.Next(searchWord))
	{
		indxMake = printerMake.findIndex(searchWord);
		if(indxMake != -1)
		{
     	for(it = printerModel[indxMake].begin(); it != printerModel[indxMake].end(); it++)
			{
				linuxPrinter = *it;

				for(int i = 1; i < amount; i++)
				{
					if(winPrinter.getByIndex(i) == linuxPrinter.getByIndex(i - 1))
						maxRes++;
					else
						break;					
				}
				if(maxRes > bestMaxRes)
				{
					bestMaxRes = 	maxRes;
					bestMatch = *it;
				}
				maxRes = 0;
			}

			res[0] = indxMake;
			res[1] = printerModel[indxMake].findIndex(bestMatch);
		
			if(res[1] == -1)
				return false;

/*
			printf("res1: %d\n", res[0]);
			printf("res2: %d\n", res[1]);
			printf("%s\n", printerMake[res[0]].latin1());
			printf("%s\n", printerModel[res[0]][res[1]].latin1());
*/

			printersView->clearSelection();
			SetFalseTrue(true);

			PrinterListItem *make = (PrinterListItem *)printersView->firstChild();
			for(int i = 0; i < res[0]; i++)
				make = (PrinterListItem *)make->nextSibling();
			make->setOpen(true);

			PrinterListItem *model = (PrinterListItem *)make->firstChild();
			for(int i = 0; i < res[1]; i++)
				model = (PrinterListItem *)model->nextSibling();
			model->setOpen(true);
			model->firstChild()->setSelected(true);
			printersView->setCurrentItem(model->firstChild());
			*retModel = model->firstChild();
			printersView->ensureItemVisible(model->firstChild());
			return true;
		}
	}
	return false;
}


void PrinterCfg::setInfoFromWindows(int printerType, QString device, SplitString netValues, SplitString advValues,  QListViewItem *model)
{
/*
printf("printerType: %d\n", printerType);
printf("device: %s\n", device.latin1());
printf("netValues: %s\n", netValues.returnSections().latin1());
printf("advValues: %s\n", advValues.returnSections().latin1());
*/
	QString tmp;
	if(printerType == Local)
	{
		for(int i = 0; i < cmbDevice->count(); i++)
		{
			if(!strcmp(device, cmbDevice->text(i)))
				cmbDevice->setCurrentItem(i);
		}
	}
	if(printerType == SMB)
	{
//		netValues.Next(tmp);
//		editHost->setText(tmp);
		netValues.Next(tmp);
		editName->setText(tmp);
	}

	*ReturnStr(1) = "lp";
	*ReturnStr(2) = "/var/spool/lpd/lp";

	canChangeData = advValues;

  cmbType->setCurrentItem(printerType);
  ShowAdditional(printerType);
}

void PrinterCfg::getWinSettings()
{
	WindowsConfig *wcfg = new WindowsConfig("/tmp/linux.cfg");
	if(wcfg)
	{
		if(wcfg->getPrinterSettings(this))
			printf("getWinSettings() success!\n");
		else
			printf("getWinSettings() failed!\n");
	}
	else
		printf("wcfg is NULL\n");
}
