/***************************************************************************
                          servicessetup.cpp  -  description
                             -------------------
    begin                : Sun May 27 2001
    copyright            : (C) 2001 SOT Finnish Software Engineering Ltd.
    author		 					 : Anton Anisimov
    author email         : aa@bestlinux.net
    url			 : http://www.bestlinux.net
    email		 : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "config.h"
#include "servicessetup.h"
#include "serviceinfo.h"
#include "configfile.h"


#include "splitstring.h"

#include <qvgroupbox.h>

#include "liconloader.h"
/*Debug*/
#include "qmessagebox.h"
#include "qapplication.h"

//ServicesSetup *pServicesConfig = new ServicesSetup( "server_services.cfg" );
inline int returnArrIndex(int count, char **mas, char *str)
{
	for(int i = 0; i < count; i++)
		if(!strcmp(mas[i], str))
			return i;

	return 0;
}

ServicesSetup::ServicesSetup(QWidget * parent, const char * name = 0){
	sConfigFileName = "";
	iCurListPos = -1;
	setServicesList();
	drawServicesPage();
}

bool ServicesSetup::setIntExtAdaptersList()
{	
int iAdapter = 0;
QString *pstrAdapter;
iIntExtAdaptersCount = 0;

	InternalNetAdapters.clear();
	ExternalNetAdapters.clear();

	if(pNetinfo)
	{
		while(iAdapter < ADAPTERS_MAX)
		{
    	pstrAdapter = new QString("eth" + QString::number(iAdapter));
      iAdapter++;

      Netinfo::Setup mode = pNetinfo->getMode(*pstrAdapter);

			if(mode == Netinfo::UseDHCPConfig || mode == Netinfo::UseStaticConfig)
			{
	      Netinfo::Interface iface = pNetinfo->getInterface(*pstrAdapter);

  	    if(iface == Netinfo::Intranet)
					InternalNetAdapters.append(pstrAdapter);
      	else if(iface == Netinfo::Extranet)
					ExternalNetAdapters.append(pstrAdapter);
	      else if(iface == Netinfo::Bothnet)
				{
	  	    InternalNetAdapters.append(pstrAdapter);
      	  ExternalNetAdapters.append(pstrAdapter);
	    	}
				else
					continue;
			}
  	}
		iIntExtAdaptersCount = InternalNetAdapters.count() + ExternalNetAdapters.count();
	}
	else
		return false;

	return true;
}

ServicesSetup::ServicesSetup( QString a_sFileName, Netinfo *a_netinfo, QWidget *parent, const char *name=0 ):
 GBLIPage(parent, name){
	sConfigFileName = a_sFileName;
	iCurListPos = -1;
  pNetinfo = a_netinfo;
	setIntExtAdaptersList();
	setServicesList();
	drawServicesPage();
}

ServicesSetup::~ServicesSetup(){
}

QList<ServiceInfo> ServicesSetup::getServicesList(){
	return ServicesList;
}

/*
void createListOfValues(QList<QString> *list, char *stringOfVal)
{
  SplitString splitStr;
  QString str, *strGlobal;
	int count = 0;

  splitStr.SetSectionsString(stringOfVal);
	while(splitStr.Next(str))
		count++;
	
  splitStr.SetSectionsString(stringOfVal);
	while(splitStr.Next(str))
	{
		printf("%s\n", str.ascii());
		strGlobal = new QString;
		*strGlobal = str;
   	list->append(strGlobal);
		delete strGlobal;
	}
}
*/

void ServicesSetup::readFromFile(QString sSettingsFileName, char *values, SplitString splitStr, bool data)
{
	int place;
	QString field, tmp;

	QString defaultConf(GBLI_DATA_PATH + QString("/data/services_configs/") +
											sSettingsFileName.mid(sSettingsFileName.findRev('/') + 1, sSettingsFileName.length()));

#ifdef GBLI_STANDALONE
	QFile file(NEWROOT + sSettingsFileName);
//	printf("file1: %s\n", file.name().latin1());
	if(!file.exists() || !file.open(IO_ReadOnly))
	{
		file.setName(defaultConf);
//		printf("file2: %s\n", file.name().latin1());
	}
#else
	QFile file(defaultConf);
#endif

//	printf("file3: %s\n", file.name().latin1());

	if(!file.isOpen())
		if(!file.exists() || !file.open(IO_ReadOnly))
			return;

	strcpy(values, "");
	while(splitStr.Next(field))
	{
		QTextStream t(&file);
		while(!t.atEnd())
		{
			QString s = t.readLine();
			if((place = s.find("#")) != -1)
				s = s.left(place);
			if(s.find(QRegExp(tmp.sprintf("%s%s%s",
				(sSettingsFileName.find("xinetd") != -1)?"^\\s*":"\\s*",
				field.latin1(), "[=\\s+]"))) != -1)
			{
				place = s.find(field);
				if(data)
				{
					//s = s.remove(place, field.length());
					s = s.remove(0, place + field.length());
					s = s.replace(QRegExp("[+=]"), "");
				}
				else
					s = s.left(place + field.length());

				s = s.simplifyWhiteSpace();
				
//				printf("Line before: '%s'\n", s.ascii());
				// Hack: check if file is not xinetd conf file and remove everything after value
				if ( sSettingsFileName.find("xinetd") == -1 && s.find(' ') != -1 )
					s = s.left( s.find(' ') );
//				printf("Line after:  '%s'\n", s.ascii());
				
				if(strlen(values))
					strcat(values, ",");
				strncat(values, s.latin1(), s.length());
				
//				if(!data)
//					printf("names: %s\n", s.latin1());
			}
		}
		file.at(0);
	}
//	printf("total: %s\n", values);
	file.close();
}

bool ServicesSetup::setServicesList()
{
	char			szBuf[512];
	QString sServiceName;
	QString			sTmp, sName, sSettingsFileName;
	QString sParamName, sParamDesc, sParamValue;
	SplitString		sValuesServ, sValues, Data[2];

	char *listOfData[] = { "DATA_NAMES", "DATA_DESCRIPTION" };
	int countData = sizeof(listOfData) / sizeof(listOfData[0]);

	for(int i = 0; i < countData; i++)
		if(Ini.ProfileStr(sConfigFileName, "XINETD_DATA", listOfData[i], "", szBuf) != 0)
			Data[i].SetSectionsString(szBuf);

//	for(int i = 0; i < countData; i++)
//		printf("data: %s\n", Data[i].returnSections().latin1());

	if (Ini.ProfileStr(sConfigFileName, "SERVICE", "NAMES", "", szBuf) != 0) {
		sValuesServ.SetSectionsString(szBuf);
		//if (!sValues.Next(sServiceName)) return FALSE;
		while ( sValuesServ.Next( sServiceName ) ) {
			ServiceInfo *pServInfo = new ServiceInfo();
//			/**/printf( "Service:%s\n", sServiceName.ascii() );
			pServInfo->setServiceName( sServiceName );
		
			if (Ini.ProfileStr(sConfigFileName, sServiceName, "SERVICE_DESCRIPTION", "", szBuf) != 0)
 				pServInfo->setServiceDescription( szBuf );
			else return FALSE;

			if (Ini.ProfileStr(sConfigFileName, sServiceName, "STATUS_BY_DEFAULT_INTRANET", "", szBuf) != 0)
			{
				if ( qstrcmp( szBuf, "ON" ) == 0 ) pServInfo->setIntranetStatus( true );
				else pServInfo->setIntranetStatus( false );
			}
			else return FALSE;

			if (Ini.ProfileStr(sConfigFileName, sServiceName, "STATUS_BY_DEFAULT_EXTRANET", "", szBuf) != 0) {
				if ( qstrcmp( szBuf, "ON" ) == 0 ) pServInfo->setExtranetStatus( true );
				else pServInfo->setExtranetStatus( false );
			} else return FALSE;

			if (Ini.ProfileStr (sConfigFileName, sServiceName, "DAEMON_NAME","", szBuf )!= 0)
			{
				//printf ("\nDAEMON_NAME=%s\n",	szBuf);
				pServInfo->SetDaemonName (QString (szBuf));
			}

			if (Ini.ProfileStr (sConfigFileName, sServiceName, "CHKCONFIG_STRING","", szBuf )!= 0)
			{
				//printf ("\nCHKCONFIG_STRING=%s\n",	szBuf);
				pServInfo->SetChkConfigString (QString (szBuf));
			}

			if(Ini.ProfileStr(sConfigFileName, sServiceName, "PROTO", "", szBuf) != 0)
				pServInfo->setProtocols(QString(szBuf));

			SplitString splitValues[3];
			QString fieldsValues[3];
			char *listOfFields[] = { "PARAMETER_NAME", "PARAMETER_DESCRIPTION", "PARAMETER_VALUE" };
			char *listOfArea[] = { "INTRANET_", "EXTRANET_" };
			char cf[256] = "CONFIG_FILE_";
			int countArea = sizeof(listOfArea) / sizeof(listOfArea[0]);
			int countFields = sizeof(listOfFields) / sizeof(listOfFields[0]);

//			printf("%s\n", sServiceName.latin1());
			for(int i = 0; i < countArea; i++)
			{
				if (Ini.ProfileStr(sConfigFileName, sServiceName,
						strncat(cf, listOfArea[i], strlen(listOfArea[i]) - 1), "", szBuf) != 0)
				{
					strcpy(cf, "CONFIG_FILE_");
					sValues.SetSectionsString(szBuf);
					while(sValues.Next(sSettingsFileName))
					{
//						printf("sSettingsFileName: %s\n", sSettingsFileName.latin1());
						sName = listOfArea[i] + sServiceName + ":" + sSettingsFileName;
											
						for(int j = 0; j < countFields; j++)
						{
							int k, l, m;
							strcpy(szBuf, "");
							Ini.ProfileStr(sConfigFileName, sName, listOfFields[j], "", szBuf);

							if(!strcmp(szBuf, "_names_"))
							{
								k = returnArrIndex(countData, listOfData, "NAMES");
								readFromFile(sSettingsFileName, szBuf, Data[k], false);
							}
							else if(!strcmp(szBuf, "_description_"))
							{
								strcpy(szBuf, "");
								
								QString readStr, gotStr;
								k = returnArrIndex(countFields, listOfFields, "PARAMETER_NAME");
								l = returnArrIndex(countData, listOfData, "DATA_NAMES");
								m = returnArrIndex(countData, listOfData, "DATA_DESCRIPTION");
								SplitString names;
								names.SetSectionsString(splitValues[k].returnSections());

								while(names.Next(readStr))
								{
									gotStr = Data[m].getByIndex(Data[l].getIndex(readStr));
									if(strlen(szBuf))
										strcat(szBuf, ",");
									strncat(szBuf, gotStr.latin1(), gotStr.length());
		    			  }
//								printf("descr: %s\n", szBuf);
							}
							else if(!strcmp(szBuf, "_read_from_file_"))
							{
								k = returnArrIndex(countFields, listOfFields, "PARAMETER_NAME");
								readFromFile(sSettingsFileName, szBuf, splitValues[k], true);
							}
#ifdef GBLI_STANDALONE
							else
							{
								if(!strcmp(listOfFields[j], "PARAMETER_VALUE"))
								{
									k = returnArrIndex(countFields, listOfFields, "PARAMETER_NAME");
									readFromFile(sSettingsFileName, szBuf, splitValues[k], true);
								}
							}
#endif
							splitValues[j].SetSectionsString(szBuf);
  					}

						bool cond1 = true, cond2 = true;
						while(1)
						{
							for(int k = 0; k < countFields; k++)
							{
								cond1 &= splitValues[k].Next(fieldsValues[k]);
								if(cond1)
									cond2 &= !fieldsValues[k].isEmpty();
							}
							if(!cond1)
								break;
							else if(cond2)
							{
								if(!strcmp(listOfArea[i], listOfArea[0]))
									pServInfo->setIntranetServiceSettings(sServiceName, sSettingsFileName, fieldsValues[0], fieldsValues[1], fieldsValues[2]);
								else if(!strcmp(listOfArea[i], listOfArea[1]))
									pServInfo->setExtranetServiceSettings(sServiceName, sSettingsFileName, fieldsValues[0], fieldsValues[1], fieldsValues[2]);
							}
						}
/*
						while(splitValues[0].Next(fieldsValues[0]) && splitValues[1].Next(fieldsValues[1]) && splitValues[2].Next(fieldsValues[2]))
						{
							if(!fieldsValues[0].isEmpty() && !fieldsValues[1].isEmpty() && !fieldsValues[2].isEmpty())
							{
								if(!strcmp(listOfArea[i], listOfArea[0]))
									pServInfo->setIntranetServiceSettings(sServiceName, sSettingsFileName, fieldsValues[0], fieldsValues[1], fieldsValues[2]);
								else if(!strcmp(listOfArea[i], listOfArea[1]))
									pServInfo->setExtranetServiceSettings(sServiceName, sSettingsFileName, fieldsValues[0], fieldsValues[1], fieldsValues[2]);
							}
						}
*/
					}
				}
			}
/*
					if (Ini.ProfileStr(sConfigFileName, sName, "PARAMETER_NAME", "", szBuf) != 0)
							sParamName = szBuf;
					if (Ini.ProfileStr(sConfigFileName, sName, "PARAMETER_DESCRIPTION", "", szBuf) != 0)
						sParamDesc = szBuf;
					if (Ini.ProfileStr(sConfigFileName, sName, "PARAMETER_VALUE", "", szBuf) != 0)
						sParamValue = szBuf;

					// If such profile dosn`t exist
					if ( !sParamName.isEmpty() && !sParamDesc.isEmpty() && !sParamValue.isEmpty() )
					pServInfo->setIntranetServiceSettings( sServiceName, sSettingsFileName, sParamName, sParamDesc, sParamValue );	
				}
			} // else return false;

			if (Ini.ProfileStr(sConfigFileName, sServiceName, "CONFIG_FILE_EXTRANET", "", szBuf) != 0) {
				sValues.SetSectionsString(szBuf);			
				while ( sValues.Next( sSettingsFileName ) ) {
					sName = "EXTRANET_" + sServiceName + ":" + sSettingsFileName;
					sParamName = sParamDesc = sParamValue = "";

					if (Ini.ProfileStr(sConfigFileName, sName, "PARAMETER_NAME", "", szBuf) != 0)
						sParamName = szBuf;
					if (Ini.ProfileStr(sConfigFileName, sName, "PARAMETER_DESCRIPTION", "", szBuf) != 0)
						sParamDesc = szBuf;
					if (Ini.ProfileStr(sConfigFileName, sName, "PARAMETER_VALUE", "", szBuf) != 0)
						sParamValue = szBuf;

					// If such profile dosn`t exist
					if ( !sParamName.isEmpty() && !sParamDesc.isEmpty() && !sParamValue.isEmpty() )
						pServInfo->setExtranetServiceSettings( sServiceName, sSettingsFileName, sParamName, sParamDesc, sParamValue );
				}
			} // else return FALSE;
*/

			ServicesList.append( pServInfo );
		}
	} else return false;
/**///printf("getServiceInformation step 9\n");	
	return true;
}

void ServicesSetup::init(){
}

void ServicesSetup::updateNetStatus( ) {
		
		if ( ServicesList.at( iCurListPos )->getIntranetStatus() && ServicesList.at( iCurListPos )->getExtranetStatus())
    	pCurrentListViewItem->setText( 1, tr( "Intranet/Extranet" ) );
		else
			if ( (ServicesList.at( iCurListPos )->getIntranetStatus()==false) && ( ServicesList.at( iCurListPos )->getExtranetStatus()==false) )
	    	pCurrentListViewItem->setText( 1, tr( "Disabled" ) );
      else
				if ( ServicesList.at( iCurListPos )->getExtranetStatus() )
		    	pCurrentListViewItem->setText( 1, tr( "Extranet" ) );
				else
					if (ServicesList.at( iCurListPos )->getIntranetStatus())
			    	pCurrentListViewItem->setText( 1, tr( "Intranet" ) );

		Services_List_LV->repaintItem ( pCurrentListViewItem );
}

void ServicesSetup::show(){
QWidget::show();
}

void ProcessDaemon(QString strItem, QString strLevels, bool bEnable)
{

	const char* ptStr = strItem.latin1();
  char strCommand[255];
	char* ptComma = 0;
  do
	{
    ptComma = strchr(ptStr ,',');

		if (ptComma!=NULL)
				*ptComma=0;

		if (bEnable == true )
		{
	    sprintf (strCommand," chroot %s /sbin/chkconfig --level %s %s on", NEWROOT.ascii() ,strLevels.latin1(), ptStr);
		}	
  	else
		{
      sprintf (strCommand," chroot %s /sbin/chkconfig --del %s", NEWROOT.ascii(), ptStr );

		}

		#ifdef GBLI_DEVEL
				printf("%s\n",strCommand);
		#endif

    system (strCommand);
		printf ("\n %s \n", ptStr);

		if (ptComma==NULL)
			break;

		ptComma++;
		ptStr=ptComma;

	}while ( 1 );
		
}

// Initialize Services page

void ServicesSetup::drawServicesPage(){


	class ServiceInfo *ServInfo;
	QList<ServiceInfo> SIList = getServicesList();

	QVBoxLayout * lv = new QVBoxLayout( this, 0, 6 );

  QVBoxLayout * l = new QVBoxLayout( 6 );
	lv->addStretch( 1 );
  lv->addLayout( l, 8 );

	QHBoxLayout * l2 = new QHBoxLayout( 6 );
	lv->addStretch( 1 );
  lv->addLayout( l2, 8 );

  Services_List_LV = new QListView( this, "Services_List_LV" );

	//As everythere by default? ;)
  Services_List_LV->setFrameStyle( QFrame::WinPanel | QFrame::Sunken );
	// our columns
  Services_List_LV->addColumn( tr( "Service" ) );
  Services_List_LV->addColumn( tr( "Firewall" ) );
  Services_List_LV->addColumn( tr( "Description" ) );

// 	Services_List_LV->header()->setClickEnabled( false, Services_List_LV->header()->count() - 1 );

//  Services_List_LV->addColumn( tr( "Intranet" ) );
//  Services_List_LV->header()->setClickEnabled( false, Services_List_LV->header()->count() - 1 );

//	Services_List_LV->addColumn( tr( "Extranet" ) );
// 	Services_List_LV->header()->setClickEnabled( false, Services_List_LV->header()->count() - 1 );

	for ( ServInfo=SIList.first(); ServInfo != 0; ServInfo=SIList.next() )
	{
		QListViewItem * item = new QListViewItem( Services_List_LV, 0 );
		item->setText( 0, tr( ServInfo->getServiceName() ) );

		if ( ServInfo->getIntranetStatus() && ServInfo->getExtranetStatus() )
		{
		   // enabled
		   item->setText( 1, tr( "Intranet/Extranet" ) );
		}
		else
			if ( (ServInfo->getIntranetStatus() == false )&& (ServInfo->getExtranetStatus()==false) )
			{
				// disabled
				item->setText( 1, tr( "Disabled" ) );
			}
			else
				if (ServInfo->getIntranetStatus())
				{
					item->setText( 1, tr( "Intranet" ) );
				}
				else
					if (ServInfo->getExtranetStatus())
						item->setText( 1, tr( "Extranet" ) );
			
		item->setText( 2, ServInfo->getServiceDescription() );
		
		/*if ( ServInfo->getIntranetStatus() )
    	item->setText( 1, tr( "ON" ) );
		else
    	item->setText( 1, tr( "OFF" ) );

		if ( ServInfo->getExtranetStatus() )
    	item->setText( 2, tr( "ON" ) );
		else
    	item->setText( 2, tr( "OFF" ) );
    */
		Services_List_LV->insertItem( item );
	}


//  Services_List_LV->setGeometry( QRect( 310, 0, 271, 350 ) );

  //Services_List_LV->setFrameShadow( QListView::Sunken );
  Services_List_LV->setAutoMask( true );
	l->addWidget( Services_List_LV );

  Intranet_CB = new QCheckBox( tr( "&Intranet" ), this, "Intranet_CB" );

	Intranet_CB->setAutoMask( true );

	l2->addWidget( Intranet_CB );

  Extranet_CB = new QCheckBox( tr( "&Extranet" ), this, "Extranet_CB" );

	Extranet_CB->setAutoMask( true );

	l2->addWidget( Extranet_CB );


/*  Description_TL = new QLabel( tr( "Description" )+":", this, "Description_TL" );

	Description_TL->setAutoMask( true );
	l2->addWidget( Description_TL );
*/
  // Service Conf Button
/*  Service_Configure_PB = new QTextView( this, "Service_Configure_PB" );

	Service_Configure_PB->setAutoMask( true );
	Service_Configure_PB->setFrameStyle( QFrame::WinPanel | QFrame::Sunken );
 	l->addWidget( Service_Configure_PB );
*/
  btnConfigure = new QPushButton( tr( "&Configure" ), this, "btnConfigure" );

#ifdef GBLI_DEVEL
  btnTest = new QPushButton( tr( "&Test" ), this, "Test" );
	btnTest->setAutoMask(true);
#endif

	btnConfigure->setAutoMask( true );
	l2->addWidget ( btnConfigure );
	
#ifdef GBLI_DEVEL
	l2->addWidget(btnTest);
#endif

 // signals and slots connections
	connect( Services_List_LV, SIGNAL( selectionChanged( QListViewItem*) ), this, SLOT( selectionChanged( QListViewItem* ) ) );
	connect( Intranet_CB, SIGNAL( toggled( bool ) ), this, SLOT( modIntranetStatus( bool ) ) );
	connect( Extranet_CB, SIGNAL( toggled( bool ) ), this, SLOT( modExtranetStatus( bool ) ) );

	connect( btnConfigure, SIGNAL( clicked () ), this, SLOT( ServicePageDialog() ) );

#ifdef GBLI_DEVEL
	connect( btnTest, SIGNAL( clicked () ), this, SLOT( finish() ) );
#endif

	// put initial selection on first list item.
	Services_List_LV->setFocus();
	Services_List_LV->setCurrentItem (Services_List_LV->firstChild());
	selectionChanged (Services_List_LV->firstChild());
	
  // tab order
/*  setTabOrder( Services_List_LV, Intranet_CB );
  setTabOrder( Intranet_CB, Extranet_CB );
  setTabOrder( Extranet_CB, Service_Configure_PB );
*/

}

// Another service was selected
void ServicesSetup::selectionChanged( QListViewItem* a_l )
{

	if (a_l == NULL)
		return ;
	
	class ServiceInfo *pServInfo;
	pCurrentListViewItem = a_l;
	QList<ServiceInfo> SIList = getServicesList();

	for ( pServInfo=SIList.first(); pServInfo != 0; pServInfo=SIList.next() ) {
		if( !pServInfo->getServiceName().compare( a_l->text( 0 ) ) ) {
			iCurListPos = SIList.at();
			break;
		}
	}
	if( !pServInfo ) {
		Service_Configure_PB->setText( tr( "No data" ) );
		Intranet_CB->setChecked( false );
		Extranet_CB->setChecked( false );
		return;
	}

// check which variables are exists?
	QList<ServiceSettings> ExtraList = pServInfo->getExtranetServicesSettings ();
	QList<ServiceSettings> IntraList = pServInfo->getIntranetServicesSettings ();

// nothing to configure.
	if (ExtraList.isEmpty() && IntraList.isEmpty())
		btnConfigure->setEnabled (false);
	else
		btnConfigure->setEnabled (true);
	
//	Service_Configure_PB->setText( pServInfo->getServiceDescription() );
	Intranet_CB->setChecked( pServInfo->getIntranetStatus() );
	Extranet_CB->setChecked( pServInfo->getExtranetStatus() );

	repaint();
}
void ServicesSetup::modIntranetStatus( bool a_stat ){
	ServicesList.at( iCurListPos )->setIntranetStatus( a_stat );
	updateNetStatus( );
//	Services_List_LV->refresh();
}
void ServicesSetup::modExtranetStatus( bool a_stat ){
	ServicesList.at( iCurListPos )->setExtranetStatus( a_stat );
	updateNetStatus( );
//	Services_List_LV->refresh();	
}

/*
#BLSC__HOST_NAME__ - Best Linux Server Configuration Host Name
#BLSC__DOMAIN_NAME__ - -/- Domain Name
#BLSC__SUBNET_MASK__ - -/- Subnet Mask
#BLSC__INTERFACE__ - -/- Interface (eth0, eth1...)
#BLSC__OTHERS__ - others parameters which is not listed here and will be necessary, like
#BLSC__RANDOM__ - return random value, BLSC_GRANDMOTHER_NAME__ - return grandmother name
#BLSC__IP_ADDRESS__
*/
void ServicesSetup::parseServiceSettings( QString a_sParamName, QString a_sValue, bool a_bIsIntranet ) {
QString sValue="";
QString sAdapter;

//#ifdef GBLI_DEVEL
//		perror("void ServicesSetup::parseServiceSettings");
//#endif

	if ( a_bIsIntranet )
	{
		//AA:Well now we don`t have any macros which keep in mind that we can have multiply amount of adapters which can be applied to Intranet or Extranet, so I will use only first found
		Log::logMain( 3, "!!!AA:Well now we don`t have any macros which keeps in mind that we can have multiply amount of adapters which applied to Intranet or Extranet, so I will use only first found" );
   	Log::logMain(32, " try assign to sAdapter\n");
	  sAdapter = *InternalNetAdapters.first();
		Log::logMain(32, " sAdapter assigned!\n ");

	} else {
		//AA:Well now we don`t have any macros which keep in mind that we can have multiply amount of adapters which can be applied to Intranet or Extranet, so I will use only first found
		Log::logMain( 3, "!!!AA:Well now we don`t have any macros which keeps in mind that we can have multiply amount of adapters which applied to Intranet or Extranet, so I will use only first found" );
	  sAdapter = *ExternalNetAdapters.first();
	}

	if( a_sParamName.compare( "BLSC__HOST_NAME__" ) == 0 ) {
		sValue = pNetinfo->getHostname();
	}
	if ( a_sParamName.compare( "BLSC__DOMAIN_NAME__" ) == 0 ){
		sValue = pNetinfo->getNISDomain();
	}
		
	if ( a_sParamName.compare( "BLSC__INTERFACE__" ) == 0 ){
		sValue = sAdapter; //Adapter
	}
	if ( a_sParamName.compare( "BLSC__IP_ADDRESS__" ) == 0 ){
		sValue = pNetinfo->getAddress( sAdapter ); //Adapter
	}
	if ( a_sParamName.compare( "BLSC__SUBNET_MASK__" ) == 0 ){
		sValue = pNetinfo->getNetmask( sAdapter ); //Adapter
	}
	if ( a_sParamName.compare( "BLSC__OTHERS__" ) == 0 ){
		sValue = "";
	}
	if ( a_sParamName.compare( "BLSC__RANDOM__" ) == 0 ){
		sValue = "43678578";
	}
	if ( a_sParamName.compare( "BLSC__GRANDMOTHER_NAME__" ) == 0 ){
		sValue = "Inna ;)";
	}
	
	/*
		if (sParamName.compare( "BLSC__ __" ) == 0 ){
			sValue="";
		}
	*/	
	if ( sValue.isEmpty() ) {
		sValue = a_sValue;
	}
	a_sValue = sValue;
}
bool ServicesSetup::changeServConfFiles(const QString a_sRoot, QList <ServiceSettings> a_ServSettingsList, bool a_bIsIntranet ){
ServiceSettings *SS;
bool bStat = true;
QString sValue;
int iMode=0;

	for ( SS = a_ServSettingsList.first(); SS != 0 ; SS = a_ServSettingsList.next() ) {				
		sValue = SS->getParamValue();

		ConfigFile *config = new ConfigFile( a_sRoot.ascii(), (SS->getConfigFileName()).ascii() );
		//some kind of hack		
//		QString U(SS->getConfigFileName().latin1());
//		if ( U.find(QString("dhcpd.conf.sample")) >=0) iMode = 1;
//		else iMode = 0;

		if ( !config->search_and_replace_new( SS->getParamName(), sValue/*, iMode*/ ) ){
			bStat = false;
	   	Log::logMain( 3, "ServicesPage config: Unable to modificate %s, param: %s\n", SS->getConfigFileName().ascii(), SS->getParamName().ascii() );
		#ifdef GBLI_DEVEL
			printf( "config->search_and_replace_new( SS->getParamName(), sValue ) (%s, %s)\n",SS->getParamName().latin1(), sValue.latin1());
			printf( "ServicesPage config: Unable to modificate %s, param: %s\n", SS->getConfigFileName().ascii(), SS->getParamName().ascii() );		
		#endif
		}	   	
		delete config;
	}
//	/**/Log::logMain( 32, "changeServConfFiles():end" );
	return bStat;
}
// Here we are convert service name to port which this service occupied .
int getPortByName (const char* pszServiceName)
{
	if ( strcasecmp(pszServiceName, "FTP")==0)
	  return 21;

	if ( strcasecmp(pszServiceName, "sshd")==0)
	  return 22;

	if ( strcasecmp(pszServiceName, "telnet")==0)
	  return 23;

	if ( strcasecmp(pszServiceName, "WWW (Apache)")==0)
	  return 80;

	if ( strcasecmp(pszServiceName, "DNS")==0)
	  return 53;

	if ( strcasecmp(pszServiceName, "NFS")==0)
	  return 2049;

	if ( strcasecmp(pszServiceName, "SSL WWW (httpsd)")==0)
	  return 443;

	if ( strcasecmp(pszServiceName, "talk")==0)
	  return 517;

	if ( strcasecmp(pszServiceName, "ntalk")==0)
	  return 518;

	if ( strcasecmp(pszServiceName, "imap")==0)
	  return	143;

	if ( strcasecmp(pszServiceName, "LDAP")==0)
	  return	389;

	if ( strcasecmp(pszServiceName, "Time (xntpd)")==0)
	  return	123;

	return -1; // unable !
}

//Modificate all necessary config files.
void ServicesSetup::modServicesConfFiles(const QString root)
{
class ServiceInfo *pServInfo;
SplitString proto;
QString *str;	
bool fileFault = false, adapters;
FILE* ptFwFile;

#ifdef GBLI_DEVEL
//	InternalNetAdapters.append(new QString("eth0"));
//	ExternalNetAdapters.append(new QString("eth1"));
//	iIntExtAdaptersCount = InternalNetAdapters.count() + ExternalNetAdapters.count();
#endif

	adapters = setIntExtAdaptersList();

	if(iIntExtAdaptersCount && adapters)
	{
//		ptFwFile = fopen((NEWROOT +"/etc/rc.d/rc.firewall").latin1(), "w+");
		ptFwFile = fopen((NEWROOT +"/etc/rc.d/rc.firewall").latin1(), "w+");

		if(ptFwFile)
		{
   		// begin firewalling script.
			fputs("#!/bin/sh\n", ptFwFile);
			fputs("IPT=`which iptables 2>/dev/null`\n", ptFwFile);
   	  fputs("if [ -z $IPT ]; then\n	exit 0\nfi\n\n", ptFwFile);
     	fputs("echo -n \"Initializing firewall ... \"\n\n", ptFwFile);
   	  fputs("$IPT -F\n$IPT -P INPUT ACCEPT\n$IPT -P OUTPUT ACCEPT\n", ptFwFile);
			fputs("$IPT -P FORWARD ACCEPT\n$IPT -X\n\n", ptFwFile);

   		if(ExternalNetAdapters.count())
   		{
   			QString *str;
   			fputs("# Reject spoofing\n", ptFwFile);
   			for(str = ExternalNetAdapters.first(); str != 0; str = ExternalNetAdapters.next())
   			{
       		fprintf(ptFwFile, "$IPT -A INPUT -i %s -s 10.0.0.0/8 -j DROP\n", (*str).latin1());
       		fprintf(ptFwFile, "$IPT -A INPUT -i %s -s 127.0.0.0/8 -j DROP\n", (*str).latin1());
   	    	fprintf(ptFwFile, "$IPT -A INPUT -i %s -s 172.16.0.0/12 -j DROP\n", (*str).latin1());
     	  	fprintf(ptFwFile, "$IPT -A INPUT -i %s -s 192.168.0.0/16 -j DROP\n\n", (*str).latin1());
   			}		
	 		}
		  fclose (ptFwFile);
		}
		else
		{
	   	Log::logMain(32, "Cannot open /etc/rc.d/rc.firewall !\n");
			fileFault = true;
		}
	}
//#ifdef GBLI_DEVEL
//	perror("in modServicesConfFiles");
//#endif

	QList<ServiceInfo> SIList = getServicesList();

	for(pServInfo=SIList.first(); pServInfo != 0; pServInfo=SIList.next())
	{
		changeServConfFiles( root, pServInfo->getIntranetServicesSettings(), true );
		changeServConfFiles( root, pServInfo->getExtranetServicesSettings(), false);

		// ChkConfig stuff.

		QString strDaemonName( pServInfo->GetDaemonName() );
		QString strChkConfigString ( pServInfo->GetChkConfigString() );
		
		// service is daemon.
		if(strDaemonName.isEmpty() == false)
		{
#ifdef GBLI_DEVEL
		printf("Service is daemon: %s\n",strDaemonName.latin1());
#endif
	    if (pServInfo->getExtranetStatus()
					|| pServInfo->getIntranetStatus() )
			{
				// enable daemon(s)
				ProcessDaemon	(strDaemonName, strChkConfigString, true);
			}
		
			if ( pServInfo->getExtranetStatus() == false
				&& pServInfo->getIntranetStatus() == false  )
			{
	     	// disable daemon(s)
				ProcessDaemon	(strDaemonName, strChkConfigString, false);
			}
		}

		if(iIntExtAdaptersCount && adapters)
		{
			QString *str;
			QString intRule, extRule, tmp;
      // getting port name
  		int iPort = getPortByName(pServInfo->getServiceName().latin1());
  	
  		if (iPort == -1)
  			continue ; // no port no chain for this service.

  		ptFwFile = fopen((NEWROOT +"/etc/rc.d/rc.firewall").latin1(), "a");
  		
			if(ptFwFile)
			{
	   		fprintf(ptFwFile, "# %s  \n", pServInfo->getServiceName().latin1());
				printf("service: %s\n", pServInfo->getServiceName().latin1());

				proto = pServInfo->getProtocols();
				if(proto.getAmount())
					printf("protocols: %s\n\n", proto.returnSections().latin1());
				else
					printf("protocols empty\n\n");

				intRule = pServInfo->getIntranetStatus() ? "ACCEPT" : "DROP";
				extRule = pServInfo->getExtranetStatus() ? "ACCEPT" : "DROP";

  			for(str = InternalNetAdapters.first(); str != 0; str = InternalNetAdapters.next())
				{
					if(proto.getAmount())
					{				
						while(proto.Next(tmp))
	  					fprintf(ptFwFile, "/sbin/iptables -A INPUT -i %s -p %s --dport %i -j %s\n", (*str).latin1(), tmp.latin1(), iPort, intRule.latin1());
					}
					else
  					fprintf(ptFwFile, "/sbin/iptables -A INPUT -i %s -p tcp --dport %i -j %s\n", (*str).latin1(), iPort, intRule.latin1());
        }

  			for(str = ExternalNetAdapters.first(); str != 0; str = ExternalNetAdapters.next())
				{
					if(proto.getAmount())
					{				
						while(proto.Next(tmp))
  						fprintf(ptFwFile, "/sbin/iptables -A INPUT -i %s -p %s --dport %i -j %s\n", (*str).latin1(), tmp.latin1(), iPort, extRule.latin1());
					}
					else
  					fprintf(ptFwFile, "/sbin/iptables -A INPUT -i %s -p tcp --dport %i -j %s\n", (*str).latin1(), iPort, extRule.latin1());
    		}

  			fclose(ptFwFile);
			}
			else
			{
		   	Log::logMain(32, "Cannot open /etc/rc.d/rc.firewall !\n");
				fileFault = true;
			}
		}
	}

	if(iIntExtAdaptersCount && adapters && !fileFault)
	{
	   // set exec  attributes for firewalling script.
		chmod(NEWROOT +"/etc/rc.d/rc.firewall", 00100|00200|00400 );

		// add for booting.
		FILE* ptFile = fopen(NEWROOT +"/etc/rc.d/rc.local", "a");
		if(ptFile)
		{
			fputs ("\n/etc/rc.d/rc.firewall\n", ptFile);
			fclose(ptFile);
		}
		else
	   	Log::logMain(32, "Cannot open /etc/rc.d/rc.local !\n");
	}

#ifndef GBLI_DEVEL
	system(("chroot " + NEWROOT + " chkconfig ipsec --level 0123456 off").latin1()); //Added by dk
#endif

	printf("iIntExtAdaptersCount: %d\n", iIntExtAdaptersCount);
	printf("int count: %d\n", InternalNetAdapters.count());
	printf("ext count: %d\n", ExternalNetAdapters.count());

	for(str = InternalNetAdapters.first(); str != 0; str = InternalNetAdapters.next())
		printf("int: %s\n", (*str).latin1());

	for(str = ExternalNetAdapters.first(); str != 0; str = ExternalNetAdapters.next())
		printf("ext: %s\n", (*str).latin1());

}

void ServicesSetup::ServicePageDialog()
{
	//printf ("calling ServicePageDialog \n ");                                                                                                     //modal
	ServSettingsConf_D SettingsConfD(this, "servicessetconfdialog", ServicesList.at( iCurListPos ), this, true, WStyle_Customize | WStyle_DialogBorder | WStyle_Title | WStyle_SysMenu  );
	SettingsConfD.exec();
  //Added by dk
  /*dk*/
	if(ServicesList.at( iCurListPos )->getServiceName()=="VPN")
		{
			QMessageBox::information(this,"Info","For full VPN configuration use vpnconfig tool \n To run it type: 'sbin/vpnconfig'");
		}
  /*dk*/
}
void ServicesSetup::finish(){
	//New root path here somehow
	/**/printf( "Services setup final stage\n" );
	modServicesConfFiles( NEWROOT );
}

ServSettingsConf_D::ServSettingsConf_D( QWidget* parent,  const char* name, ServiceInfo *a_pCurService, ServicesSetup *a_pServSetup, bool modal, WFlags fl )
: QDialog( parent, name, modal, fl ){
//ServiceInfo *pCurService = NULL;

QList<ServiceSettings> ExtranetSettingsList;
QList<ServiceSettings> IntranetSettingsList;

//printf ("We are inside ServSettingsConf_D constructor\n");

ServiceSettings *SS;
int totalitems = 0;

	if ( a_pCurService == NULL )
	{
		printf (" a_pCurService is NULL \n");
		return;
	}
	else
	{
		m_pCurService = a_pCurService;
		//printf ("a_pCurService is Ok\n");
	}

	IntranetSettingsList = a_pCurService->getIntranetServicesSettings();
	ExtranetSettingsList = a_pCurService->getExtranetServicesSettings();
	setCaption( tr( "Configure" ) + ":" + a_pCurService->getServiceName() );

	//printf ("Setting Caption.. \n");

	pSSDialog = new SSSetupElement( this, "SSDialog" );

	if (pSSDialog == NULL)
		{
			printf (" Failed to create pSSDialog \n");
			return ;
		}	
   else
		{
     //printf ("pSSDialog created \n");
		}

	QScrollView* sv= new QScrollView(this);

	if (sv == NULL)
	{
		printf (" Failed to create sv \n");
		return ;		
	}
	else
		{
			//printf ("Scroll view created \n ");
		}
//	((QWidget*)sv)->setPaletteBackgroundPixmap (LIconLoader::loadIcon( TEXTURE )  );
	//printf ("Adding scroll view \n");

	pSSDialog->l2->addWidget (sv);
  sv->enableClipper(TRUE);

	//printf ("Scroll View added \n ");	

	QGroupBox* pVGroup = new QGroupBox (tr("Intranet"), this,"IntranetGroup");

	if (pVGroup == NULL)
	{
		printf ("pVGroup failed to create! \n");
		return ;
	}

  pVGroup->setColumns (2);
	pSSDialog->parent = pVGroup;
  pSSDialog->dlg = this;

	//printf ("Adding intranet settings !\n");	

	for ( SS = IntranetSettingsList.first(); SS != 0 ; SS = IntranetSettingsList.next() )
	{				
		QString sNewValue = SS->getParamValue();

		//printf ("sNewValue=%s \n",sNewValue.latin1() );

    //printf ("Parse Service Settings! \n");

		if (a_pServSetup == NULL)
		{
			printf ("a_pServSetup is  NULL!! exiting ");
			return ;
		}
	//	a_pServSetup->parseServiceSettings( SS->getParamName(), sNewValue, 1 );
		
		//printf ("Add Element!\n ");

		pSSDialog->add( SS->getParamName(), SS->getParamDescription(), sNewValue );
	}

	//printf ("Intranet settings Added !\n");

  totalitems += pSSDialog->elcount*3;
	sv->addChild (pVGroup);

	//printf ("pVGroup added \n");
	                                                       // border

	// here to check how much elements
	int iIntranetSizeY =( (pSSDialog->maxStrPixH*3)* (pSSDialog->elcount) );

	//test
	iIntranetSizeY += this->fontMetrics( ).height ();
  //end test

	pSSDialog->elcount = 0;
//	pSSDialog->maxStrPixH = 0;
	/**/
	
	QGroupBox* pExtraGroup = new QGroupBox (tr("Extranet"), this, "ExtranetGroup ");

	if (pExtraGroup == NULL)
	{
		printf ("Failed to create pExtraGroup \n");
		return ;
	}

//	pSSDialog->l2->addWidget( pExtraGroup );
	pSSDialog->parent =  pExtraGroup;
	pExtraGroup->setColumns ( 2 );
	
	//printf (" Adding Extra Group Settings \n");	

	for ( SS = ExtranetSettingsList.first(); SS != 0 ; SS = ExtranetSettingsList.next() ) {				
		QString sNewValue = SS->getParamValue();
//		a_pServSetup->parseServiceSettings( SS->getParamName(), sNewValue, 1 );
		pSSDialog->add( SS->getParamName(), SS->getParamDescription(), sNewValue );
	}	

	//printf ("Extra Group Settings added! \n");
	
	totalitems += pSSDialog->elcount*3;

	
	sv->addChild(pExtraGroup, 0, iIntranetSizeY);

//	printf ("\n Max string is %i pixel(s) len\n", pSSDialog->maxStrPixW );
	int Space = this->fontMetrics( ).width ('W')*6;

	pSSDialog->maxStrPixW +=Space;

	pVGroup->setGeometry(0, 0, pSSDialog->maxStrPixW, iIntranetSizeY);

  pExtraGroup->setGeometry(0, iIntranetSizeY, pSSDialog->maxStrPixW, ( (pSSDialog->maxStrPixH*3)* (pSSDialog->elcount) )+ pSSDialog->maxStrPixH);

	if (ExtranetSettingsList.isEmpty())
	{
		sv->resizeContents( pSSDialog->maxStrPixW, iIntranetSizeY);
		pExtraGroup->hide();	
	}
  else
	{
		sv->resizeContents( pSSDialog->maxStrPixW, iIntranetSizeY+( ((pSSDialog->maxStrPixH*3)* (pSSDialog->elcount) ))+pSSDialog->maxStrPixH );
	}

	QRect rcGeo;
	rcGeo = this->geometry();
	rcGeo.setWidth( pSSDialog->maxStrPixW+10);

	if (totalitems <= 7) // visible at once
		rcGeo.setHeight( pSSDialog->maxStrPixH * (totalitems+3) );
	else
		rcGeo.setHeight( pSSDialog->maxStrPixH*7 );

	this->setGeometry (rcGeo);

	// another buttons to add 
	PushButtonOK = new QPushButton( tr("&Ok"),this );
	PushButtonCancel = new QPushButton( tr("&Cancel"),this  );
  
	pSSDialog->lh->addWidget( PushButtonOK );
	pSSDialog->lh->addWidget( PushButtonCancel );


	PushButtonCancel->setAutoMask( true );
	PushButtonOK->setAutoMask( true );
	
	connect( PushButtonOK, SIGNAL( clicked () ), this, SLOT( accept() ) );
	connect( PushButtonCancel, SIGNAL( clicked () ), this, SLOT( reject() ) );
	
}

void ServSettingsConf_D::editLineEdit( const QString & a_newString )
{
	//printf( "New value: %s\n", a_newString.ascii() );

}
// az add Here save settings .
void ServSettingsConf_D::accept()
{
	QList<ServiceSettings> ExtranetSettingsList;
	QList<ServiceSettings> IntranetSettingsList;

	IntranetSettingsList = m_pCurService->getIntranetServicesSettings();
	ExtranetSettingsList = m_pCurService->getExtranetServicesSettings();

	ServiceSettings *SS = NULL;
	//
  QLineEdit* pLineEdit = pSSDialog->ParamValueLE_List.first();
  //
	for ( SS = IntranetSettingsList.first(); SS != 0 ; SS = IntranetSettingsList.next() )
	{				
		SS->setParamValue(pLineEdit->text());
		pLineEdit = pSSDialog->ParamValueLE_List.next ();
	}

 	for ( SS = ExtranetSettingsList.first(); SS != 0 ; SS = ExtranetSettingsList.next() )
	{
		SS->setParamValue(pLineEdit->text());
		pLineEdit = pSSDialog->ParamValueLE_List.next ();
	}	
	
	QDialog::accept();
}

ServSettingsConf_D::~ServSettingsConf_D(){
}

SSSetupElement::SSSetupElement( QWidget* a_pParent = 0, const char* name = 0, ServiceSettings *a_pSS = 0,  bool modal = true ){
	pSS = a_pSS;
	parent = a_pParent;
	
	l = new QVBoxLayout(  parent );

	lh = new QHBoxLayout(0);
	l2 = new QVBoxLayout( 0 );
	l->addLayout (l2);
	l->addLayout (lh);

	maxStrPixH = 0;
	maxStrPixW = 0;
  elcount = 0;
}

SSSetupElement::~SSSetupElement(){
}

void SSSetupElement::header( QString a_sName ){
		QLineEdit* EmptyLEdit = new QLineEdit( "", parent );
  	EmptyLEdit->setEnabled( FALSE );
  	EmptyLEdit->setText( tr( a_sName ) + ":" );
		EmptyLEdit->setAutoMask( true );
		l->addWidget( EmptyLEdit );
/*
	  QLabel* NetworkClassLabel = new QLabel( "", parent );
	  NetworkClassLabel->setAutoMask( true );
		l2->addWidget( NetworkClassLabel );
*/		
		QLineEdit* EmptyLEdit2 = new QLineEdit( "", parent );
  	EmptyLEdit2->setEnabled( FALSE );
		EmptyLEdit2->setAutoMask( true );
		l2->addWidget( EmptyLEdit2 );

}

int getChCount (QLabel * pLabel)
{
	QString strTmp	(	pLabel->text());
	return pLabel->fontMetrics( ).width (strTmp, strTmp.length());
}

int getChCount (QLineEdit * pLine)
{
	QString strTmp	(	pLine->text());
	return pLine->fontMetrics( ).width (strTmp, strTmp.length());
}


void SSSetupElement::add( QString a_sParamName, QString a_sParamDescription, QString a_sParamValue ){

  	Parameter_name_TL = new QLabel( "Parameter_name_TL", parent );
  	Parameter_name_TL->setText( tr( "Parameter name:" ) );
		Parameter_name_TL->setAutoMask( true );

		int count = getChCount ( Parameter_name_TL);
		//printf ("\n Chars count =%i \n", count);

		Parameter_Name_LE = new QLabel("Parameter_Name_LE", parent);
		Parameter_Name_LE->setText(a_sParamName);
		Parameter_Name_LE->setAutoMask( true );

    if ((getChCount(Parameter_name_TL)+ getChCount(Parameter_Name_LE) ) > maxStrPixW)
			maxStrPixW = getChCount(Parameter_name_TL)+ getChCount(Parameter_Name_LE);
	
  	
  	Parameter_description_TL = new QLabel( "Parameter_description_TL", parent );
  	Parameter_description_TL->setText( tr( "Description:" ) );
		Parameter_description_TL->setAutoMask( true );

  	Parameter_Description_LE = new QLineEdit( "Parameter_Description_LE", parent );
  	Parameter_Description_LE->setEnabled( FALSE );
		Parameter_Description_LE->setText( a_sParamDescription );
		Parameter_Description_LE->setAutoMask( true );

    if ((getChCount (Parameter_description_TL) + getChCount (Parameter_Description_LE)) > maxStrPixW)
			maxStrPixW =  getChCount (Parameter_description_TL) + getChCount (Parameter_Description_LE);
				
	  Parameter_value_TL = new QLabel( "Parameter_value_TL", parent );
  	Parameter_value_TL->setText( tr( "Parameter value:" ) );
		Parameter_value_TL->setAutoMask( true );


	  QLineEdit *pParameter_Value_LE = new QLineEdit( "Parameter_Value_LE", parent );
		connect( pParameter_Value_LE, SIGNAL( textChanged( const QString & ) ), dlg, SLOT( editLineEdit( const QString & ) ) );

	  pParameter_Value_LE->setText( a_sParamValue );
		pParameter_Value_LE->setAutoMask( true );
		ParamValueLE_List.append( pParameter_Value_LE );

	if ((getChCount (pParameter_Value_LE) + getChCount(Parameter_value_TL))>maxStrPixW )
		maxStrPixW = getChCount (pParameter_Value_LE) + getChCount(Parameter_value_TL);


	maxStrPixH = Parameter_Name_LE->height ();
	elcount++;
}
