/***************************************************************************
                          servicessetup.h  - description
                             -------------------                                         
    begin                : Sun May 27 2001                                           
    copyright            : (C) 2001 SOT Finnish Software Engineering Ltd. 
    author		 : Anton Anisimov
    author email         : aa@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef SERVICESSETUP_H
#define SERVICESSETUP_H

#include "config.h"
#include <qstring.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qlabel.h>
//#include <qwhatsthis.h>
#include <qframe.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qbutton.h>
#include <qtextview.h>
#include <qlistview.h>
#include <qheader.h>
#include <qgroupbox.h>
#include <qlineedit.h>
#include <qdialog.h>


#include "serviceinfo.h"
#include "gblipage.h"
#include "network.h"
#include "ini_file.h"
#include "log.h"
#include "ini_file.h"
#include "splitstring.h"

/**
  *@author Anton Anisimov
  */

class ServicesSetup: public GBLIPage {
Q_OBJECT
public: 
	ServicesSetup( QWidget *parent, const char *name=0 );
//	ServicesSetup( char *a_szFileName );
	ServicesSetup( QString a_sFileName, Netinfo *a_netinfo, QWidget *parent, const char *name=0 );
	~ServicesSetup();

	QList<ServiceInfo> getServicesList();

	void init();
  void finish();
	void show();
	void parseServiceSettings( QString a_sParamName, QString a_sValue, bool a_bIsIntranet );

signals:
    void nextEnabled( QWidget*, bool);

protected slots:
	  void selectionChanged( QListViewItem* );
		void modIntranetStatus( bool );
		void modExtranetStatus( bool );
		void ServicePageDialog();
		

private:
	QString sConfigFileName;
	IniFile			Ini;
	Netinfo *pNetinfo;
	QList<QString> InternalNetAdapters, ExternalNetAdapters;
	int iIntExtAdaptersCount;

	QList<ServiceInfo> ServicesList;
  bool setServicesList();
	void updateServiceInfo();
	void updateNetStatus();
	void drawServicesPage();
	void modServicesConfFiles(const QString root);
//Engine to make dirty work - change configuration files
	bool changeServConfFiles(const QString a_sRoot, QList <ServiceSettings> a_ServSettingsList, bool a_bIsIntranet);
	bool setIntExtAdaptersList();	
	void readFromFile(QString sServiceName, char *values, SplitString splitStr, bool data);

  int iCurListPos;
	QListViewItem *pCurrentListViewItem;

  QFrame* Frame3;
  QCheckBox* Extranet_CB;
  QCheckBox* Intranet_CB;
  QLabel* Description_TL;
  QPushButton* btnConfigure;
#ifdef GBLI_DEVEL
  QPushButton* btnTest;
#endif
  QTextView* Service_Configure_PB;
  QListView* Services_List_LV;
//	QWhatsThis wt;
};
class SSSetupElement;
class ServSettingsConf_D : public QDialog
{
    Q_OBJECT

public:
    ServSettingsConf_D( QWidget* parent = 0, const char* name = 0, ServiceInfo *a_pCurService = 0, ServicesSetup *a_pServSetup = 0, bool modal = TRUE, WFlags fl = 0 );
    ~ServSettingsConf_D();
    QGroupBox* NetworkType_GB;
    QLineEdit* Parameter_Name_LE;
    QLineEdit* Parameter_Description_LE;
//    QList<QLineEdit> ParamValueLE_List;
		SSSetupElement *pSSDialog;
    QLabel* Parameter_value_TL;
    QLabel* Parameter_name_TL;
    QLabel* Parameter_description_TL;
    QLabel* NetworkClassLabel; /*Strange I allready added this but can`t see it. ;(*/
		QPushButton* PushButtonOK;
		QPushButton* PushButtonCancel;
protected :
		ServiceInfo *m_pCurService;
private:		
    void createServiceConfDialog( QWidget* parent );
protected slots:
		void editLineEdit( const QString & a_newString );

		void accept ();
};

class SSSetupElement : public QDialog
{
    Q_OBJECT

public:
		SSSetupElement( QWidget* a_pParent = 0, const char* name = 0, ServiceSettings *a_pSS = 0,  bool modal = true );
    ~SSSetupElement();		
		void add( QString a_sParamName, QString a_sParamDescription, QString a_sParamValue );
		void header( QString a_sName );
private:
    QGroupBox* NetworkType_GB;
//    QLineEdit* Parameter_Name_LE;
		QLabel* Parameter_Name_LE;
    QLineEdit* Parameter_Description_LE;

    QLabel* Parameter_value_TL;
    QLabel* Parameter_name_TL;
    QLabel* Parameter_description_TL;
		ServiceSettings *pSS; //Is it ServiceSettings
public :
		QWidget* parent; //???
		QWidget* dlg;
    QList<QLineEdit> ParamValueLE_List;
public :		
		QHBoxLayout *lh;
		QVBoxLayout *l, *l2;
		int maxStrPixH;
		int maxStrPixW;
    int elcount;
//protected slots:
//		void editLineEdit( const QString & a_newString );		
};

#endif
