/***************************************************************************
                          splitstring.h  -  description                              
                             -------------------                                         
    begin                : Wed Jan 10 2001                                           
    copyright            : (C) 2001 SOT Finnish Software Engineering Ltd. 
    author		 					 : Sergei Bednoi, Vadim Khakhulin
    author email         : sb@bestlinux.net, vh@bestlinux.net
    url			 			: http://www.bestlinux.net
    email		 			: linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                        http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/





#ifndef SPLITSTRING_H
#define SPLITSTRING_H

#include <qstring.h>

class SplitString {
public:
	SplitString();
	SplitString(const char *init, const char sep = ',');
	~SplitString();
	
	bool isEmpty();
	void setEmpty();
	void SetSeparatorChar(char cNewSeparator);
	void SetSectionsString(const char* szNewString);	
	bool Next(QString& sNextSection);
	bool Next2(QString& sNextSection);

	int getIndex(QString findStr);
	void delByIndex(int index);
	QString getByIndex(int index);
	void addSection(const QString add);
	QString returnSections() { return sSections; }
	int getAmount()
	{
		if(sSections == "")
			return 0;

		return sSections.contains(cSeparator) + 1;
	}

	void operator+=(const QString add) { addSection(add); }
	void operator=(SplitString &split);
	void operator=(const QString newStr);
	void operator=(const char *newStr);
private:
	QString		sSections;          // String containing sections
	char			cSeparator;         // separated by some characters(default ',')
	int lastPos;
	int nextPos;
};

#endif
