/***************************************************************************
                                 steplabel.h
                             -------------------                                         
    begin                : Thu Nov 30 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author               : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url                  : http://www.bestlinux.net
    email                : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef STEPLABEL_H
#define STEPLABEL_H

#include <qlabel.h>
#include <qwidget.h>
#include <qevent.h>

#include "gblipage.h"

/**
  *@author Anton Safonov (Maddy)
  */

class StepLabel : public QLabel  {
    Q_OBJECT
public:
	friend class GBLIPage;

	StepLabel(): QLabel( NULL, NULL ){}
	StepLabel( QWidget * parent, QWidget * a_page, const char * name, GBLIPage::Status a_iStatus );

	QWidget * getPage(){ return page; };
	GBLIPage::Status getStatus(){ return iStatus; };
	bool getVisited(){ return blVisited; };
	static bool available( QString name );
	
	void move( int x, int y );
	void hide(){ if( backLabel ) backLabel->hide(); QLabel::hide(); }
	void show(){ if( backLabel ) backLabel->show(); QLabel::show(); }

public slots:
	void setCurrent( bool a_bl );
	void setVisited( bool a_bl );

private slots:
	void setStatus( int );

signals:
	void pressed( QWidget *, const QString& );

protected:
	void mousePressEvent ( QMouseEvent * e );
	void updateIcon();

private:
	GBLIPage::Status iStatus;
	bool blCurrent;
	QWidget *page;
	bool blVisited;

	QColor backColor;
	QLabel *backLabel;

};

#endif
