/***************************************************************************
                                target.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef TARGET_H
#define TARGET_H

#include "config.h"
#include "gblipage.h"

#include <qwidget.h>

class PartitionView;
class QButtonGroup;
class LInlineHelp;
class QRadioButton;
class QProgressBar;
class QLabel;

class Target: public GBLIPage
{
    Q_OBJECT
public:
    Target( PartitionView* view, QWidget * parent, const char * name = 0 );
    ~Target();
    enum Set { Disk = 1, Partitions, Custom, Update };

    Set selected() const;
		int notAvailForUpdate(const char *part);

public slots:
		void finish() {}
		
protected:
    void showEvent( QShowEvent * );

private slots:
    void setSelected( int );
    void checkDisks();

private:
    PartitionView *pview;
    Set s;
    QButtonGroup * gb;
    LInlineHelp* inlineHelp;
    QRadioButton* entireHarddiskButton;
    QRadioButton* preparedPartitionsButton;
    QRadioButton* customButton;

    QRadioButton* updateButton;

    QLabel* diskCheckLabel;
    QProgressBar* diskCheckProgressBar;
    bool firstShow;
};

#endif



