/***************************************************************************
                              timezone.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef TIMEZONE_H
#define TIMEZONE_H
#include <qwidget.h>
#include <qpixmap.h>
#include <qlist.h>
#include <qlineedit.h>
#include <qtimer.h>
#include <qdict.h>
#include <sys/time.h>
#include <unistd.h>

#include "config.h"
#include "gblipage.h"

class QListView;
class QRadioButton;
class QListViewItem;
class QLabel;
class QComboBox;

class ZoneInfo
{
public:
    ZoneInfo( const QString& line, bool coords = TRUE );
    ~ZoneInfo(){};

    double x;
    double y;
    QString country;
    QString city;
    QString comment;
    bool coordinates;
};

class World: public QWidget
{
    Q_OBJECT
public:
    World( QWidget * parent = 0, const char * name = 0 );
    ~World();

    void readInZoneInfo( QComboBox* zone );

    ZoneInfo* nearestZone( int x, int y);

    QString getComment( const QString& zone);

signals:
    void highlighted( const QString& );
    void selected( const QString& );

 public slots:
    void highlight( const QString& );

protected:
    void paintEvent( QPaintEvent* );
    void resizeEvent( QResizeEvent* );
    void mouseMoveEvent( QMouseEvent* );
    void mouseReleaseEvent( QMouseEvent * );
    void enterEvent( QEvent * );
    void leaveEvent( QEvent * );


private:

    QPixmap worldpm;
    int w;
    int h;
    int relw;
    int relh;
    int ox;
    int oy;

    QList<ZoneInfo> zones;
    QDict<ZoneInfo> zoneDict;
    ZoneInfo* high;

    QLabel* cityIndicator;

};

// this class is not used anymore, see Language
class TimeZone: public GBLIPage
{
    Q_OBJECT
public:
    TimeZone( QWidget * parent = 0, const char * name = 0 );
    ~TimeZone();

    QString timezone();
		void finish( QString dir );

		int getHourDiff(){ return iHourDiff; };

public slots:
    void setTimezone( const QString& );
    void prepare();

		void updateTimeField();

protected:
    void showEvent( QShowEvent* );
    void hideEvent( QShowEvent* );

private:
    World*  world;
    bool prepared;

    QComboBox* comboZone;
    QLabel*  comment;

public:
    QRadioButton* radioLocaltime;
    QRadioButton* radioGMT;

		QLineEdit *curTime;

		QTimer *updateTimer;

		int iHourDiff;
};


#endif

