/***************************************************************************
                                upgradepage.h
                             -------------------
    begin                : Tue Jan 4 2000
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef UPGRADEPAGE_H
#define UPGRADEPAGE_H

#include "gblipage.h"
#include "language.h"
#include "partitionsel.h"
#include "partitionview.h"
#include "config.h"
#include "hash.h"
#include "networkpage.h"
#include "PackageSelect.h"

#include <qapplication.h>
#include <qwidget.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlist.h>
#include <qlistview.h>
#include <rpm/rpmlib.h>
#include <rpm/header.h>

#define INST_REBUILD_CANCEL 100
#define INST_REBUILD_FAILED 101
#define INST_WRONG_VERSION 102

class pkgSet;
class InstallSelect;
class PartitionSelector;
class PackageSelect;
class packageInfo;

class UpgradePage : public PartitionSelector {
   Q_OBJECT
public:
	UpgradePage(PartitionView* pview_, PartitionSelector::Mode m,
		QWidget * parent, const char * name, Target *target_ = 0);
	~UpgradePage();

	int findUpdates(InstallSelect *a_update, PackageSelect *packSelect = 0);
	void notMustBe(InstallSelect *a_update);

	int eraseUnselectedRPMS( InstallSelect *a_update );
	void umountFS();

public slots:
	void finish() {}
	
protected:
//	void showEvent(QShowEvent *);

private:
	void compareFileList(int availFileCount, char **availBaseNames,
                            char ** availDirNames, int * availDirIndexes,
                            int instFileCount, char **instBaseNames,
                            char ** instDirNames, int * instDirIndexes,
                            struct hash_table *ht);
	void addLostFiles();
	int findPackagesWithObsoletes();
	int findUpgradePackages();
	int removeMovedFilesAlreadyHandled();
	int findPackagesWithRelocatedFiles();
	void printCount();
	int unmarkPackagesAlreadyInstalled();
	int mountFileSystem();

//	void umountFS();
	int checkLinuxesVersions();
	int sameProblem(struct rpmDependencyConflict * ap,
									struct rpmDependencyConflict * bp);

	QListView *view;	

	rpmdb db;
	pkgSet *psp;
	struct hash_table *ht;

	char **newMnt;
};
#endif


