/***************************************************************************
                               xserver.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "config.h"
#include "xserver.h"
#include "qglobal.h"
#include "language.h"
#include "log.h"

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <signal.h>

#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>

#include <qregexp.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <qtextstream.h>
#include <qdatetime.h>

bool XServer::runSVGA = false;
bool XServer::runS3Trio = false;

bool XServer::safe_mode = false;

XServer::XServer()
{
    r = false;

  	char *tmp = getenv( "safe_mode" );
  	if( tmp ){
  		XServer::safe_mode = tmp[0] == 49;
//  		Log::logMain( 1, "safe_mode: %d\n", tmp[0] );
  		Log::logMain( 32, "XServer forced to use VGA mode\n" );
  	}

#if defined(GBLI_DEVEL) || defined(GBLI_STANDALONE)
		XServer::runSVGA = true;
    r = true;
    return; // we must have X already
#endif

		QFileInfo fi( "/etc/X11/X" );
#ifdef GBLI_DEVEL
		if( true ){
#else
    if( !fi.exists() ){
#endif
      XServer::allowsSVGA();
      if( !QFileInfo( "/etc/X11/X" ).exists() )
        return; // ;( what can i do?
    }else{
  		char mlink[128];
  		memset( mlink, 0, sizeof( mlink ) );
  		readlink( "/etc/X11/X", mlink, 128 );
#ifndef XFREE_4
      XServer::runSVGA = !!strstr( mlink, "XF86_SVGA" );
#else
      XServer::runSVGA = QFileInfo( "/tmp/SVGA" ).exists();
#endif
    }
    XServer::runS3Trio = QFileInfo( "/tmp/S3" ).exists();

		// run it in a separate process
    xpid = fork();
    if ( xpid == 0 ) {
			int i = getdtablesize();
			while( i >= 0 ) {
	  	  ::close( i );
	    	i--;
			}
			::open( "/dev/null", O_RDWR );
			::dup( 0 );
			if ( ::open( "/tmp/xserver-output",
		  	O_WRONLY|O_CREAT|O_TRUNC, 0777 ) < 0 )
		      ::dup( 0 );
//			::nice( -19 );
			::execlp( "/etc/X11/X", "/etc/X11/X", ":1", "vt07",
      	"-bestRefresh",
//      	XServer::runS3Trio?"-bpp":"-cc", XServer::runS3Trio?"16":"3", 0 );
      	 0 );
			::exit( 0 );
    }
//printf( "xpid: %d\n", xpid );

		int count = 0;
    while( !r && count++ < 60 ) {
			// make a nice socket for the X server probe
			int datafd = socket( AF_INET, SOCK_STREAM, 0 );
			if ( datafd < 0 )
	  	  return;
			int on = 1;
			if (setsockopt( datafd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on))<0)
	  	  return;
			struct sockaddr_in probe;
			probe.sin_family = AF_INET;
			probe.sin_addr.s_addr = htonl( 0x7f000001 );
			probe.sin_port = htons( 6001 );

			// then try to connect until an attempt succeeds
			r = connect( datafd, (struct sockaddr *)&probe, sizeof(probe) ) >= 0;
			if ( !r )
		    sleep( 1 );
    }

//		if( !r ) return;
		
//    startKWM();
		r = true;
}

bool XServer::allowsSVGA()
{
 	bool serverError = false;

	Log::logMain( 0, "%s\n", QDateTime::currentDateTime().toString().ascii() );

	if( !serverError ){
    int xpid1 = ::fork();
    if ( xpid1 == 0 ) {
  		int i = getdtablesize();
  		while( i >= 0 ) {
    	  ::close( i );
      	i--;
  		}
  		::open( "/dev/null", O_RDWR );
  		::dup( 0 );
  		::nice( -17 );
  		if( ::open( "/tmp/xserver-output-test",
  	  	O_WRONLY|O_CREAT|O_TRUNC, 0777 ) < 0 )
    	    ::dup( 0 );
  		::execlp(
#ifndef XFREE_4
				XServer::path()+"XF86_SVGA", "XF86_SVGA",
#else
				XServer::path()+"XFree86", "XFree86",
#endif
				":2", "vt07",
#ifndef XFREE_4
      	"-bestRefresh", "-probeonly",
#else
				"-configure", "-quiet",
#endif
//				"-cc", "3",
        0 );
  		::exit( 0 );
    }
  	::waitpid( xpid1, NULL, 0 );

#ifndef XFREE_4  	
    QFile f( "/tmp/xserver-output-test" );
    if ( f.open( IO_ReadOnly ) ) { // file opened successfully
  	 	QTextStream t( &f );	    // use a text stream
  		QString xf86 = t.read();

  		int pos;
      int len;

      serverError = (QRegExp("server error").match( xf86, 0, &len ) >= 0);
      if( serverError )
      	Log::logMain( 32, "Server error!\n" );
      if( !serverError ){
  	    serverError = (QRegExp("None of the configured devices were detected").match( xf86, 0, &len ) >= 0);
        if( serverError )
        	Log::logMain( 32, "No device found!\n" );
  		}

  		if( !serverError ){
  			serverError = true;
        QRegExp mode( "(\\*\\*) [^ ]*: Mode " );
  			pos = 0;
        while( (pos = mode.match( xf86, pos, &len )) >= 0 ){
        	QString tmp = xf86.mid( pos+len, 8 );
    			if( tmp == "\"640x480" ){
    				serverError = false;
  					break;
  				}
					pos++;
        }
        if( serverError )
        	Log::logMain( 32, "No appropriate mode found!\n" );
  		}
  		if( !serverError ){// try to detect s3Trio
        QRegExp mode( "(..) [^ ]*: chipset: " );
  			if( (pos = mode.match( xf86, 0, &len )) >= 0 ){
        	QString tmp = xf86.mid( pos+len, 9 ).stripWhiteSpace();
  		    XServer::runS3Trio = !!tmp.contains("s3_virge");
        }
  //XServer::runS3Trio = true;
        if( XServer::runS3Trio ){
          Log::logMain( 32, "Xserver runs on S3 Trio card\n" );
  //      setupS3Trio();
          ::symlink( "/etc/X11/X", "/tmp/S3" );
        }
      }		
    	f.close();
  	}
#else
		if( QFile( "/root/XF86Config.new" ).exists() ){
#ifndef GBLI_DEVEL
			system( "mv /etc/X11/XF86Config /etc/X11/XF86Config.old" );
			system( "mv /root/XF86Config.new /etc/X11/XF86Config" );
#endif
			if( XServer::safe_mode )
				serverError = true;
			else
				serverError =
					getXConfigString( "/etc/X11/XF86Config", "Device", "Driver" ) == "vga";
		}else
			serverError = true;
#endif
		if( !XServer::safe_mode )
	    Log::logMain( 32, "Xserver%s allow%s SVGA\n", serverError?" doesn't":"", serverError?"":"s" );
	}else
		Log::logMain( 32, "XServer forced to use VGA mode\n" );
		
//printf( "server error: %d\n", serverError );
  XServer::runSVGA = !serverError;
#ifndef GBLI_DEVEL
  	::unlink( "/etc/X11/X" );
  #ifndef XFREE_4
    ::symlink( XServer::path() + (XServer::runSVGA?"XF86_SVGA":"XF86_VGA16"), "/etc/X11/X" );
		setupMouse();
  #else
    ::symlink( XServer::path() + "XFree86", "/etc/X11/X" );

    if( !serverError )
	    ::symlink( "/etc/X11/X", "/tmp/SVGA" );

		tuneUpXConfig( "/etc/X11/XF86Config" );
  #endif
#endif

#ifdef GBLI_DEVEL
	tuneUpXConfig( "/root/XF86Config.new" ); // test
#endif

	return XServer::runSVGA;
}

XServer::~XServer()
{
	killX();
}

void XServer::killX(){
#ifndef GBLI_DEVEL
	if( kwmpid ){
	  ::kill( kwmpid, 9 );
  	::waitpid( kwmpid, NULL, 0 );
		kwmpid = 0;
	}else{
//		Log::logMain( 32, "Called killall for kwm!" );
//		system( "killall -9 kwm >/dev/null 2>&1" );
		Log::logMain( 32, "Called killall for xfwm!" );
		system( "killall -9 xfwm >/dev/null 2>&1" );
	}

  ::sleep( 1 );

	if( xpid ){
	  ::kill( xpid, 15 );
  	::waitpid( xpid, NULL, 0 );
		xpid = 0;
	}else{
		Log::logMain( 32, "Called killall for X!" );
		system( "killall -9 X >/dev/null 2>&1" );
	}
	Log::closeMain();
#endif
}

bool XServer::tuneUpXConfig( QString fileName ){
	bool result = false;

	system( ("cp -f "+ fileName +" "+fileName +"_old").ascii() );

	QFile xfconf( fileName +"_old" );
	QFile xfconfnew( fileName );
	if( xfconf.open( IO_ReadOnly ) ){
	  if( xfconfnew.open( IO_WriteOnly ) ){
			QTextStream inf( &xfconf );
			QTextStream outf( &xfconfnew );
			QString section = "";
			QString sectStr = "Section";
			int spec = 0;
			bool serverFlags = false;
		
			bool noDepth = false;
			QRegExp ident( "Identifier\\s+\"Card\\d?\"" );

			while( !inf.eof() ){
				QString str( inf.readLine() );
				int len = str.length();

				if( !len ){
				}else if( str.left( 7 ) == sectStr ){
					section = str.mid( 9, len - 10 );
//Log::logMain( 32, "Begin section: \'%s\'\n", section.ascii() );
					if( section == "Files" )
						outf << "Section \"Files\"" << endl;
					if( !serverFlags && section == "InputDevice" ){
       			outf << "Section \"ServerFlags\"" << endl;
       			outf << "\tOption\t\"DontZap\" \"true\"" << endl;
       			outf << "\tOption\t\"DisableVidModeExtension\" \"true\"" << endl;
       			outf << "\tOption\t\"AllowNonLocalModInDev\" \"true\"" << endl;
       			outf << "\tOption\t\"AllowMouseOpenFail\" \"true\"" << endl;
       			outf << "\tOption\t\"BlankTime\" \"0\"" << endl;
       			outf << "\tOption\t\"StandbyTime\" \"0\"" << endl;
       			outf << "\tOption\t\"SuspendTime\" \"0\"" << endl;
       			outf << "\tOption\t\"OffTime\" \"0\"" << endl;
       			outf << "\tOption\t\"NoPM\" \"true\"" << endl;
       			outf << "EndSection" << endl << endl;
						serverFlags = true;
					}
				}else	if( len == 10 && str == "EndSection" ){
//Log::logMain( 32, "EndSection: %s\n", section.ascii() );
					if( !section.length() ){
					}else if( section == "Module" ){
  					outf << "Load  \"freetype\"" << endl;
  					outf << "Load  \"type1\"" << endl;
  				}else if( section == "ServerFlags" ){
						outf << "Option\t\"DontZap\" \"true\"" << endl;
						outf << "Option\t\"DisableVidModeExtension\" \"true\"" << endl;
						outf << "Option\t\"AllowNonLocalModInDev\" \"true\"" << endl;
						outf << "Option\t\"AllowMouseOpenFail\" \"true\"" << endl;
       			outf << "\tOption\t\"BlankTime\" \"0\"" << endl;
       			outf << "\tOption\t\"StandbyTime\" \"0\"" << endl;
       			outf << "\tOption\t\"SuspendTime\" \"0\"" << endl;
       			outf << "\tOption\t\"OffTime\" \"0\"" << endl;
       			outf << "\tOption\t\"NoPM\" \"true\"" << endl;
						serverFlags = true;
  				}else if( section == "InputDevice" ){
						switch( spec ){
							case 1:
    						outf << "Option\t\"AutoRepeat\" \"500 30\"" << endl;
    						outf << "Option\t\"XkbRules\" \"xfree86\"" << endl;
    						outf << "Option\t\"XkbModel\" \"pc102\"" << endl;
    						outf << "Option\t\"XkbLayout\" \"us\"" << endl;
								break;
							case 2:
    						outf << "Option\t\"ZAxisMapping\" \"4 5\"" << endl;
    						outf << "Option\t\"Emulate3Buttons\"" << endl;
								outf << "Option\t\"Emulate3Timeout\"\t\"50\"" << endl;
								break;
							default: break;
						}
  				}else if( section == "Files" ){
//						outf << "FontPath\t\"unix/:-1" << endl;
						outf << "FontPath\t\"/usr/X11R6/lib/X11/fonts/Type1/\"" << endl;
						outf << "FontPath\t\"/usr/X11R6/lib/X11/fonts/cyrillic/\"" << endl;
						outf << "FontPath\t\"/usr/X11R6/lib/X11/fonts/75dpi/\"" << endl;
						outf << "FontPath\t\"/usr/X11R6/lib/X11/fonts/misc/\"" << endl;
  				}else if( section == "Monitor" ){
						if( spec != 3 ){
	 						outf << "HorizSync\t30-50" << endl;
 							outf << "VertRefresh\t55-70" << endl;
						}
						outf << "# An improved VGA 640x480 mode (hsync = 31.5kHz, refresh = 70Hz)" << endl;
						outf << "ModeLine \"640x480/70Hz\" 29.4 640 664 760 800 480 491 493 525" << endl;
  				}else if( section == "Screen" ){
						if( !noDepth )
	 						outf << "DefaultDepth\t" << (XServer::safe_mode?4:16) << endl;
					}
					section = "";
					if( spec == 5 ) spec = -1;
				}else if( str.find( "Depth" ) > 0 ){
					if( str.find( "DefaultColorDepth" ) >= 0 || str.find( "DefaultDepth" ) >= 0 )
						noDepth = true;
					if( !noDepth ){
  					if( XServer::runSVGA )
  						outf << "Modes\t\"640x480/70Hz\"" << endl;
  					else
  						outf << "Modes\t\"640x480\"" << endl;
					}
				}else{
					if( spec == 4 && XServer::safe_mode && str.find( "Driver" ) >= 0 ){
						outf << "Clocks 25.175" << endl;
						str = "Driver \"vga\"";
						spec = 5;
					}
					if( spec == 2 && str.find( "\"auto\"" ) >= 0 ){
			  		char mlink[128];
			  		memset( mlink, 0, sizeof( mlink ) );
			  		readlink( "/dev/mouse", mlink, 128 );
						str = "Option \"Protocol\" ";
						if( strstr( mlink, "psaux" ) )
							str += "\"PS/2\"";
						else if( strstr( mlink, "ttyS" ) )
							str += "\"Microsoft\"";
						else if( !system( "grep intellimouse -i /tmp/usb/devices >/dev/null 2>&1" ) )
							str += "\"IMPS/2\"";
						else if( !system( "grep mouse -i /tmp/usb/devices >/dev/null 2>&1" ) ){
							// lets assume that keyboard doesn't report itself as Logitech
							if( !system( "grep logitech -i /tmp/usb/devices >/dev/null 2>&1" ) )
								str += "\"IMPS/2\"";// this Logitech works best as Intellimouse ;(
							else
								str += "\"PS/2\"";
						}else
							str += "\"auto\"";
					}
					if( str.find( "DefaultColorDepth" ) >= 0 ||str.find( "DefaultDepth" ) >= 0 )
						noDepth = true;
//printf( "Str: %s --- %d\n", str.ascii(), spec );
					if( spec == 0 && str.find( "Keyboard0" ) > (len-12) ) spec = 1;
					else if( spec == 1 && str.find( "Mouse0" ) > (len-12) ) spec = 2;
					else if( spec == 2 && str.find( "HorizSync" ) >= 0 ) spec = 3;
					else if( (spec == 3 || spec == 2) && XServer::safe_mode &&
						section == "Device" && ident.match( str ) >= 0 )
							spec = 4;
				}
				if( section != "Files" ){
					if( spec != 5 || str.find( "Chip" ) < 0 )
					  outf << str << endl;
				}
			}			

			xfconfnew.close();
			result = true;
		}
		xfconf.close();
		::unlink( (fileName +"_old").ascii() );
  }
	return result;
}

QString XServer::getXConfigString( QString fileName, QString section, QString parameter ){
	QFile xfconf( fileName );
	QString result = "";
	if( xfconf.open( IO_ReadOnly ) ){
		QTextStream inf( &xfconf );
		bool foundSection = false;
		QString beginSection = "Section \""+ section +"\"";
		QString endSection = "EndSection";
		while( !inf.eof() ){
			QString str( inf.readLine() );
			if( foundSection ){
				str = str.simplifyWhiteSpace();
//printf( "str: %s - %s\n", str.latin1(), parameter.latin1() );
				if( !str.find( parameter ) ){
					int begin = str.find( "\"" );
					if( begin > 0 ){
						int end = str.find( "\"", begin+1 );
						if( end > begin ){
						  result = str.mid( begin, end );
							break;
						}
					}
				}else if( str == endSection )
					break;
			}else{
				foundSection = ( str == beginSection );
			}
		}
		xfconf.close();
	}
	return result;
}

int XServer::startKWM()
{
#if defined(GBLI_DEVEL) || defined(GBLI_STANDALONE)
		return 0;
#endif

//		system( "kbgndwm >/dev/null 2>&1 &" );
//		system( "killall -15 kbgndwm" );
		kwmpid = 0;

    // succeeded.  keep the connection open, so the X server won't
    // exit.  start a window manager.
    if ( (kwmpid = ::fork()) == 0 ) {
			int i = ::getdtablesize();
			while( i >= 0 ) {
	  	  ::close( i );
	    	i--;
			}
			::open( "/dev/null", O_RDWR );
			::dup( 1 );
			::dup( 2 );
//			::nice( -18 );
			::nice( 8 );
			
      ::setenv( "LC_ALL", Language::lang->lc_all->ascii(), 1 );
      ::setenv( "LANG", Language::lang->key->ascii(), 1 );
      ::setenv( "LINGUAS", Language::lang->key->ascii(), 1 );
      ::setenv( "LANGUAGE", Language::lang->lc_all->ascii(), 1 );
      ::setenv( "LOCALE", Language::lang->lc_all->ascii(), 1 );
//			::execlp( "/usr/bin/kwm", "kwm", /*"-style", "windows",*/ 0 );
			::execlp( "/usr/bin/xfwm", "xfwm", /*"-style", "windows",*/ ">/dev/null", "2>&1", 0 );
			::exit( 0 );
    }
//printf( "kwmpid: %d\n", kwmpid );
		return kwmpid;
}

void XServer::setupMouse()
{
		char mlink[128];
		memset( mlink, 0, sizeof( mlink ) );
		readlink( "/dev/mouse", mlink, 128 );
		/**///printf( "Link into %s\n", mlink );
		if( strstr( mlink, "psaux" ) ) return;

#ifdef GBLI_DEVEL
return;
#endif
		
		system( "cp -f /etc/X11/XF86Config /etc/X11/XF86Config_old" );
		QFile xfconf( "/etc/X11/XF86Config_old" );
		QFile xfconfnew( "/etc/X11/XF86Config" );
		if( xfconf.open( IO_ReadOnly ) ){
		  if( xfconfnew.open( IO_WriteOnly ) ){
  			QTextStream inf( &xfconf );
  			QTextStream outf( &xfconfnew );
  			while( !inf.eof() ){
  				QString str( inf.readLine() );
  				if( str.find( "Protocol" ) != -1 && str.find( "PS" ) != -1 ) {
						QString QSNewMType;
						if ( ReadMouseXFreeInfo( "/etc/sysconfig/mouse", &QSNewMType ) ) {
							outf << "    Protocol\t\"" + QSNewMType + "\"" << endl;
							/**///printf( "New mouse type for X=%s\n", QSNewMType.data() );
						}else
							outf << "    Protocol\t\"Microsoft\"" << endl;
  				}else{
 					  outf << str << endl;
  		    }
  			}			
  			xfconfnew.close();
  		}
			xfconf.close();
			::unlink( "/etc/X11/XF86Config_old" );
	  }
}

void XServer::setupS3Trio()
{
    if( !XServer::runS3Trio ) return;

#ifdef GBLI_DEVEL
return;
#endif

		system( "cp -f /etc/X11/XF86Config /etc/X11/XF86Config_old" );
		QFile xfconf( "/etc/X11/XF86Config_old" );
		QFile xfconfnew( "/etc/X11/XF86Config" );
		if( xfconf.open( IO_ReadOnly ) ){
		  if( xfconfnew.open( IO_WriteOnly ) ){
  			QTextStream inf( &xfconf );
  			QTextStream outf( &xfconfnew );
  			while( !inf.eof() ){
  				QString str( inf.readLine() );
  				if( str.find( "OffTime" ) != -1 ){
  					outf << str << endl;
#ifndef XFREE_4
						outf << "    DefaultColorDepth 16" << endl;
#else
						outf << "    DefaultDepth 16" << endl;
#endif
//  				}else if( str.find( "Depth" ) != -1 && (str.find( "16" ) != -1 || str.find( "8" ) != -1) ){
//    				outf << str << endl;
//						outf << "        Visual      \"TrueColor\"" << endl;
	    		}else{
    				outf << str << endl;	    		
    			}
  			}			
  			xfconfnew.close();
  		}
			xfconf.close();
			::unlink( "/etc/X11/XF86Config_old" );
	  }
}

void XServer::removeCyrillicFonts(){
#ifdef GBLI_DEVEL
return;
#endif
		system( "cp -f /etc/X11/XF86Config /etc/X11/XF86Config_old" );
		QFile xfconf( "/etc/X11/XF86Config_old" );
		QFile xfconfnew( "/etc/X11/XF86Config" );
		if( xfconf.open( IO_ReadOnly ) ){
		  if( xfconfnew.open( IO_WriteOnly ) ){
  			QTextStream inf( &xfconf );
  			QTextStream outf( &xfconfnew );
  			while( !inf.eof() ){
  				QString str( inf.readLine() );
  				if( str.find( "fonts/cyrillic" ) < 0 )
  					outf << str << endl;
  			}			
  			xfconfnew.close();
  		}
			xfconf.close();
			::unlink( "/etc/X11/XF86Config_old" );
	  }
}

//Read info from /etc/sysconfig/mouse
// path is path on it.
bool XServer::ReadMouseXFreeInfo( const char *a_szPath, QString *a_pQSMType )
{
  QFile QFMSysConf( a_szPath );
	if ( QFMSysConf.open( IO_ReadOnly ) ) {
		QTextStream QFMSysInF( &QFMSysConf );
		QString str;
		while( !QFMSysInF.eof() ){
			str = QFMSysInF.readLine( );
			if( str.find( "XMOUSETYPE=" ) != -1 ) {
						int iFirstQuatMark = str.find( '"' );
						int iLastQuatMark = str.find( '"', iFirstQuatMark + 1 );
						*a_pQSMType = str.mid( iFirstQuatMark + 1, iLastQuatMark - iFirstQuatMark - 1 );
						return TRUE;
				}					
		}
	}

  return FALSE;
}
