#!/usr/bin/python

import sys
if not "/sbin" in sys.path:
        sys.path.append("/sbin")

class NameSpace:
	None

# =================================================================================================
# Python Convinince
# -----------------
# Stuff to tame this screwy language
from types import *

# =================================================================================================
# General Modules
# ---------------

import string
import sys
import time

# =================================================================================================
# Main
# ----

main = NameSpace()
main.dynamic_box_name = "local"

# =================================================================================================
# Queue Types Namespace
# ---------------------
queue_types = NameSpace()
queue_types.type_dict = {}
queue_types.type_list = []
queue_types.type_blacklist = []

queue_types.local = NameSpace()
queue_types.local.type_name = "LOCAL"
queue_types.local.long_pretty_name = "Local Printer Device"
queue_types.local.check = lambda: 1
queue_types.local.message = ""
queue_types.type_dict[queue_types.local.type_name] = queue_types.local
queue_types.type_list.append(queue_types.local)

queue_types.lpd = NameSpace()
queue_types.lpd.type_name = "LPD"
queue_types.lpd.long_pretty_name = "Unix Print Queue"
queue_types.lpd.check = lambda: 1
queue_types.lpd.message = ""
queue_types.type_dict[queue_types.lpd.type_name] = queue_types.lpd
queue_types.type_list.append(queue_types.lpd)

queue_types.smb = NameSpace()
queue_types.smb.type_name = "SMB"
queue_types.smb.long_pretty_name = "Windows Print Queue"
queue_types.smb.check = lambda: os.path.exists("/usr/bin/smbclient")
queue_types.smb.messages = [
	"SMB print queues require the \"smbclient\" program, which does not appear to be installed.",
	"It is part of the \"samba-client\" package, as distributed by Red Hat.",
	"Do you wish to enable it anyway?",
]
queue_types.smb.message = string.join(queue_types.smb.messages, '\n')
queue_types.type_dict[queue_types.smb.type_name] = queue_types.smb
queue_types.type_list.append(queue_types.smb)

queue_types.ncp = NameSpace()
queue_types.ncp.type_name = "NCP"
queue_types.ncp.long_pretty_name = "Novell Print Queue"
queue_types.ncp.check = lambda: os.path.exists("/usr/bin/nprint")
queue_types.ncp.messages = [
	"NCP print queues require the \"nprint\" program, which does not appear to be installed.",
	"It is part of the \"ncpfs\" package, as distributed by Red Hat.",
	"Do you wish to enable it anyway?",
]
queue_types.ncp.message = string.join(queue_types.ncp.messages, '\n')
queue_types.type_dict[queue_types.ncp.type_name] = queue_types.ncp
queue_types.type_list.append(queue_types.ncp)

queue_types.custom = NameSpace()
queue_types.custom.type_name = "CUSTOM"
queue_types.custom.long_pretty_name = "Custom Command"
queue_types.custom.check = lambda: 1
queue_types.custom.message = ""
queue_types.type_dict[queue_types.custom.type_name] = queue_types.custom
queue_types.type_list.append(queue_types.custom)

# =================================================================================================

drivers = NameSpace()

drivers.foomatic = NameSpace()
drivers.foomatic.filter_type = "MAGICFILTER"
drivers.foomatic.mf_type = "MFOMATIC"

drivers.postscript = NameSpace()
drivers.postscript.label = "Postscript Printer"
drivers.postscript.filter_type = "MAGICFILTER"
drivers.postscript.mf_type = "POSTSCRIPT"

drivers.text = NameSpace()
drivers.text.label = "Text Only Printer"
drivers.text.filter_type = "MAGICFILTER"
drivers.text.mf_type = "TEXT"

drivers.raw = NameSpace()
drivers.raw.label = "Raw Print Queue"
drivers.raw.filter_type = "NONE"

drivers.custom = NameSpace()
drivers.custom.label = "Custom Filter"
drivers.custom.filter_type = "CUSTOM"

# =================================================================================================
# Alchemist
# ---------
#
# Alchemist interaction code
from pyalchemist import *

queue_edit = NameSpace()
queue_edit.dynamic_queue_ctx = None
queue_edit.dynamic_queue_box = None
queue_edit.static_queue_ctx = None

def init_queue_edit(editbox = "local"):
	editor = SubspaceEditor("printconf")
	dict = editor.editReadBox(editbox)
	
	queue_edit.dynamic_queue_box = dict["dynamic_box"]
	queue_edit.dynamic_queue_ctx = dict["dynamic_context"]
	queue_edit.static_queue_ctx = dict["static_context"]

def init_queue_edit_or_die(editbox = "local"):
	try:
		init_queue_edit(editbox)
	except KeyError:
		sys.stderr.write("ERROR: No box named \"%s\" found." % editbox)
		sys.exit(1)

	if not queue_edit.dynamic_queue_box.caps.get('write'):
		sys.stderr.write("ERROR: box \"%s\" is not a writable interface." % editbox)
		sys.exit(1)
		
def save_queues():
	queue_edit.dynamic_queue_ctx.serial = time.time()
	queue_edit.dynamic_queue_box.write(queue_edit.dynamic_queue_ctx)

# =====================================================================================================
# New Queue Dialog
# ----------------
nqd = NameSpace()
qld = NameSpace()
qed = NameSpace()
qed.driver = NameSpace()
qed.driver.foomatic = NameSpace()
printer = NameSpace()

nqd.data = {}
nqd.driver_tuple = None
nqd.queue_type_space = None

type = ${type}
queue = "${queue_name}"

def nqd_run():
        nqd.data["queue_name"] = queue

        nqd.data["mf_flags"] = { "send_FF" : "${sendFF}" }
        nqd.data["mf_flags"]["send_EOT"] = "${sendEOT}"
        nqd.data["mf_flags"]["assume_data_is_text"] = "${assumeDataIsText}"
        nqd.data["mf_flags"]["rerender_Postscript"] = "${rerenderPostscript}"
        nqd.data["mf_flags"]["convert_text_to_Postscript"] = "${convertTextToPostscript}"

	if type == 0:
	        nqd.data["local_printer_device"] = "${device_key}"
	        nqd.queue_type_space = queue_types.local
	elif type == 1:
	        nqd.data["lpd_server"] = "${server_lpd}"
        	nqd.data["lpd_queue"] = "${queue_lpd}"
	        nqd.queue_type_space = queue_types.lpd
	elif type == 2:
	        nqd.data["smb_share"] = "${share}"
	        nqd.data["smb_ip"] = "${server_smb}"
        	nqd.data["smb_workgroup"] = "${workgroup}"
	        nqd.data["smb_user"] = "${user_smb}"
        	nqd.data["smb_password"] = "${passwd_smb}"
	        nqd.queue_type_space = queue_types.smb
	elif type == 3:
	        nqd.data["ncp_server"] = "${server_ncp}"
        	nqd.data["ncp_queue"] = "${queue_ncp}"
	        nqd.data["ncp_user"] = "${user_ncp}"
        	nqd.data["ncp_password"] = "${passwd_ncp}"
	        nqd.queue_type_space = queue_types.ncp

        printer.id = "${printer_id}"
        printer_driver = "${printer_driver}"
        nqd.driver_tuple = (drivers.foomatic, (printer, printer_driver))

        construct_queue(nqd.queue_type_space, nqd.data, nqd.driver_tuple)

	(qld.queue_dict_dict, qld.alias_dict_dict) = get_queues()
	queue_dict = qld.queue_dict_dict[queue]

	qed.queue_dict = queue_dict
	qed.queue = qed.queue_dict["queue"]	

	qed.driver.f_type = "MAGICFILTER"
	qed.driver.foomatic.mf_type = "MFOMATIC"
	qed.driver.foomatic.printer_id = printer.id
	qed.driver.foomatic.gs_driver = printer_driver

	driverspace_setup(qed.queue, qed.driver)
	driverspace_apply(qed.queue, qed.driver)
	
# =================================================================================================
# Queue Constructor
# -----------------

def construct_queue(type_space, data_dict, driver_tuple):
	queue_name = data_dict["queue_name"]

	queue = queue_edit.dynamic_queue_ctx.data["/printconf/print_queues"].addData(AdmListType, queue_name)
	queue.atomic = 1

	queue.addData(AdmListType, "alias_list").anonymous = 1
	
	queue["queue_type"] = type_space.type_name # type_name = LPD
	queue_data = queue.addData(AdmListType, "queue_data")

	if type_space == queue_types.local:
		queue_data["local_printer_device"] = data_dict["local_printer_device"]

	elif type_space == queue_types.lpd:
		queue_data["lpd_server"] = data_dict["lpd_server"]
		queue_data["lpd_queue"] = data_dict["lpd_queue"]
		queue_data.addData(AdmBoolType, "lpd_strict_rfc1179") # defaults to false

	elif type_space == queue_types.smb:
		queue_data["smb_share"] = data_dict["smb_share"]
		queue_data["smb_ip"] = data_dict["smb_ip"]
		queue_data["smb_workgroup"] = data_dict["smb_workgroup"]
		queue_data["smb_user"] = data_dict["smb_user"]
		queue_data["smb_password"] = data_dict["smb_password"]
		queue_data.addData(AdmBoolType, "smb_translate") # defaults to false

	elif type_space == queue_types.ncp:
		queue_data["ncp_server"] = data_dict["ncp_server"]
		queue_data["ncp_queue"] = data_dict["ncp_queue"]
		queue_data["ncp_user"] = data_dict["ncp_user"]
		queue_data["ncp_password"] = data_dict["ncp_password"]
	
	elif type_space == queue_types.jetdirect:
		queue_data["jetdirect_ip"] = data_dict["jetdirect_ip"]
		queue_data["jetdirect_port"] = data_dict["jetdirect_port"]

	filter_data = queue.addData(AdmListType, "filter_data")
	queue["filter_type"] = driver_tuple[0].filter_type # filter_type = MAGICFILTER

	if driver_tuple[0] == drivers.raw:
		None
	else:
		filter_data["mf_type"] = driver_tuple[0].mf_type

		mf_flags = filter_data.addData(AdmListType, "flags")
		if data_dict.has_key("mf_flags"):
			for (key, value) in data_dict["mf_flags"].items():
				mf_flags.addData(AdmBoolType, key).value = int(value) # such flags as send_EOT, assume_data_is_text etc

		if driver_tuple[0] == drivers.foomatic:
			(printer, gs_driver) = driver_tuple[1]

			filter_data["printer_id"] = printer.id.encode('latin-1')
			filter_data["gs_driver"] = gs_driver.encode('latin-1')

# =================================================================================================
def driverspace_apply(queue, driverspace):

        f_data = queue["filter_data"]

        f_data.addData(AdmBoolType, "print_header_page").value = \
                driverspace.misc_filter_options[("print_header_page", "bool")]

        if driverspace.f_type == "MAGICFILTER":
		f_data["filter_locale"] = str(driverspace.foomatic.special_defaults[("filter_locale", "enum")])

                if driverspace.foomatic.mf_type == "MFOMATIC":
			defaults = f_data.addData(AdmListType, "foomatic_defaults")
			defaults.anonymous = 1

			for ((op_shortname, op_type), op_value) in driverspace.foomatic.defaults.items():
				op = defaults.addData(AdmListType, "option_default")
				op["name"] = str(op_shortname)
				op["type"] = str(op_type)
				op["default"] = str(op_value)

# =================================================================================================
def driverspace_setup(queue, driverspace):

        driverspace.foomatic = NameSpace()
        driverspace.foomatic.defaults = {}

        driverspace.foomatic.special_defaults = {
                ("page_size", "enum")           : "Letter",
                ("filter_locale", "enum")       : "C"
        }

        f_data = queue["filter_data"]

        if f_data.has_key("print_header_page"):
                print_header_page = f_data["print_header_page"].value
        else:
                print_header_page = 0

        driverspace.misc_filter_options = {
                ("print_header_page", "bool")   : print_header_page
        }

        if driverspace.f_type == "MAGICFILTER":

                #driverspace.foomatic.mf_flags = {}
                #for flag in f_data["flags"]:
                #        driverspace.foomatic.mf_flags[(flag.name, "bool")] = flag.value

                driverspace.foomatic.mf_type = f_data["mf_type"].value

                # We cannot count on this being present, it is a new value.
                if f_data.has_key("filter_locale"):
                        driverspace.foomatic.special_defaults[("filter_locale", "enum")] = \
                                                                f_data["filter_locale"].value

                if driverspace.foomatic.mf_type == "MFOMATIC":
			resolution = "${resolution}"
			colourDepth = "${colourDepth}"
			pageSize = "${pageSize}"

			if resolution != "Default":
				key = ("Resolution", "enum")
				driverspace.foomatic.defaults[key] = resolution
			if colourDepth != "Default":
				key = ("ColourDepth", "enum")
				driverspace.foomatic.defaults[key] = colourDepth
			if pageSize != "Default":
				key = ("PageSize", "enum")
				driverspace.foomatic.defaults[key] = pageSize
                else:
                        raise RuntimeError, "unknown mf_type %s" % driverspace.foomatic.mf_type

        else:
                raise RuntimeError, "unknown filter_type %s" % driverspace.f_type

# =================================================================================================

def get_queues():
        # returns a tuple:
        # element 1, a dict of dicts indexed by name
        # element 2, a dict of dicts indexed by alias

        # both with:
        # queue
        # editable      - can i edit this queue?
        # override      - does this queue mask another queue?

        queue_dict_dict = {}
        alias_dict_dict = {}

        for queue in queue_edit.dynamic_queue_ctx.data["/printconf/print_queues"]:
                override = queue_dict_dict.has_key(queue.name)

                queue_dict = {
                        "queue"         : queue,
                        "editable"      : 1,
                        "override"      : override,
                        "valid"         : 1}
                queue_dict_dict[queue.name] = queue_dict

                for alias in queue["alias_list"]:
                        alias_dict_dict[alias.value] = queue_dict

        return (queue_dict_dict, alias_dict_dict)

# =================================================================================================

def tui_main_run():
        # set up the edit environment
        print "Initializing alchemist edit environment ..."
        init_queue_edit_or_die(main.dynamic_box_name)

        nqd_run()
        save_queues()

	markNsp(namespace = "printconf", mark = "_PRINTCONF_BACKEND_")

        sys.exit(0)


tui_main_run()
